
angular.module('mobility-app').controller('ChartsCtrl', function ($window, $scope, $filter, $state, $ionicLoading, $ionicViewSwitcher, backendData, previousState, GraphService, $timeout, MenuService) {
	var self = this;

	//-- local variables
	var chartSwiper;
	var titlesSwiper;
	var activeSlideIndex = 0;  // do not use swiper.activeIndex because it will not be available on load
	var activeGraphIndex = $state.params.graphIndex < 0 ? 0 : $state.params.graphIndex; // selected graph. Only one at a time. It will be common to all the slides.
	var activeSeries = [];     // selected series. Will be common to all the slides.
	var highlightedDataIndex = []; // the highlighted data in each slide 
	var maxIndexWithData = [];
	var visibleNoteIndex = -1;
	var previousIndex = $state.params.previousIndex;
	var length = backendData.length;
	var groupBy = $state.params.groupBy;
	var graphCategoryMapping
	var _graphType = $state.params.type;





	//-- controller variables and functions (accessed from DOM)
	self.displayGraphMenu = false; // this variable will be used for phone view only. 

	self.data = [];

	self.topContributors = [];

	self.title = $state.params.title || 'No data available';
	


	self.selectedGraph = self.title;

	self.currentDate = 'Data loaded at ' + moment().format('MMMM DD, YYYY HH:mm:ss');

	self.graphNames = [];

	self.graphData = [];

	self.categories = [];

	self.selectedCategory = "";

	self.handleAllClicks = function (event) {
		// if notification box is visible, hide it.
		if (hideBox()) {
			event.preventDefault();
			event.stopPropagation();
		}
	};

	//-- NAVIGATION
	self.goBack = function (event) {
		if (event) event.stopPropagation();
		hideBox();

		$ionicLoading.show();
		window.cordova ? $ionicViewSwitcher.nextDirection("back") : $ionicViewSwitcher.nextDirection("swap");
		$state.go(previousState, { previousIndex: previousIndex });
	};


	//-- INITIALIZATION
	function getGraphName(str) {
		var lstr = str.toLowerCase();

		

		
		


		if (lstr.indexOf('@^@') !=  -1 ) {
			return str.split('@^@')[1];
		}


		

		

		if (lstr.indexOf('upgrades daily') == 0) {
			return 'Upgrades And Data Change';
		}

		// if (lstr.indexOf('iphone activations') == 0) {
		// 	return 'iPhone Activations';
		// }


		if (lstr.endsWith('daily')) {
			return str.substring(0, lstr.indexOf('daily'));
		}

		



		if (groupBy == 'type') {
			return str.substring(str.indexOf('-') + 1).trim().split(' ')[0].trim();
		}







		if (lstr.indexOf('today') == 0) {
			return 'TLG Transactions per Minute';
		}

		if (lstr.indexOf('week') == 0) {
			return 'TLG Transactions per Minute';
		}

		if (lstr.indexOf('peak') == 0) {
			return 'TLG Transactions per Minute';
		}

		if (lstr.indexOf('120%') == 0) {
			return 'TLG Transactions per Minute';
		}

		if (lstr.indexOf('25%') == 0) {
			return 'TLG Transactions per Minute';
		}




		if (lstr.indexOf('churn') >= 0) {
			return 'Total';
		}

		if (lstr.indexOf('collection aged') == 0) {
			return 'Collection Aged';
		}

		if (lstr.indexOf('(order fallout)') >= 0) {
			str = str.replace('(Order Fallout)', '').trim();
		}

		if (lstr.indexOf('total activations') == 0) {
			return 'Activations';
		}

		if (str.indexOf('-') > 0) {
			return str.substring(0, str.lastIndexOf('-')).trim();
		}

		return str.substring(0, str.indexOf(' ')).trim();
	};

	function getLegendName(str) {
		var lstr = str.toLowerCase();

		

		// For iPhone transactions

		if (lstr.indexOf('@^@') !=  -1 ) {
			return str.split('@^@')[0];
		}


		
		if (lstr.endsWith('daily')) {
			return 'Daily';
		}
		


		// TLG graphs

		if (lstr.indexOf('today') == 0) {
			return str;
		}

		if (lstr.indexOf('week') == 0) {
			return str;
		}

		if (lstr.indexOf('peak') == 0) {
			return str;
		}

		if (lstr.indexOf('120%') == 0) {
			return str;
		}

		if (lstr.indexOf('25%') == 0) {
			return str;
		}




		if (lstr.indexOf('churn') >= 0) {
			return str;
		}

		if (lstr.indexOf('collection aged') == 0) {
			return str.substring(str.indexOf('(') + 1, str.indexOf(')'));
		}

		if (str.indexOf('-') > 0) {
			return str.substring(str.lastIndexOf('-') + 1).trim();
		}

		return str.substring(str.indexOf(' ') + 1).trim();
	};

	function groupGraphsByTitle(backendData) {
		var obj = {};
		for (var i = 0; i < backendData.length; i++) {
			if (!obj[backendData[i].title]) {
				obj[backendData[i].title] = {
					title: backendData[i].title,
					graphs: []
				};
			}

			for (var j = 0; j < backendData[i].graphs.length; j++) {
				obj[backendData[i].title].graphs.push(backendData[i].graphs[j]);
			}
		}

		var arr = [];
		for (var key in obj) {
			arr.push(obj[key]);
		}

		return arr;
	};

	function mapCategory(str) {
		var lstr = str.toLowerCase();

		// if (str.indexOf('vas') >= 0) {
		// 	return 'VAS';
		// }
		// if (str.indexOf('sms') >= 0) {
		// 	return 'TEXT'
		// }
		// if (str.indexOf('mms') >= 0 || str.indexOf('gprs') >= 0) {
		// 	return 'DATA';
		// }



		if (lstr.indexOf('@^@') !=  -1 ) {
			return str.split('@^@')[1];
		}

		return str;




	};

	function groupGraphsByCategory(backendData) {
		self.categories = [];

		var str;
		var category;
		for (var i = 0; i < backendData.length; i++) {
			for (var j = 0; j < backendData[i].graphs.length; j++) {
				for (var k = 0; k < backendData[i].graphs[j].metricSeries.length; k++) {
					str = backendData[i].graphs[j].metricSeries[k].info.name;
					category = mapCategory(str);
					if (self.categories.indexOf(category) < 0) {
						self.categories.push(category);
					}
					backendData[i].graphs[j].metricSeries[k].info.category = category;
				}
			}
		}

		self.selectedCategory = self.categories[0];
		return backendData;
	};

	// manipulate the data coming from backend so it will always match the expected
	// structure by the service and controller
	function prepareData(backendData) {
		self.graphNames = [];
		self.graphData = [];
		var allGraphs = [];
		var str = '';
		var legendName = '';
		var graphName = '';
		var graph;
		var metric;
		var notes = false;

		if (groupBy == 'category') {
			backendData = groupGraphsByCategory(backendData);
		}
		else if (backendData.length > 3) {
			backendData = groupGraphsByTitle(backendData);
		}
		length = backendData.length;

		// get names and legends for each graph
		for (var graphIndex = 0; graphIndex < length; graphIndex++) {
			self.graphNames[graphIndex] = [];
			self.graphData[graphIndex] = {};

			for (var i = 0; i < backendData[graphIndex].graphs.length; i++) {
				for (var j = 0; j < backendData[graphIndex].graphs[i].metricSeries.length; j++) {
					str = backendData[graphIndex].graphs[i].metricSeries[j].info.name;

					graphName = getGraphName(str);
					if (self.graphNames[graphIndex].indexOf(graphName) < 0) {
						self.graphNames[graphIndex].push(graphName);
						self.graphData[graphIndex][graphName] = { legends: [] };
					}

					legendName = getLegendName(str);
					if (self.graphData[graphIndex][graphName].legends.indexOf(legendName) < 0) {
						self.graphData[graphIndex][graphName].legends.push(legendName);
					}
				}
			}
		}

		// restructure all graphs
		for (var graphIndex = 0; graphIndex < length; graphIndex++) {

			// initialize return object
			allGraphs[graphIndex] = {
				title: '',
				graphs: [],
				supportTabularView: false // tabular view indicator

			};

			// group graphs by name
			for (var i = 0; i < self.graphNames[graphIndex].length; i++) {
				allGraphs[graphIndex].graphs.push({
					title: self.graphNames[graphIndex][i],
					metricSeries: [],
					notes: []
				});
			}


			// add indicator for tabular view support

			if (backendData[graphIndex].gauges && angular.isArray(backendData[graphIndex].gauges)) {
				if (backendData[graphIndex].gauges.length > 0) { // only if we have some data
					allGraphs[graphIndex].gauges = backendData[graphIndex].gauges.slice(0);
					allGraphs[graphIndex].supportTabularView = true;
				}
			}


			// add metrics to graphs
			for (var i = 0; i < backendData[graphIndex].graphs.length; i++) {
				graph = backendData[graphIndex].graphs[i];

				// add minMaxValue if exists
				if (graph.minMaxValue) {
					allGraphs[graphIndex].graphs[i].minMaxValue = graph.minMaxValue;
				}



				allGraphs[graphIndex].title = backendData[graphIndex].title;

				notes = true;
				for (var j = 0; j < graph.metricSeries.length; j++) {
					str = graph.metricSeries[j].info.name;
					graphName = getGraphName(str);

					for (var k = 0; k < allGraphs[graphIndex].graphs.length; k++) {
						if (allGraphs[graphIndex].graphs[k].title == graphName) {
							allGraphs[graphIndex].graphs[k].subTitle = graph.subTitle;
							metric = graph.metricSeries[j];
							metric.info.fullname = metric.info.name;
							metric.info.title = graphName;
							allGraphs[graphIndex].graphs[k].metricSeries.push(metric);

							if (notes) {
								allGraphs[graphIndex].graphs[k].notes = allGraphs[graphIndex].graphs[k].notes.concat(graph.notes);
								notes = false;
							}
						}
					}
				}
			}
		}

		/*if (groupBy == 'category') {
			var catCount = {};
			for (var i=0; i < allGraphs.length; i++) {
				for (var j=0; j < allGraphs[i].graphs.length; j++) {
					catCount = {
						'VOICE': 0,
						'DATA': 0,
						'TEXT': 0,
						'VAS': 0
					};

					for (var k=0; k < allGraphs[i].graphs[j].metricSeries.length; k++) {
						allGraphs[i].graphs[j].metricSeries[k].info.serieIndex = catCount[allGraphs[i].graphs[j].metricSeries[k].info.category];
						catCount[allGraphs[i].graphs[j].metricSeries[k].info.category]++;
					}
				}
			}
		}*/

		return allGraphs;
	};

	function initializeVariables() {
		// change screen title to match selected graph
		if (groupBy != 'type') {
			//self.title = self.graphNames[activeSlideIndex][activeGraphIndex];

			self.title = (_graphType == 'iphone-transactions') ? 'iPhone Activations ' : self.graphNames[activeSlideIndex][activeGraphIndex];


			
		}
		self.selectedGraph = self.graphNames[activeSlideIndex][activeGraphIndex];

		// draw first graph in each slide
		maxIndexWithData = [];
		highlightedDataIndex = [];
		activeSeries = [];
		for (var i = 0; i < self.data.length; i++) {
			// highlight the latest defined point
			maxIndexWithData.push(0);
			highlightedDataIndex.push(0);
			activeSeries[i] = [];



			for (var j = 0; j < self.data[i].graphs[activeGraphIndex].metricSeries.length; j++) {
				activeSeries[i][j] = true;

				for (var k = 0; k < self.data[i].graphs[activeGraphIndex].metricSeries[j].values.length; k++) {
					if (self.data[i].graphs[activeGraphIndex].metricSeries[j].values[k].value != undefined) {
						maxIndexWithData[i] = k;
					}
				}
			}

			highlightedDataIndex[i] = maxIndexWithData[i];
		}


	};

	//-- redraw gauges and graph on window resize  
	if (!window.cordova) {
		angular.element($window).bind('resize', function () {
			// wrap around a timeout to wait elements resizing before redrawing.
			// A timeout zero, puts the function in next digest cycle.
			$timeout(function () {
				initialize(true);
			}, 300);
		});
	}

	$scope.$on('$ionicView.beforeEnter', function () {
		MenuService.close();

		if (!backendData || backendData.length < 1) {
			self.goBack();
			return;
		}

		self.data = prepareData(backendData);
		initializeVariables();
	});

	$scope.$on('$ionicView.afterEnter', function () {
		if (!self.data) return;

		$timeout(function () {
			initialize();
		}, 0);
	});

	//-- ASYNC HANDLING OF GRAPH
	// When user touches the graph, the highlighted area changes, so the values on screen should change
	self.graphTouchNotification = function (newVal) {
		if (newVal == highlightedDataIndex[activeSlideIndex]) {
			return;
		}

		if (newVal < 0 || newVal > maxIndexWithData[activeSlideIndex]) {
			return;
		}

		highlightedDataIndex[activeSlideIndex] = newVal;
		highlightData();
		$scope.$apply();
	};
	GraphService.registerGraphClickEventCallBack(self.graphTouchNotification);

	var notificationBoxStyle = {};
	var notificationBoxPointerStyle = {};

	function setNotificationBoxVisible() {
		notificationBoxStyle['opacity'] = '1';
		notificationBoxStyle['visibility'] = 'visible';

		notificationBoxPointerStyle['opacity'] = '1';
		notificationBoxPointerStyle['visibility'] = 'visible';
	};
	function setNotificationBoxHidden() {
		notificationBoxStyle['opacity'] = '0';
		notificationBoxStyle['visibility'] = 'hidden';

		notificationBoxPointerStyle['opacity'] = '0';
		notificationBoxPointerStyle['visibility'] = 'hidden';
	};

	self.getNotificationBoxStyle = function (index) {
		if (index != activeSlideIndex) {
			return {};
		}
		return notificationBoxStyle;
	};
	self.getNotificationBoxPointerStyle = function (index) {
		if (index != activeSlideIndex) {
			return {};
		}
		return notificationBoxPointerStyle;
	};

	self.noteTouchNotification = function (values) {
		var box = document.getElementById('notification-box-' + activeSlideIndex);
		if (visibleNoteIndex == Number(values.index)) {
			if (box.style.visibility == 'visible') {
				hideBox();
			}
			else {
				setNotificationBoxVisible();

				var marker = angular.element(document.getElementById(values.chart + '-note-marker-' + visibleNoteIndex));
				marker.addClass('active immediate');
			}
		}
		else {
			var chartElement = document.getElementById(values.chart);
			var halfBoxWidth = Math.round(box.clientWidth / 2);
			var leftPosition = values.left + chartElement.offsetLeft - halfBoxWidth;
			var minLeftPosition = chartElement.offsetLeft + values.offsetLeft;
			var maxLeftPosition = chartElement.offsetLeft + chartElement.clientWidth - values.offsetRight;

			// check for position limit on the left side
			var translatedBoxPosition = 0;
			var translatedPointerPosition = 0;
			if (leftPosition < minLeftPosition) {
				translatedBoxPosition = minLeftPosition;
				translatedPointerPosition = values.left - values.offsetLeft;
			}
			// check for position limit on the right side
			else if (leftPosition + box.clientWidth > maxLeftPosition) {
				translatedBoxPosition = maxLeftPosition - box.clientWidth;
				translatedPointerPosition = (box.clientWidth - (maxLeftPosition - leftPosition)) + halfBoxWidth;
			}
			// position where calculated
			else {
				translatedBoxPosition = leftPosition;
				translatedPointerPosition = halfBoxWidth;
			}

			notificationBoxStyle['-webkit-transform'] = 'translateX(' + translatedBoxPosition + 'px)';
			notificationBoxStyle['transform'] = 'translateX(' + translatedBoxPosition + 'px)';
			notificationBoxPointerStyle['-webkit-transform'] = 'translateX(' + translatedPointerPosition + 'px)';
			notificationBoxPointerStyle['transform'] = 'translateX(' + translatedPointerPosition + 'px)';

			setNotificationBoxVisible();

			angular.element(document.getElementById(values.chart + '-note-marker-' + visibleNoteIndex)).removeClass('active immediate');
			visibleNoteIndex = Number(values.index);

			angular.element(document.getElementById(values.chart + '-note-marker-' + visibleNoteIndex)).addClass('active');
		}

		$scope.$apply();
	};
	GraphService.registerNoteClickEventCallBack(self.noteTouchNotification);

	function hideBox() {
		// if notification box is visible, hide it.
		var box = document.getElementById('notification-box-' + activeSlideIndex);
		if (box && box.style.visibility == 'visible') {
			setNotificationBoxHidden();
			angular.element(document.getElementById('chart' + activeSlideIndex + '-note-marker-' + visibleNoteIndex)).removeClass('active immediate');
			return true;
		}
		return false;
	};

	//-- NOTES
	self.getCurrentNotes = function () {
		var currentGraph = self.data[activeSlideIndex].graphs[activeGraphIndex];
		var notes = (visibleNoteIndex >= 0) ? currentGraph.notes[visibleNoteIndex] ? currentGraph.notes[visibleNoteIndex] : [] : [];
		if (notes.constructor === Array) {
			return notes;
		}

		var notesArr = [];
		notesArr.push(notes);
		return notesArr;
	};


	//-- TABULAR DATA LOGIC

	self.isTabularGraphViewMode = false;


	self.setGraphViewMode = function () {
		self.isTabularGraphViewMode = false;
		self.displayGraphMenu = false; // close the menu in phone view
	};

	self.setTabularViewMode = function () {
		self.isTabularGraphViewMode = true;
		self.displayGraphMenu = false; // close the menu in phone view
	};


	self.getTabularViewTitles = function (index) {

		var _titles = [];
		if (self.data[index].supportTabularView == true) {
			//"title": "Activations Day-6|Date^Total Activation^Change % from last week",

			//@TODO decide how to pass the titles

			_titles = self.data[index].gauges[0].title.split('|')[1].split('^');
		}

		return _titles;



	};

	//-- GRAPHS
	function initialize(isUpdate) {
		if (isUpdate) {
			titlesSwiper.update();

			chartSwiper.update();
			chartSwiper.slideTo(chartSwiper.activeIndex);
		}
		else {
			chartSwiper = new Swiper('.gallery-main', {
				spaceBetween: 0,
				// swiper configuration for iPad when short swipe is disabled
				shortSwipes: false,
				longSwipesRatio: 0.1,
				longSwipesMs: 50,
				// desktop version
				mousewheelControl: true
			});
			titlesSwiper = new Swiper('.gallery-titles', {
				spaceBetween: 30,
				centeredSlides: true,
				slidesPerView: 'auto',
				touchRatio: 0.2,
				slideToClickedSlide: true,
				// swiper configuration for iPad when short swipe is disabled
				shortSwipes: false,
				longSwipesRatio: 0.1,
				longSwipesMs: 50,
				// desktop version
				mousewheelControl: true
			});

			chartSwiper.params.control = titlesSwiper;
			titlesSwiper.params.control = chartSwiper;

			chartSwiper.on('onTransitionEnd', function (swiper) {
				hideBox();
				if (swiper.activeIndex < length) {
					activeSlideIndex = swiper.activeIndex;
					visibleNoteIndex = -1;
					self.toggleGraph(activeGraphIndex, true);
				}



				$scope.$apply();
			});
		}

		for (var i = 0; i < self.data.length; i++) {

			GraphService.drawGraphWithLegend('chart' + i, self.data[i].graphs[activeGraphIndex], highlightedDataIndex[i], undefined, false, self.selectedCategory);
		}
	};

	self.isGraphActive = function (graphIndex) {
		return (activeGraphIndex == graphIndex);
	};

	self.toggleGraph = function (graphIndex, force) {
		if (!force && self.isGraphActive(graphIndex)) {
			return;
		}

		self.displayGraphMenu = false; // close the menu in phone view

		// change screen title to match selected graph
		if (groupBy != 'type') {
			//self.title = self.graphNames[activeSlideIndex][graphIndex];
			self.title = (_graphType == 'iphone-transactions') ? 'iPhone Activations ' : self.graphNames[activeSlideIndex][graphIndex];
		}


		// set activeGraphIndex in case not matching between weekly and monthly 
		if (self.graphNames[activeSlideIndex][graphIndex]) {
			activeGraphIndex = graphIndex;
		} else {
			activeGraphIndex = 0;
		}

		self.selectedGraph = self.graphNames[activeSlideIndex][activeGraphIndex];

		//activeGraphIndex = graphIndex;

		var graph = self.data[activeSlideIndex].graphs[activeGraphIndex];
		for (var i = 0; i < graph.metricSeries.length; i++) {
			activeSeries[activeSlideIndex][i] = true;
		}

		var multiAxis = (groupBy == 'type');
		if (multiAxis && (graph.metricSeries.length != 2 || graph.metricSeries[0].info.unit == graph.metricSeries[1].info.unit)) {
			multiAxis = false;
		}


		GraphService.drawGraphWithLegend('chart' + activeSlideIndex, graph, highlightedDataIndex[activeSlideIndex], activeSeries[activeSlideIndex], multiAxis, self.selectedCategory);



	};

	self.toggleCategory = function (category) {
		self.selectedCategory = category;
		self.toggleGraph(activeGraphIndex, true);
	};

	function highlightData() {
		GraphService.highlightArea('chart' + activeSlideIndex, highlightedDataIndex[activeSlideIndex]);
	};

	self.isSerieActive = function (serieIndex) {
		if (groupBy == 'category') {
			var index = 0;
			for (var i = 0; i < self.data[activeSlideIndex].graphs[activeGraphIndex].metricSeries.length; i++) {
				if (self.data[activeSlideIndex].graphs[activeGraphIndex].metricSeries[i].info.category != self.selectedCategory) {
					continue;
				}

				if (index == serieIndex) {
					serieIndex = i;
					break;
				}
				index++;
			}
		}

		return activeSeries[activeSlideIndex][serieIndex];
	};

	self.toggleSerie = function (serieIndex) {
		if (groupBy == 'category') {
			var index = 0;
			for (var i = 0; i < self.data[activeSlideIndex].graphs[activeGraphIndex].metricSeries.length; i++) {
				if (self.data[activeSlideIndex].graphs[activeGraphIndex].metricSeries[i].info.category != self.selectedCategory) {
					continue;
				}

				if (index == serieIndex) {
					serieIndex = i;
					break;
				}
				index++;
			}
		}

		// serie not available
		if (!self.data[activeSlideIndex].graphs[activeGraphIndex].metricSeries[serieIndex]) {
			return;
		}




		activeSeries[activeSlideIndex][serieIndex] = !activeSeries[activeSlideIndex][serieIndex]; // toggle value


		var activeCount = 0;
		for (var i = 0; i < activeSeries[activeSlideIndex].length; i++) {
			if (activeSeries[activeSlideIndex][i]) {
				activeCount++;
				break;
			}
		}

		// always keep at least 1 selected.
		if (activeCount == 0) {
			activeSeries[activeSlideIndex][serieIndex] = !activeSeries[activeSlideIndex][serieIndex]; // toggle back
			return;
		}
		GraphService.setSerieVisibility('chart' + activeSlideIndex, serieIndex, activeSeries[activeSlideIndex][serieIndex]);
		highlightData();
	};

	self.getLegendItems = function (index) {
		if (groupBy == 'category') {
			var items = [];
			for (var i = 0; i < self.data[activeSlideIndex].graphs[activeGraphIndex].metricSeries.length; i++) {
				if (self.data[activeSlideIndex].graphs[activeGraphIndex].metricSeries[i].info.category != self.selectedCategory) {
					continue;
				}
				self.data[activeSlideIndex].graphs[activeGraphIndex].metricSeries[i].info.serieIndex = i;
				items.push(getLegendName(self.data[activeSlideIndex].graphs[activeGraphIndex].metricSeries[i].info.name));
			}
			return items;
		}



		var _legends = [];
		var _index = index;

		try {
			//console.log('getLegendItems ' + JSON.stringify(self.graphData[_index][self.selectedGraph]));
			//console.log('activeSlideIndex ' + activeSlideIndex);
			//console.log('self.selectedGraph ' + self.selectedGraph);
			
			_legends = self.graphData[_index][self.selectedGraph].legends.slice(0);
			


			
		} catch (err) {
			//console.log('Error in getLegendItems');
		}


		return _legends;
	};

	self.getLegendTitleClass = function() {
		return (_graphType == 'iphone-transactions') ? ['title', 'truncate', 'regular'] : ['title', 'truncate'];
	};

	self.getLegendSymbolStyle = function (serieIndex) {
		// serie not available
		if (!self.data[activeSlideIndex].graphs[activeGraphIndex].metricSeries[serieIndex]) {
			return {};
		}

		if (groupBy == 'category') {
			var index = 0;
			for (var i = 0; i < self.data[activeSlideIndex].graphs[activeGraphIndex].metricSeries.length; i++) {
				if (self.data[activeSlideIndex].graphs[activeGraphIndex].metricSeries[i].info.category != self.selectedCategory) {
					continue;
				}

				if (index == serieIndex) {
					serieIndex = i;
					break;
				}
				index++;
			}
		}

		return { 'border-color': GraphService.getColorForSerie('chart' + activeSlideIndex, serieIndex) };
	};

	self.getSeriesValue = function (serieIndex) {
		if (groupBy == 'category') {
			var index = 0;
			for (var i = 0; i < self.data[activeSlideIndex].graphs[activeGraphIndex].metricSeries.length; i++) {
				if (self.data[activeSlideIndex].graphs[activeGraphIndex].metricSeries[i].info.category != self.selectedCategory) {
					continue;
				}

				if (index == serieIndex) {
					serieIndex = i;
					break;
				}
				index++;
			}
		}

		var metric = self.data[activeSlideIndex].graphs[activeGraphIndex].metricSeries[serieIndex];
		// metric not available
		if (!metric) {
			activeSeries[activeSlideIndex][serieIndex] = false;
			return 'N/A';
		}

		var value = metric.values[highlightedDataIndex[activeSlideIndex]].value;


		if (!value && value !== 0) {

			//if (angular.isUndefined(value)) {	
			//activeSeries[activeSlideIndex][serieIndex] = false; // don't disable the graph if no value 
			return 'N/A';
		}

		return $filter('numberFormatter')(value, metric.info.unit,2);
	};

	self.hasPrevData = function () {
		return highlightedDataIndex[activeSlideIndex] > 0;
	}

	self.hasNextData = function () {
		if (highlightedDataIndex[activeSlideIndex] == undefined) {
			return false;
		}

		// @TODO: check this logic , it allows navigation to future hours for activations
		// var graph = self.data[activeSlideIndex].graphs[activeGraphIndex];

		// if (_graphType == 'iphone-transactions'){
		// 	return highlightedDataIndex[activeSlideIndex] < graph.metricSeries[0].values.length - 1; 
		// } else {
		// 	return highlightedDataIndex[activeSlideIndex] < maxIndexWithData[activeSlideIndex];
		// }


		return highlightedDataIndex[activeSlideIndex] < maxIndexWithData[activeSlideIndex];

	};

	self.nextData = function () {




		if (self.isTabularGraphViewMode && self.data[activeSlideIndex].supportTabularView) return; // disable date keys on activeSlideIndex tabular view

		if (self.hasNextData()) {
			highlightedDataIndex[activeSlideIndex]++;
			highlightData();
		}
	};

	self.prevData = function () {
		if (self.isTabularGraphViewMode && self.data[activeSlideIndex].supportTabularView) return; // disable date keys on activeSlideIndex tabular view

		if (self.hasPrevData()) {
			highlightedDataIndex[activeSlideIndex]--;
			highlightData();

		}
	};

	self.getDisplayDate = function () {
		var graph = self.data[activeSlideIndex].graphs[activeGraphIndex];

		var format = 'DD MMMM';
		if (graph.metricSeries[0].info.updateSchedule.toUpperCase() == 'MONTHLY') {
			format = 'MMMM';
		}

		//  var shiftHour = false;
		// if (graph.metricSeries[0].info.updateSchedule.toUpperCase() == 'HOURLY') {
		// 	//format = 'DD MMM HH:mm';
		// 	format = 'ha';
		// 	shiftHour = true;
		// }

		var str = graph.metricSeries[0].values[highlightedDataIndex[activeSlideIndex]].date;
		// if (shiftHour) {
		// 	str = moment(str, 'YYYY-MM-DDTHH:mm:ss').add( 1 ,'h').format('YYYY-MM-DDTHH:mm:ss');
		// }


		// if (_graphType == 'activations') {
		// 	str = graph.metricSeries[graph.metricSeries.length - 1].values[highlightedDataIndex[activeSlideIndex]].date;
		// }



		return $filter('dateFormatter')(str, format);
	};
});
