
angular.module('mobility-app').controller('GlossaryCtrl', function ($scope, $state, $window, $timeout, AppInfo, MenuService, backendData) {
	var self = this;

	//-- controller variables - accessed from DOM
	self.currentDate = 'Data loaded at ' + moment().format('MMMM DD, YYYY HH:mm:ss');

	self.data = $.extend(true, {}, backendData);
	self.glossaryElements = null;
	

	//-- MENU CONTROL
	self.toggleSideMenu = function () {
		MenuService.toggle();
	};

	//-- When selecting glossary element
	self.displayGlossary = function (index) {
		self.glossaryElements[index].selected = !self.glossaryElements[index].selected;
	};

	//-- Auto Refresh
	$timeout(function () {
		$state.go($state.current, {}, { reload: true });
	}, AppInfo.RefreshTime);


	function initializeElements() {
		var elements = [];
		if (!self.data.glossaryElements || self.data.glossaryElements.length < 1) return self.data.glossaryElements;
		for (var i = 0; i < self.data.glossaryElements.length; i++) {
			//elements.push($.extend(true, {selected: (i == 0 ? true : false) }, self.data.glossaryElements[i]));
			elements.push($.extend(true, {selected: false }, self.data.glossaryElements[i]));

		}
		return elements;
	};


	//-- INITIALIZATION
	$scope.$on('$ionicView.beforeEnter', function (event) {

		self.glossaryElements = initializeElements();

	});

	//-- draw gauges and graphs after elements are built
	$scope.$on('$ionicView.afterEnter', function (event) {
		//-- redraw gauges and graph on window resize  
		if (!window.cordova) {
			angular.element($window).bind('resize', function () {
				// wrap around a timeout to wait elements resizing before drawing gauges and graphs
				$timeout(function () {
					initialize(true);
				}, 300);
			});
		}

		// a timeout zero, puts the function in next digest cycle.
		$timeout(function () {
			initialize(false);
		}, 0);
	});

	function initialize(isUpdate) {

		if (self.glossaryElements && self.glossaryElements.length > 1) {
			self.glossaryElements[0].selected = true;
		}
	};

});
