
angular.module('mobility-app').controller('SettingsCtrl', function($scope, $localstorage, $cordovaEmailComposer, AppInfo, MenuService, backendData) {
	var self = this;

	function isAutoLoginEnabled() {
		return $localstorage.getAutoLogin() === 'ENABLED';
	};
	
	self.autoLogin = isAutoLoginEnabled();

	self.showAutoLogin = (window.cordova);

	self.currentDate = moment().format('MMMM DD, YYYY');

	//-- MENU CONTROL
	self.toggleSideMenu = function() {
		MenuService.toggle();
	};

	self.copyright = 'Copyright © ' + moment().format('YYYY') + ' Amdocs. All Rights Reserved.';

	self.about = "Reproduction or distribution other than for intended purposes is prohibited, without the prior writen consent of Amdocs. ";
	self.about += "The trademarks and service marks of Amdocs, including the Amdocs mark and logo, Intentional Customer Experience, CES, Clarify, Ensemble, Enabler, Return on Relationship, Intelecable, Collabrent, XACCT, DST Innovis, Stibo Graphic Software, Qpass, Cramer, SigValue, JacobsRimell, ChangingWorlds, jNetX, OpenMarket Inc., MX Telecom Inc., MX Telecom Ltd, Streamezzo, and Bridgewater Systems are exclusive property of Amdocs, and may not be used without permission. ";
	self.about += "All other marks are the property of their respective owners.";

	$scope.$on('$ionicView.beforeEnter', function() {
		self.autoLogin = isAutoLoginEnabled();
	});

	self.getAppName = function() {
		return AppInfo.AppName;
	};

	self.getVersion = function() {
		return window.cordova ? 'v' + AppInfo.AppVersion : 'Web';
	};

	self.getName = function() {
		var user = backendData.user;
		return (user.firstName + ' ' + user.lastName).toLowerCase();
	};

	self.getEmail = function() {
		return backendData.user.email;
	};

	self.toggle = function() {
		if (self.autoLogin) {
			$localstorage.setAutoLogin('ENABLED');
		} else {
			$localstorage.setAutoLogin('DISABLED');
		}
	};

	self.sendEmail = function() {
		var mailTo = '';
		var mailSubject = AppInfo.AppName;
		var mailBody = moment().format("DD MMM YYYY - h:mm A");

		if (window.cordova) {
			$cordovaEmailComposer.isAvailable().then(function() {
				var email = {
					//app: emailApp,
					to: mailTo,
					subject: mailSubject,
					body: mailBody,
					isHtml: false
				};
				$cordovaEmailComposer.open(email).then(null, function () {
					// user cancelled email
				});
			}, function () {
				alert('Email application is not available');
				return;
			});
		}
		else {
			window.location.href = "mailto:" + mailTo
	             + "?subject=" + escape(mailSubject)
	             + "&body=" + escape(mailBody);
		}
	};
});
