
angular.module('mobility-app').controller('SystemHealthCtrl', function($scope, $timeout, $state, $ionicLoading, $ionicViewSwitcher, $filter, AppInfo, MenuService, GaugeService, backendData) {
	var self = this;

	//-- controller variables - accessed from DOM
	self.currentDate = 'Data loaded at ' + moment().format('MMMM DD, YYYY HH:mm:ss');

	self.data = $.extend(true, {}, backendData);
	self.metrics = null;

	self.getClasses = function(metric) {
		var clazz = metric.status.toLowerCase() + ' ';
		var str = metric.system.toLowerCase();

		if (str.indexOf('ordering') >= 0) {
			clazz += 'oms';
		}
		else if (str.indexOf('crm') >= 0) {
			clazz += 'crm';
		}
		else if (str == 'invoicing') {
			clazz += 'inv';
		}
		else if (str.indexOf('activator') >= 0) {
			clazz += 'cm';
		}
		else if (str.indexOf('turbo') >= 0) {
			clazz += 'ar';
		}
		else if (str.indexOf('eod') >= 0) {
			clazz += 'rpl';
		}
		else if (str.indexOf('multi-channel') >= 0) {
			clazz += 'olc';
		}

		return clazz;
	};

	self.goToGraph = function (system) {
		var type;
		
		var str = system.toLowerCase();

		if (str.indexOf('ordering') >= 0) {
			type = 'oms-completion';
		}
		else if (str.indexOf('crm') >= 0) {
			type = 'crm-backlog';
		}
		else if (str == 'invoicing') {
			type = 'invoicing';
		}
		else if (str.indexOf('activator') >= 0) {
			type = 'activator';
		}
		else if (str.indexOf('pre') >= 0) {
			type = 'tc-prepaid';
		}
		else if (str.indexOf('post') >= 0) {
			type = 'tc-postpaid';
		}
		else if (str.indexOf('eod') >= 0) {
			type = 'eod-completion';
		}
		else if (str.indexOf('multi-channel') >= 0) {
			type = 'mcss';
		}

		if (!type) return;

		$timeout.cancel(promise);
		$ionicLoading.show();
		window.cordova ? $ionicViewSwitcher.nextDirection("forward") : $ionicViewSwitcher.nextDirection("swap");
		$state.go('app.charts', { title: system, type: 'system-health/' + type, previous: $state.current.name });
	};

	//-- MENU CONTROL
	self.toggleSideMenu = function() {
		MenuService.toggle();
	};
	

	//-- Auto Refresh
	var promise = $timeout(function() {
		$state.go($state.current, {}, {reload: true});
	}, AppInfo.RefreshTime);

	//-- INITIALIZATION
	function getMetricValue(metric) {
		if (metric.info.unit == 'HOURS') {
			return $filter('convertHours')(metric.value.value);
		}

		if (metric.info.unit == 'MINUTES') {
			return $filter('convertMinutes')(metric.value.value);
		}

		var value = $filter('number')(metric.value.value);
		if (metric.info.unit == 'PERCENTAGE') {
			value += '%';
		}
		return value;
	};

	function initializeMetrics() {
		var metrics = {};

		var str;
		for (var i=0; i < self.data.gauges.length; i++) {
			str = self.data.gauges[i].metric.info.name.split(' - ');
			str[0] = str[0].trim();
			metrics[str[0]] = {
				system: str[0],
				title: str[1].trim(),
				value: getMetricValue(self.data.gauges[i].metric),
				status: self.data.gauges[i].metric.value.status
			};
		}

		return metrics;
	};

	//-- re-structure the data coming from backend
	$scope.$on('$ionicView.beforeEnter', function(event) {
		self.metrics = initializeMetrics();
	});

});
