
angular.module('mobility-app')

	.constant('$ionicLoadingConfig', {
		template: '<ion-spinner></ion-spinner>',
		noBackdrop: false,
		hideOnStateChange: true
	})

	.config(function ($httpProvider, $ionicConfigProvider, $urlRouterProvider, $stateProvider) {

		//$httpProvider.interceptors.push('BackendServiceInterceptor');
		$httpProvider.interceptors.push('EDSAuthHttpResponseInterceptor');
		$httpProvider.defaults.cache = false;

		$ionicConfigProvider.views.maxCache(0); // do not cache views
		$ionicConfigProvider.views.swipeBackEnabled(false); // disable swipe back 

		$ionicConfigProvider.scrolling.jsScrolling(false); // enables native scrolling

		// to support web version
		if (window.cordova) {
			$urlRouterProvider.otherwise('/login');
		}
		else {
			$httpProvider.defaults.headers.common['Device-Type'] = 'browser';
			$urlRouterProvider.otherwise('/app/dashboard');

		}


		var removeTLGMinMaxMetrics = function (response) {

			var _modifiedResponse = response;

			var _tlgIndex = -1;
			for (var index = 0; index < response[0].graphs.length; index++) {
				if (response[0].graphs[index].title === "TLG Transactions per Minute") {
					_tlgIndex = index;
					break;
				}
			}


			if (_tlgIndex != -1) {

				var _metricSeries = response[0].graphs[_tlgIndex].metricSeries;
				var _filteredMetricSeries = [];
				var _minMaxObject = {};

				for (var i = 0; i < _metricSeries.length; i++) {
					if ((_metricSeries[i].info.name === '25% TPM Limit') || (_metricSeries[i].info.name === '120% TPM Limit')) {
						// add to min max object
						if (_metricSeries[i].info.name === '25% TPM Limit') {
							_minMaxObject.min = {
								"value": _metricSeries[i].values[0].value,
								"text": _metricSeries[i].info.name
							};
						} else if (_metricSeries[i].info.name === '120% TPM Limit') {
							_minMaxObject.max = {
								"value": _metricSeries[i].values[0].value,
								"text": _metricSeries[i].info.name
							};
						}

						continue;
					}
					_filteredMetricSeries.push(_metricSeries[i]);
				}

				_modifiedResponse[0].graphs[_tlgIndex].metricSeries = _filteredMetricSeries.slice(0);

				if (_minMaxObject.min && _minMaxObject.max) {
					_modifiedResponse[0].graphs[_tlgIndex].minMaxValue = _minMaxObject;
				}
			}

			return _modifiedResponse;



		};



		var formatiPhoneTransactionsWeeklyTitles1 = function (response) {
			var _modifiedResponse = response;
			var _graphs = [];
			var _metricSeries = [];
			var _filteredMetricSeries = [];
			var _firstDateStr = "";
			var _dateStr = "";

			if (response[0].title.toLowerCase().indexOf('iphone transactions weekly') == 0) {
				// define the graphs titels


				// loop thru all graphs:
				// align graph title to include date
				// align metrics titles to include date
				// modify matrics value dates
				_graphs = response[0].graphs;

				for (var i = 0; i < _graphs.length; i++) {
					_filteredMetricSeries = [];
					if (_graphs[i].title.indexOf('Day-0') != -1) {
						_firstDateStr = _graphs[i].metricSeries[0].values[0].date || "";
					}

					if (_firstDateStr) {
						_dateStr = moment(_firstDateStr, 'YYYY-MM-DDTHH:mm:ss').subtract(i, 'd').format('dddd, MMM DD');
						_graphs[i].title = _graphs[i].title.replace('Day-' + i, '@^@' + _dateStr);

						_metricSeries = _graphs[i].metricSeries;

						// loop thru metrics, change titles and value date
						for (var y = 0; y < _metricSeries.length; y++) {

							//replace the name
							_metricSeries[y].info.name = _metricSeries[y].info.name.replace('Day-' + i, '@^@' + _dateStr);
							// align the date in the values
							_metricSeries[y].values = _metricSeries[y].values.map(function (value) {
								value.date = moment(value.date, 'YYYY-MM-DDTHH:mm:ss').subtract(i, 'd').format('YYYY-MM-DDTHH:mm:ss');
								return value;
							});

							_filteredMetricSeries.push(_metricSeries[y]);

						}
						_graphs[i].metricSeries = _filteredMetricSeries.slice(0);
					}
				}




				_modifiedResponse[0].graphs[0].title = "Weekly";
				_modifiedResponse[0].title = "Weekly";

			}


			if (response[1].title.toLowerCase().indexOf('iphone transactions monthly') == 0) {
				_modifiedResponse[1].graphs[0].title = "Monthly";
				_modifiedResponse[1].title = "Monthly";

				_metricSeries = _modifiedResponse[1].graphs[0].metricSeries;
				_filteredMetricSeries = [];

				for (var z = 0; z < _metricSeries.length; z++) {
					_metricSeries[z].info.name = _metricSeries[z].info.name.replace('Transactions Daily', '@^@Monthly');
					_filteredMetricSeries.push(_metricSeries[z]);
				}

				_modifiedResponse[1].graphs[0].metricSeries = _filteredMetricSeries.slice(0);

			}





			return _modifiedResponse;



		};


		var formatiPhoneTransactionsWeeklyTitles = function (response) {
			var _modifiedResponse = response;
			var _graphs = [];
			var _metricSeries = [];
			var _filteredMetricSeries = [];
			var _firstDateStr = "";
			var _dateStr = "";
			var _gauges = [];
			var _filteredGauges = [];

			

			if (response[0].title.toLowerCase().indexOf('iphone transactions weekly') == 0) {
				_modifiedResponse[0].graphs[0].title = "Weekly";
				_modifiedResponse[0].title = "Weekly";

				_metricSeries = _modifiedResponse[0].graphs[0].metricSeries;
				_filteredMetricSeries = [];

				for (var z = 0; z < _metricSeries.length; z++) {
					_metricSeries[z].info.name = _metricSeries[z].info.name.replace('Transactions Daily', '@^@Weekly');
					_filteredMetricSeries.push(_metricSeries[z]);
				}

				_modifiedResponse[0].graphs[0].metricSeries = _filteredMetricSeries.slice(0);



				// modify gauges (tabulare view) dates

				_gauges = response[0].gauges;

				for (var y = 0; y < _gauges.length; y++) {
					// align the date in the metrics values
					_gauges[y].metric.value.date = _gauges[y].majorMetric.value.date = moment(_gauges[y].metric.value.date, 'YYYY-MM-DDTHH:mm:ss').subtract((_gauges.length - y) - 1 , 'd').format('YYYY-MM-DDTHH:mm:ss');
					_filteredGauges.push(_gauges[y]);
				}

				_modifiedResponse[0].gauges = _filteredGauges.slice(0);






			}





			if (response[1].title.toLowerCase().indexOf('iphone transactions monthly') == 0) {
				_modifiedResponse[1].graphs[0].title = "Monthly";
				_modifiedResponse[1].title = "Monthly";

				_metricSeries = _modifiedResponse[1].graphs[0].metricSeries;
				_filteredMetricSeries = [];

				for (var z = 0; z < _metricSeries.length; z++) {
					_metricSeries[z].info.name = _metricSeries[z].info.name.replace('Transactions Daily', '@^@Monthly');
					_filteredMetricSeries.push(_metricSeries[z]);
				}

				_modifiedResponse[1].graphs[0].metricSeries = _filteredMetricSeries.slice(0);

			}





			return _modifiedResponse;



		};





		var formatActivationsWeeklyTitles = function (response) {

			var _modifiedResponse = response;
			var _metricSeries = response[0].graphs[0].metricSeries;


			var _filteredMetricSeries = [];
			var _dateStr = "";

			var _gauges = response[0].gauges;
			var _filteredGauges = [];


			if (response[0].title.toLowerCase().indexOf('activations weekly') == 0) {


				// modify graph dates
				for (var i = 0; i < _metricSeries.length; i++) {

					// align the date in the values

					_metricSeries[i].values = _metricSeries[i].values.map(function (value) {
						value.date = moment(value.date, 'YYYY-MM-DDTHH:mm:ss').subtract((_metricSeries.length - i) - 1, 'd').format('YYYY-MM-DDTHH:mm:ss');
						return value;

					});

					// gat date from first value date
					_dateStr = _metricSeries[i].values[0].date || "";



					_metricSeries[i].info.name = "Activations - " + moment(_dateStr, 'YYYY-MM-DDTHH:mm:ss').format('dddd, MMM DD');

					_filteredMetricSeries.push(_metricSeries[i]);

				}


				// modify gauges (tabulare view) dates


				for (var y = 0; y < _gauges.length; y++) {
					// align the date in the metrics values
					_gauges[y].metric.value.date = _gauges[y].majorMetric.value.date = moment(_gauges[y].metric.value.date, 'YYYY-MM-DDTHH:mm:ss').subtract((_gauges.length - y) - 1, 'd').format('YYYY-MM-DDTHH:mm:ss');
					_filteredGauges.push(_gauges[y]);
				}




				_modifiedResponse[0].graphs[0].metricSeries = _filteredMetricSeries.slice(0);
				_modifiedResponse[0].graphs[0].title = "Weekly";


				_modifiedResponse[0].gauges = _filteredGauges.slice(0);

				_modifiedResponse[0].title = "Weekly";

			}


			if (response[1].title.toLowerCase().indexOf('activations monthly') == 0) {
				_modifiedResponse[1].graphs[0].title = "Monthly";
				_modifiedResponse[1].title = "Monthly";
			}





			return _modifiedResponse;



		};


		var formatActivationsTitles = function (response) {

			var _modifiedResponse = response;
			var _metricSeries = response[0].graphs[0].metricSeries;


			var _filteredMetricSeries = [];
			var _dateStr = "";

			var _gauges = response[0].gauges;
			var _filteredGauges = [];


			if (response[0].title.toLowerCase().indexOf('activations weekly') == 0) {


				// // modify graph dates
				// for (var i = 0 ; i < _metricSeries.length; i++) {

				// 	// align the date in the values

				// 	_metricSeries[i].values = 	_metricSeries[i].values.map(function(value) {
				// 		value.date = moment(value.date, 'YYYY-MM-DDTHH:mm:ss').subtract( (_metricSeries.length - i) - 1 ,'d').format('YYYY-MM-DDTHH:mm:ss');
				// 		return value;

				// 	});

				// 	// gat date from first value date
				// 	_dateStr = _metricSeries[i].values[0].date || "";



				// 	_metricSeries[i].info.name = "Activations - " + moment(_dateStr, 'YYYY-MM-DDTHH:mm:ss').format('dddd, MMM DD') ;

				// 	_filteredMetricSeries.push(_metricSeries[i]);

				// }


				// // modify gauges (tabulare view) dates


				// 	for (var y = 0 ; y < _gauges.length; y++) {
				// 		// align the date in the metrics values
				// 		_gauges[y].metric.value.date = _gauges[y].majorMetric.value.date = moment(_gauges[y].metric.value.date, 'YYYY-MM-DDTHH:mm:ss').subtract( ( _gauges.length - y) - 1 ,'d').format('YYYY-MM-DDTHH:mm:ss');
				// 		_filteredGauges.push(_gauges[y]);
				// 	}




				//		_modifiedResponse[0].graphs[0].metricSeries = _filteredMetricSeries.slice(0);
				_modifiedResponse[0].graphs[0].title = "Weekly";


				//	_modifiedResponse[0].gauges = _filteredGauges.slice(0);

				_modifiedResponse[0].title = "Weekly";

			}


			if (response[1].title.toLowerCase().indexOf('activations monthly') == 0) {
				_modifiedResponse[1].graphs[0].title = "Monthly";
				_modifiedResponse[1].title = "Monthly";
			}





			return _modifiedResponse;



		};




		$stateProvider
			.state('login', {
				url: '/login',
				templateUrl: 'templates/login.html',
				controller: 'LoginCtrl as vm'
			})
			.state('reset', {
				url: '/reset',
				templateUrl: 'templates/login.reset.html',
				controller: 'ResetPasswordCtrl as vm'
			})
			.state('register', {
				url: '/register',
				templateUrl: 'templates/login.register.html',
				controller: 'NewAccountCtrl as vm',
				resolve: {
					backendData: function (BackendService) {
						return BackendService.getPasswordPolicies();
					}
				}
			})

			.state('app', {
				url: '/app',
				abstract: true,
				templateUrl: 'templates/app.html',
				controller: 'AppCtrl as vm'
			})
			.state('app.dashboard', {
				url: '/dashboard',
				resolve: {
					backendData: function (BackendService, $q) {


						var defer = $q.defer();

						BackendService.getDashboardData().then(
							function (response) {
								// remove min max metrics
								defer.resolve(removeTLGMinMaxMetrics(response));
							},
							function (error) {
								defer.reject(error);
							});
						return defer.promise;
					}
				},
				views: {
					'appContent': {
						templateUrl: 'templates/dashboard.html',
						controller: 'DashboardCtrl as vm'
					}
				}
			})
			.state('app.billing', {
				url: '/billing',
				resolve: {
					backendData: function (BackendService) {
						return BackendService.getBillingData();
					}
				},
				views: {
					'appContent': {
						templateUrl: 'templates/billing.html',
						controller: 'BillingCtrl as vm'
					}
				}
			})
			.state('app.revenue', {
				url: '/revenue',
				resolve: {
					backendData: function (BackendService) {
						return BackendService.getRevenueData();
					}
				},
				views: {
					'appContent': {
						templateUrl: 'templates/revenue.html',
						controller: 'RevenueCtrl as vm'
					}
				}
			})
			.state('app.operations', {
				url: '/operations',
				resolve: {
					backendData: function (BackendService) {
						return BackendService.getOperationsData();
					}
				},
				views: {
					'appContent': {
						templateUrl: 'templates/operations.html',
						controller: 'OperationsCtrl as vm'
					}
				}
			})
			.state('app.systemhealth', {
				url: '/systemHealth',
				resolve: {
					backendData: function (BackendService) {
						return BackendService.getSystemHealthData();
					}
				},
				views: {
					'appContent': {
						templateUrl: 'templates/systemhealth.html',
						controller: 'SystemHealthCtrl as vm'
					}
				}
			})
			.state('app.glossary', {
				url: '/glossary',
				resolve: {
					backendData: function (BackendService) {
						return BackendService.getGlossaryData();
					}
				},
				views: {
					'appContent': {
						templateUrl: 'templates/glossary.html',
						controller: 'GlossaryCtrl as vm'
					}
				}
			})
			.state('app.settings', {
				url: '/settings',
				resolve: {
					backendData: function (BackendService) {
						return BackendService.getUserProfile();
					}
				},
				views: {
					'appContent': {
						templateUrl: 'templates/settings.html',
						controller: 'SettingsCtrl as vm'
					}
				}
			})
			.state('app.charts', {
				url: '/charts',
				params: {
					title: '',
					type: '',
					previous: 'app.dashboard',
					previousIndex: 0,
					graphIndex: -1,
					groupBy: 'title'
				},
				resolve: {
					previousState: function ($q, $localstorage, $stateParams) {
						var defer = $q.defer();

						var params = $stateParams;
						if (params.type == '') {
							params = $localstorage.getObject('chartPreviousState');
						}

						if (!params || !params.previous || params.previous.length < 1) {
							defer.resolve($stateParams.previous);
						}
						defer.resolve(params.previous);

						return defer.promise;
					},
					backendData: function ($stateParams, $q, $localstorage, BackendService, MenuService) {
						var defer = $q.defer();

						var params = $stateParams;
						if (params.type == '') {
							params = $localstorage.getObject('chartPreviousState');
							if (!params || !params.type || params.type == '') {
								defer.resolve([]);
								return defer.promise;
							}

							MenuService.selectMenu(params.previous);
						}
						else {
							$localstorage.setObject('chartPreviousState', params);
						}

						if (params.type.indexOf('bill-cycle') >= 0) {
							BackendService.getBillCycleGraph(params.type).then(
								function (response) {
									defer.resolve(response);
								},
								function (error) {
									defer.reject(error);
								});
						} else if (params.type.indexOf('tlg-tpm') >= 0) {
							BackendService.getTlgTpmGraphs().then(
								function (response) {
									// remove min max metrics
									defer.resolve(removeTLGMinMaxMetrics(response));
								},
								function (error) {
									defer.reject(error);
								});
						} else if (params.type.indexOf('activations') >= 0) {
							BackendService.getWeekMonthGraphs('overview/activations').then(
								function (response) {
									// format titles for weekly
									defer.resolve(formatActivationsTitles(response));
								},
								function (error) {
									defer.reject(error);
								});
						} else if (params.type.indexOf('iphone-transactions') >= 0) {
							BackendService.getWeekMonthGraphs('overview/iphone-transactions').then(
								function (response) {
									// format titles for weekly
									defer.resolve(formatiPhoneTransactionsWeeklyTitles(response));
									//defer.resolve(response);
								},
								function (error) {
									defer.reject(error);
								});
						} else {


							// by default expand only weekly and monthly


							BackendService.getWeekMonthGraphs(params.type).then(
								function (response) {
									defer.resolve(response);
								},
								function (error) {
									defer.reject(error);
								});





							// BackendService.getWeekMonthQuarterGraphs(params.type).then(
							// 	function (response) {
							// 		defer.resolve(response);
							// 	},
							// 	function (error) {
							// 		defer.reject(error);
							// 	});
						}

						return defer.promise;
					}
				},
				views: {
					'appContent': {
						templateUrl: 'templates/charts.html',
						controller: 'ChartsCtrl as vm'
					}
				}
			})
			.state('app.report', {
				url: '/report',
				resolve: {
					reportFile: function ($q, $templateCache, BackendService) {
						var defer = $q.defer();
						BackendService.getReport().then(function (fileContent) {
							$templateCache.put('report.html', fileContent);
							defer.resolve('report.html');
						},
							function (error) {
								defer.reject(error);
							});
						return defer.promise;
					}
				},
				views: {
					'appContent': {
						templateUrl: 'templates/report.html',
						controller: 'ReportCtrl as vm'
					}
				}
			})
			.state('app.pdf', {
				url: '/pdf',
				params: {
					fileName: ''
				},
				resolve: {
					pdfFile: function ($stateParams, FileService) {
						return FileService.downloadFile($stateParams.fileName);
					}
				},
				views: {
					'appContent': {
						templateUrl: 'templates/pdf.html',
						controller: 'PdfCtrl as vm'
					}
				}
			});
	});
