
angular.module('mobility-app').service('MenuService', function($state, $ionicLoading, $ionicViewSwitcher) {
	var self = this;
	var selectCallBack;
	var asyncValue;

	self.close = function() {
		$('.app-content, .left-menu').removeClass('open');
	};

	self.toggle = function() {
		$('.app-content, .left-menu').toggleClass('open');
	};

	self.goTo = function(state) {
		$ionicLoading.show();
		$ionicViewSwitcher.nextDirection("enter");
		$state.go('app.' + state).then(function() {
			self.close();
		});
	};

	//-- Call back from App Controller, allow other controllers to change the menu selection
	self.registerSelectCallBack = function(callBack) {
		selectCallBack = callBack;
		if (asyncValue) {
			callBack(asyncValue);
			asyncValue = null;
		}
	};

	self.selectMenu = function(state) {
		if (selectCallBack) {
			selectCallBack(state);
		}
		else {
			asyncValue = state;
		}
	};
});
