
angular.module('mobility-app').service('UpdateService', function (AppInfo, $q, $http, $timeout, $ionicPopup, $ionicLoading) {
	var self = this;


	self.update = function () {
		var defer = $q.defer();


		$http.get(AppInfo.UpdateURL, {
			timeout: 30000, // limit to 30 sec timeout for update URL
			headers: {
				'If-Modified-Since': 0,
				'Cache-Control': 'no-cache, no-store, must-revalidate'
			}
		}).
		success(function (data, status, headers, config) {
				if (data.hasOwnProperty('version') && (data.version != AppInfo.AppVersion)) {
					$ionicLoading.hide();

					$ionicPopup.confirm({
						title: 'New Version',
						template: 'Version ' + data.version + ' is available. Would you like to download it?',
						okText: 'Download'
					})
						.then(function (userChosenDownload) {
							if (userChosenDownload) {
								$ionicLoading.show();
								if (ionic.Platform.isAndroid()) {
									downloadFile(data.AndroidUpdateURL).then(function (success) {
										defer.resolve();
									},
										function (error) {
											alert(error);
											defer.resolve();
										});
								}
								else if (ionic.Platform.isIOS()) {
									window.location.href = "itms-services://?action=download-manifest&url=" + data.iOSUpdateURL;
									defer.resolve();
								}
							}
						});
				} else {
					defer.resolve();
				}
			}).
			error(function (data, status, headers, config) {
				defer.resolve(); // resolve with no errors
			});




		// $http.get(AppInfo.UpdateURL, { timeout: 30000 , // limit to 30 sec timeout for update URL
		// 	headers: {
		// 		'If-Modified-Since': 0,
		// 		'Cache-Control': 'no-cache, no-store, must-revalidate'
		// 	} 
		// }).then(  

		// 	function (data) {

		// 		if (data.hasOwnProperty('version') && (data.version != AppInfo.AppVersion)) {
		// 			$ionicLoading.hide();

		// 			$ionicPopup.confirm({
		// 				title: 'New Version',
		// 				template: 'Version ' + data.version + ' is available. Would you like to download it?',
		// 				okText: 'Download'
		// 			})
		// 				.then(function (userChosenDownload) {
		// 					if (userChosenDownload) {
		// 						$ionicLoading.show();
		// 						if (ionic.Platform.isAndroid()) {
		// 							downloadFile(data.AndroidUpdateURL).then(function (success) {
		// 								defer.resolve();
		// 							},
		// 								function (error) {
		// 									alert(error);
		// 									defer.resolve();
		// 								});
		// 						}
		// 						else if (ionic.Platform.isIOS()) {
		// 							window.location.href = "itms-services://?action=download-manifest&url=" + data.iOSUpdateURL;
		// 							defer.resolve();
		// 						}
		// 					}
		// 				});
		// 		} else {
		// 			defer.resolve();
		// 		}


		// 	},
		// 	function (error) {
		// 		//console.log('Error occurred in updating the URL. ' + JSON.stringify(error));
		// 		defer.resolve(); // resolve with no errors
		// 	}
		// );




		return defer.promise;
	};



	function downloadFile(fileName) {
		var defer = $q.defer();

		var file = fileName.substring(fileName.lastIndexOf('/') + 1);
		var targetPath = cordova.file.externalCacheDirectory + file;

		new FileTransfer().download(
			encodeURI(fileName),
			targetPath,
			function (entry) {
				window.plugins.webintent.startActivity({
					action: window.plugins.webintent.ACTION_VIEW,
					url: entry.toURL(),
					type: 'application/vnd.android.package-archive'
				},
					function () {
						defer.resolve();
					},
					function (error) {
						//console.log('Failed to install application: ' + JSON.stringify(error))
						defer.reject('Failed to install application.');
					});
			},
			function (error) {
				//console.log('Failed to download application: ' + JSON.stringify(error));
				defer.reject('Failed to download application.');
			},
			false, {}
		);

		return defer.promise;
	};
});
