
angular.module('mobility-app').service('UserService', function(AppInfo, $injector, $q, $localstorage) {
	var self = this;

	var user = {};
	var profiles = [];

	// self.getCurrentUser = function() {
	// 	return user.userId;
	// };

	self.getUserDetails = function() {
		return user;
	};

	self.getUserProfile = function() {

		var defer = $q.defer();
		if (AppInfo.useMockedData) {
			defer.resolve({
				user: {
					firstName: 'Lorem',
					lastName: 'Ipsum',
					email: 'no@contact.com'
				}
			});

			return defer.promise;
		}

		var request = {
			method: 'GET',
			url: AppInfo.ServicesURL + '/users/profiles?date=' + new Date().getTime()
		};

		var BackendResponseHandling = $injector.get('BackendResponseHandling');
		var $http = $injector.get('$http');

		$http(request).then(
			function(response) {
				var handledResponse = BackendResponseHandling.handle(response);
				if (handledResponse) {
					user = handledResponse.user;
					profiles = handledResponse.profiles;
					defer.resolve(handledResponse);
				}
				else {
					BackendResponseHandling.handleError(response);
					defer.reject(response);
				}
			},
			function(error) {
				BackendResponseHandling.handleError(error);
				defer.reject(error);
			}
		);

		return defer.promise;
	};

	/*self.authenticate = function(userId, pass) {
		user = {
			'userId': userId
		};

		// save user id and basic auth to enable auto login
		$localstorage.setBasicAuth(userId, pass);

		var defer = $q.defer();
		if (AppInfo.useMockedData) {
			defer.resolve(userId);
			return defer.promise;
		}

		var request = {
			method: 'GET',
			url: AppInfo.ServicesURL + '/users/profiles?date=' + new Date().getTime(),
			headers: {
				'auth-att-uid': userId
			}
		};

		var BackendResponseHandling = $injector.get('BackendResponseHandling');
		var $http = $injector.get('$http');

		$http(request).then(
			function(response) {
				var handledResponse = BackendResponseHandling.handle(response);
				if (handledResponse) {
					if (handledResponse.user) {
						if (!handledResponse.user.active) {
							var error = {message: 'User is not active'};
							BackendResponseHandling.handleError(error);
							defer.reject(error);
						}
						user = handledResponse.user;
						profiles = handledResponse.profiles;
					}
					defer.resolve(handledResponse);
				}
				else {
					defer.reject();
				}
			},
			function(error) {
				BackendResponseHandling.handleError(error);
				defer.reject(error);
			}
		);
		return defer.promise;
	}*/
});
