
function getMockGraphWithVariantData(title, startDate, endDate) {
	return {
		"id": 1,
		"title": title,
		"subTitle": "Daily",
		"metricSeries": [
			{
				"info": {
					"id": 1481,
					"name": title,
					"unit": "VALUE",
					"updateSchedule": "DAILY"
				},
				"values": [
					{
						"date": "2017-2-11T00:00:00 -0500",
						"value": 22000,
						"status": "GRAY"
					},
					{
						"date": "2017-2-12T00:00:00 -0500",
						"value": 81000,
						"status": "GRAY"
					},
					{
						"date": "2017-2-13T00:00:00 -0500",
						"value": 115000,
						"status": "GRAY"
					},
					{
						"date": "2017-2-14T00:00:00 -0500",
						"value": 40000,
						"status": "GRAY"
					},
					{
						"date": "2017-2-15T00:00:00 -0500",
						"value": 90000,
						"status": "GRAY"
					},
					{
						"date": "2017-2-16T00:00:00 -0500",
						"value": 39000,
						"status": "GRAY"
					},
					{
						"date": "2017-2-17T00:00:00 -0500",
						"value": 90000,
						"status": "GRAY"
					}
				]
			},
			{
				"info": {
					"id": 1481,
					"name": title,
					"unit": "VALUE",
					"updateSchedule": "DAILY"
				},
				"values": [
					{
						"date": "2017-2-11T00:00:00 -0500",
						"value": 25000,
						"status": "GRAY"
					},
					{
						"date": "2017-2-12T00:00:00 -0500",
						"value": 85000,
						"status": "GRAY"
					},
					{
						"date": "2017-2-13T00:00:00 -0500",
						"value": 125000,
						"status": "GRAY"
					},
					{
						"date": "2017-2-14T00:00:00 -0500",
						"value": 60000,
						"status": "GRAY"
					},
					{
						"date": "2017-2-15T00:00:00 -0500",
						"value": 80000,
						"status": "GRAY"
					},
					{
						"date": "2017-2-16T00:00:00 -0500",
						"value": 44000,
						"status": "GRAY"
					}
				]
			},
			{
				"info": {
					"id": 1481,
					"name": "Titles Processed Variant",
					"unit": "VALUE",
					"updateSchedule": "DAILY"
				},
				"values": [
					{
						"date": "2017-2-11T00:00:00 -0500",
						"value": [16000, 35000],
						"status": "GRAY"
					},
					{
						"date": "2017-2-12T00:00:00 -0500",
						"value": [66000, 85000],
						"status": "GRAY"
					},
					{
						"date": "2017-2-13T00:00:00 -0500",
						"value": [100000, 122000],
						"status": "GRAY"
					},
					{
						"date": "2017-2-14T00:00:00 -0500",
						"value": [30000, 65000],
						"status": "GRAY"
					},
					{
						"date": "2017-2-15T00:00:00 -0500",
						"value": [70000, 110000],
						"status": "GRAY"
					},
					{
						"date": "2017-2-16T00:00:00 -0500",
						"value": [31000, 45000],
						"status": "GRAY"
					},
					{
						"date": "2017-2-17T00:00:00 -0500",
						"value": [75000, 105000],
						"status": "GRAY"
					}
				]
			}

		],
		"notes": []
	};
};


function getMockActivationWeeklyGraph() {

	var startDate = moment('2017-5-1T00:00:00 -0500', 'YYYY-MM-DDTHH:mm:ss');


	var rndValue = function getRandomInt(min, max) {
		min = Math.ceil(min);
		max = Math.floor(max);
		return Math.floor(Math.random() * (max - min)) + min;
	};



	startDate.add(-1, 'weeks');


	var _values = [];



	var _metricSeries = [];

	for (var i = 0; i < 7; i++) {
		_values = [];

		for (var hour = 0; hour < 24; hour++) {
			_values.push(
				{
					"date": startDate.format(),
					"value": rndValue(200, 20000),
					"status": "GRAY"
				}
			);
			startDate.add(1, 'hours');

		}


		_metricSeries.push({
			"info": {
				"id": "102" + i,
				"name": "Activations - Day" + (i + 1),
				"unit": "HOURLY",
				"updateSchedule": "HOURLY"
			},
			"values": _values
		});
	}


	return {
		"id": 2,
		"title": "Activations",
		"subTitle": "Hourly",
		"metricSeries": _metricSeries,
		"notes": []
	};

};





function createMockWeeklyGraphWithData(title, data) {

	var startDate = moment('2017-2-11T00:00:00 -0500', 'YYYY-MM-DDTHH:mm:ss');

	var _values = [];
	for (var i = 0; i < 7; i++) {
		_values.push(
			{
				"date": startDate.format(),
				"value": data[i],
				"status": "GRAY"
			}
		);
		startDate.add(1, 'days');
	}


	return {
		"id": 2,
		"title": title,
		"subTitle": "Daily",
		"metricSeries": [
			{
				"info": {
					"id": 1011,
					"name": title,
					"unit": "VALUE",
					"updateSchedule": "DAILY"
				},
				"values":
				_values
			}
		],
		"notes": []
	};

};

function createMockMontlyGraphWithData(title, data) {

	var startDate = moment('2017-2-1T00:00:00 -0500', 'YYYY-MM-DDTHH:mm:ss');
	var _values = [];
	var _dayInMonth = startDate.daysInMonth();

	for (var i = 0; i < _dayInMonth; i++) {
		_values.push(
			{
				"date": startDate.format(),
				"value": data[i],
				"status": "GRAY"
			}
		);
		startDate.add(1, 'days');
	}


	return {
		"id": 2,
		"title": title,
		"subTitle": "Daily",
		"metricSeries": [
			{
				"info": {
					"id": 1011,
					"name": title,
					"unit": "VALUE",
					"updateSchedule": "DAILY"
				},
				"values":
				_values
			}
		],
		"notes": []
	};

};

function createMockQuarterlyGraphWithData(title, data) {

	var startDate = moment('2016-10-1T00:00:00 -0500', 'YYYY-MM-DDTHH:mm:ss');

	var _values = [];
	for (var i = 0; i < 13; i++) {
		_values.push(
			{
				"date": startDate.format(),
				"value": data[i],
				"status": "GRAY"
			}
		);
		startDate.add(1, 'weeks');
	}


	return {
		"id": 2,
		"title": title,
		"subTitle": "Daily",
		"metricSeries": [
			{
				"info": {
					"id": 1011,
					"name": title,
					"unit": "VALUE",
					"updateSchedule": "DAILY"
				},
				"values":
				_values
			}
		],
		"notes": []
	};

};


function createMockMinMaxHourlyGraphWithData(title, data, minVal, maxVal) {

	var startDate = moment('2017-04-05T00:00:00 -0500', 'YYYY-MM-DDTHH:mm:ss');




	var _values = [];
	for (var i = 0; i < 24; i++) {




		_values.push(
			{
				"date": startDate.format(),
				"value": data[i],
				"status": "GRAY"
			}
		);
		startDate.add(1, 'h');
	}


	return {
		"id": 2,
		"title": title,
		"subTitle": "Hourly",
		"minValue": minVal,
		"maxValue": maxVal,
		"metricSeries": [
			{
				"info": {
					"id": 1011,
					"name": title,
					"unit": "VALUE",
					"updateSchedule": "HOURLY"
				},
				"values":
				_values
			}
		],
		"notes": []
	};

};



var MockedData = {

	'user': {
		"status": 200,
		"data": {
			"user": {
				"firstName": "lorem",
				"lastName": "ipsium",
				"email": "lorem@amdocs.com",
				"active": true
			},
			"profiles": [
				{
					"id": 0,
					"name": "ITExecutive"
				}
			]
		}
	}
	, 'overview': {
		"status": 200,
		"data": {
			"graphs": [
				{
					"id": 2,
					"title": "TLG Transactions per Minute",
					"metricSeries": [
						{
							"info": {
								"id": 1000,
								"name": "TODAY",
								"unit": "VALUE",
								"updateSchedule": "HOURLY"
							},
							"values": [
								{
									"date": "2017-05-03T00:00:00 -0500",
									"value": 278235,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T01:00:00 -0500",
									"value": 277995,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T02:00:00 -0500",
									"value": 215406,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T03:00:00 -0500",
									"value": 200343,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T04:00:00 -0500",
									"value": 187239,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T05:00:00 -0500",
									"value": 305121,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T06:00:00 -0500",
									"value": 415752,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T07:00:00 -0500",
									"value": 536934,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T08:00:00 -0500",
									"value": 727506,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T09:00:00 -0500",
									"value": 885114,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T10:00:00 -0500",
									"value": 1000452,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T11:00:00 -0500",
									"value": 1001505,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T12:00:00 -0500",
									"value": 1095171,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T13:00:00 -0500",
									"value": 1097427,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T14:00:00 -0500",
									"value": 1084860,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T15:00:00 -0500",
									"value": 1072851,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T16:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T17:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T18:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T19:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T20:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T21:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T22:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T23:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1001,
								"name": "Week ago",
								"unit": "VALUE",
								"updateSchedule": "HOURLY"
							},
							"values": [
								{
									"date": "2017-05-03T00:00:00 -0500",
									"value": 347109,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T01:00:00 -0500",
									"value": 242310,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T02:00:00 -0500",
									"value": 152142,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T03:00:00 -0500",
									"value": 217746,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T04:00:00 -0500",
									"value": 229707,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T05:00:00 -0500",
									"value": 363390,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T06:00:00 -0500",
									"value": 443709,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T07:00:00 -0500",
									"value": 646179,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T08:00:00 -0500",
									"value": 829299,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T09:00:00 -0500",
									"value": 988629,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T10:00:00 -0500",
									"value": 1125798,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T11:00:00 -0500",
									"value": 1154460,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T12:00:00 -0500",
									"value": 1163742,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T13:00:00 -0500",
									"value": 1157070,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T14:00:00 -0500",
									"value": 1185861,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T15:00:00 -0500",
									"value": 1145592,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T16:00:00 -0500",
									"value": 1123905,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T17:00:00 -0500",
									"value": 1107639,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T18:00:00 -0500",
									"value": 957132,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T19:00:00 -0500",
									"value": 870390,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T20:00:00 -0500",
									"value": 1518837,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T21:00:00 -0500",
									"value": 726675,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T22:00:00 -0500",
									"value": 600117,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T23:00:00 -0500",
									"value": 349971,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1002,
								"name": "Peak Retail Volume",
								"unit": "VALUE",
								"updateSchedule": "HOURLY"
							},
							"values": [
								{
									"date": "2017-05-03T00:00:00 -0500",
									"value": 245133,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T01:00:00 -0500",
									"value": 202221,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T02:00:00 -0500",
									"value": 199389,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T03:00:00 -0500",
									"value": 156768,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T04:00:00 -0500",
									"value": 155277,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T05:00:00 -0500",
									"value": 204195,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T06:00:00 -0500",
									"value": 445398,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T07:00:00 -0500",
									"value": 689118,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T08:00:00 -0500",
									"value": 963153,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T09:00:00 -0500",
									"value": 968706,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T10:00:00 -0500",
									"value": 1156182,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T11:00:00 -0500",
									"value": 1071246,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T12:00:00 -0500",
									"value": 1060059,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T13:00:00 -0500",
									"value": 1040241,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T14:00:00 -0500",
									"value": 1027458,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T15:00:00 -0500",
									"value": 1027419,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T16:00:00 -0500",
									"value": 1009650,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T17:00:00 -0500",
									"value": 961704,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T18:00:00 -0500",
									"value": 840774,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T19:00:00 -0500",
									"value": 735102,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T20:00:00 -0500",
									"value": 595047,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T21:00:00 -0500",
									"value": 482235,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T22:00:00 -0500",
									"value": 390051,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T23:00:00 -0500",
									"value": 343923,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1003,
								"name": "25% TPM Limit",
								"unit": "VALUE",
								"updateSchedule": "HOURLY"
							},
							"values": [
								{
									"date": "2017-05-03T00:00:00 -0500",
									"value": 1200000,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T01:00:00 -0500",
									"value": 1200000,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T02:00:00 -0500",
									"value": 1200000,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T03:00:00 -0500",
									"value": 1200000,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T04:00:00 -0500",
									"value": 1200000,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T05:00:00 -0500",
									"value": 1200000,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T06:00:00 -0500",
									"value": 1200000,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T07:00:00 -0500",
									"value": 1200000,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T08:00:00 -0500",
									"value": 1200000,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T09:00:00 -0500",
									"value": 1200000,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T10:00:00 -0500",
									"value": 1200000,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T11:00:00 -0500",
									"value": 1200000,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T12:00:00 -0500",
									"value": 1200000,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T13:00:00 -0500",
									"value": 1200000,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T14:00:00 -0500",
									"value": 1200000,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T15:00:00 -0500",
									"value": 1200000,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T16:00:00 -0500",
									"value": 1200000,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T17:00:00 -0500",
									"value": 1200000,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T18:00:00 -0500",
									"value": 1200000,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T19:00:00 -0500",
									"value": 1200000,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T20:00:00 -0500",
									"value": 1200000,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T21:00:00 -0500",
									"value": 1200000,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T22:00:00 -0500",
									"value": 1200000,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T23:00:00 -0500",
									"value": 1200000,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1004,
								"name": "120% TPM Limit",
								"unit": "VALUE",
								"updateSchedule": "HOURLY"
							},
							"values": [
								{
									"date": "2017-05-03T00:00:00 -0500",
									"value": 1980000,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T01:00:00 -0500",
									"value": 1980000,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T02:00:00 -0500",
									"value": 1980000,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T03:00:00 -0500",
									"value": 1980000,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T04:00:00 -0500",
									"value": 1980000,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T05:00:00 -0500",
									"value": 1980000,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T06:00:00 -0500",
									"value": 1980000,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T07:00:00 -0500",
									"value": 1980000,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T08:00:00 -0500",
									"value": 1980000,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T09:00:00 -0500",
									"value": 1980000,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T10:00:00 -0500",
									"value": 1980000,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T11:00:00 -0500",
									"value": 1980000,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T12:00:00 -0500",
									"value": 1980000,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T13:00:00 -0500",
									"value": 1980000,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T14:00:00 -0500",
									"value": 1980000,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T15:00:00 -0500",
									"value": 1980000,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T16:00:00 -0500",
									"value": 1980000,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T17:00:00 -0500",
									"value": 1980000,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T18:00:00 -0500",
									"value": 1980000,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T19:00:00 -0500",
									"value": 1980000,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T20:00:00 -0500",
									"value": 1980000,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T21:00:00 -0500",
									"value": 1980000,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T22:00:00 -0500",
									"value": 1980000,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T23:00:00 -0500",
									"value": 1980000,
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				},
				{
					"id": 1,
					"title": "Activations",
					"metricSeries": [
						{
							"info": {
								"id": 1005,
								"name": "Activations",
								"unit": "VALUE",
								"updateSchedule": "HOURLY"
							},
							"values": [
								{
									"date": "2017-05-03T00:00:00 -0500",
									"value": 316,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T01:00:00 -0500",
									"value": 505,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T02:00:00 -0500",
									"value": 146,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T03:00:00 -0500",
									"value": 407,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T04:00:00 -0500",
									"value": 144,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T05:00:00 -0500",
									"value": 368,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T06:00:00 -0500",
									"value": 744,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T07:00:00 -0500",
									"value": 1758,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T08:00:00 -0500",
									"value": 3348,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T09:00:00 -0500",
									"value": 9705,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T10:00:00 -0500",
									"value": 11610,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T11:00:00 -0500",
									"value": 12574,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T12:00:00 -0500",
									"value": 13443,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T13:00:00 -0500",
									"value": 14038,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T14:00:00 -0500",
									"value": 16383,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T15:00:00 -0500",
									"value": 6914,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T16:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T17:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T18:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T19:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T20:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T21:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T22:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T23:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			],
			"gauges": [
				{
					"id": 2,
					"title": "Upgrades and Device Change",
					"systemInfo": {
						"id": 1000,
						"name": "Dashboard"
					},
					"minValue": 0,
					"maxValue": 3000000,
					"direction": "DOWN",
					"metric": {
						"info": {
							"id": 1008,
							"name": "Upgrades Accumulated",
							"unit": "VALUE",
							"updateSchedule": "HOURLY"
						},
						"value": {
							"date": "2017-05-03T15:00:00 -0500",
							"value": 857560,
							"status": "BLUE"
						}
					},
					"majorMetric": {
						"info": {
							"id": 1009,
							"name": "Last Hour",
							"unit": "VALUE",
							"updateSchedule": "HOURLY"
						},
						"value": {
							"date": "2017-05-03T15:00:00 -0500",
							"value": 41988,
							"status": "GRAY"
						}
					},
					"minorMetric": {
						"info": {
							"id": 1010,
							"name": "Checkpoint",
							"unit": "VALUE",
							"updateSchedule": "HOURLY"
						},
						"value": {
							"date": "2017-05-03T15:00:00 -0500",
							"value": 909135,
							"status": "GRAY"
						}
					},
					"startWithStatus": "BLUE",
					"thresholds": [],
					"type": "REGULAR",
					"pcntDiffToMajorMetric": 1943,
					"pcntDiffToMinorMetric": -5,
					"history": [
						{
							"id": 2,
							"title": "Upgrades and Device Change",
							"date": "2017-05-03T07:00:00 -0500",
							"value": 331606,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 2,
							"title": "Upgrades and Device Change",
							"date": "2017-05-03T08:00:00 -0500",
							"value": 373318,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 2,
							"title": "Upgrades and Device Change",
							"date": "2017-05-03T09:00:00 -0500",
							"value": 430086,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 2,
							"title": "Upgrades and Device Change",
							"date": "2017-05-03T10:00:00 -0500",
							"value": 492904,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 2,
							"title": "Upgrades and Device Change",
							"date": "2017-05-03T11:00:00 -0500",
							"value": 564083,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 2,
							"title": "Upgrades and Device Change",
							"date": "2017-05-03T12:00:00 -0500",
							"value": 641718,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 2,
							"title": "Upgrades and Device Change",
							"date": "2017-05-03T13:00:00 -0500",
							"value": 717257,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 2,
							"title": "Upgrades and Device Change",
							"date": "2017-05-03T14:00:00 -0500",
							"value": 795083,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 2,
							"title": "Upgrades and Device Change",
							"date": "2017-05-03T15:00:00 -0500",
							"value": 857560,
							"status": "GREEN",
							"direction": "UP"
						}
					]
				},
				{
					"id": 3,
					"title": "Sim Changes",
					"systemInfo": {
						"id": 1000,
						"name": "Dashboard"
					},
					"minValue": 0,
					"maxValue": 500000,
					"direction": "DOWN",
					"metric": {
						"info": {
							"id": 1011,
							"name": "Sim Changes Accumulated",
							"unit": "VALUE",
							"updateSchedule": "HOURLY"
						},
						"value": {
							"date": "2017-05-03T15:00:00 -0500",
							"value": 41894,
							"status": "BLUE"
						}
					},
					"majorMetric": {
						"info": {
							"id": 1012,
							"name": "Last Hour",
							"unit": "VALUE",
							"updateSchedule": "HOURLY"
						},
						"value": {
							"date": "2017-05-03T15:00:00 -0500",
							"value": 3476,
							"status": "GRAY"
						}
					},
					"minorMetric": {
						"info": {
							"id": 1013,
							"name": "Checkpoint",
							"unit": "VALUE",
							"updateSchedule": "HOURLY"
						},
						"value": {
							"date": "2017-05-03T15:00:00 -0500",
							"value": 44201,
							"status": "GRAY"
						}
					},
					"startWithStatus": "BLUE",
					"thresholds": [],
					"type": "REGULAR",
					"pcntDiffToMajorMetric": 1106,
					"pcntDiffToMinorMetric": -5,
					"history": [
						{
							"id": 3,
							"title": "Sim Changes",
							"date": "2017-05-03T07:00:00 -0500",
							"value": 1484,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 3,
							"title": "Sim Changes",
							"date": "2017-05-03T08:00:00 -0500",
							"value": 3497,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 3,
							"title": "Sim Changes",
							"date": "2017-05-03T09:00:00 -0500",
							"value": 7225,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 3,
							"title": "Sim Changes",
							"date": "2017-05-03T10:00:00 -0500",
							"value": 11990,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 3,
							"title": "Sim Changes",
							"date": "2017-05-03T11:00:00 -0500",
							"value": 17570,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 3,
							"title": "Sim Changes",
							"date": "2017-05-03T12:00:00 -0500",
							"value": 23904,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 3,
							"title": "Sim Changes",
							"date": "2017-05-03T13:00:00 -0500",
							"value": 30376,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 3,
							"title": "Sim Changes",
							"date": "2017-05-03T14:00:00 -0500",
							"value": 36707,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 3,
							"title": "Sim Changes",
							"date": "2017-05-03T15:00:00 -0500",
							"value": 41894,
							"status": "GREEN",
							"direction": "UP"
						}
					]
				},
				{
					"id": 4,
					"title": "Cancellations",
					"systemInfo": {
						"id": 1000,
						"name": "Dashboard"
					},
					"minValue": 0,
					"maxValue": 500000,
					"direction": "UP",
					"metric": {
						"info": {
							"id": 1014,
							"name": "Cancellations Accumulated",
							"unit": "VALUE",
							"updateSchedule": "HOURLY"
						},
						"value": {
							"date": "2017-05-03T15:00:00 -0500",
							"value": 49075,
							"status": "BLUE"
						}
					},
					"majorMetric": {
						"info": {
							"id": 1015,
							"name": "Last Hour",
							"unit": "VALUE",
							"updateSchedule": "HOURLY"
						},
						"value": {
							"date": "2017-05-03T15:00:00 -0500",
							"value": 2609,
							"status": "GRAY"
						}
					},
					"minorMetric": {
						"info": {
							"id": 1016,
							"name": "Checkpoint",
							"unit": "VALUE",
							"updateSchedule": "HOURLY"
						},
						"value": {
							"date": "2017-05-03T15:00:00 -0500",
							"value": 43868,
							"status": "GRAY"
						}
					},
					"startWithStatus": "BLUE",
					"thresholds": [],
					"type": "REGULAR",
					"pcntDiffToMajorMetric": 1781,
					"pcntDiffToMinorMetric": 12,
					"history": [
						{
							"id": 4,
							"title": "Cancellations",
							"date": "2017-05-03T07:00:00 -0500",
							"value": 19976,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 4,
							"title": "Cancellations",
							"date": "2017-05-03T08:00:00 -0500",
							"value": 21794,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 4,
							"title": "Cancellations",
							"date": "2017-05-03T09:00:00 -0500",
							"value": 24157,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 4,
							"title": "Cancellations",
							"date": "2017-05-03T10:00:00 -0500",
							"value": 26949,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 4,
							"title": "Cancellations",
							"date": "2017-05-03T11:00:00 -0500",
							"value": 31398,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 4,
							"title": "Cancellations",
							"date": "2017-05-03T12:00:00 -0500",
							"value": 35466,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 4,
							"title": "Cancellations",
							"date": "2017-05-03T13:00:00 -0500",
							"value": 39858,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 4,
							"title": "Cancellations",
							"date": "2017-05-03T14:00:00 -0500",
							"value": 45003,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 4,
							"title": "Cancellations",
							"date": "2017-05-03T15:00:00 -0500",
							"value": 49075,
							"status": "GREEN",
							"direction": "UP"
						}
					]
				},
				{
					"id": 5,
					"title": "Net Additions",
					"systemInfo": {
						"id": 1000,
						"name": "Dashboard"
					},
					"minValue": 0,
					"maxValue": 500000,
					"direction": "DOWN",
					"metric": {
						"info": {
							"id": 1017,
							"name": "Net Additions Accumulated",
							"unit": "VALUE",
							"updateSchedule": "HOURLY"
						},
						"value": {
							"date": "2017-05-03T15:00:00 -0500",
							"value": 43328,
							"status": "BLUE"
						}
					},
					"majorMetric": {
						"info": {
							"id": 1018,
							"name": "Last Hour",
							"unit": "VALUE",
							"updateSchedule": "HOURLY"
						},
						"value": {
							"date": "2017-05-03T15:00:00 -0500",
							"value": 4305,
							"status": "GRAY"
						}
					},
					"minorMetric": {
						"info": {
							"id": 1019,
							"name": "Checkpoint",
							"unit": "VALUE",
							"updateSchedule": "HOURLY"
						},
						"value": {
							"date": "2017-05-03T15:00:00 -0500",
							"value": 64581,
							"status": "GRAY"
						}
					},
					"startWithStatus": "BLUE",
					"thresholds": [],
					"type": "REGULAR",
					"pcntDiffToMajorMetric": 907,
					"pcntDiffToMinorMetric": -32,
					"history": [
						{
							"id": 5,
							"title": "Net Additions",
							"date": "2017-05-03T07:00:00 -0500",
							"value": -16066,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 5,
							"title": "Net Additions",
							"date": "2017-05-03T08:00:00 -0500",
							"value": -15241,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 5,
							"title": "Net Additions",
							"date": "2017-05-03T09:00:00 -0500",
							"value": -9999,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 5,
							"title": "Net Additions",
							"date": "2017-05-03T10:00:00 -0500",
							"value": -1861,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 5,
							"title": "Net Additions",
							"date": "2017-05-03T11:00:00 -0500",
							"value": 8241,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 5,
							"title": "Net Additions",
							"date": "2017-05-03T12:00:00 -0500",
							"value": 17107,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 5,
							"title": "Net Additions",
							"date": "2017-05-03T13:00:00 -0500",
							"value": 24612,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 5,
							"title": "Net Additions",
							"date": "2017-05-03T14:00:00 -0500",
							"value": 35323,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 5,
							"title": "Net Additions",
							"date": "2017-05-03T15:00:00 -0500",
							"value": 43328,
							"status": "GREEN",
							"direction": "UP"
						}
					]
				}
			],
			"issues": [
				{
					"id": 1000058821,
					"date": "2017-05-03T17:23:53 -0500",
					"details": [
						{
							"Application": "Telegence CSM"
						},
						{
							"Severity": "P1"
						},
						{
							"Start time": "2017-05-03T17:23:53 -0500"
						},
						{
							"Issue": "One of the TLG DR server was down"
						},
						{
							"Business impact": "Business impact is currently under investigation. Detailed business impact will be provided on our next update."
						},
						{
							"Root cause": "N/A"
						},
						{
							"Resolution manager": null
						},
						{
							"User name": "SD707E"
						},
						{
							"Status": "Init"
						},
						{
							"Update notes": null
						}
					]
				},
				{
					"id": 1000058820,
					"date": "2017-05-03T17:21:47 -0500",
					"details": [
						{
							"Application": "Telegence CSM"
						},
						{
							"Severity": "P1"
						},
						{
							"Start time": "2017-05-03T17:21:47 -0500"
						},
						{
							"Issue": "One of the TLG DR server was down"
						},
						{
							"Business impact": "Business impact is currently under investigation. Detailed business impact will be provided on our next update.\r\n"
						},
						{
							"Root cause": "N/A"
						},
						{
							"Resolution manager": null
						},
						{
							"User name": "SD707E"
						},
						{
							"Status": "Init"
						},
						{
							"Update notes": null
						}
					]
				},
				{
					"id": 1000058819,
					"date": "2017-05-03T17:16:42 -0500",
					"details": [
						{
							"Application": "Telegence CSM impacts Mobility Enabler"
						},
						{
							"Severity": "P1"
						},
						{
							"Start time": "2017-05-03T17:16:42 -0500"
						},
						{
							"Issue": "One of the TLG DR server was down"
						},
						{
							"Business impact": "Business impact is currently under investigation. Detailed business impact will be provided on our next update. "
						},
						{
							"Root cause": "N/A"
						},
						{
							"Resolution manager": null
						},
						{
							"User name": "SD707E"
						},
						{
							"Status": "Init"
						},
						{
							"Update notes": null
						}
					]
				},
				{
					"id": 1000058827,
					"date": "2017-05-03T15:54:00 -0500",
					"details": [
						{
							"Application": "YAHOO impacts MPSYS"
						},
						{
							"Severity": "Proactive"
						},
						{
							"Start time": "2017-05-03T15:54:00 -0500"
						},
						{
							"Issue": "YAHOO queues were building up "
						},
						{
							"Business impact": "The ATT Yahoo Members would experience delay or inability to sign into Yahoo Portal or access Yahoo email if password change fails."
						},
						{
							"Root cause": "Support teams suspected to be possbile network issue which caused the queues. Details RC investigation will be done offline by them."
						},
						{
							"Resolution manager": "NA"
						},
						{
							"User name": "OC6055"
						},
						{
							"Status": "Final"
						},
						{
							"Update notes": null
						}
					]
				},
				{
					"id": 1000058826,
					"date": "2017-05-03T14:39:00 -0500",
					"details": [
						{
							"Application": "Lightspeed Enabler"
						},
						{
							"Severity": "P2"
						},
						{
							"Start time": "2017-05-03T14:39:00 -0500"
						},
						{
							"Issue": "Zone 3 servers were not reachable"
						},
						{
							"Business impact": "There was no impact as no application running on Zone 3."
						},
						{
							"Root cause": "It was found that when DRS initiated an automatic VMotion; the VM would get hung and become inaccessible (get disconnected from Network)"
						},
						{
							"Resolution manager": "kp009w"
						},
						{
							"User name": "JV349C"
						},
						{
							"Status": "Init/Final"
						},
						{
							"Update notes": null
						}
					]
				},
				{
					"id": 1000058823,
					"date": "2017-05-03T13:10:00 -0500",
					"details": [
						{
							"Application": "Telegence API impacts CSI"
						},
						{
							"Severity": "Proactive"
						},
						{
							"Start time": "2017-05-03T13:10:00 -0500"
						},
						{
							"Issue": "API support were seeing timeout for CSI client."
						},
						{
							"Business impact": "CSI users would have not been able to perform any account related activities."
						},
						{
							"Root cause": "API support will check on the RCA for the JVM hung and causing impact to CSI . "
						},
						{
							"Resolution manager": "NA"
						},
						{
							"User name": "SD707E"
						},
						{
							"Status": "Final"
						},
						{
							"Update notes": null
						}
					]
				},
				{
					"id": 1000058817,
					"date": "2017-05-03T04:55:42 -0500",
					"details": [
						{
							"Application": "Mediation Data impacts CMG ILB;CMG OFFLINE;Mobility Enabler"
						},
						{
							"Severity": "P1"
						},
						{
							"Start time": "2017-05-03T04:55:42 -0500"
						},
						{
							"Issue": "One of the Mediation database host was seeing high CPU which impacting CMG ILB; CMG OFFLINE and Mobility Enabler."
						},
						{
							"Business impact": "CMG ILB - Unable to route and deliver Billing Records to Mediation (late cycle; incorrect bill; etc)\r\nCMG OFFLINE - Unable to route Billing Records to Enabler (late cycle; incorrect bill; etc). Delay in ducs notification\r\nMobility  Enabler - There would have been delay in DUCs notification at Enabler and backlog of degraded files will get accumulated. These degraded files will processed later."
						},
						{
							"Root cause": "System admin would be investigating on the root cause analysis for the impacted server."
						},
						{
							"Resolution manager": "pr859r"
						},
						{
							"User name": "NS6750"
						},
						{
							"Status": "Final"
						},
						{
							"Update notes": null
						}
					]
				},
				{
					"id": 1000058816,
					"date": "2017-05-03T02:43:52 -0500",
					"details": [
						{
							"Application": "Lightspeed Enabler"
						},
						{
							"Severity": "P2"
						},
						{
							"Start time": "2017-05-03T02:43:52 -0500"
						},
						{
							"Issue": "One of the Lightspeed Enabler disaster recovery database server was inaccessible."
						},
						{
							"Business impact": "There was no impact to online as traffic is served by Main environment. Impacted server is disaster recovery."
						},
						{
							"Root cause": "Root cause will be investigated by SA and vendor for the errors seen in the logs."
						},
						{
							"Resolution manager": "pd0618"
						},
						{
							"User name": "NS6750"
						},
						{
							"Status": "Final"
						},
						{
							"Update notes": null
						}
					]
				},
				{
					"id": 1000058815,
					"date": "2017-05-03T02:33:00 -0500",
					"details": [
						{
							"Application": "BDS"
						},
						{
							"Severity": "P2"
						},
						{
							"Start time": "2017-05-03T02:33:00 -0500"
						},
						{
							"Issue": "One of the BDS application server was inaccessible."
						},
						{
							"Business impact": "No impact to online due to redundancy"
						},
						{
							"Root cause": "VM-Ware support found that there is an issue with configuration on the VM server. SA and VM-Ware team will investigate further on root cause."
						},
						{
							"Resolution manager": "ld667u"
						},
						{
							"User name": "SR383P"
						},
						{
							"Status": "Final"
						},
						{
							"Update notes": null
						}
					]
				},
				{
					"id": 1000058818,
					"date": "2017-05-03T01:00:44 -0500",
					"details": [
						{
							"Application": "LS CRM"
						},
						{
							"Severity": "Proactive"
						},
						{
							"Start time": "2017-05-03T01:00:44 -0500"
						},
						{
							"Issue": "The integrated conversion for today has been completed."
						},
						{
							"Business impact": "There was no impact to production."
						},
						{
							"Root cause": "This was done as a part of Change Request ."
						},
						{
							"Resolution manager": null
						},
						{
							"User name": "KK499C"
						},
						{
							"Status": "Init/Final"
						},
						{
							"Update notes": null
						}
					]
				},
				{
					"id": 1000058812,
					"date": "2017-05-02T19:18:00 -0500",
					"details": [
						{
							"Application": "Lightspeed Enabler"
						},
						{
							"Severity": "P2"
						},
						{
							"Start time": "2017-05-02T19:18:00 -0500"
						},
						{
							"Issue": "One of the Zone3 application servers was inaccessible"
						},
						{
							"Business impact": "There was no impact as we do not have any application running on Zone 3 yet."
						},
						{
							"Root cause": "ESX team found that the server was migrated at ESX level. This is related to a known issue being addressed in Chronic issue 475465."
						},
						{
							"Resolution manager": "sn216m"
						},
						{
							"User name": "JV349C"
						},
						{
							"Status": "Final"
						},
						{
							"Update notes": "ESX team migrated server back and SA rebooted it. "
						}
					]
				}
			],
			"isMornAvailEnabled": false
		}
	},

	'overview/tlg-tpm': {
		"status": 200,
		"data": {
			"title": "TLG Transactions per Minute",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 2,
					"title": "TLG Transactions per Minute",
					"metricSeries": [
						{
							"info": {
								"id": 1000,
								"name": "TODAY",
								"unit": "VALUE",
								"updateSchedule": "HOURLY"
							},
							"values": [
								{
									"date": "2017-04-14T00:00:00 -0500",
									"value": 314340,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T01:00:00 -0500",
									"value": 366864,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T02:00:00 -0500",
									"value": 311043,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T03:00:00 -0500",
									"value": 284034,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T04:00:00 -0500",
									"value": 264540,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T05:00:00 -0500",
									"value": 321177,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T06:00:00 -0500",
									"value": 466164,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T07:00:00 -0500",
									"value": 625884,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T08:00:00 -0500",
									"value": 840216,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T09:00:00 -0500",
									"value": 1002966,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T10:00:00 -0500",
									"value": 1103778,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T11:00:00 -0500",
									"value": 1117035,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T12:00:00 -0500",
									"value": 1130823,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T13:00:00 -0500",
									"value": 1106838,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T14:00:00 -0500",
									"value": 1066185,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T15:00:00 -0500",
									"value": 1076010,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T16:00:00 -0500",
									"value": 1048209,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T17:00:00 -0500",
									"value": 1101918,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T18:00:00 -0500",
									"value": 924138,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T19:00:00 -0500",
									"value": 837447,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T20:00:00 -0500",
									"value": 753006,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T21:00:00 -0500",
									"value": 626022,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T22:00:00 -0500",
									"value": 574503,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T23:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1001,
								"name": "Week ago",
								"unit": "VALUE",
								"updateSchedule": "HOURLY"
							},
							"values": [
								{
									"date": "2017-04-14T00:00:00 -0500",
									"value": 367368,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T01:00:00 -0500",
									"value": 346041,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T02:00:00 -0500",
									"value": 254190,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T03:00:00 -0500",
									"value": 325404,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T04:00:00 -0500",
									"value": 316125,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T05:00:00 -0500",
									"value": 415059,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T06:00:00 -0500",
									"value": 536871,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T07:00:00 -0500",
									"value": 682650,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T08:00:00 -0500",
									"value": 891372,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T09:00:00 -0500",
									"value": 1055895,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T10:00:00 -0500",
									"value": 1095624,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T11:00:00 -0500",
									"value": 1135257,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T12:00:00 -0500",
									"value": 1145187,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T13:00:00 -0500",
									"value": 1144371,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T14:00:00 -0500",
									"value": 1140915,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T15:00:00 -0500",
									"value": 1135290,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T16:00:00 -0500",
									"value": 1092201,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T17:00:00 -0500",
									"value": 1026591,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T18:00:00 -0500",
									"value": 949749,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T19:00:00 -0500",
									"value": 845310,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T20:00:00 -0500",
									"value": 751902,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T21:00:00 -0500",
									"value": 601968,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T22:00:00 -0500",
									"value": 552450,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T23:00:00 -0500",
									"value": 422220,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1002,
								"name": "Peak Retail Volume",
								"unit": "VALUE",
								"updateSchedule": "HOURLY"
							},
							"values": [
								{
									"date": "2017-04-14T00:00:00 -0500",
									"value": 245133,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T01:00:00 -0500",
									"value": 202221,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T02:00:00 -0500",
									"value": 199389,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T03:00:00 -0500",
									"value": 156768,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T04:00:00 -0500",
									"value": 155277,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T05:00:00 -0500",
									"value": 204195,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T06:00:00 -0500",
									"value": 445398,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T07:00:00 -0500",
									"value": 689118,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T08:00:00 -0500",
									"value": 963153,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T09:00:00 -0500",
									"value": 968706,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T10:00:00 -0500",
									"value": 1156182,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T11:00:00 -0500",
									"value": 1071246,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T12:00:00 -0500",
									"value": 1060059,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T13:00:00 -0500",
									"value": 1040241,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T14:00:00 -0500",
									"value": 1027458,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T15:00:00 -0500",
									"value": 1027419,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T16:00:00 -0500",
									"value": 1009650,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T17:00:00 -0500",
									"value": 961704,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T18:00:00 -0500",
									"value": 840774,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T19:00:00 -0500",
									"value": 735102,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T20:00:00 -0500",
									"value": 595047,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T21:00:00 -0500",
									"value": 482235,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T22:00:00 -0500",
									"value": 390051,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T23:00:00 -0500",
									"value": 343923,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1003,
								"name": "25% TPM Limit",
								"unit": "VALUE",
								"updateSchedule": "HOURLY"
							},
							"values": [
								{
									"date": "2017-04-14T00:00:00 -0500",
									"value": 1200000,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T01:00:00 -0500",
									"value": 1200000,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T02:00:00 -0500",
									"value": 1200000,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T03:00:00 -0500",
									"value": 1200000,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T04:00:00 -0500",
									"value": 1200000,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T05:00:00 -0500",
									"value": 1200000,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T06:00:00 -0500",
									"value": 1200000,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T07:00:00 -0500",
									"value": 1200000,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T08:00:00 -0500",
									"value": 1200000,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T09:00:00 -0500",
									"value": 1200000,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T10:00:00 -0500",
									"value": 1200000,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T11:00:00 -0500",
									"value": 1200000,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T12:00:00 -0500",
									"value": 1200000,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T13:00:00 -0500",
									"value": 1200000,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T14:00:00 -0500",
									"value": 1200000,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T15:00:00 -0500",
									"value": 1200000,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T16:00:00 -0500",
									"value": 1200000,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T17:00:00 -0500",
									"value": 1200000,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T18:00:00 -0500",
									"value": 1200000,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T19:00:00 -0500",
									"value": 1200000,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T20:00:00 -0500",
									"value": 1200000,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T21:00:00 -0500",
									"value": 1200000,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T22:00:00 -0500",
									"value": 1200000,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T23:00:00 -0500",
									"value": 1200000,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1004,
								"name": "120% TPM Limit",
								"unit": "VALUE",
								"updateSchedule": "HOURLY"
							},
							"values": [
								{
									"date": "2017-04-14T00:00:00 -0500",
									"value": 1980000,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T01:00:00 -0500",
									"value": 1980000,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T02:00:00 -0500",
									"value": 1980000,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T03:00:00 -0500",
									"value": 1980000,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T04:00:00 -0500",
									"value": 1980000,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T05:00:00 -0500",
									"value": 1980000,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T06:00:00 -0500",
									"value": 1980000,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T07:00:00 -0500",
									"value": 1980000,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T08:00:00 -0500",
									"value": 1980000,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T09:00:00 -0500",
									"value": 1980000,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T10:00:00 -0500",
									"value": 1980000,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T11:00:00 -0500",
									"value": 1980000,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T12:00:00 -0500",
									"value": 1980000,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T13:00:00 -0500",
									"value": 1980000,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T14:00:00 -0500",
									"value": 1980000,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T15:00:00 -0500",
									"value": 1980000,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T16:00:00 -0500",
									"value": 1980000,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T17:00:00 -0500",
									"value": 1980000,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T18:00:00 -0500",
									"value": 1980000,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T19:00:00 -0500",
									"value": 1980000,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T20:00:00 -0500",
									"value": 1980000,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T21:00:00 -0500",
									"value": 1980000,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T22:00:00 -0500",
									"value": 1980000,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T23:00:00 -0500",
									"value": 1980000,
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	},

	'overview/activations/weekly': {
		"status": 200,
		"data": {
			"title": "Activations Weekly",
			"metrics": [],
			"gauges": [
				{
					"id": 15,
					"title": "Activations Day-6",
					"systemInfo": {
						"id": 1000,
						"name": "Dashboard"
					},
					"direction": "UP",
					"metric": {
						"info": {
							"id": 100506,
							"name": "Activations Day-6",
							"unit": "VALUE",
							"updateSchedule": "HOURLY"
						},
						"value": {
							"date": "2017-05-03T23:00:00 -0500",
							"value": 1238,
							"status": "BLUE"
						}
					},
					"majorMetric": {
						"info": {
							"id": 10050601,
							"name": "Activations Day-6 Previous Week",
							"unit": "VALUE",
							"updateSchedule": "HOURLY"
						},
						"value": {
							"date": "2017-05-03T23:00:00 -0500",
							"value": 1166,
							"status": "GRAY"
						}
					},
					"startWithStatus": "BLUE",
					"thresholds": [],
					"type": "REGULAR",
					"pcntDiffToMajorMetric": 7,
					"history": []
				},
				{
					"id": 14,
					"title": "Activations Day-5",
					"systemInfo": {
						"id": 1000,
						"name": "Dashboard"
					},
					"direction": "DOWN",
					"metric": {
						"info": {
							"id": 100505,
							"name": "Activations Day-5",
							"unit": "VALUE",
							"updateSchedule": "HOURLY"
						},
						"value": {
							"date": "2017-05-03T23:00:00 -0500",
							"value": 1013,
							"status": "BLUE"
						}
					},
					"majorMetric": {
						"info": {
							"id": 10050501,
							"name": "Activations Day-5 Previous Week",
							"unit": "VALUE",
							"updateSchedule": "HOURLY"
						},
						"value": {
							"date": "2017-05-03T23:00:00 -0500",
							"value": 1196,
							"status": "GRAY"
						}
					},
					"startWithStatus": "BLUE",
					"thresholds": [],
					"type": "REGULAR",
					"pcntDiffToMajorMetric": -15,
					"history": []
				},
				{
					"id": 13,
					"title": "Activations Day-4",
					"systemInfo": {
						"id": 1000,
						"name": "Dashboard"
					},
					"direction": "UP",
					"metric": {
						"info": {
							"id": 100504,
							"name": "Activations Day-4",
							"unit": "VALUE",
							"updateSchedule": "HOURLY"
						},
						"value": {
							"date": "2017-05-03T23:00:00 -0500",
							"value": 599,
							"status": "BLUE"
						}
					},
					"majorMetric": {
						"info": {
							"id": 10050401,
							"name": "Activations Day-4 Previous Week",
							"unit": "VALUE",
							"updateSchedule": "HOURLY"
						},
						"value": {
							"date": "2017-05-03T23:00:00 -0500",
							"value": 559,
							"status": "GRAY"
						}
					},
					"startWithStatus": "BLUE",
					"thresholds": [],
					"type": "REGULAR",
					"pcntDiffToMajorMetric": 8,
					"history": []
				},
				{
					"id": 12,
					"title": "Activations Day-3",
					"systemInfo": {
						"id": 1000,
						"name": "Dashboard"
					},
					"direction": "UP",
					"metric": {
						"info": {
							"id": 100503,
							"name": "Activations Day-3",
							"unit": "VALUE",
							"updateSchedule": "HOURLY"
						},
						"value": {
							"date": "2017-05-03T23:00:00 -0500",
							"value": 535,
							"status": "BLUE"
						}
					},
					"majorMetric": {
						"info": {
							"id": 10050301,
							"name": "Activations Day-3 Previous Week",
							"unit": "VALUE",
							"updateSchedule": "HOURLY"
						},
						"value": {
							"date": "2017-05-03T23:00:00 -0500",
							"value": 347,
							"status": "GRAY"
						}
					},
					"startWithStatus": "BLUE",
					"thresholds": [],
					"type": "REGULAR",
					"pcntDiffToMajorMetric": 55,
					"history": []
				},
				{
					"id": 11,
					"title": "Activations Day-2",
					"systemInfo": {
						"id": 1000,
						"name": "Dashboard"
					},
					"direction": "DOWN",
					"metric": {
						"info": {
							"id": 100502,
							"name": "Activations Day-2",
							"unit": "VALUE",
							"updateSchedule": "HOURLY"
						},
						"value": {
							"date": "2017-05-03T23:00:00 -0500",
							"value": 812,
							"status": "BLUE"
						}
					},
					"majorMetric": {
						"info": {
							"id": 10050201,
							"name": "Activations Day-2 Previous Week",
							"unit": "VALUE",
							"updateSchedule": "HOURLY"
						},
						"value": {
							"date": "2017-05-03T23:00:00 -0500",
							"value": 1404,
							"status": "GRAY"
						}
					},
					"startWithStatus": "BLUE",
					"thresholds": [],
					"type": "REGULAR",
					"pcntDiffToMajorMetric": -42,
					"history": []
				},
				{
					"id": 10,
					"title": "Activations Day-1",
					"systemInfo": {
						"id": 1000,
						"name": "Dashboard"
					},
					"direction": "DOWN",
					"metric": {
						"info": {
							"id": 100501,
							"name": "Activations Day-1",
							"unit": "VALUE",
							"updateSchedule": "HOURLY"
						},
						"value": {
							"date": "2017-05-03T23:00:00 -0500",
							"value": 1146,
							"status": "BLUE"
						}
					},
					"majorMetric": {
						"info": {
							"id": 10050101,
							"name": "Activations Day-1 Previous Week",
							"unit": "VALUE",
							"updateSchedule": "HOURLY"
						},
						"value": {
							"date": "2017-05-03T23:00:00 -0500",
							"value": 1413,
							"status": "GRAY"
						}
					},
					"startWithStatus": "BLUE",
					"thresholds": [],
					"type": "REGULAR",
					"pcntDiffToMajorMetric": -18,
					"history": []
				}
			],
			"graphs": [
				{
					"id": 3,
					"title": "Activations Weekly",
					"metricSeries": [
						{
							"info": {
								"id": 100506,
								"name": "Activations Day-6",
								"unit": "VALUE",
								"updateSchedule": "HOURLY"
							},
							"values": [
								{
									"date": "2017-05-03T00:00:00 -0500",
									"value": 741,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T01:00:00 -0500",
									"value": 450,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T02:00:00 -0500",
									"value": 161,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T03:00:00 -0500",
									"value": 317,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T04:00:00 -0500",
									"value": 167,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T05:00:00 -0500",
									"value": 478,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T06:00:00 -0500",
									"value": 663,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T07:00:00 -0500",
									"value": 3484,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T08:00:00 -0500",
									"value": 7849,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T09:00:00 -0500",
									"value": 12565,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T10:00:00 -0500",
									"value": 9240,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T11:00:00 -0500",
									"value": 15857,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T12:00:00 -0500",
									"value": 11715,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T13:00:00 -0500",
									"value": 16711,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T14:00:00 -0500",
									"value": 15211,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T15:00:00 -0500",
									"value": 13830,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T16:00:00 -0500",
									"value": 9785,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T17:00:00 -0500",
									"value": 9878,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T18:00:00 -0500",
									"value": 9725,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T19:00:00 -0500",
									"value": 6120,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T20:00:00 -0500",
									"value": 5428,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T21:00:00 -0500",
									"value": 3261,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T22:00:00 -0500",
									"value": 1574,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T23:00:00 -0500",
									"value": 1238,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 100505,
								"name": "Activations Day-5",
								"unit": "VALUE",
								"updateSchedule": "HOURLY"
							},
							"values": [
								{
									"date": "2017-05-03T00:00:00 -0500",
									"value": 1189,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T01:00:00 -0500",
									"value": 502,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T02:00:00 -0500",
									"value": 496,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T03:00:00 -0500",
									"value": 623,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T04:00:00 -0500",
									"value": 164,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T05:00:00 -0500",
									"value": 3856,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T06:00:00 -0500",
									"value": 6026,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T07:00:00 -0500",
									"value": 6750,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T08:00:00 -0500",
									"value": 8632,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T09:00:00 -0500",
									"value": 7314,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T10:00:00 -0500",
									"value": 8420,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T11:00:00 -0500",
									"value": 10857,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T12:00:00 -0500",
									"value": 9435,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T13:00:00 -0500",
									"value": 10543,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T14:00:00 -0500",
									"value": 9803,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T15:00:00 -0500",
									"value": 9746,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T16:00:00 -0500",
									"value": 9614,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T17:00:00 -0500",
									"value": 8667,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T18:00:00 -0500",
									"value": 8187,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T19:00:00 -0500",
									"value": 6052,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T20:00:00 -0500",
									"value": 5582,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T21:00:00 -0500",
									"value": 2835,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T22:00:00 -0500",
									"value": 1809,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T23:00:00 -0500",
									"value": 1013,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 100504,
								"name": "Activations Day-4",
								"unit": "VALUE",
								"updateSchedule": "HOURLY"
							},
							"values": [
								{
									"date": "2017-05-03T00:00:00 -0500",
									"value": 422,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T01:00:00 -0500",
									"value": 327,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T02:00:00 -0500",
									"value": 279,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T03:00:00 -0500",
									"value": 237,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T04:00:00 -0500",
									"value": 182,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T05:00:00 -0500",
									"value": 570,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T06:00:00 -0500",
									"value": 609,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T07:00:00 -0500",
									"value": 1410,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T08:00:00 -0500",
									"value": 2469,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T09:00:00 -0500",
									"value": 4025,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T10:00:00 -0500",
									"value": 5793,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T11:00:00 -0500",
									"value": 7428,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T12:00:00 -0500",
									"value": 8747,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T13:00:00 -0500",
									"value": 9463,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T14:00:00 -0500",
									"value": 9861,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T15:00:00 -0500",
									"value": 9395,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T16:00:00 -0500",
									"value": 8932,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T17:00:00 -0500",
									"value": 7485,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T18:00:00 -0500",
									"value": 6122,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T19:00:00 -0500",
									"value": 4613,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T20:00:00 -0500",
									"value": 3131,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T21:00:00 -0500",
									"value": 1909,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T22:00:00 -0500",
									"value": 1014,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T23:00:00 -0500",
									"value": 599,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 100503,
								"name": "Activations Day-3",
								"unit": "VALUE",
								"updateSchedule": "HOURLY"
							},
							"values": [
								{
									"date": "2017-05-03T00:00:00 -0500",
									"value": 245,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T01:00:00 -0500",
									"value": 172,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T02:00:00 -0500",
									"value": 105,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T03:00:00 -0500",
									"value": 131,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T04:00:00 -0500",
									"value": 105,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T05:00:00 -0500",
									"value": 98,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T06:00:00 -0500",
									"value": 257,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T07:00:00 -0500",
									"value": 337,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T08:00:00 -0500",
									"value": 659,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T09:00:00 -0500",
									"value": 1632,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T10:00:00 -0500",
									"value": 3230,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T11:00:00 -0500",
									"value": 5080,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T12:00:00 -0500",
									"value": 6130,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T13:00:00 -0500",
									"value": 6813,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T14:00:00 -0500",
									"value": 6752,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T15:00:00 -0500",
									"value": 6632,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T16:00:00 -0500",
									"value": 5324,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T17:00:00 -0500",
									"value": 3806,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T18:00:00 -0500",
									"value": 2830,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T19:00:00 -0500",
									"value": 1991,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T20:00:00 -0500",
									"value": 1349,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T21:00:00 -0500",
									"value": 864,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T22:00:00 -0500",
									"value": 606,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T23:00:00 -0500",
									"value": 535,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 100502,
								"name": "Activations Day-2",
								"unit": "VALUE",
								"updateSchedule": "HOURLY"
							},
							"values": [
								{
									"date": "2017-05-03T00:00:00 -0500",
									"value": 380,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T01:00:00 -0500",
									"value": 250,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T02:00:00 -0500",
									"value": 156,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T03:00:00 -0500",
									"value": 128,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T04:00:00 -0500",
									"value": 112,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T05:00:00 -0500",
									"value": 153,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T06:00:00 -0500",
									"value": 548,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T07:00:00 -0500",
									"value": 1459,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T08:00:00 -0500",
									"value": 3514,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T09:00:00 -0500",
									"value": 5752,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T10:00:00 -0500",
									"value": 7102,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T11:00:00 -0500",
									"value": 8599,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T12:00:00 -0500",
									"value": 9041,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T13:00:00 -0500",
									"value": 9801,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T14:00:00 -0500",
									"value": 9553,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T15:00:00 -0500",
									"value": 10233,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T16:00:00 -0500",
									"value": 9288,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T17:00:00 -0500",
									"value": 9242,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T18:00:00 -0500",
									"value": 7595,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T19:00:00 -0500",
									"value": 5450,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T20:00:00 -0500",
									"value": 4080,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T21:00:00 -0500",
									"value": 2662,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T22:00:00 -0500",
									"value": 1379,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T23:00:00 -0500",
									"value": 812,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 100501,
								"name": "Activations Day-1",
								"unit": "VALUE",
								"updateSchedule": "HOURLY"
							},
							"values": [
								{
									"date": "2017-05-03T00:00:00 -0500",
									"value": 427,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T01:00:00 -0500",
									"value": 208,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T02:00:00 -0500",
									"value": 226,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T03:00:00 -0500",
									"value": 343,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T04:00:00 -0500",
									"value": 119,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T05:00:00 -0500",
									"value": 452,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T06:00:00 -0500",
									"value": 595,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T07:00:00 -0500",
									"value": 1691,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T08:00:00 -0500",
									"value": 2709,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T09:00:00 -0500",
									"value": 4506,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T10:00:00 -0500",
									"value": 5417,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T11:00:00 -0500",
									"value": 7109,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T12:00:00 -0500",
									"value": 6795,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T13:00:00 -0500",
									"value": 7508,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T14:00:00 -0500",
									"value": 9441,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T15:00:00 -0500",
									"value": 10471,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T16:00:00 -0500",
									"value": 9119,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T17:00:00 -0500",
									"value": 7951,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T18:00:00 -0500",
									"value": 7067,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T19:00:00 -0500",
									"value": 4666,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T20:00:00 -0500",
									"value": 3609,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T21:00:00 -0500",
									"value": 2401,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T22:00:00 -0500",
									"value": 930,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T23:00:00 -0500",
									"value": 1146,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1005,
								"name": "Activations",
								"unit": "VALUE",
								"updateSchedule": "HOURLY"
							},
							"values": [
								{
									"date": "2017-05-03T00:00:00 -0500",
									"value": 316,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T01:00:00 -0500",
									"value": 505,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T02:00:00 -0500",
									"value": 146,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T03:00:00 -0500",
									"value": 407,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T04:00:00 -0500",
									"value": 144,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T05:00:00 -0500",
									"value": 368,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T06:00:00 -0500",
									"value": 744,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T07:00:00 -0500",
									"value": 1758,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T08:00:00 -0500",
									"value": 3348,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T09:00:00 -0500",
									"value": 9705,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T10:00:00 -0500",
									"value": 11610,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T11:00:00 -0500",
									"value": 12574,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T12:00:00 -0500",
									"value": 13443,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T13:00:00 -0500",
									"value": 14038,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T14:00:00 -0500",
									"value": 16383,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T15:00:00 -0500",
									"value": 6914,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T16:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T17:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T18:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T19:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T20:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T21:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T22:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T23:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'overview/activations/monthly': {
		"status": 200,
		"data": {
			"title": "Activations Monthly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 4,
					"title": "Activations Monthly",
					"metricSeries": [
						{
							"info": {
								"id": 100507,
								"name": "Activations Daily",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2017-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-04-02T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-04-03T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-04-04T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-04-05T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-04-06T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-04-07T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-04-08T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-04-09T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-04-10T00:00:00 -0500",
									"value": 764563,
									"status": "GRAY"
								},
								{
									"date": "2017-04-11T00:00:00 -0500",
									"value": 1543234,
									"status": "GRAY"
								},
								{
									"date": "2017-04-12T00:00:00 -0500",
									"value": 1587394,
									"status": "GRAY"
								},
								{
									"date": "2017-04-13T00:00:00 -0500",
									"value": 1308118,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T00:00:00 -0500",
									"value": 1487006,
									"status": "GRAY"
								},
								{
									"date": "2017-04-15T00:00:00 -0500",
									"value": 811277,
									"status": "GRAY"
								},
								{
									"date": "2017-04-16T00:00:00 -0500",
									"value": 247532,
									"status": "GRAY"
								},
								{
									"date": "2017-04-17T00:00:00 -0500",
									"value": 1357787,
									"status": "GRAY"
								},
								{
									"date": "2017-04-18T00:00:00 -0500",
									"value": 1576384,
									"status": "GRAY"
								},
								{
									"date": "2017-04-19T00:00:00 -0500",
									"value": 1323935,
									"status": "GRAY"
								},
								{
									"date": "2017-04-20T00:00:00 -0500",
									"value": 1457390,
									"status": "GRAY"
								},
								{
									"date": "2017-04-21T00:00:00 -0500",
									"value": 1226379,
									"status": "GRAY"
								},
								{
									"date": "2017-04-22T00:00:00 -0500",
									"value": 912101,
									"status": "GRAY"
								},
								{
									"date": "2017-04-23T00:00:00 -0500",
									"value": 508558,
									"status": "GRAY"
								},
								{
									"date": "2017-04-24T00:00:00 -0500",
									"value": 884396,
									"status": "GRAY"
								},
								{
									"date": "2017-04-25T00:00:00 -0500",
									"value": 1525617,
									"status": "GRAY"
								},
								{
									"date": "2017-04-26T00:00:00 -0500",
									"value": 1526386,
									"status": "GRAY"
								},
								{
									"date": "2017-04-27T00:00:00 -0500",
									"value": 1469095,
									"status": "GRAY"
								},
								{
									"date": "2017-04-28T00:00:00 -0500",
									"value": 1398597,
									"status": "GRAY"
								},
								{
									"date": "2017-04-29T00:00:00 -0500",
									"value": 883629,
									"status": "GRAY"
								},
								{
									"date": "2017-04-30T00:00:00 -0500",
									"value": 526881,
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'overview/activations/quarterly': {
		"status": 200,
		"data": {
			"title": "Quarterly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "Total Activations",
					"subTitle": "Weekly",
					"metricSeries": [
						{
							"info": {
								"id": 1005,
								"name": "Total activations",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 163,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 126,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 217,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 112,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 65,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 217,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 130,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 218,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 128,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 84,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 160,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	,'overview/upgrades/weekly': {
		"status": 200,
		"data": {
			"title": "Upgrades and Device Changes Weekly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 10,
					"title": "Upgrades Weekly",
					"metricSeries": [
						{
							"info": {
								"id": 110001,
								"name": "Upgrades Daily",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2017-04-26T00:00:00 -0500",
									"value": 1322803,
									"status": "GRAY"
								},
								{
									"date": "2017-04-27T00:00:00 -0500",
									"value": 1316080,
									"status": "GRAY"
								},
								{
									"date": "2017-04-28T00:00:00 -0500",
									"value": 1525079,
									"status": "GRAY"
								},
								{
									"date": "2017-04-29T00:00:00 -0500",
									"value": 1251118,
									"status": "GRAY"
								},
								{
									"date": "2017-04-30T00:00:00 -0500",
									"value": 952634,
									"status": "GRAY"
								},
								{
									"date": "2017-05-01T00:00:00 -0500",
									"value": 1279853,
									"status": "GRAY"
								},
								{
									"date": "2017-05-02T00:00:00 -0500",
									"value": 1472947,
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'overview/upgrades/monthly': {
		"status": 200,
		"data": {
			"title": "Upgrades and Device Changes Monthly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 11,
					"title": "Upgrades Monthly",
					"metricSeries": [
						{
							"info": {
								"id": 110001,
								"name": "Upgrades Daily",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2017-04-01T00:00:00 -0500",
									"value": 1470145,
									"status": "GRAY"
								},
								{
									"date": "2017-04-02T00:00:00 -0500",
									"value": 1402006,
									"status": "GRAY"
								},
								{
									"date": "2017-04-03T00:00:00 -0500",
									"value": 1377405,
									"status": "GRAY"
								},
								{
									"date": "2017-04-04T00:00:00 -0500",
									"value": 1330699,
									"status": "GRAY"
								},
								{
									"date": "2017-04-05T00:00:00 -0500",
									"value": 1311159,
									"status": "GRAY"
								},
								{
									"date": "2017-04-06T00:00:00 -0500",
									"value": 1341263,
									"status": "GRAY"
								},
								{
									"date": "2017-04-07T00:00:00 -0500",
									"value": 1363603,
									"status": "GRAY"
								},
								{
									"date": "2017-04-08T00:00:00 -0500",
									"value": 1270070,
									"status": "GRAY"
								},
								{
									"date": "2017-04-09T00:00:00 -0500",
									"value": 1047862,
									"status": "GRAY"
								},
								{
									"date": "2017-04-10T00:00:00 -0500",
									"value": 1336582,
									"status": "GRAY"
								},
								{
									"date": "2017-04-11T00:00:00 -0500",
									"value": 1470327,
									"status": "GRAY"
								},
								{
									"date": "2017-04-12T00:00:00 -0500",
									"value": 1357428,
									"status": "GRAY"
								},
								{
									"date": "2017-04-13T00:00:00 -0500",
									"value": 1292541,
									"status": "GRAY"
								},
								{
									"date": "2017-04-14T00:00:00 -0500",
									"value": 1452879,
									"status": "GRAY"
								},
								{
									"date": "2017-04-15T00:00:00 -0500",
									"value": 1253866,
									"status": "GRAY"
								},
								{
									"date": "2017-04-16T00:00:00 -0500",
									"value": 819347,
									"status": "GRAY"
								},
								{
									"date": "2017-04-17T00:00:00 -0500",
									"value": 1319554,
									"status": "GRAY"
								},
								{
									"date": "2017-04-18T00:00:00 -0500",
									"value": 1397711,
									"status": "GRAY"
								},
								{
									"date": "2017-04-19T00:00:00 -0500",
									"value": 1389076,
									"status": "GRAY"
								},
								{
									"date": "2017-04-20T00:00:00 -0500",
									"value": 1438843,
									"status": "GRAY"
								},
								{
									"date": "2017-04-21T00:00:00 -0500",
									"value": 1594777,
									"status": "GRAY"
								},
								{
									"date": "2017-04-22T00:00:00 -0500",
									"value": 1134171,
									"status": "GRAY"
								},
								{
									"date": "2017-04-23T00:00:00 -0500",
									"value": 1054934,
									"status": "GRAY"
								},
								{
									"date": "2017-04-24T00:00:00 -0500",
									"value": 1238805,
									"status": "GRAY"
								},
								{
									"date": "2017-04-25T00:00:00 -0500",
									"value": 1285948,
									"status": "GRAY"
								},
								{
									"date": "2017-04-26T00:00:00 -0500",
									"value": 1322803,
									"status": "GRAY"
								},
								{
									"date": "2017-04-27T00:00:00 -0500",
									"value": 1316080,
									"status": "GRAY"
								},
								{
									"date": "2017-04-28T00:00:00 -0500",
									"value": 1525079,
									"status": "GRAY"
								},
								{
									"date": "2017-04-29T00:00:00 -0500",
									"value": 1251118,
									"status": "GRAY"
								},
								{
									"date": "2017-04-30T00:00:00 -0500",
									"value": 952634,
									"status": "GRAY"
								},
								{
									"date": "2017-05-01T00:00:00 -0500",
									"value": 1279853,
									"status": "GRAY"
								},
								{
									"date": "2017-05-02T00:00:00 -0500",
									"value": 1472947,
									"status": "GRAY"
								},
								{
									"date": "2017-05-03T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-05-04T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-05-05T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-05-06T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-05-07T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-05-08T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-05-09T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-05-10T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-05-11T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-05-12T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-05-13T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-05-14T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-05-15T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-05-16T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-05-17T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-05-18T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-05-19T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-05-20T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-05-21T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-05-22T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-05-23T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-05-24T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-05-25T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-05-26T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-05-27T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-05-28T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-05-29T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-05-30T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2017-05-31T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}


	, 'overview/total-orders/weekly': {
		"status": 200,
		"data": {
			"title": "Weekly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "Total Orders",
					"subTitle": "Daily",
					"metricSeries": [
						{
							"info": {
								"id": 1481,
								"name": "Total Orders",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 182,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 185,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 120,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 213,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 163,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 184,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": [
						{
							"id": 1,
							"type": "G_NOTE",
							"date": "2016-06-20T00:00:00 -0500",
							"title": "Manual Data",
							"details": "Due to fake data entered",
							"elementId": 1
						}
					]
				},

			]
		}
	}

	, 'overview/total-orders/monthly': {
		"status": 200,
		"data": {
			"title": "Monthly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "Total Orders",
					"subTitle": "Daily",
					"metricSeries": [
						{
							"info": {
								"id": 1481,
								"name": "Total Orders",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-05-28T00:00:00 -0500",
									"value": 230,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 157,
									"status": "GRAY"
								},
								{
									"date": "2016-05-30T00:00:00 -0500",
									"value": 148,
									"status": "GRAY"
								},
								{
									"date": "2016-05-31T00:00:00 -0500",
									"value": 89,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 203,
									"status": "GRAY"
								},
								{
									"date": "2016-06-02T00:00:00 -0500",
									"value": 179,
									"status": "GRAY"
								},
								{
									"date": "2016-06-03T00:00:00 -0500",
									"value": 117,
									"status": "GRAY"
								},
								{
									"date": "2016-06-04T00:00:00 -0500",
									"value": 167,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 192,
									"status": "GRAY"
								},
								{
									"date": "2016-06-06T00:00:00 -0500",
									"value": 141,
									"status": "GRAY"
								},
								{
									"date": "2016-06-07T00:00:00 -0500",
									"value": 168,
									"status": "GRAY"
								},
								{
									"date": "2016-06-08T00:00:00 -0500",
									"value": 72,
									"status": "GRAY"
								},
								{
									"date": "2016-06-09T00:00:00 -0500",
									"value": 153,
									"status": "GRAY"
								},
								{
									"date": "2016-06-10T00:00:00 -0500",
									"value": 99,
									"status": "GRAY"
								},
								{
									"date": "2016-06-11T00:00:00 -0500",
									"value": 238,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 230,
									"status": "GRAY"
								},
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 197,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 222,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 156,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 79,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 113,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 90,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 136,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 182,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 185,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 120,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 213,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 163,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 184,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": [
						{
							"id": 1,
							"type": "G_NOTE",
							"date": "2016-06-20T00:00:00 -0500",
							"title": "Manual Data",
							"details": "Due to fake data entered",
							"elementId": 1
						}
					]
				}
			]
		}
	}

	, 'overview/total-orders/quarterly': {
		"status": 200,
		"data": {
			"title": "Quarterly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "Total Orders",
					"subTitle": "Weekly",
					"metricSeries": [
						{
							"info": {
								"id": 1485,
								"name": "Total Orders",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 238,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 182,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 211,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 116,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 55,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 157,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 127,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 77,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 249,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 115,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 171,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'overview/total-subscribers/weekly': {
		"status": 200,
		"data": {
			"title": "Weekly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "Total Subscribers",
					"subTitle": "Daily",
					"metricSeries": [
						{
							"info": {
								"id": 1011,
								"name": "Total Subscribers",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 113,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 67,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 184,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 179,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 68,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 2807274,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'overview/total-subscribers/monthly': {
		"status": 200,
		"data": {
			"title": "Monthly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "Total Subscribers",
					"subTitle": "Daily",
					"metricSeries": [
						{
							"info": {
								"id": 1011,
								"name": "Total Subscribers",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-05-28T00:00:00 -0500",
									"value": 242,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 77,
									"status": "GRAY"
								},
								{
									"date": "2016-05-30T00:00:00 -0500",
									"value": 132,
									"status": "GRAY"
								},
								{
									"date": "2016-05-31T00:00:00 -0500",
									"value": 120,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 110,
									"status": "GRAY"
								},
								{
									"date": "2016-06-02T00:00:00 -0500",
									"value": 87,
									"status": "GRAY"
								},
								{
									"date": "2016-06-03T00:00:00 -0500",
									"value": 104,
									"status": "GRAY"
								},
								{
									"date": "2016-06-04T00:00:00 -0500",
									"value": 244,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 92,
									"status": "GRAY"
								},
								{
									"date": "2016-06-06T00:00:00 -0500",
									"value": 226,
									"status": "GRAY"
								},
								{
									"date": "2016-06-07T00:00:00 -0500",
									"value": 223,
									"status": "GRAY"
								},
								{
									"date": "2016-06-08T00:00:00 -0500",
									"value": 80,
									"status": "GRAY"
								},
								{
									"date": "2016-06-09T00:00:00 -0500",
									"value": 216,
									"status": "GRAY"
								},
								{
									"date": "2016-06-10T00:00:00 -0500",
									"value": 123,
									"status": "GRAY"
								},
								{
									"date": "2016-06-11T00:00:00 -0500",
									"value": 156,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 247,
									"status": "GRAY"
								},
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 138,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 104,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 115,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 54,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 157,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 162,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 91,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 113,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 67,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 184,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 179,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 68,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 2807274,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'overview/total-subscribers/quarterly': {
		"status": 200,
		"data": {
			"title": "Quarterly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "Total Subscribers",
					"subTitle": "Weekly",
					"metricSeries": [
						{
							"info": {
								"id": 1015,
								"name": "Total Subscribers",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 211,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 168,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 107,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 123,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 68,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 154,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 72,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 240,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 119,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 147,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 200,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'overview/total-recharge-transactions/weekly': {
		"status": 200,
		"data": {
			"title": "Weekly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "Total Recharge Transactions",
					"subTitle": "Daily",
					"metricSeries": [
						{
							"info": {
								"id": 1021,
								"name": "Total Recharge transactions",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 6508631,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 6154566,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 6017558,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 6042879,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 6232985,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 6156689,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'overview/total-recharge-transactions/monthly': {
		"status": 200,
		"data": {
			"title": "Monthly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "Total Recharge Transactions",
					"subTitle": "Daily",
					"metricSeries": [
						{
							"info": {
								"id": 1021,
								"name": "Total Recharge transactions",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-05-28T00:00:00 -0500",
									"value": 6478117,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 6210339,
									"status": "GRAY"
								},
								{
									"date": "2016-05-30T00:00:00 -0500",
									"value": 6959847,
									"status": "GRAY"
								},
								{
									"date": "2016-05-31T00:00:00 -0500",
									"value": 6472868,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 6482011,
									"status": "GRAY"
								},
								{
									"date": "2016-06-02T00:00:00 -0500",
									"value": 6491576,
									"status": "GRAY"
								},
								{
									"date": "2016-06-03T00:00:00 -0500",
									"value": 6700670,
									"status": "GRAY"
								},
								{
									"date": "2016-06-04T00:00:00 -0500",
									"value": 6391961,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 6149138,
									"status": "GRAY"
								},
								{
									"date": "2016-06-06T00:00:00 -0500",
									"value": 6871921,
									"status": "GRAY"
								},
								{
									"date": "2016-06-07T00:00:00 -0500",
									"value": 6665406,
									"status": "GRAY"
								},
								{
									"date": "2016-06-08T00:00:00 -0500",
									"value": 6479470,
									"status": "GRAY"
								},
								{
									"date": "2016-06-09T00:00:00 -0500",
									"value": 6279018,
									"status": "GRAY"
								},
								{
									"date": "2016-06-10T00:00:00 -0500",
									"value": 6536462,
									"status": "GRAY"
								},
								{
									"date": "2016-06-11T00:00:00 -0500",
									"value": 190,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 6248007,
									"status": "GRAY"
								},
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 6725691,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 6257483,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 6200038,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 6223335,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 6389553,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 6312740,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 110,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 6508631,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 6154566,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 6017558,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 6042879,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 6232985,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 6156689,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'overview/total-recharge-transactions/quarterly': {
		"status": 200,
		"data": {
			"title": "Quarterly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "Total Recharge Transactions",
					"subTitle": "Weekly",
					"metricSeries": [
						{
							"info": {
								"id": 1025,
								"name": "Total Recharge transactions",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 100,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 160,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 213,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 215,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 59,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 69,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 73,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 118,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 226,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 55,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 90,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'overview/total-recharge-revenue/weekly': {
		"status": 200,
		"data": {
			"title": "Weekly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "Total Recharge Revenue",
					"subTitle": "Daily",
					"metricSeries": [
						{
							"info": {
								"id": 1031,
								"name": "Total Recharge revenue",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 171020064,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 166173024,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 157698224,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 161366720,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 166540016,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 158628576,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'overview/total-recharge-revenue/monthly': {
		"status": 200,
		"data": {
			"title": "Monthly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "Total Recharge Revenue",
					"subTitle": "Daily",
					"metricSeries": [
						{
							"info": {
								"id": 1031,
								"name": "Total Recharge revenue",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-05-28T00:00:00 -0500",
									"value": 164515488,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 160259072,
									"status": "GRAY"
								},
								{
									"date": "2016-05-30T00:00:00 -0500",
									"value": 179597696,
									"status": "GRAY"
								},
								{
									"date": "2016-05-31T00:00:00 -0500",
									"value": 168320048,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 178901472,
									"status": "GRAY"
								},
								{
									"date": "2016-06-02T00:00:00 -0500",
									"value": 171417904,
									"status": "GRAY"
								},
								{
									"date": "2016-06-03T00:00:00 -0500",
									"value": 174923248,
									"status": "GRAY"
								},
								{
									"date": "2016-06-04T00:00:00 -0500",
									"value": 162352336,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 153178752,
									"status": "GRAY"
								},
								{
									"date": "2016-06-06T00:00:00 -0500",
									"value": 178530512,
									"status": "GRAY"
								},
								{
									"date": "2016-06-07T00:00:00 -0500",
									"value": 171933280,
									"status": "GRAY"
								},
								{
									"date": "2016-06-08T00:00:00 -0500",
									"value": 169743136,
									"status": "GRAY"
								},
								{
									"date": "2016-06-09T00:00:00 -0500",
									"value": 162822080,
									"status": "GRAY"
								},
								{
									"date": "2016-06-10T00:00:00 -0500",
									"value": 171588000,
									"status": "GRAY"
								},
								{
									"date": "2016-06-11T00:00:00 -0500",
									"value": 164,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 157971216,
									"status": "GRAY"
								},
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 179452016,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 164906640,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 164864096,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 165021456,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 166344896,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 162840240,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 78,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 171020064,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 166173024,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 157698224,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 161366720,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 166540016,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 158628576,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'overview/total-recharge-revenue/quarterly': {
		"status": 200,
		"data": {
			"title": "Quarterly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "Total Recharge Revenue",
					"subTitle": "Weekly",
					"metricSeries": [
						{
							"info": {
								"id": 1035,
								"name": "Total Recharge revenue",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 230,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 209,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 91,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 107,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 158,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 172,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 206,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 182,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 144,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 162,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 91,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'overview/churn/weekly': {
		"status": 200,
		"data": {
			"title": "Weekly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "Churn",
					"subTitle": "Daily",
					"metricSeries": [
						{
							"info": {
								"id": 1321,
								"name": "Churn Voluntary",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 348,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 403,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 335,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 395,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 330,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 238,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1331,
								"name": "Churn Involuntary",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 82,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 50,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 73,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 49,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 681,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 33,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'overview/churn/monthly': {
		"status": 200,
		"data": {
			"title": "Monthly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "Churn",
					"subTitle": "Daily",
					"metricSeries": [
						{
							"info": {
								"id": 1321,
								"name": "Churn Voluntary",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-05-28T00:00:00 -0500",
									"value": 106,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 69,
									"status": "GRAY"
								},
								{
									"date": "2016-05-30T00:00:00 -0500",
									"value": 76,
									"status": "GRAY"
								},
								{
									"date": "2016-05-31T00:00:00 -0500",
									"value": 167,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 242,
									"status": "GRAY"
								},
								{
									"date": "2016-06-02T00:00:00 -0500",
									"value": 248,
									"status": "GRAY"
								},
								{
									"date": "2016-06-03T00:00:00 -0500",
									"value": 73,
									"status": "GRAY"
								},
								{
									"date": "2016-06-04T00:00:00 -0500",
									"value": 126,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 207,
									"status": "GRAY"
								},
								{
									"date": "2016-06-06T00:00:00 -0500",
									"value": 51,
									"status": "GRAY"
								},
								{
									"date": "2016-06-07T00:00:00 -0500",
									"value": 91,
									"status": "GRAY"
								},
								{
									"date": "2016-06-08T00:00:00 -0500",
									"value": 94,
									"status": "GRAY"
								},
								{
									"date": "2016-06-09T00:00:00 -0500",
									"value": 241,
									"status": "GRAY"
								},
								{
									"date": "2016-06-10T00:00:00 -0500",
									"value": 152,
									"status": "GRAY"
								},
								{
									"date": "2016-06-11T00:00:00 -0500",
									"value": 176,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 187,
									"status": "GRAY"
								},
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 168,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 182,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 58,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 134,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 295,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 257,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 116,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 348,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 403,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 335,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 395,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 330,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 238,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1331,
								"name": "Churn Involuntary",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-05-28T00:00:00 -0500",
									"value": 101,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 152,
									"status": "GRAY"
								},
								{
									"date": "2016-05-30T00:00:00 -0500",
									"value": 180,
									"status": "GRAY"
								},
								{
									"date": "2016-05-31T00:00:00 -0500",
									"value": 196,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 241,
									"status": "GRAY"
								},
								{
									"date": "2016-06-02T00:00:00 -0500",
									"value": 198,
									"status": "GRAY"
								},
								{
									"date": "2016-06-03T00:00:00 -0500",
									"value": 112,
									"status": "GRAY"
								},
								{
									"date": "2016-06-04T00:00:00 -0500",
									"value": 50,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 226,
									"status": "GRAY"
								},
								{
									"date": "2016-06-06T00:00:00 -0500",
									"value": 117,
									"status": "GRAY"
								},
								{
									"date": "2016-06-07T00:00:00 -0500",
									"value": 186,
									"status": "GRAY"
								},
								{
									"date": "2016-06-08T00:00:00 -0500",
									"value": 142,
									"status": "GRAY"
								},
								{
									"date": "2016-06-09T00:00:00 -0500",
									"value": 123,
									"status": "GRAY"
								},
								{
									"date": "2016-06-10T00:00:00 -0500",
									"value": 123,
									"status": "GRAY"
								},
								{
									"date": "2016-06-11T00:00:00 -0500",
									"value": 187,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 156,
									"status": "GRAY"
								},
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 170,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 125,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 214,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 140,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 24,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 62,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 98,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 82,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 50,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 73,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 49,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 681,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 33,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'overview/churn/quarterly': {
		"status": 200,
		"data": {
			"title": "Quarterly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "Churn",
					"subTitle": "Weekly",
					"metricSeries": [
						{
							"info": {
								"id": 1325,
								"name": "Churn Voluntary",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 84,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 179,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 181,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 180,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 106,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 87,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 146,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 97,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 59,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 237,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 241,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1335,
								"name": "Churn Involuntary",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 183,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 68,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 138,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 58,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 206,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 201,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 117,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 157,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 111,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 152,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 113,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'overview/usage/weekly': {
		"status": 200,
		"data": {
			"title": "Weekly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "Usage",
					"subTitle": "Daily",
					"metricSeries": [
						{
							"info": {
								"id": 1341,
								"name": "Postpaid Usage Count - VOICE",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 60209,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 106506,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 155594,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 200363,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 245029,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 291987,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 326686,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1351,
								"name": "Postpaid Usage Count -  SMS ",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 54996,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 103716,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 160269,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 213274,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 264356,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 437938,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 481383,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1361,
								"name": "Postpaid Usage Count -  GPRS ",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 10249,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 18125,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 26311,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 34046,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 41693,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 49424,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 54791,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1371,
								"name": "Postpaid Usage Count  - ROAMING VOICE",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 289,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 490,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 706,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 909,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 1088,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 1349,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 1543,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1381,
								"name": "Postpaid Usage Count - ROAMING SMS ",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 422,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 726,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 1051,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 1362,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 1650,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 1999,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 2238,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1391,
								"name": "Postpaid Usage Count -  ROAMING GPRS",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 290,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 514,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 743,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 981,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 1189,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 1464,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 1650,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1401,
								"name": "Postpaid Usage Count - VAS",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 195,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 337,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 487,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 631,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 775,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 919,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 1014,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1411,
								"name": "Postpaid Usage Revenue- VOICE",
								"unit": "DOLLAR",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-06T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1421,
								"name": "Postpaid Usage Revenue- SMS",
								"unit": "DOLLAR",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-06T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1431,
								"name": "Postpaid Usage Revenue- GPRS",
								"unit": "DOLLAR",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-06T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1441,
								"name": "Postpaid Usage Revenue- ROAMING VOICE",
								"unit": "DOLLAR",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-06T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1451,
								"name": "Postpaid Usage Revenue- ROAMING SMS",
								"unit": "DOLLAR",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-06T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1461,
								"name": "Postpaid Usage Revenue- ROAMING GPRS",
								"unit": "DOLLAR",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-06T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1471,
								"name": "Postpaid Usage Revenue- VAS",
								"unit": "DOLLAR",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-06T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1161,
								"name": "Prepaid Usage Count- VASCSP",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 421221,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 418821,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 413443,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 403534,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 385425,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 406131,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 415777,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1171,
								"name": "Prepaid Usage Count- VIDEO",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 3567,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 3669,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 4083,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 3648,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 3404,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 4025,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 3790,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1181,
								"name": "Prepaid Usage Count- DUO",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 6446,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 10279,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 9320,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 7058,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 4313,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 9815,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 10751,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1191,
								"name": "Prepaid Usage Count- MMS",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 1376,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 1540,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 1605,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 1378,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 1230,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 1635,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 1618,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1201,
								"name": "Prepaid Usage Count- SMS",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 52500260,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 48630464,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 52601304,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 53766600,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 51152072,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 49356560,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 48312936,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1211,
								"name": "Prepaid Usage Count- AT&TToAT&T Call",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 4328258,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 4593970,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 4769741,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 4441846,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 3984560,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 4634919,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 4631796,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1221,
								"name": "Prepaid Usage Count- AT&TToAT&T SMS",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 11503422,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 12253524,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 12832334,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 11903146,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 10673479,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 12326477,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 12234212,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1231,
								"name": "Prepaid Usage Count- AT&TToSmart Call",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 131768,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 140396,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 143340,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 134377,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 121469,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 141108,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 140640,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1241,
								"name": "Prepaid Usage Count- CAMEL",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 121,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 188,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 129,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 138,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 178,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 142,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 118,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1251,
								"name": "Prepaid Usage Count- AT&TToSmart SMS",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 6372564,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 6178692,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 6865875,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 6648604,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 6105509,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 6449304,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 6344432,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1261,
								"name": "Prepaid Usage Count- EAGLE",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 94,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 93,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 84,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 104,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 55,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 52,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 50,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1271,
								"name": "Prepaid Usage Count- GPRS",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 120379296,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 111850688,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 113273984,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 114228840,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 114605360,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 112876264,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 112046432,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1281,
								"name": "Prepaid Usage Count- VOICE",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 13429298,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 12898072,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 13481479,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 13442747,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 13407925,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 13147264,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 12891946,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1291,
								"name": "Prepaid Usage Count- Intl Call SMS",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 46863,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 44398,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 45566,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 26046,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 22181,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 40066,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 36646,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1641,
								"name": "Prepaid Usage Revenue- VASCSP",
								"unit": "DOLLAR",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 1620007.1,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 1621832.2,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 1633421.8,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 1601827.8,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 1505100.9,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 1612656.6,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 1634786.8,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1651,
								"name": "Prepaid Usage Revenue- VIDEO",
								"unit": "DOLLAR",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 1287.5,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 1355.43,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 1578.67,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 1401.08,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 963.55,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 1307.8,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 1411.04,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1661,
								"name": "Prepaid Usage Revenue- DUO",
								"unit": "DOLLAR",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1671,
								"name": "Prepaid Usage Revenue- MMS",
								"unit": "DOLLAR",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 6875,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 7745,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 8050,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 6940,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 6135,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 8150,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 8075,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1681,
								"name": "Prepaid Usage Revenue- SMS",
								"unit": "DOLLAR",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 1543451.5,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 1519298.5,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 1512211.5,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 1428287.5,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 1346227,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 1493452,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 1448240.5,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1691,
								"name": "Prepaid Usage Revenue- AT&TToAT&T Call",
								"unit": "DOLLAR",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 544080.3,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 619456.6,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 624623.06,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 551226.5,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 460742.66,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 611903.44,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 609754.56,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1701,
								"name": "Prepaid Usage Revenue- AT&TToAT&T SMS",
								"unit": "DOLLAR",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 513836,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 618266.5,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 630323,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 533034.5,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 439916.5,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 613271,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 602369.5,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1711,
								"name": "Prepaid Usage Revenue- AT&TToSmart Call",
								"unit": "DOLLAR",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 401880.88,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 454938.25,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 459968,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 400460,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 343401.5,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 447983,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 456697,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1721,
								"name": "Prepaid Usage Revenue- CAMEL",
								"unit": "DOLLAR",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 2640,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 4470,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 4320,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 3120,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 4440,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 2400,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 2640,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1731,
								"name": "Prepaid Usage Revenue- AT&TToSmart SMS",
								"unit": "DOLLAR",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 375778,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 396483,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 423907,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 373723,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 327455,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 403427,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 400089,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1741,
								"name": "Prepaid Usage Revenue- EAGLE",
								"unit": "DOLLAR",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 240,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 120,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 240,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 150,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 360,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 600,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1751,
								"name": "Prepaid Usage Revenue- GPRS",
								"unit": "DOLLAR",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 312016,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 306656.5,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 307112.06,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 315264.72,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 306459.28,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 308750.2,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 312005.4,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1761,
								"name": "Prepaid Usage Revenue- VOICE",
								"unit": "DOLLAR",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 993426.56,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 1051153.5,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 1056997.9,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 956003.25,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 878093.6,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 1062081.8,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 1071877.5,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1771,
								"name": "Prepaid Usage Revenue- Intl Call SMS",
								"unit": "DOLLAR",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 168279,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 166637,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 156885,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 150096,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 141398,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 159037,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 152396,
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'overview/usage/monthly': {
		"status": 200,
		"data": {
			"title": "Monthly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "Usage",
					"subTitle": "Daily",
					"metricSeries": [
						{
							"info": {
								"id": 1341,
								"name": "Postpaid Usage Count - VOICE",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 289583,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 322557,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 62641,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 112048,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 160610,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 199360,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 247627,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 291007,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 322005,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 62155,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 113237,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 153985,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 198462,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"value": 240938,
									"status": "GRAY"
								},
								{
									"date": "2016-06-27T00:00:00 -0500",
									"value": 289768,
									"status": "GRAY"
								},
								{
									"date": "2016-06-28T00:00:00 -0500",
									"value": 322639,
									"status": "GRAY"
								},
								{
									"date": "2016-06-29T00:00:00 -0500",
									"value": 60163,
									"status": "GRAY"
								},
								{
									"date": "2016-06-30T00:00:00 -0500",
									"value": 112807,
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"value": 155164,
									"status": "GRAY"
								},
								{
									"date": "2016-07-02T00:00:00 -0500",
									"value": 200238,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"value": 242584,
									"status": "GRAY"
								},
								{
									"date": "2016-07-04T00:00:00 -0500",
									"value": 290279,
									"status": "GRAY"
								},
								{
									"date": "2016-07-05T00:00:00 -0500",
									"value": 323871,
									"status": "GRAY"
								},
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 60209,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 106506,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 155594,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 200363,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 245029,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 291987,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 326686,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1351,
								"name": "Postpaid Usage Count -  SMS ",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 334403,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 372595,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 83938,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 148385,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 215598,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 270134,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 278751,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 279148,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 322956,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 154138,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 221519,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 276492,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 339984,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"value": 398107,
									"status": "GRAY"
								},
								{
									"date": "2016-06-27T00:00:00 -0500",
									"value": 464166,
									"status": "GRAY"
								},
								{
									"date": "2016-06-28T00:00:00 -0500",
									"value": 503993,
									"status": "GRAY"
								},
								{
									"date": "2016-06-29T00:00:00 -0500",
									"value": 68307,
									"status": "GRAY"
								},
								{
									"date": "2016-06-30T00:00:00 -0500",
									"value": 128862,
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"value": 178093,
									"status": "GRAY"
								},
								{
									"date": "2016-07-02T00:00:00 -0500",
									"value": 233231,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"value": 278595,
									"status": "GRAY"
								},
								{
									"date": "2016-07-04T00:00:00 -0500",
									"value": 326141,
									"status": "GRAY"
								},
								{
									"date": "2016-07-05T00:00:00 -0500",
									"value": 360760,
									"status": "GRAY"
								},
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 54996,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 103716,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 160269,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 213274,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 264356,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 437938,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 481383,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1361,
								"name": "Postpaid Usage Count -  GPRS ",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 42671,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 47173,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 8566,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 14213,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 19992,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 24973,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 30614,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 32413,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 36512,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 11880,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 18386,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 23875,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 30123,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"value": 35857,
									"status": "GRAY"
								},
								{
									"date": "2016-06-27T00:00:00 -0500",
									"value": 42102,
									"status": "GRAY"
								},
								{
									"date": "2016-06-28T00:00:00 -0500",
									"value": 46613,
									"status": "GRAY"
								},
								{
									"date": "2016-06-29T00:00:00 -0500",
									"value": 9533,
									"status": "GRAY"
								},
								{
									"date": "2016-06-30T00:00:00 -0500",
									"value": 18132,
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"value": 25340,
									"status": "GRAY"
								},
								{
									"date": "2016-07-02T00:00:00 -0500",
									"value": 33343,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"value": 40623,
									"status": "GRAY"
								},
								{
									"date": "2016-07-04T00:00:00 -0500",
									"value": 48760,
									"status": "GRAY"
								},
								{
									"date": "2016-07-05T00:00:00 -0500",
									"value": 54078,
									"status": "GRAY"
								},
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 10249,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 18125,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 26311,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 34046,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 41693,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 49424,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 54791,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1371,
								"name": "Postpaid Usage Count  - ROAMING VOICE",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 1301,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 1427,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 299,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 512,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 723,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 878,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 1010,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 1208,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 1373,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 284,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 507,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 683,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 898,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"value": 1065,
									"status": "GRAY"
								},
								{
									"date": "2016-06-27T00:00:00 -0500",
									"value": 1281,
									"status": "GRAY"
								},
								{
									"date": "2016-06-28T00:00:00 -0500",
									"value": 1399,
									"status": "GRAY"
								},
								{
									"date": "2016-06-29T00:00:00 -0500",
									"value": 255,
									"status": "GRAY"
								},
								{
									"date": "2016-06-30T00:00:00 -0500",
									"value": 474,
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"value": 642,
									"status": "GRAY"
								},
								{
									"date": "2016-07-02T00:00:00 -0500",
									"value": 817,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"value": 941,
									"status": "GRAY"
								},
								{
									"date": "2016-07-04T00:00:00 -0500",
									"value": 1119,
									"status": "GRAY"
								},
								{
									"date": "2016-07-05T00:00:00 -0500",
									"value": 1272,
									"status": "GRAY"
								},
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 289,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 490,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 706,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 909,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 1088,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 1349,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 1543,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1381,
								"name": "Postpaid Usage Count - ROAMING SMS ",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 1891,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 2074,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 422,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 760,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 1076,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 1299,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 1547,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 1841,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 2077,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 422,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 747,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 1002,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 1320,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"value": 1562,
									"status": "GRAY"
								},
								{
									"date": "2016-06-27T00:00:00 -0500",
									"value": 1865,
									"status": "GRAY"
								},
								{
									"date": "2016-06-28T00:00:00 -0500",
									"value": 2044,
									"status": "GRAY"
								},
								{
									"date": "2016-06-29T00:00:00 -0500",
									"value": 346,
									"status": "GRAY"
								},
								{
									"date": "2016-06-30T00:00:00 -0500",
									"value": 682,
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"value": 936,
									"status": "GRAY"
								},
								{
									"date": "2016-07-02T00:00:00 -0500",
									"value": 1237,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"value": 1455,
									"status": "GRAY"
								},
								{
									"date": "2016-07-04T00:00:00 -0500",
									"value": 1729,
									"status": "GRAY"
								},
								{
									"date": "2016-07-05T00:00:00 -0500",
									"value": 1940,
									"status": "GRAY"
								},
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 422,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 726,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 1051,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 1362,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 1650,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 1999,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 2238,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1391,
								"name": "Postpaid Usage Count -  ROAMING GPRS",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 1340,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 1462,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 307,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 557,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 824,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 1014,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 1166,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 1351,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 1514,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 291,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 537,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 726,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 955,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"value": 1132,
									"status": "GRAY"
								},
								{
									"date": "2016-06-27T00:00:00 -0500",
									"value": 1351,
									"status": "GRAY"
								},
								{
									"date": "2016-06-28T00:00:00 -0500",
									"value": 1465,
									"status": "GRAY"
								},
								{
									"date": "2016-06-29T00:00:00 -0500",
									"value": 256,
									"status": "GRAY"
								},
								{
									"date": "2016-06-30T00:00:00 -0500",
									"value": 483,
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"value": 663,
									"status": "GRAY"
								},
								{
									"date": "2016-07-02T00:00:00 -0500",
									"value": 842,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"value": 994,
									"status": "GRAY"
								},
								{
									"date": "2016-07-04T00:00:00 -0500",
									"value": 1188,
									"status": "GRAY"
								},
								{
									"date": "2016-07-05T00:00:00 -0500",
									"value": 1324,
									"status": "GRAY"
								},
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 290,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 514,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 743,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 981,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 1189,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 1464,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 1650,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1401,
								"name": "Postpaid Usage Count - VAS",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 924,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 1015,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 203,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 352,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 504,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 633,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 778,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 790,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 996,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 222,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 377,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 504,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 658,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"value": 798,
									"status": "GRAY"
								},
								{
									"date": "2016-06-27T00:00:00 -0500",
									"value": 949,
									"status": "GRAY"
								},
								{
									"date": "2016-06-28T00:00:00 -0500",
									"value": 1038,
									"status": "GRAY"
								},
								{
									"date": "2016-06-29T00:00:00 -0500",
									"value": 190,
									"status": "GRAY"
								},
								{
									"date": "2016-06-30T00:00:00 -0500",
									"value": 352,
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"value": 484,
									"status": "GRAY"
								},
								{
									"date": "2016-07-02T00:00:00 -0500",
									"value": 637,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"value": 776,
									"status": "GRAY"
								},
								{
									"date": "2016-07-04T00:00:00 -0500",
									"value": 922,
									"status": "GRAY"
								},
								{
									"date": "2016-07-05T00:00:00 -0500",
									"value": 1016,
									"status": "GRAY"
								},
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 195,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 337,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 487,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 631,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 775,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 919,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 1014,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1411,
								"name": "Postpaid Usage Revenue- VOICE",
								"unit": "DOLLAR",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-13T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-27T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-28T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-29T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-30T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-02T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-04T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-05T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-06T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1421,
								"name": "Postpaid Usage Revenue- SMS",
								"unit": "DOLLAR",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-13T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-27T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-28T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-29T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-30T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-02T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-04T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-05T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-06T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1431,
								"name": "Postpaid Usage Revenue- GPRS",
								"unit": "DOLLAR",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-13T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-27T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-28T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-29T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-30T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-02T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-04T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-05T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-06T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1441,
								"name": "Postpaid Usage Revenue- ROAMING VOICE",
								"unit": "DOLLAR",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-13T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-27T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-28T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-29T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-30T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-02T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-04T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-05T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-06T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1451,
								"name": "Postpaid Usage Revenue- ROAMING SMS",
								"unit": "DOLLAR",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-13T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-27T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-28T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-29T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-30T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-02T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-04T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-05T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-06T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1461,
								"name": "Postpaid Usage Revenue- ROAMING GPRS",
								"unit": "DOLLAR",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-13T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-27T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-28T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-29T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-30T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-02T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-04T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-05T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-06T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1471,
								"name": "Postpaid Usage Revenue- VAS",
								"unit": "DOLLAR",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-13T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-27T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-28T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-29T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-30T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-02T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-04T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-05T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-06T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1161,
								"name": "Prepaid Usage Count- VASCSP",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 439459,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 443367,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 469821,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 397644,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 412312,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 402465,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 397535,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 445111,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 437673,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 398565,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 416183,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 394079,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 467847,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"value": 440470,
									"status": "GRAY"
								},
								{
									"date": "2016-06-27T00:00:00 -0500",
									"value": 420109,
									"status": "GRAY"
								},
								{
									"date": "2016-06-28T00:00:00 -0500",
									"value": 382208,
									"status": "GRAY"
								},
								{
									"date": "2016-06-29T00:00:00 -0500",
									"value": 216104,
									"status": "GRAY"
								},
								{
									"date": "2016-06-30T00:00:00 -0500",
									"value": 484564,
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"value": 511884,
									"status": "GRAY"
								},
								{
									"date": "2016-07-02T00:00:00 -0500",
									"value": 567827,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"value": 445269,
									"status": "GRAY"
								},
								{
									"date": "2016-07-04T00:00:00 -0500",
									"value": 493820,
									"status": "GRAY"
								},
								{
									"date": "2016-07-05T00:00:00 -0500",
									"value": 435195,
									"status": "GRAY"
								},
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 421221,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 418821,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 413443,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 403534,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 385425,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 406131,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 415777,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1171,
								"name": "Prepaid Usage Count- VIDEO",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 4219,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 3892,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 3987,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 4052,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 3974,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 3854,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 3745,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 3914,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 3985,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 3965,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 3708,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 4186,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 3950,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"value": 3473,
									"status": "GRAY"
								},
								{
									"date": "2016-06-27T00:00:00 -0500",
									"value": 3883,
									"status": "GRAY"
								},
								{
									"date": "2016-06-28T00:00:00 -0500",
									"value": 2676,
									"status": "GRAY"
								},
								{
									"date": "2016-06-29T00:00:00 -0500",
									"value": 749,
									"status": "GRAY"
								},
								{
									"date": "2016-06-30T00:00:00 -0500",
									"value": 4142,
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"value": 4550,
									"status": "GRAY"
								},
								{
									"date": "2016-07-02T00:00:00 -0500",
									"value": 4283,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"value": 3663,
									"status": "GRAY"
								},
								{
									"date": "2016-07-04T00:00:00 -0500",
									"value": 4273,
									"status": "GRAY"
								},
								{
									"date": "2016-07-05T00:00:00 -0500",
									"value": 3845,
									"status": "GRAY"
								},
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 3567,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 3669,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 4083,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 3648,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 3404,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 4025,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 3790,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1181,
								"name": "Prepaid Usage Count- DUO",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 10175,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 10203,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 10528,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 10374,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 9875,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 7664,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 5418,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 9911,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 10508,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 10573,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 10379,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 12487,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 9749,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"value": 4390,
									"status": "GRAY"
								},
								{
									"date": "2016-06-27T00:00:00 -0500",
									"value": 10394,
									"status": "GRAY"
								},
								{
									"date": "2016-06-28T00:00:00 -0500",
									"value": 9105,
									"status": "GRAY"
								},
								{
									"date": "2016-06-29T00:00:00 -0500",
									"value": 1127,
									"status": "GRAY"
								},
								{
									"date": "2016-06-30T00:00:00 -0500",
									"value": 9966,
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"value": 9640,
									"status": "GRAY"
								},
								{
									"date": "2016-07-02T00:00:00 -0500",
									"value": 7290,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"value": 4647,
									"status": "GRAY"
								},
								{
									"date": "2016-07-04T00:00:00 -0500",
									"value": 11165,
									"status": "GRAY"
								},
								{
									"date": "2016-07-05T00:00:00 -0500",
									"value": 10673,
									"status": "GRAY"
								},
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 6446,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 10279,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 9320,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 7058,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 4313,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 9815,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 10751,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1191,
								"name": "Prepaid Usage Count- MMS",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 1561,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 1686,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 1533,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 1476,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 1439,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 1534,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 1559,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 1619,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 1563,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 1527,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 1537,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 1449,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 1464,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"value": 1284,
									"status": "GRAY"
								},
								{
									"date": "2016-06-27T00:00:00 -0500",
									"value": 1480,
									"status": "GRAY"
								},
								{
									"date": "2016-06-28T00:00:00 -0500",
									"value": 1059,
									"status": "GRAY"
								},
								{
									"date": "2016-06-29T00:00:00 -0500",
									"value": 393,
									"status": "GRAY"
								},
								{
									"date": "2016-06-30T00:00:00 -0500",
									"value": 1549,
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"value": 1568,
									"status": "GRAY"
								},
								{
									"date": "2016-07-02T00:00:00 -0500",
									"value": 1508,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"value": 1327,
									"status": "GRAY"
								},
								{
									"date": "2016-07-04T00:00:00 -0500",
									"value": 1651,
									"status": "GRAY"
								},
								{
									"date": "2016-07-05T00:00:00 -0500",
									"value": 1653,
									"status": "GRAY"
								},
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 1376,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 1540,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 1605,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 1378,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 1230,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 1635,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 1618,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1201,
								"name": "Prepaid Usage Count- SMS",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 55758416,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 51154312,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 50400664,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 50930944,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 51232768,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 52171424,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 51828560,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 52055748,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 49166228,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 48575128,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 48646640,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 50614700,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 52821512,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"value": 51046880,
									"status": "GRAY"
								},
								{
									"date": "2016-06-27T00:00:00 -0500",
									"value": 49791256,
									"status": "GRAY"
								},
								{
									"date": "2016-06-28T00:00:00 -0500",
									"value": 28094360,
									"status": "GRAY"
								},
								{
									"date": "2016-06-29T00:00:00 -0500",
									"value": 10450358,
									"status": "GRAY"
								},
								{
									"date": "2016-06-30T00:00:00 -0500",
									"value": 48774580,
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"value": 58203032,
									"status": "GRAY"
								},
								{
									"date": "2016-07-02T00:00:00 -0500",
									"value": 52752540,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"value": 49334176,
									"status": "GRAY"
								},
								{
									"date": "2016-07-04T00:00:00 -0500",
									"value": 49425488,
									"status": "GRAY"
								},
								{
									"date": "2016-07-05T00:00:00 -0500",
									"value": 50775584,
									"status": "GRAY"
								},
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 52500260,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 48630464,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 52601304,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 53766600,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 51152072,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 49356560,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 48312936,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1211,
								"name": "Prepaid Usage Count- AT&TToAT&T Call",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 4909894,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 4749727,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 4800359,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 4800979,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 4917749,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 4659996,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 4208446,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 4735087,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 4698315,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 4669442,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 4657012,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 4858302,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 4574901,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"value": 4048069,
									"status": "GRAY"
								},
								{
									"date": "2016-06-27T00:00:00 -0500",
									"value": 4686563,
									"status": "GRAY"
								},
								{
									"date": "2016-06-28T00:00:00 -0500",
									"value": 3282898,
									"status": "GRAY"
								},
								{
									"date": "2016-06-29T00:00:00 -0500",
									"value": 916237,
									"status": "GRAY"
								},
								{
									"date": "2016-06-30T00:00:00 -0500",
									"value": 4154187,
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"value": 4920001,
									"status": "GRAY"
								},
								{
									"date": "2016-07-02T00:00:00 -0500",
									"value": 4504668,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"value": 4017433,
									"status": "GRAY"
								},
								{
									"date": "2016-07-04T00:00:00 -0500",
									"value": 4691563,
									"status": "GRAY"
								},
								{
									"date": "2016-07-05T00:00:00 -0500",
									"value": 4758260,
									"status": "GRAY"
								},
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 4328258,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 4593970,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 4769741,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 4441846,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 3984560,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 4634919,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 4631796,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1221,
								"name": "Prepaid Usage Count- AT&TToAT&T SMS",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 13763942,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 12792511,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 12829746,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 12945292,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 13011826,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 12020011,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 11569482,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 12867610,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 12424762,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 12340385,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 12309241,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 12590653,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 11892352,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"value": 10667643,
									"status": "GRAY"
								},
								{
									"date": "2016-06-27T00:00:00 -0500",
									"value": 12323629,
									"status": "GRAY"
								},
								{
									"date": "2016-06-28T00:00:00 -0500",
									"value": 7801503,
									"status": "GRAY"
								},
								{
									"date": "2016-06-29T00:00:00 -0500",
									"value": 2622698,
									"status": "GRAY"
								},
								{
									"date": "2016-06-30T00:00:00 -0500",
									"value": 12292963,
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"value": 12592828,
									"status": "GRAY"
								},
								{
									"date": "2016-07-02T00:00:00 -0500",
									"value": 11508141,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"value": 10471239,
									"status": "GRAY"
								},
								{
									"date": "2016-07-04T00:00:00 -0500",
									"value": 12278776,
									"status": "GRAY"
								},
								{
									"date": "2016-07-05T00:00:00 -0500",
									"value": 12741701,
									"status": "GRAY"
								},
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 11503422,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 12253524,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 12832334,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 11903146,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 10673479,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 12326477,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 12234212,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1231,
								"name": "Prepaid Usage Count- AT&TToSmart Call",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 155943,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 147552,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 146703,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 149766,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 151603,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 145659,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 132756,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 146734,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 147196,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 140401,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 136922,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 145361,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 139612,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"value": 123021,
									"status": "GRAY"
								},
								{
									"date": "2016-06-27T00:00:00 -0500",
									"value": 141459,
									"status": "GRAY"
								},
								{
									"date": "2016-06-28T00:00:00 -0500",
									"value": 105602,
									"status": "GRAY"
								},
								{
									"date": "2016-06-29T00:00:00 -0500",
									"value": 29298,
									"status": "GRAY"
								},
								{
									"date": "2016-06-30T00:00:00 -0500",
									"value": 128621,
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"value": 160252,
									"status": "GRAY"
								},
								{
									"date": "2016-07-02T00:00:00 -0500",
									"value": 155051,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"value": 138323,
									"status": "GRAY"
								},
								{
									"date": "2016-07-04T00:00:00 -0500",
									"value": 152323,
									"status": "GRAY"
								},
								{
									"date": "2016-07-05T00:00:00 -0500",
									"value": 147296,
									"status": "GRAY"
								},
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 131768,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 140396,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 143340,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 134377,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 121469,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 141108,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 140640,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1241,
								"name": "Prepaid Usage Count- CAMEL",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 145,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 177,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 142,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 136,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 118,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 195,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 188,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 126,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 170,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 125,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 163,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 124,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 178,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"value": 109,
									"status": "GRAY"
								},
								{
									"date": "2016-06-27T00:00:00 -0500",
									"value": 150,
									"status": "GRAY"
								},
								{
									"date": "2016-06-28T00:00:00 -0500",
									"value": 105,
									"status": "GRAY"
								},
								{
									"date": "2016-06-29T00:00:00 -0500",
									"value": 37,
									"status": "GRAY"
								},
								{
									"date": "2016-06-30T00:00:00 -0500",
									"value": 85,
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"value": 115,
									"status": "GRAY"
								},
								{
									"date": "2016-07-02T00:00:00 -0500",
									"value": 111,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"value": 122,
									"status": "GRAY"
								},
								{
									"date": "2016-07-04T00:00:00 -0500",
									"value": 83,
									"status": "GRAY"
								},
								{
									"date": "2016-07-05T00:00:00 -0500",
									"value": 87,
									"status": "GRAY"
								},
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 121,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 188,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 129,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 138,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 178,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 142,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 118,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1251,
								"name": "Prepaid Usage Count- AT&TToSmart SMS",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 7147727,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 6509370,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 6498636,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 6421368,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 6678017,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 6485899,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 6426161,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 6565185,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 6288120,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 6189344,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 6223706,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 6537580,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 6495241,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"value": 6035935,
									"status": "GRAY"
								},
								{
									"date": "2016-06-27T00:00:00 -0500",
									"value": 6384760,
									"status": "GRAY"
								},
								{
									"date": "2016-06-28T00:00:00 -0500",
									"value": 3971159,
									"status": "GRAY"
								},
								{
									"date": "2016-06-29T00:00:00 -0500",
									"value": 1323943,
									"status": "GRAY"
								},
								{
									"date": "2016-06-30T00:00:00 -0500",
									"value": 6348668,
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"value": 6590747,
									"status": "GRAY"
								},
								{
									"date": "2016-07-02T00:00:00 -0500",
									"value": 6323361,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"value": 5879450,
									"status": "GRAY"
								},
								{
									"date": "2016-07-04T00:00:00 -0500",
									"value": 6397995,
									"status": "GRAY"
								},
								{
									"date": "2016-07-05T00:00:00 -0500",
									"value": 6597663,
									"status": "GRAY"
								},
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 6372564,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 6178692,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 6865875,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 6648604,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 6105509,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 6449304,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 6344432,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1261,
								"name": "Prepaid Usage Count- EAGLE",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 52,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 29,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 35,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 44,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 43,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 49,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 45,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 42,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 80,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 12,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 47,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 47,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 30,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"value": 47,
									"status": "GRAY"
								},
								{
									"date": "2016-06-27T00:00:00 -0500",
									"value": 38,
									"status": "GRAY"
								},
								{
									"date": "2016-06-28T00:00:00 -0500",
									"value": 26,
									"status": "GRAY"
								},
								{
									"date": "2016-06-29T00:00:00 -0500",
									"value": 25,
									"status": "GRAY"
								},
								{
									"date": "2016-06-30T00:00:00 -0500",
									"value": 79,
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"value": 86,
									"status": "GRAY"
								},
								{
									"date": "2016-07-02T00:00:00 -0500",
									"value": 76,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"value": 68,
									"status": "GRAY"
								},
								{
									"date": "2016-07-04T00:00:00 -0500",
									"value": 59,
									"status": "GRAY"
								},
								{
									"date": "2016-07-05T00:00:00 -0500",
									"value": 106,
									"status": "GRAY"
								},
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 94,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 93,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 84,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 104,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 55,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 52,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 50,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1271,
								"name": "Prepaid Usage Count- GPRS",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 109907920,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 109997928,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 109670328,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 109645032,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 111674736,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 114390256,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 116592640,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 112646312,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 111236136,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 111638608,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 111059352,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 111900352,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 113934776,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"value": 114593240,
									"status": "GRAY"
								},
								{
									"date": "2016-06-27T00:00:00 -0500",
									"value": 110917200,
									"status": "GRAY"
								},
								{
									"date": "2016-06-28T00:00:00 -0500",
									"value": 75172832,
									"status": "GRAY"
								},
								{
									"date": "2016-06-29T00:00:00 -0500",
									"value": 32979304,
									"status": "GRAY"
								},
								{
									"date": "2016-06-30T00:00:00 -0500",
									"value": 112276408,
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"value": 114694528,
									"status": "GRAY"
								},
								{
									"date": "2016-07-02T00:00:00 -0500",
									"value": 124568304,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"value": 123515704,
									"status": "GRAY"
								},
								{
									"date": "2016-07-04T00:00:00 -0500",
									"value": 119550048,
									"status": "GRAY"
								},
								{
									"date": "2016-07-05T00:00:00 -0500",
									"value": 122032072,
									"status": "GRAY"
								},
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 120379296,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 111850688,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 113273984,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 114228840,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 114605360,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 112876264,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 112046432,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1281,
								"name": "Prepaid Usage Count- VOICE",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 14075724,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 13276208,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 13117266,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 13241591,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 13510409,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 13777474,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 13807071,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 13271047,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 13003719,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 12824933,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 12827525,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 13561815,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 13635230,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"value": 13498747,
									"status": "GRAY"
								},
								{
									"date": "2016-06-27T00:00:00 -0500",
									"value": 13228019,
									"status": "GRAY"
								},
								{
									"date": "2016-06-28T00:00:00 -0500",
									"value": 8492251,
									"status": "GRAY"
								},
								{
									"date": "2016-06-29T00:00:00 -0500",
									"value": 2713993,
									"status": "GRAY"
								},
								{
									"date": "2016-06-30T00:00:00 -0500",
									"value": 13544802,
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"value": 13458974,
									"status": "GRAY"
								},
								{
									"date": "2016-07-02T00:00:00 -0500",
									"value": 13200693,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"value": 13222579,
									"status": "GRAY"
								},
								{
									"date": "2016-07-04T00:00:00 -0500",
									"value": 13286220,
									"status": "GRAY"
								},
								{
									"date": "2016-07-05T00:00:00 -0500",
									"value": 13214223,
									"status": "GRAY"
								},
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 13429298,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 12898072,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 13481479,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 13442747,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 13407925,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 13147264,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 12891946,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1291,
								"name": "Prepaid Usage Count- Intl Call SMS",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 33449,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 37444,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 41290,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 35735,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 31412,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 24688,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 28611,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 26279,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 32304,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 32479,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 35456,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 24038,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 23790,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"value": 21944,
									"status": "GRAY"
								},
								{
									"date": "2016-06-27T00:00:00 -0500",
									"value": 32333,
									"status": "GRAY"
								},
								{
									"date": "2016-06-28T00:00:00 -0500",
									"value": 35369,
									"status": "GRAY"
								},
								{
									"date": "2016-06-29T00:00:00 -0500",
									"value": 6456,
									"status": "GRAY"
								},
								{
									"date": "2016-06-30T00:00:00 -0500",
									"value": 39658,
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"value": 39140,
									"status": "GRAY"
								},
								{
									"date": "2016-07-02T00:00:00 -0500",
									"value": 24432,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"value": 23845,
									"status": "GRAY"
								},
								{
									"date": "2016-07-04T00:00:00 -0500",
									"value": 28706,
									"status": "GRAY"
								},
								{
									"date": "2016-07-05T00:00:00 -0500",
									"value": 38923,
									"status": "GRAY"
								},
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 46863,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 44398,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 45566,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 26046,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 22181,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 40066,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 36646,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1641,
								"name": "Prepaid Usage Revenue- VASCSP",
								"unit": "DOLLAR",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 1656586.8,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 1693613.1,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 1683161.2,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 1523481,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 1595897.5,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 1558658,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 1510690,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 1682155.5,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 1690092.4,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 1578014.5,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 1605176.5,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 1578863.2,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 1722478,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"value": 1665775,
									"status": "GRAY"
								},
								{
									"date": "2016-06-27T00:00:00 -0500",
									"value": 1627586,
									"status": "GRAY"
								},
								{
									"date": "2016-06-28T00:00:00 -0500",
									"value": 1415207.5,
									"status": "GRAY"
								},
								{
									"date": "2016-06-29T00:00:00 -0500",
									"value": 727494.2,
									"status": "GRAY"
								},
								{
									"date": "2016-06-30T00:00:00 -0500",
									"value": 1823314.8,
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"value": 2069098.2,
									"status": "GRAY"
								},
								{
									"date": "2016-07-02T00:00:00 -0500",
									"value": 2154634,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"value": 1692409.2,
									"status": "GRAY"
								},
								{
									"date": "2016-07-04T00:00:00 -0500",
									"value": 1879541.1,
									"status": "GRAY"
								},
								{
									"date": "2016-07-05T00:00:00 -0500",
									"value": 1701936.8,
									"status": "GRAY"
								},
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 1620007.1,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 1621832.2,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 1633421.8,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 1601827.8,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 1505100.9,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 1612656.6,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 1634786.8,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1651,
								"name": "Prepaid Usage Revenue- VIDEO",
								"unit": "DOLLAR",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 1586,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 1749.94,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 1495.6,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 1210.84,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 1220.85,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 1712.12,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 1702.36,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 1398,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 1665.5,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 1603,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 1175.28,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 1345.38,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 1419.02,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"value": 1201.66,
									"status": "GRAY"
								},
								{
									"date": "2016-06-27T00:00:00 -0500",
									"value": 1503.44,
									"status": "GRAY"
								},
								{
									"date": "2016-06-28T00:00:00 -0500",
									"value": 803.5,
									"status": "GRAY"
								},
								{
									"date": "2016-06-29T00:00:00 -0500",
									"value": 194.22,
									"status": "GRAY"
								},
								{
									"date": "2016-06-30T00:00:00 -0500",
									"value": 1680.88,
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"value": 1450.82,
									"status": "GRAY"
								},
								{
									"date": "2016-07-02T00:00:00 -0500",
									"value": 1510.67,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"value": 1278.83,
									"status": "GRAY"
								},
								{
									"date": "2016-07-04T00:00:00 -0500",
									"value": 1601.42,
									"status": "GRAY"
								},
								{
									"date": "2016-07-05T00:00:00 -0500",
									"value": 1560.92,
									"status": "GRAY"
								},
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 1287.5,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 1355.43,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 1578.67,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 1401.08,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 963.55,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 1307.8,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 1411.04,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1661,
								"name": "Prepaid Usage Revenue- DUO",
								"unit": "DOLLAR",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-06-27T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-06-28T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-06-29T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-06-30T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-07-02T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-07-04T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-07-05T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1671,
								"name": "Prepaid Usage Revenue- MMS",
								"unit": "DOLLAR",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 7845,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 8420,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 7705,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 7410,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 7200,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 7685,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 7815,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 8095,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 7830,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 7640,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 7700,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 7300,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 7355,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"value": 6425,
									"status": "GRAY"
								},
								{
									"date": "2016-06-27T00:00:00 -0500",
									"value": 7405,
									"status": "GRAY"
								},
								{
									"date": "2016-06-28T00:00:00 -0500",
									"value": 5335,
									"status": "GRAY"
								},
								{
									"date": "2016-06-29T00:00:00 -0500",
									"value": 1965,
									"status": "GRAY"
								},
								{
									"date": "2016-06-30T00:00:00 -0500",
									"value": 7750,
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"value": 7835,
									"status": "GRAY"
								},
								{
									"date": "2016-07-02T00:00:00 -0500",
									"value": 7565,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"value": 6635,
									"status": "GRAY"
								},
								{
									"date": "2016-07-04T00:00:00 -0500",
									"value": 8265,
									"status": "GRAY"
								},
								{
									"date": "2016-07-05T00:00:00 -0500",
									"value": 8320,
									"status": "GRAY"
								},
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 6875,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 7745,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 8050,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 6940,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 6135,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 8150,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 8075,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1681,
								"name": "Prepaid Usage Revenue- SMS",
								"unit": "DOLLAR",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 2094162,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 1978571.5,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 2006316,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 1975469.5,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 1635834.5,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 1577066.5,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 1546148.5,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 1736032.5,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 1640548.5,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 1594552,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 1582633.5,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 1601745.5,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 1533210.5,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"value": 1443627.5,
									"status": "GRAY"
								},
								{
									"date": "2016-06-27T00:00:00 -0500",
									"value": 1560838.5,
									"status": "GRAY"
								},
								{
									"date": "2016-06-28T00:00:00 -0500",
									"value": 1137224.5,
									"status": "GRAY"
								},
								{
									"date": "2016-06-29T00:00:00 -0500",
									"value": 443097.5,
									"status": "GRAY"
								},
								{
									"date": "2016-06-30T00:00:00 -0500",
									"value": 1611230.5,
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"value": 1887243,
									"status": "GRAY"
								},
								{
									"date": "2016-07-02T00:00:00 -0500",
									"value": 2182311.5,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"value": 1757000,
									"status": "GRAY"
								},
								{
									"date": "2016-07-04T00:00:00 -0500",
									"value": 1771521.5,
									"status": "GRAY"
								},
								{
									"date": "2016-07-05T00:00:00 -0500",
									"value": 1664856,
									"status": "GRAY"
								},
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 1543451.5,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 1519298.5,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 1512211.5,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 1428287.5,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 1346227,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 1493452,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 1448240.5,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1691,
								"name": "Prepaid Usage Revenue- AT&TToAT&T Call",
								"unit": "DOLLAR",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 685127.94,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 628172.06,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 615373.25,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 628095.94,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 645669.94,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 583233.2,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 496200.25,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 649019,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 609193.25,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 610010.56,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 610355.4,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 621471.4,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 562618.6,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"value": 454410,
									"status": "GRAY"
								},
								{
									"date": "2016-06-27T00:00:00 -0500",
									"value": 610214.6,
									"status": "GRAY"
								},
								{
									"date": "2016-06-28T00:00:00 -0500",
									"value": 453406.2,
									"status": "GRAY"
								},
								{
									"date": "2016-06-29T00:00:00 -0500",
									"value": 107783.65,
									"status": "GRAY"
								},
								{
									"date": "2016-06-30T00:00:00 -0500",
									"value": 552249.6,
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"value": 739468.8,
									"status": "GRAY"
								},
								{
									"date": "2016-07-02T00:00:00 -0500",
									"value": 782601.4,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"value": 550503.06,
									"status": "GRAY"
								},
								{
									"date": "2016-07-04T00:00:00 -0500",
									"value": 697607.25,
									"status": "GRAY"
								},
								{
									"date": "2016-07-05T00:00:00 -0500",
									"value": 657407.9,
									"status": "GRAY"
								},
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 544080.3,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 619456.6,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 624623.06,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 551226.5,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 460742.66,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 611903.44,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 609754.56,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1701,
								"name": "Prepaid Usage Revenue- AT&TToAT&T SMS",
								"unit": "DOLLAR",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 751063.5,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 659865.5,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 658522.5,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 661869,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 680913.5,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 586112,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 574371.5,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 679195.5,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 633753.5,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 626994.5,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 630251.5,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 650954,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 565074.5,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"value": 465377,
									"status": "GRAY"
								},
								{
									"date": "2016-06-27T00:00:00 -0500",
									"value": 640824,
									"status": "GRAY"
								},
								{
									"date": "2016-06-28T00:00:00 -0500",
									"value": 457065.5,
									"status": "GRAY"
								},
								{
									"date": "2016-06-29T00:00:00 -0500",
									"value": 122667.5,
									"status": "GRAY"
								},
								{
									"date": "2016-06-30T00:00:00 -0500",
									"value": 635941,
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"value": 738907,
									"status": "GRAY"
								},
								{
									"date": "2016-07-02T00:00:00 -0500",
									"value": 725297,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"value": 532216.5,
									"status": "GRAY"
								},
								{
									"date": "2016-07-04T00:00:00 -0500",
									"value": 689478.5,
									"status": "GRAY"
								},
								{
									"date": "2016-07-05T00:00:00 -0500",
									"value": 658610,
									"status": "GRAY"
								},
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 513836,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 618266.5,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 630323,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 533034.5,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 439916.5,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 613271,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 602369.5,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1711,
								"name": "Prepaid Usage Revenue- AT&TToSmart Call",
								"unit": "DOLLAR",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 483704.38,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 472220.25,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 464146.12,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 473206.25,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 483077.12,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 439129.88,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 379685.38,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 460053,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 455933.75,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 450516.12,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 447845.5,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 460740.5,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 419827.62,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"value": 347412.75,
									"status": "GRAY"
								},
								{
									"date": "2016-06-27T00:00:00 -0500",
									"value": 458793.25,
									"status": "GRAY"
								},
								{
									"date": "2016-06-28T00:00:00 -0500",
									"value": 347389,
									"status": "GRAY"
								},
								{
									"date": "2016-06-29T00:00:00 -0500",
									"value": 89292.5,
									"status": "GRAY"
								},
								{
									"date": "2016-06-30T00:00:00 -0500",
									"value": 400337.38,
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"value": 496618.5,
									"status": "GRAY"
								},
								{
									"date": "2016-07-02T00:00:00 -0500",
									"value": 455592,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"value": 384374.5,
									"status": "GRAY"
								},
								{
									"date": "2016-07-04T00:00:00 -0500",
									"value": 480413.88,
									"status": "GRAY"
								},
								{
									"date": "2016-07-05T00:00:00 -0500",
									"value": 470177.88,
									"status": "GRAY"
								},
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 401880.88,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 454938.25,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 459968,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 400460,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 343401.5,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 447983,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 456697,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1721,
								"name": "Prepaid Usage Revenue- CAMEL",
								"unit": "DOLLAR",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 5640,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 8970,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 6840,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 3840,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 3000,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 6360,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 4740,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 4740,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 3960,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 2340,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 3240,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 2880,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 5400,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"value": 3480,
									"status": "GRAY"
								},
								{
									"date": "2016-06-27T00:00:00 -0500",
									"value": 3360,
									"status": "GRAY"
								},
								{
									"date": "2016-06-28T00:00:00 -0500",
									"value": 2400,
									"status": "GRAY"
								},
								{
									"date": "2016-06-29T00:00:00 -0500",
									"value": 600,
									"status": "GRAY"
								},
								{
									"date": "2016-06-30T00:00:00 -0500",
									"value": 3000,
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"value": 1440,
									"status": "GRAY"
								},
								{
									"date": "2016-07-02T00:00:00 -0500",
									"value": 2520,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"value": 3840,
									"status": "GRAY"
								},
								{
									"date": "2016-07-04T00:00:00 -0500",
									"value": 3120,
									"status": "GRAY"
								},
								{
									"date": "2016-07-05T00:00:00 -0500",
									"value": 3240,
									"status": "GRAY"
								},
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 2640,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 4470,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 4320,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 3120,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 4440,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 2400,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 2640,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1731,
								"name": "Prepaid Usage Revenue- AT&TToSmart SMS",
								"unit": "DOLLAR",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 526148,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 460797,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 464689,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 464835,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 475693,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 430471,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 445139,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 475734,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 449300,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 428300,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 434321,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 453137,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 416448,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"value": 363113,
									"status": "GRAY"
								},
								{
									"date": "2016-06-27T00:00:00 -0500",
									"value": 438916,
									"status": "GRAY"
								},
								{
									"date": "2016-06-28T00:00:00 -0500",
									"value": 307109,
									"status": "GRAY"
								},
								{
									"date": "2016-06-29T00:00:00 -0500",
									"value": 90831,
									"status": "GRAY"
								},
								{
									"date": "2016-06-30T00:00:00 -0500",
									"value": 444054,
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"value": 502156,
									"status": "GRAY"
								},
								{
									"date": "2016-07-02T00:00:00 -0500",
									"value": 513614,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"value": 407094,
									"status": "GRAY"
								},
								{
									"date": "2016-07-04T00:00:00 -0500",
									"value": 466024,
									"status": "GRAY"
								},
								{
									"date": "2016-07-05T00:00:00 -0500",
									"value": 441999,
									"status": "GRAY"
								},
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 375778,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 396483,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 423907,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 373723,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 327455,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 403427,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 400089,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1741,
								"name": "Prepaid Usage Revenue- EAGLE",
								"unit": "DOLLAR",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 360,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 240,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 120,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 1020,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 360,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 120,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 540,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 600,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 360,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 120,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 120,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 2790,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 120,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"value": 480,
									"status": "GRAY"
								},
								{
									"date": "2016-06-27T00:00:00 -0500",
									"value": 630,
									"status": "GRAY"
								},
								{
									"date": "2016-06-28T00:00:00 -0500",
									"value": 120,
									"status": "GRAY"
								},
								{
									"date": "2016-06-29T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-06-30T00:00:00 -0500",
									"value": 150,
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"value": 630,
									"status": "GRAY"
								},
								{
									"date": "2016-07-02T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"value": 240,
									"status": "GRAY"
								},
								{
									"date": "2016-07-04T00:00:00 -0500",
									"value": 360,
									"status": "GRAY"
								},
								{
									"date": "2016-07-05T00:00:00 -0500",
									"value": 240,
									"status": "GRAY"
								},
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 240,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 120,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 240,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 150,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 360,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 600,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1751,
								"name": "Prepaid Usage Revenue- GPRS",
								"unit": "DOLLAR",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 467048.03,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 445718.03,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 434866.06,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 432007.12,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 445281.66,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 450763.6,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 441172.03,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 458216.12,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 428207.25,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 409975.28,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 405897.94,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 413439.62,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 407281.38,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"value": 392424.06,
									"status": "GRAY"
								},
								{
									"date": "2016-06-27T00:00:00 -0500",
									"value": 378061.06,
									"status": "GRAY"
								},
								{
									"date": "2016-06-28T00:00:00 -0500",
									"value": 225810.27,
									"status": "GRAY"
								},
								{
									"date": "2016-06-29T00:00:00 -0500",
									"value": 76380.02,
									"status": "GRAY"
								},
								{
									"date": "2016-06-30T00:00:00 -0500",
									"value": 303488.4,
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"value": 338444.38,
									"status": "GRAY"
								},
								{
									"date": "2016-07-02T00:00:00 -0500",
									"value": 364539.7,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"value": 336436.22,
									"status": "GRAY"
								},
								{
									"date": "2016-07-04T00:00:00 -0500",
									"value": 338070.88,
									"status": "GRAY"
								},
								{
									"date": "2016-07-05T00:00:00 -0500",
									"value": 323488.38,
									"status": "GRAY"
								},
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 312016,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 306656.5,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 307112.06,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 315264.72,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 306459.28,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 308750.2,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 312005.4,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1761,
								"name": "Prepaid Usage Revenue- VOICE",
								"unit": "DOLLAR",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 1168727.2,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 1089164.9,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 1054620.2,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 1060414.1,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 1092492.2,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 1014427.8,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 978732.4,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 1137323.1,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 1049479.6,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 1022275.2,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 1011375.5,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 1053894.1,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 965743.6,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"value": 860719.7,
									"status": "GRAY"
								},
								{
									"date": "2016-06-27T00:00:00 -0500",
									"value": 1034662.75,
									"status": "GRAY"
								},
								{
									"date": "2016-06-28T00:00:00 -0500",
									"value": 753771.06,
									"status": "GRAY"
								},
								{
									"date": "2016-06-29T00:00:00 -0500",
									"value": 211163.73,
									"status": "GRAY"
								},
								{
									"date": "2016-06-30T00:00:00 -0500",
									"value": 966253.3,
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"value": 1323182.9,
									"status": "GRAY"
								},
								{
									"date": "2016-07-02T00:00:00 -0500",
									"value": 1476159.8,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"value": 1084509.9,
									"status": "GRAY"
								},
								{
									"date": "2016-07-04T00:00:00 -0500",
									"value": 1234008.1,
									"status": "GRAY"
								},
								{
									"date": "2016-07-05T00:00:00 -0500",
									"value": 1115509.8,
									"status": "GRAY"
								},
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 993426.56,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 1051153.5,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 1056997.9,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 956003.25,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 878093.6,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 1062081.8,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 1071877.5,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1771,
								"name": "Prepaid Usage Revenue- Intl Call SMS",
								"unit": "DOLLAR",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 189851.12,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 193501,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 224642,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 199188.66,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 153509.12,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 150864.12,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 215038.12,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 166059.27,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 148135.12,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 154707,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 142239,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 152279,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 146952,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"value": 142933,
									"status": "GRAY"
								},
								{
									"date": "2016-06-27T00:00:00 -0500",
									"value": 155661,
									"status": "GRAY"
								},
								{
									"date": "2016-06-28T00:00:00 -0500",
									"value": 104358,
									"status": "GRAY"
								},
								{
									"date": "2016-06-29T00:00:00 -0500",
									"value": 44198,
									"status": "GRAY"
								},
								{
									"date": "2016-06-30T00:00:00 -0500",
									"value": 162459,
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"value": 176214,
									"status": "GRAY"
								},
								{
									"date": "2016-07-02T00:00:00 -0500",
									"value": 169133,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"value": 163485,
									"status": "GRAY"
								},
								{
									"date": "2016-07-04T00:00:00 -0500",
									"value": 176003,
									"status": "GRAY"
								},
								{
									"date": "2016-07-05T00:00:00 -0500",
									"value": 166981,
									"status": "GRAY"
								},
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 168279,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 166637,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 156885,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 150096,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 141398,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 159037,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 152396,
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'overview/usage/quarterly': {
		"status": 200,
		"data": {
			"title": "Quarterly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "Usage",
					"subTitle": "Weekly",
					"metricSeries": [
						{
							"info": {
								"id": 1345,
								"name": "Postpaid Usage Count - VOICE",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 202,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 235,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 207,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 234,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 80,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 233964,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 244609,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 122,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 67,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"value": 158,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"value": 242584,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1355,
								"name": "Postpaid Usage Count -  SMS ",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 75,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 97,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 147,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 232,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 135,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 205779,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 293234,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 240,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 73,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"value": 234,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"value": 278595,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1365,
								"name": "Postpaid Usage Count -  GPRS ",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 99,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 114,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 204,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 111,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 240,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 38432,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 36602,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 217,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 117,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"value": 148,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"value": 40623,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1375,
								"name": "Postpaid Usage Count  - ROAMING VOICE",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 93,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 112,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 103,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 140,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 87,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 1080,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 1059,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 119,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 193,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"value": 157,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"value": 941,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1385,
								"name": "Postpaid Usage Count - ROAMING SMS ",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 195,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 223,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 68,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 242,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 153,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 1679,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 1549,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 222,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 128,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"value": 192,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"value": 1455,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1395,
								"name": "Postpaid Usage Count -  ROAMING GPRS",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 215,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 172,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 119,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 179,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 213,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 982,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 1085,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 247,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 203,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"value": 241,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"value": 994,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1405,
								"name": "Postpaid Usage Count - VAS",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 64,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 146,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 103,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 165,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 179,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 835,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 815,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 162,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 142,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"value": 115,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"value": 776,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1415,
								"name": "Postpaid Usage Revenue- VOICE",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 68.66,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 80.05,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 40.14,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 89.57,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 98.18,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 0.7,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 51.87,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 98.68,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 60.96,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"value": 22.88,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1425,
								"name": "Postpaid Usage Revenue- SMS",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 33.33,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 89.23,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 58.87,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 6.42,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 21.84,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 78.59,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 98.72,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 1.49,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 5.57,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"value": 74.59,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1435,
								"name": "Postpaid Usage Revenue- GPRS",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 67,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 15.58,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 17.02,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 77.75,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 24.6,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 80.15,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 4.75,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 97.41,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 34.85,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"value": 93.61,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1445,
								"name": "Postpaid Usage Revenue- ROAMING VOICE",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 5.1,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 67.98,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 8.67,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 67.67,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 83.81,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 3.99,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 44.61,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 11.19,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 72.68,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"value": 28.56,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1455,
								"name": "Postpaid Usage Revenue- ROAMING SMS",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 39.57,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 16,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 31.86,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 54.95,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 47.14,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 45.4,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 13.17,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 20.52,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 29.45,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"value": 89.28,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1465,
								"name": "Postpaid Usage Revenue- ROAMING GPRS",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 19.28,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 42.06,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 95.04,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 15.68,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 87.52,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 51.66,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 32.33,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 16.47,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 73.48,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"value": 52.47,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1475,
								"name": "Postpaid Usage Revenue- VAS",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 33.23,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 15.34,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 30.07,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 73.06,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 35.41,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 83.57,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 94.84,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 0.4,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 40.65,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"value": 80.09,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'overview/crm-cases/weekly': {
		"status": 200,
		"data": {
			"title": "Weekly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "Open/Close Cases",
					"subTitle": "Daily",
					"metricSeries": [
						{
							"info": {
								"id": 1301,
								"name": "Cases Opened",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 1845,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 2566,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 2133,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 2126,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 2311,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 1804,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1311,
								"name": "Cases Closed",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 7716,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 7890,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 8238,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 7861,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 7363,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 7124,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1821,
								"name": "Cases Backlog",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 74,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 214,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 142,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 234,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 96,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 143,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'overview/crm-cases/monthly': {
		"status": 200,
		"data": {
			"title": "Monthly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "Open/Close Cases",
					"subTitle": "Daily",
					"metricSeries": [
						{
							"info": {
								"id": 1301,
								"name": "Cases Opened",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-05-28T00:00:00 -0500",
									"value": 1249,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 1394,
									"status": "GRAY"
								},
								{
									"date": "2016-05-30T00:00:00 -0500",
									"value": 2368,
									"status": "GRAY"
								},
								{
									"date": "2016-05-31T00:00:00 -0500",
									"value": 2894,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 2752,
									"status": "GRAY"
								},
								{
									"date": "2016-06-02T00:00:00 -0500",
									"value": 2602,
									"status": "GRAY"
								},
								{
									"date": "2016-06-03T00:00:00 -0500",
									"value": 2041,
									"status": "GRAY"
								},
								{
									"date": "2016-06-04T00:00:00 -0500",
									"value": 1206,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 742,
									"status": "GRAY"
								},
								{
									"date": "2016-06-06T00:00:00 -0500",
									"value": 3315,
									"status": "GRAY"
								},
								{
									"date": "2016-06-07T00:00:00 -0500",
									"value": 2317,
									"status": "GRAY"
								},
								{
									"date": "2016-06-08T00:00:00 -0500",
									"value": 3649,
									"status": "GRAY"
								},
								{
									"date": "2016-06-09T00:00:00 -0500",
									"value": 2131,
									"status": "GRAY"
								},
								{
									"date": "2016-06-10T00:00:00 -0500",
									"value": 2118,
									"status": "GRAY"
								},
								{
									"date": "2016-06-11T00:00:00 -0500",
									"value": 82,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 1820,
									"status": "GRAY"
								},
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 1985,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 2370,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 2698,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 1846,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 1847,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 1370,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 132,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 1845,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 2566,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 2133,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 2126,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 2311,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 1804,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1311,
								"name": "Cases Closed",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-05-28T00:00:00 -0500",
									"value": 7489,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 6210,
									"status": "GRAY"
								},
								{
									"date": "2016-05-30T00:00:00 -0500",
									"value": 7710,
									"status": "GRAY"
								},
								{
									"date": "2016-05-31T00:00:00 -0500",
									"value": 9546,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 6037,
									"status": "GRAY"
								},
								{
									"date": "2016-06-02T00:00:00 -0500",
									"value": 6554,
									"status": "GRAY"
								},
								{
									"date": "2016-06-03T00:00:00 -0500",
									"value": 7135,
									"status": "GRAY"
								},
								{
									"date": "2016-06-04T00:00:00 -0500",
									"value": 6915,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 5291,
									"status": "GRAY"
								},
								{
									"date": "2016-06-06T00:00:00 -0500",
									"value": 6539,
									"status": "GRAY"
								},
								{
									"date": "2016-06-07T00:00:00 -0500",
									"value": 7133,
									"status": "GRAY"
								},
								{
									"date": "2016-06-08T00:00:00 -0500",
									"value": 7084,
									"status": "GRAY"
								},
								{
									"date": "2016-06-09T00:00:00 -0500",
									"value": 7598,
									"status": "GRAY"
								},
								{
									"date": "2016-06-10T00:00:00 -0500",
									"value": 7449,
									"status": "GRAY"
								},
								{
									"date": "2016-06-11T00:00:00 -0500",
									"value": 170,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 5901,
									"status": "GRAY"
								},
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 6715,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 7499,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 7835,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 7505,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 7164,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 6884,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 157,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 7716,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 7890,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 8238,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 7861,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 7363,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 7124,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1821,
								"name": "Cases Backlog",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-05-28T00:00:00 -0500",
									"value": 210,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 83,
									"status": "GRAY"
								},
								{
									"date": "2016-05-30T00:00:00 -0500",
									"value": 249,
									"status": "GRAY"
								},
								{
									"date": "2016-05-31T00:00:00 -0500",
									"value": 51,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 81,
									"status": "GRAY"
								},
								{
									"date": "2016-06-02T00:00:00 -0500",
									"value": 85,
									"status": "GRAY"
								},
								{
									"date": "2016-06-03T00:00:00 -0500",
									"value": 82,
									"status": "GRAY"
								},
								{
									"date": "2016-06-04T00:00:00 -0500",
									"value": 84,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 208,
									"status": "GRAY"
								},
								{
									"date": "2016-06-06T00:00:00 -0500",
									"value": 175,
									"status": "GRAY"
								},
								{
									"date": "2016-06-07T00:00:00 -0500",
									"value": 135,
									"status": "GRAY"
								},
								{
									"date": "2016-06-08T00:00:00 -0500",
									"value": 198,
									"status": "GRAY"
								},
								{
									"date": "2016-06-09T00:00:00 -0500",
									"value": 206,
									"status": "GRAY"
								},
								{
									"date": "2016-06-10T00:00:00 -0500",
									"value": 181,
									"status": "GRAY"
								},
								{
									"date": "2016-06-11T00:00:00 -0500",
									"value": 113,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 199,
									"status": "GRAY"
								},
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 232,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 209,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 203,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 83,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 247,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 107,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 230,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 74,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 214,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 142,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 234,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 96,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 143,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'overview/crm-cases/quarterly': {
		"status": 200,
		"data": {
			"title": "Quarterly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "Open/Close Cases",
					"subTitle": "Weekly",
					"metricSeries": [
						{
							"info": {
								"id": 1305,
								"name": "Cases Opened",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 60,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 67,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 86,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 134,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 87,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 225,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 143,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 199,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 184,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 152,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 137,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1315,
								"name": "Cases Closed",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 224,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 54,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 228,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 220,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 108,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 189,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 74,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 136,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 204,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 214,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 188,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1825,
								"name": "Cases Backlog",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 185,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 167,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 160,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 171,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 129,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 187,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 94,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 192,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 162,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 69,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 218,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}




	, 'overview/order-fallout/weekly': {
		"status": 200,
		"data": {
			"title": "Weekly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "Order Fallout",
					"subTitle": "Daily",
					"metricSeries": [
						{
							"info": {
								"id": 1041,
								"name": "(Order Fallout) Incoming Count - Amdocs",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 4,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 8,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 15,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 17,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 17,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 19,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1051,
								"name": "(Order Fallout) Incoming Count - AT&T",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 2307,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 2682,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 2643,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 2484,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 2543,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 1720,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1081,
								"name": "(Order Fallout) Cumulative Count - Amdocs",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 61,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 68,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 73,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 56,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 87,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 105,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1091,
								"name": "(Order Fallout) Cumulative Count - AT&T",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 35643,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 37220,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 38749,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 36845,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 38445,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 39268,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1121,
								"name": "(Order Fallout) Notify Billing Cumulative - Amdocs",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 47,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 48,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 41,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 40,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 44,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 45,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1131,
								"name": "(Order Fallout) Aged 1 Week Cumulative - Amdocs",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 40,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 43,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 42,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 34,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 49,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 49,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1061,
								"name": "(Order Fallout)  Incoming Percentage - Amdocs",
								"unit": "PERCENTAGE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 0.01,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 0.02,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 0.04,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 0.04,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 0.04,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 0.05,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1071,
								"name": "(Order Fallout)  Incoming Percentage - AT&T",
								"unit": "PERCENTAGE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 4.62,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 5.78,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 6.24,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 5.66,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 5.38,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 4.79,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1101,
								"name": "(Order Fallout) Cumulative Percentage - Amdocs",
								"unit": "PERCENTAGE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1111,
								"name": "(Order Fallout) Cumulative Percentage - AT&T",
								"unit": "PERCENTAGE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 0.01,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 0.01,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 0.01,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 0.01,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 0.01,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'overview/order-fallout/monthly': {
		"status": 200,
		"data": {
			"title": "Monthly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "Call Center AHT",
					"subTitle": "Daily",
					"metricSeries": [
						{
							"info": {
								"id": 1041,
								"name": "(Order Fallout) Incoming Count - Amdocs",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-05-28T00:00:00 -0500",
									"value": 16,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 8,
									"status": "GRAY"
								},
								{
									"date": "2016-05-30T00:00:00 -0500",
									"value": 19,
									"status": "GRAY"
								},
								{
									"date": "2016-05-31T00:00:00 -0500",
									"value": 21,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 6,
									"status": "GRAY"
								},
								{
									"date": "2016-06-02T00:00:00 -0500",
									"value": 11,
									"status": "GRAY"
								},
								{
									"date": "2016-06-03T00:00:00 -0500",
									"value": 27,
									"status": "GRAY"
								},
								{
									"date": "2016-06-04T00:00:00 -0500",
									"value": 15,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 19,
									"status": "GRAY"
								},
								{
									"date": "2016-06-06T00:00:00 -0500",
									"value": 9,
									"status": "GRAY"
								},
								{
									"date": "2016-06-07T00:00:00 -0500",
									"value": 12,
									"status": "GRAY"
								},
								{
									"date": "2016-06-08T00:00:00 -0500",
									"value": 9,
									"status": "GRAY"
								},
								{
									"date": "2016-06-09T00:00:00 -0500",
									"value": 20,
									"status": "GRAY"
								},
								{
									"date": "2016-06-10T00:00:00 -0500",
									"value": 17,
									"status": "GRAY"
								},
								{
									"date": "2016-06-11T00:00:00 -0500",
									"value": 70,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 12,
									"status": "GRAY"
								},
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 13,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 9,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 8,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 10,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 19,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 26,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 193,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 4,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 8,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 15,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 17,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 17,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 19,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1051,
								"name": "(Order Fallout) Incoming Count - AT&T",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-05-28T00:00:00 -0500",
									"value": 1583,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 1342,
									"status": "GRAY"
								},
								{
									"date": "2016-05-30T00:00:00 -0500",
									"value": 2641,
									"status": "GRAY"
								},
								{
									"date": "2016-05-31T00:00:00 -0500",
									"value": 2617,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 2257,
									"status": "GRAY"
								},
								{
									"date": "2016-06-02T00:00:00 -0500",
									"value": 2592,
									"status": "GRAY"
								},
								{
									"date": "2016-06-03T00:00:00 -0500",
									"value": 2592,
									"status": "GRAY"
								},
								{
									"date": "2016-06-04T00:00:00 -0500",
									"value": 1532,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 1212,
									"status": "GRAY"
								},
								{
									"date": "2016-06-06T00:00:00 -0500",
									"value": 2138,
									"status": "GRAY"
								},
								{
									"date": "2016-06-07T00:00:00 -0500",
									"value": 2677,
									"status": "GRAY"
								},
								{
									"date": "2016-06-08T00:00:00 -0500",
									"value": 2452,
									"status": "GRAY"
								},
								{
									"date": "2016-06-09T00:00:00 -0500",
									"value": 2541,
									"status": "GRAY"
								},
								{
									"date": "2016-06-10T00:00:00 -0500",
									"value": 2558,
									"status": "GRAY"
								},
								{
									"date": "2016-06-11T00:00:00 -0500",
									"value": 131,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 1170,
									"status": "GRAY"
								},
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 2430,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 2584,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 2369,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 2622,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 2158,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 1388,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 227,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 2307,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 2682,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 2643,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 2484,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 2543,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 1720,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1081,
								"name": "(Order Fallout) Cumulative Count - Amdocs",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-05-28T00:00:00 -0500",
									"value": 114,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 105,
									"status": "GRAY"
								},
								{
									"date": "2016-05-30T00:00:00 -0500",
									"value": 86,
									"status": "GRAY"
								},
								{
									"date": "2016-05-31T00:00:00 -0500",
									"value": 105,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 106,
									"status": "GRAY"
								},
								{
									"date": "2016-06-02T00:00:00 -0500",
									"value": 99,
									"status": "GRAY"
								},
								{
									"date": "2016-06-03T00:00:00 -0500",
									"value": 122,
									"status": "GRAY"
								},
								{
									"date": "2016-06-04T00:00:00 -0500",
									"value": 134,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 151,
									"status": "GRAY"
								},
								{
									"date": "2016-06-06T00:00:00 -0500",
									"value": 101,
									"status": "GRAY"
								},
								{
									"date": "2016-06-07T00:00:00 -0500",
									"value": 74,
									"status": "GRAY"
								},
								{
									"date": "2016-06-08T00:00:00 -0500",
									"value": 80,
									"status": "GRAY"
								},
								{
									"date": "2016-06-09T00:00:00 -0500",
									"value": 67,
									"status": "GRAY"
								},
								{
									"date": "2016-06-10T00:00:00 -0500",
									"value": 64,
									"status": "GRAY"
								},
								{
									"date": "2016-06-11T00:00:00 -0500",
									"value": 221,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 91,
									"status": "GRAY"
								},
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 70,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 79,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 80,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 77,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 89,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 128,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 175,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 61,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 68,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 73,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 56,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 87,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 105,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1091,
								"name": "(Order Fallout) Cumulative Count - AT&T",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-05-28T00:00:00 -0500",
									"value": 47510,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 48323,
									"status": "GRAY"
								},
								{
									"date": "2016-05-30T00:00:00 -0500",
									"value": 49943,
									"status": "GRAY"
								},
								{
									"date": "2016-05-31T00:00:00 -0500",
									"value": 45312,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 46322,
									"status": "GRAY"
								},
								{
									"date": "2016-06-02T00:00:00 -0500",
									"value": 47977,
									"status": "GRAY"
								},
								{
									"date": "2016-06-03T00:00:00 -0500",
									"value": 49574,
									"status": "GRAY"
								},
								{
									"date": "2016-06-04T00:00:00 -0500",
									"value": 50492,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 47457,
									"status": "GRAY"
								},
								{
									"date": "2016-06-06T00:00:00 -0500",
									"value": 48081,
									"status": "GRAY"
								},
								{
									"date": "2016-06-07T00:00:00 -0500",
									"value": 49459,
									"status": "GRAY"
								},
								{
									"date": "2016-06-08T00:00:00 -0500",
									"value": 50922,
									"status": "GRAY"
								},
								{
									"date": "2016-06-09T00:00:00 -0500",
									"value": 49151,
									"status": "GRAY"
								},
								{
									"date": "2016-06-10T00:00:00 -0500",
									"value": 47335,
									"status": "GRAY"
								},
								{
									"date": "2016-06-11T00:00:00 -0500",
									"value": 132,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 42468,
									"status": "GRAY"
								},
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 43183,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 44076,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 41111,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 42577,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 36823,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 37467,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 67,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 35643,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 37220,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 38749,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 36845,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 38445,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 39268,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1121,
								"name": "(Order Fallout) Notify Billing Cumulative - Amdocs",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-05-28T00:00:00 -0500",
									"value": 71,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 60,
									"status": "GRAY"
								},
								{
									"date": "2016-05-30T00:00:00 -0500",
									"value": 58,
									"status": "GRAY"
								},
								{
									"date": "2016-05-31T00:00:00 -0500",
									"value": 72,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 81,
									"status": "GRAY"
								},
								{
									"date": "2016-06-02T00:00:00 -0500",
									"value": 69,
									"status": "GRAY"
								},
								{
									"date": "2016-06-03T00:00:00 -0500",
									"value": 71,
									"status": "GRAY"
								},
								{
									"date": "2016-06-04T00:00:00 -0500",
									"value": 70,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 73,
									"status": "GRAY"
								},
								{
									"date": "2016-06-06T00:00:00 -0500",
									"value": 79,
									"status": "GRAY"
								},
								{
									"date": "2016-06-07T00:00:00 -0500",
									"value": 61,
									"status": "GRAY"
								},
								{
									"date": "2016-06-08T00:00:00 -0500",
									"value": 60,
									"status": "GRAY"
								},
								{
									"date": "2016-06-09T00:00:00 -0500",
									"value": 35,
									"status": "GRAY"
								},
								{
									"date": "2016-06-10T00:00:00 -0500",
									"value": 37,
									"status": "GRAY"
								},
								{
									"date": "2016-06-11T00:00:00 -0500",
									"value": 194,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 39,
									"status": "GRAY"
								},
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 34,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 33,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 31,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 37,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 37,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 52,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 174,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 47,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 48,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 41,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 40,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 44,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 45,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1131,
								"name": "(Order Fallout) Aged 1 Week Cumulative - Amdocs",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-05-28T00:00:00 -0500",
									"value": 57,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 58,
									"status": "GRAY"
								},
								{
									"date": "2016-05-30T00:00:00 -0500",
									"value": 43,
									"status": "GRAY"
								},
								{
									"date": "2016-05-31T00:00:00 -0500",
									"value": 50,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 70,
									"status": "GRAY"
								},
								{
									"date": "2016-06-02T00:00:00 -0500",
									"value": 62,
									"status": "GRAY"
								},
								{
									"date": "2016-06-03T00:00:00 -0500",
									"value": 65,
									"status": "GRAY"
								},
								{
									"date": "2016-06-04T00:00:00 -0500",
									"value": 66,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 69,
									"status": "GRAY"
								},
								{
									"date": "2016-06-06T00:00:00 -0500",
									"value": 76,
									"status": "GRAY"
								},
								{
									"date": "2016-06-07T00:00:00 -0500",
									"value": 60,
									"status": "GRAY"
								},
								{
									"date": "2016-06-08T00:00:00 -0500",
									"value": 61,
									"status": "GRAY"
								},
								{
									"date": "2016-06-09T00:00:00 -0500",
									"value": 32,
									"status": "GRAY"
								},
								{
									"date": "2016-06-10T00:00:00 -0500",
									"value": 40,
									"status": "GRAY"
								},
								{
									"date": "2016-06-11T00:00:00 -0500",
									"value": 131,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 43,
									"status": "GRAY"
								},
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 44,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 44,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 44,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 54,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 58,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 73,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 154,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 40,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 43,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 42,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 34,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 49,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 49,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1061,
								"name": "(Order Fallout)  Incoming Percentage - Amdocs",
								"unit": "PERCENTAGE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-05-28T00:00:00 -0500",
									"value": 0.04,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 0.02,
									"status": "GRAY"
								},
								{
									"date": "2016-05-30T00:00:00 -0500",
									"value": 0.04,
									"status": "GRAY"
								},
								{
									"date": "2016-05-31T00:00:00 -0500",
									"value": 0.05,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 0.01,
									"status": "GRAY"
								},
								{
									"date": "2016-06-02T00:00:00 -0500",
									"value": 0.02,
									"status": "GRAY"
								},
								{
									"date": "2016-06-03T00:00:00 -0500",
									"value": 0.06,
									"status": "GRAY"
								},
								{
									"date": "2016-06-04T00:00:00 -0500",
									"value": 0.04,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 0.07,
									"status": "GRAY"
								},
								{
									"date": "2016-06-06T00:00:00 -0500",
									"value": 0.02,
									"status": "GRAY"
								},
								{
									"date": "2016-06-07T00:00:00 -0500",
									"value": 0.03,
									"status": "GRAY"
								},
								{
									"date": "2016-06-08T00:00:00 -0500",
									"value": 0.03,
									"status": "GRAY"
								},
								{
									"date": "2016-06-09T00:00:00 -0500",
									"value": 0.05,
									"status": "GRAY"
								},
								{
									"date": "2016-06-10T00:00:00 -0500",
									"value": 0.03,
									"status": "GRAY"
								},
								{
									"date": "2016-06-11T00:00:00 -0500",
									"value": 98.59,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 0.04,
									"status": "GRAY"
								},
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 0.02,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 0.02,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 0.02,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 0.02,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 0.05,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 0.05,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 19.98,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 0.01,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 0.02,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 0.04,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 0.04,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 0.04,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 0.05,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1071,
								"name": "(Order Fallout)  Incoming Percentage - AT&T",
								"unit": "PERCENTAGE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-05-28T00:00:00 -0500",
									"value": 4.36,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 3.84,
									"status": "GRAY"
								},
								{
									"date": "2016-05-30T00:00:00 -0500",
									"value": 5.62,
									"status": "GRAY"
								},
								{
									"date": "2016-05-31T00:00:00 -0500",
									"value": 5.99,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 2.4,
									"status": "GRAY"
								},
								{
									"date": "2016-06-02T00:00:00 -0500",
									"value": 4.96,
									"status": "GRAY"
								},
								{
									"date": "2016-06-03T00:00:00 -0500",
									"value": 5.47,
									"status": "GRAY"
								},
								{
									"date": "2016-06-04T00:00:00 -0500",
									"value": 3.78,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 4.27,
									"status": "GRAY"
								},
								{
									"date": "2016-06-06T00:00:00 -0500",
									"value": 4.76,
									"status": "GRAY"
								},
								{
									"date": "2016-06-07T00:00:00 -0500",
									"value": 7.52,
									"status": "GRAY"
								},
								{
									"date": "2016-06-08T00:00:00 -0500",
									"value": 7.12,
									"status": "GRAY"
								},
								{
									"date": "2016-06-09T00:00:00 -0500",
									"value": 6.03,
									"status": "GRAY"
								},
								{
									"date": "2016-06-10T00:00:00 -0500",
									"value": 5.13,
									"status": "GRAY"
								},
								{
									"date": "2016-06-11T00:00:00 -0500",
									"value": 85.19,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 4.34,
									"status": "GRAY"
								},
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 4.55,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 5.41,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 4.95,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 6.09,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 5.87,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 2.55,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 1.19,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 4.62,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 5.78,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 6.24,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 5.66,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 5.38,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 4.79,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1101,
								"name": "(Order Fallout) Cumulative Percentage - Amdocs",
								"unit": "PERCENTAGE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-05-28T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-05-30T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-05-31T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-06-02T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-06-03T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-06-04T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-06-06T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-06-07T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-06-08T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-06-09T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-06-10T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-06-11T00:00:00 -0500",
									"value": 49.32,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 48.41,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1111,
								"name": "(Order Fallout) Cumulative Percentage - AT&T",
								"unit": "PERCENTAGE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-05-28T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-05-30T00:00:00 -0500",
									"value": 0.01,
									"status": "GRAY"
								},
								{
									"date": "2016-05-31T00:00:00 -0500",
									"value": 0.01,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 0.01,
									"status": "GRAY"
								},
								{
									"date": "2016-06-02T00:00:00 -0500",
									"value": 0.01,
									"status": "GRAY"
								},
								{
									"date": "2016-06-03T00:00:00 -0500",
									"value": 0.01,
									"status": "GRAY"
								},
								{
									"date": "2016-06-04T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-06-06T00:00:00 -0500",
									"value": 0.01,
									"status": "GRAY"
								},
								{
									"date": "2016-06-07T00:00:00 -0500",
									"value": 0.01,
									"status": "GRAY"
								},
								{
									"date": "2016-06-08T00:00:00 -0500",
									"value": 0.01,
									"status": "GRAY"
								},
								{
									"date": "2016-06-09T00:00:00 -0500",
									"value": 0.01,
									"status": "GRAY"
								},
								{
									"date": "2016-06-10T00:00:00 -0500",
									"value": 0.01,
									"status": "GRAY"
								},
								{
									"date": "2016-06-11T00:00:00 -0500",
									"value": 69.85,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 0.01,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 0.01,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 0.01,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 0.01,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 0.01,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 31.2,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 0.01,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 0.01,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 0.01,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 0.01,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 0.01,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'overview/order-fallout/quarterly': {
		"status": 200,
		"data": {
			"title": "Quarterly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "Call Center AHT",
					"subTitle": "Weekly",
					"metricSeries": [
						{
							"info": {
								"id": 1045,
								"name": "(Order Fallout) Incoming Count - Amdocs",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 103,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 140,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 68,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 200,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 95,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 51,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 121,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 170,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 113,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 237,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 82,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1055,
								"name": "(Order Fallout) Incoming Count - AT&T",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 88,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 73,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 198,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 235,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 82,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 165,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 137,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 126,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 216,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 63,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 101,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1085,
								"name": "(Order Fallout) Cumulative Count - Amdocs",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 131,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 167,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 205,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 223,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 235,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 151,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 77,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 72,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 223,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 158,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 88,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1095,
								"name": "(Order Fallout) Cumulative Count - AT&T",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 118,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 226,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 112,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 156,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 178,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 105,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 94,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 112,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 87,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 232,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 106,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1125,
								"name": "(Order Fallout) Notify Billing Cumulative - Amdocs",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 78,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 220,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 82,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 139,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 217,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 225,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 116,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 86,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 73,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 211,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 50,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1135,
								"name": "(Order Fallout) Aged 1 Week Cumulative - Amdocs",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 95,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 200,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 128,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 127,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 95,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 237,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 121,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 151,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 228,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 151,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 188,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1065,
								"name": "(Order Fallout)  Incoming Percentage - Amdocs",
								"unit": "PERCENTAGE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 10.68,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 12.02,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 2.66,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 10.67,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 35.48,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 89.81,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 73.1,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 43.14,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 29.11,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 20.36,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 43.14,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1075,
								"name": "(Order Fallout)  Incoming Percentage - AT&T",
								"unit": "PERCENTAGE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 64.02,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 1.35,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 47.91,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 92.51,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 88.11,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 8.08,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 7.56,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 85.67,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 92.72,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 72.99,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 44.16,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1105,
								"name": "(Order Fallout) Cumulative Percentage - Amdocs",
								"unit": "PERCENTAGE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 20.81,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 53.86,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 95.32,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 68.87,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 73.52,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 2.22,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 74.63,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 50.17,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 55.91,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 25.34,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 79.25,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 1115,
								"name": "(Order Fallout) Cumulative Percentage - AT&T",
								"unit": "PERCENTAGE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 14.82,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 70.51,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 76.54,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 32.64,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 66.97,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 50.86,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 42.65,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 94.98,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 4.92,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 52.58,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 18.1,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'top-product-devices': {
		"status": 200,
		"data": {
			"title": "Top Devices and Product Offers",
			"graphs": [],
			"gauges": [],
			"metrics": [],
			"topContributors": [
				{
					"totalAmounts": 1426,
					"contributors": [
						{
							"activity": "iPhone 7",
							"amount": 153456,
							"update": "iPhone 7"
						},
						{
							"activity": "iPhone 6",
							"amount": 70003,
							"update": "iPhone 6"
						},
						{
							"activity": "Samsung Galaxy S7",
							"amount": 80067,
							"update": "Samsung Galaxy S7"
						},
						{
							"activity": "Samsung Galaxy J1 2016 Gold",
							"amount": 95,
							"update": "Samsung Galaxy J1 2016 Gold"
						},
						{
							"activity": "Lenovo A2010 Blk",
							"amount": 86,
							"update": "Lenovo A2010 Blk"
						},
						{
							"activity": "Huawei Titan Blk",
							"amount": 80,
							"update": "Huawei Titan Blk"
						},
						{
							"activity": "Samsung Galaxy J1 Mini Blk",
							"amount": 80,
							"update": "Samsung Galaxy J1 Mini Blk"
						},
						{
							"activity": "Asus Zenfone Go (ZB452KG) Silver",
							"amount": 64,
							"update": "Asus Zenfone Go (ZB452KG) Silver"
						},
						{
							"activity": "Lenovo A6000 Blk",
							"amount": 61,
							"update": "Lenovo A6000 Blk"
						},
						{
							"activity": "Samsung Galaxy J5 2016 Wht",
							"amount": 53,
							"update": "Samsung Galaxy J5 2016 Wht"
						},
						{
							"activity": "Samsung Tab 3 7.0 Bundle",
							"amount": 46,
							"update": "Samsung Tab 3 7.0 Bundle"
						},
						{
							"activity": "LENOVO A6000 BUN BLK",
							"amount": 45,
							"update": "LENOVO A6000 BUN BLK"
						},
						{
							"activity": "Samsung Galaxy J1 2016 Wht",
							"amount": 41,
							"update": "Samsung Galaxy J1 2016 Wht"
						},
						{
							"activity": "Samsung Galaxy J1 Mini Wht",
							"amount": 40,
							"update": "Samsung Galaxy J1 Mini Wht"
						},
						{
							"activity": "Samsung Tab 3 10.1 P5210",
							"amount": 36,
							"update": "Samsung Tab 3 10.1 P5210"
						},
						{
							"activity": "Samsung Galaxy S7 32GB Gold",
							"amount": 35,
							"update": "Samsung Galaxy S7 32GB Gold"
						},
						{
							"activity": "Samsung Galaxy J5 Bun Gold",
							"amount": 30,
							"update": "Samsung Galaxy J5 Bun Gold"
						},
						{
							"activity": "Samsung Galaxy J7 Blk",
							"amount": 28,
							"update": "Samsung Galaxy J7 Blk"
						},
						{
							"activity": "Huawei E3531",
							"amount": 27,
							"update": "Huawei E3531"
						},
						{
							"activity": "Samsung Galaxy J7 2016 Wht",
							"amount": 27,
							"update": "Samsung Galaxy J7 2016 Wht"
						},
						{
							"activity": "Samsung Galaxy J7 2016 Gold",
							"amount": 25,
							"update": "Samsung Galaxy J7 2016 Gold"
						},
						{
							"activity": "iPhone 6s 16GB Rose Gold",
							"amount": 22,
							"update": "iPhone 6s 16GB Rose Gold"
						},
						{
							"activity": "IPHONE 5S GOLD 16GB",
							"amount": 21,
							"update": "IPHONE 5S GOLD 16GB"
						},
						{
							"activity": "Cloudfone Geo 500Q Blk",
							"amount": 18,
							"update": "Cloudfone Geo 500Q Blk"
						},
						{
							"activity": "Samsung Galaxy S7 Edge 32GB Silver",
							"amount": 17,
							"update": "Samsung Galaxy S7 Edge 32GB Silver"
						},
						{
							"activity": "iPhone SE 16GB R.Gold",
							"amount": 17,
							"update": "iPhone SE 16GB R.Gold"
						},
						{
							"activity": "Samsung S5 White 16GB",
							"amount": 17,
							"update": "Samsung S5 White 16GB"
						},
						{
							"activity": "Samsung Galaxy S7 32GB Blk",
							"amount": 17,
							"update": "Samsung Galaxy S7 32GB Blk"
						},
						{
							"activity": "Samsung Galaxy J2 Wht",
							"amount": 16,
							"update": "Samsung Galaxy J2 Wht"
						},
						{
							"activity": "Samsung Galaxy J5 Gold",
							"amount": 16,
							"update": "Samsung Galaxy J5 Gold"
						},
						{
							"activity": "AP P8500",
							"amount": 15,
							"update": "AP P8500"
						},
						{
							"activity": "Lenovo A6000 Gray",
							"amount": 15,
							"update": "Lenovo A6000 Gray"
						},
						{
							"activity": "Huawei E5330 D1",
							"amount": 15,
							"update": "Huawei E5330 D1"
						},
						{
							"activity": "iPhone 6s 64GB Rose Gold",
							"amount": 14,
							"update": "iPhone 6s 64GB Rose Gold"
						},
						{
							"activity": "Cloudfone Excite 400dx Blk",
							"amount": 14,
							"update": "Cloudfone Excite 400dx Blk"
						},
						{
							"activity": "Samsung Galaxy S7 Edge 32GB Blk",
							"amount": 14,
							"update": "Samsung Galaxy S7 Edge 32GB Blk"
						},
						{
							"activity": "Cherry Mobile Flare J1 Gray",
							"amount": 14,
							"update": "Cherry Mobile Flare J1 Gray"
						},
						{
							"activity": "Cherry Mobile Flare S4 Lite Blk",
							"amount": 14,
							"update": "Cherry Mobile Flare S4 Lite Blk"
						}
					]
				},
				{
					"totalAmounts": 33036,
					"contributors": [
						{
							"activity": "Mobile Share Value Plan",
							"amount": 13980,
							"update": "Mobile Share Value Plan"
						},
						{
							"activity": "Consumer AT&T Broadband Super Homephone",
							"amount": 4148,
							"update": "Consumer AT&T Broadband Super Homephone"
						},
						{
							"activity": "Best-Ever mySUPERPLAN 999",
							"amount": 1938,
							"update": "Best-Ever mySUPERPLAN 999"
						},
						{
							"activity": "Best-Ever mySUPERPLAN All Unli",
							"amount": 1724,
							"update": "Best-Ever mySUPERPLAN All Unli"
						},
						{
							"activity": "GoSurf Plan",
							"amount": 1353,
							"update": "GoSurf Plan"
						},
						{
							"activity": "Best-Ever mySUPERPLAN 499",
							"amount": 1127,
							"update": "Best-Ever mySUPERPLAN 499"
						},
						{
							"activity": "Mainstream Line Only",
							"amount": 1089,
							"update": "Mainstream Line Only"
						},
						{
							"activity": "Best-Ever mySUPERPLAN 1799",
							"amount": 1020,
							"update": "Best-Ever mySUPERPLAN 1799"
						},
						{
							"activity": "mySUPERPLAN All Unli Plan",
							"amount": 721,
							"update": "mySUPERPLAN All Unli Plan"
						},
						{
							"activity": "Tattoo Unli 999 w/o VOICE",
							"amount": 609,
							"update": "Tattoo Unli 999 w/o VOICE"
						},
						{
							"activity": "Alternate",
							"amount": 528,
							"update": "Alternate"
						},
						{
							"activity": "Tactical Line-Only",
							"amount": 502,
							"update": "Tactical Line-Only"
						},
						{
							"activity": "Tattoo Plan 999 X",
							"amount": 354,
							"update": "Tattoo Plan 999 X"
						},
						{
							"activity": "Tactical",
							"amount": 272,
							"update": "Tactical"
						},
						{
							"activity": "BUSINESS FLEX PLAN",
							"amount": 249,
							"update": "BUSINESS FLEX PLAN"
						},
						{
							"activity": "Best-Ever mySUPERPLAN 299",
							"amount": 237,
							"update": "Best-Ever mySUPERPLAN 299"
						},
						{
							"activity": "Plan Zero",
							"amount": 204,
							"update": "Plan Zero"
						},
						{
							"activity": "myBusiness Unli Plus Postpaid Plan",
							"amount": 179,
							"update": "myBusiness Unli Plus Postpaid Plan"
						},
						{
							"activity": "Best-Ever mySUPERPLAN 1299",
							"amount": 167,
							"update": "Best-Ever mySUPERPLAN 1299"
						},
						{
							"activity": "MYBUSINESS POSTPAID PLAN ALL UNLI",
							"amount": 154,
							"update": "MYBUSINESS POSTPAID PLAN ALL UNLI"
						},
						{
							"activity": "Tattoo Easy Plan 999",
							"amount": 146,
							"update": "Tattoo Easy Plan 999"
						},
						{
							"activity": "BUSINESS PLUS",
							"amount": 123,
							"update": "BUSINESS PLUS"
						},
						{
							"activity": "mySUPERPLAN 299",
							"amount": 114,
							"update": "mySUPERPLAN 299"
						},
						{
							"activity": "myStarter Plan 500",
							"amount": 113,
							"update": "myStarter Plan 500"
						},
						{
							"activity": "myStarter Plan 300",
							"amount": 112,
							"update": "myStarter Plan 300"
						},
						{
							"activity": "Best-Ever mySUPERPLAN All Unli for BUSINESS",
							"amount": 112,
							"update": "Best-Ever mySUPERPLAN All Unli for BUSINESS"
						},
						{
							"activity": "UnliSurf Combo 1799",
							"amount": 109,
							"update": "UnliSurf Combo 1799"
						},
						{
							"activity": "mySUPERPLAN 499",
							"amount": 93,
							"update": "mySUPERPLAN 499"
						},
						{
							"activity": "Best-Ever mySUPERPLAN 999 for BUSINESS",
							"amount": 90,
							"update": "Best-Ever mySUPERPLAN 999 for BUSINESS"
						},
						{
							"activity": "Best-Ever mySUPERPLAN 2499",
							"amount": 86,
							"update": "Best-Ever mySUPERPLAN 2499"
						},
						{
							"activity": "UnliSurf Combo 999",
							"amount": 86,
							"update": "UnliSurf Combo 999"
						},
						{
							"activity": "AT&T Super Homephone",
							"amount": 83,
							"update": "AT&T Super Homephone"
						},
						{
							"activity": "BUSINESS PLUS COMBO",
							"amount": 81,
							"update": "BUSINESS PLUS COMBO"
						},
						{
							"activity": "Best-Ever mySUPERPLAN 1799 for BUSINESS",
							"amount": 61,
							"update": "Best-Ever mySUPERPLAN 1799 for BUSINESS"
						},
						{
							"activity": "Tattoo Plan 299 Z",
							"amount": 59,
							"update": "Tattoo Plan 299 Z"
						},
						{
							"activity": "MYBUSINESS POSTPAID PLAN 1799",
							"amount": 55,
							"update": "MYBUSINESS POSTPAID PLAN 1799"
						},
						{
							"activity": "MYBUSINESS POSTPAID PLAN 999",
							"amount": 49,
							"update": "MYBUSINESS POSTPAID PLAN 999"
						},
						{
							"activity": "Advantage Plan",
							"amount": 47,
							"update": "Advantage Plan"
						},
						{
							"activity": "Tattoo Plan 499 Z",
							"amount": 47,
							"update": "Tattoo Plan 499 Z"
						},
						{
							"activity": "MSP Group Plan Extension",
							"amount": 45,
							"update": "MSP Group Plan Extension"
						},
						{
							"activity": "BUSINESS PLAN",
							"amount": 38,
							"update": "BUSINESS PLAN"
						},
						{
							"activity": "Best-Ever mySUPERPLAN 499 for BUSINESS",
							"amount": 36,
							"update": "Best-Ever mySUPERPLAN 499 for BUSINESS"
						},
						{
							"activity": "MYBUSINESS POSTPAID PLAN 2499",
							"amount": 35,
							"update": "MYBUSINESS POSTPAID PLAN 2499"
						},
						{
							"activity": "G-Text Plan 500",
							"amount": 31,
							"update": "G-Text Plan 500"
						},
						{
							"activity": "IN-HOUSE SU PLAN",
							"amount": 31,
							"update": "IN-HOUSE SU PLAN"
						},
						{
							"activity": "MYBUSINESS POSTPAID PLAN 499",
							"amount": 26,
							"update": "MYBUSINESS POSTPAID PLAN 499"
						},
						{
							"activity": "My Fully-Loaded Plan 299",
							"amount": 25,
							"update": "My Fully-Loaded Plan 299"
						},
						{
							"activity": "G-Flex Plan 800",
							"amount": 23,
							"update": "G-Flex Plan 800"
						},
						{
							"activity": "MYBUSINESS POSTPAID PLAN 299",
							"amount": 23,
							"update": "MYBUSINESS POSTPAID PLAN 299"
						},
						{
							"activity": "mySUPERPLAN 999",
							"amount": 22,
							"update": "mySUPERPLAN 999"
						},
						{
							"activity": "Tattoo Easy Plan 299",
							"amount": 17,
							"update": "Tattoo Easy Plan 299"
						},
						{
							"activity": "Tattoo Easy Plan 499",
							"amount": 17,
							"update": "Tattoo Easy Plan 499"
						},
						{
							"activity": "Best-Ever mySUPERPLAN 299 for BUSINESS",
							"amount": 16,
							"update": "Best-Ever mySUPERPLAN 299 for BUSINESS"
						},
						{
							"activity": "Best-Ever MSP UnliSurf Plan 1799",
							"amount": 16,
							"update": "Best-Ever MSP UnliSurf Plan 1799"
						},
						{
							"activity": "Platinum Roaming Plan 5000",
							"amount": 14,
							"update": "Platinum Roaming Plan 5000"
						},
						{
							"activity": "G-FLEX PLAN W/O DATA SE",
							"amount": 14,
							"update": "G-FLEX PLAN W/O DATA SE"
						},
						{
							"activity": "myPlatinum Lifestyle Plan 4999 - All Net",
							"amount": 14,
							"update": "myPlatinum Lifestyle Plan 4999 - All Net"
						},
						{
							"activity": "SG AT&T Broadband Super Homephone",
							"amount": 14,
							"update": "SG AT&T Broadband Super Homephone"
						},
						{
							"activity": "myPlatinum Lifestyle Plan 3799",
							"amount": 14,
							"update": "myPlatinum Lifestyle Plan 3799"
						},
						{
							"activity": "UnliSurf Combo 2499",
							"amount": 13,
							"update": "UnliSurf Combo 2499"
						},
						{
							"activity": "Free Tattoo Plan 999X bundled with Postpaid Plan",
							"amount": 13,
							"update": "Free Tattoo Plan 999X bundled with Postpaid Plan"
						},
						{
							"activity": "MSP Group Plan (3 lines) P1499",
							"amount": 13,
							"update": "MSP Group Plan (3 lines) P1499"
						},
						{
							"activity": "AT&T Tattoo Unlimited 999",
							"amount": 12,
							"update": "AT&T Tattoo Unlimited 999"
						},
						{
							"activity": "G-Flex Plan 250",
							"amount": 11,
							"update": "G-Flex Plan 250"
						},
						{
							"activity": "ACCOUNT SPECIFIC BUSINESS PLUS PLAN",
							"amount": 10,
							"update": "ACCOUNT SPECIFIC BUSINESS PLUS PLAN"
						},
						{
							"activity": "Tattoo LTE 1299 X",
							"amount": 10,
							"update": "Tattoo LTE 1299 X"
						},
						{
							"activity": "Plan 100",
							"amount": 10,
							"update": "Plan 100"
						},
						{
							"activity": "MYBUSINESS POSTPAID PLAN 1299",
							"amount": 9,
							"update": "MYBUSINESS POSTPAID PLAN 1299"
						},
						{
							"activity": "Tattoo Consumable Plan 299",
							"amount": 9,
							"update": "Tattoo Consumable Plan 299"
						},
						{
							"activity": "myBusiness Fixed Budget Plan",
							"amount": 9,
							"update": "myBusiness Fixed Budget Plan"
						},
						{
							"activity": "Best-Ever mySUPERPLAN 2499 for BUSINESS",
							"amount": 8,
							"update": "Best-Ever mySUPERPLAN 2499 for BUSINESS"
						},
						{
							"activity": "BlackBerry UnliSurf Combo 999",
							"amount": 8,
							"update": "BlackBerry UnliSurf Combo 999"
						},
						{
							"activity": "Tattoo Consumable Plan 499",
							"amount": 8,
							"update": "Tattoo Consumable Plan 499"
						},
						{
							"activity": "Platinum Premier 5K - 10 Freebies (A-E) or 1 Freebie (H-J)",
							"amount": 7,
							"update": "Platinum Premier 5K - 10 Freebies (A-E) or 1 Freebie (H-J)"
						},
						{
							"activity": "Best-Ever mySUPERPLAN 1299 for BUSINESS",
							"amount": 7,
							"update": "Best-Ever mySUPERPLAN 1299 for BUSINESS"
						},
						{
							"activity": "In-house Regular Plan",
							"amount": 7,
							"update": "In-house Regular Plan"
						},
						{
							"activity": "Personal Plan 799",
							"amount": 6,
							"update": "Personal Plan 799"
						},
						{
							"activity": "Load Tipid Combo 300",
							"amount": 6,
							"update": "Load Tipid Combo 300"
						},
						{
							"activity": "My Fully-Loaded Plan 499",
							"amount": 6,
							"update": "My Fully-Loaded Plan 499"
						},
						{
							"activity": "My Fully-Loaded Plan 299 (FCN)",
							"amount": 5,
							"update": "My Fully-Loaded Plan 299 (FCN)"
						},
						{
							"activity": "AT&T Postpaid iPad LTE Surfing Plan 999",
							"amount": 5,
							"update": "AT&T Postpaid iPad LTE Surfing Plan 999"
						},
						{
							"activity": "Platinum ALL-NET Plan 5000 FOR BUSINESS",
							"amount": 5,
							"update": "Platinum ALL-NET Plan 5000 FOR BUSINESS"
						},
						{
							"activity": "ACCOUNT SPECIFIC BUSINESS FLEX PLAN (WITH SUPERDUO)",
							"amount": 5,
							"update": "ACCOUNT SPECIFIC BUSINESS FLEX PLAN (WITH SUPERDUO)"
						},
						{
							"activity": "G-Mix 800",
							"amount": 5,
							"update": "G-Mix 800"
						},
						{
							"activity": "myShare Plan",
							"amount": 4,
							"update": "myShare Plan"
						},
						{
							"activity": "Platinum 5K",
							"amount": 4,
							"update": "Platinum 5K"
						},
						{
							"activity": "G-Flex Plan 500",
							"amount": 4,
							"update": "G-Flex Plan 500"
						},
						{
							"activity": "G-Flex Plan 1200",
							"amount": 4,
							"update": "G-Flex Plan 1200"
						},
						{
							"activity": "SAN MIGUEL GROUP PLAN",
							"amount": 4,
							"update": "SAN MIGUEL GROUP PLAN"
						},
						{
							"activity": "ACCOUNT SPECIFIC BUSINESS FLEX PLAN",
							"amount": 4,
							"update": "ACCOUNT SPECIFIC BUSINESS FLEX PLAN"
						},
						{
							"activity": "G-FLEX PLAN SE",
							"amount": 4,
							"update": "G-FLEX PLAN SE"
						},
						{
							"activity": "Super Davao Plan",
							"amount": 3,
							"update": "Super Davao Plan"
						},
						{
							"activity": "Best-Ever mySUPERPLAN 3799",
							"amount": 3,
							"update": "Best-Ever mySUPERPLAN 3799"
						},
						{
							"activity": "G-Talk 1200",
							"amount": 3,
							"update": "G-Talk 1200"
						},
						{
							"activity": "Best-Ever MSP Surf Plan 499",
							"amount": 3,
							"update": "Best-Ever MSP Surf Plan 499"
						},
						{
							"activity": "BUSINESS PLUS WITH P200 CONSUMABLE",
							"amount": 3,
							"update": "BUSINESS PLUS WITH P200 CONSUMABLE"
						},
						{
							"activity": "My Fully-Loaded Plan 3799",
							"amount": 3,
							"update": "My Fully-Loaded Plan 3799"
						},
						{
							"activity": "myPlatinum Lifestyle Plan 4999 - Roam",
							"amount": 3,
							"update": "myPlatinum Lifestyle Plan 4999 - Roam"
						},
						{
							"activity": "G-Flex Plan 5K",
							"amount": 3,
							"update": "G-Flex Plan 5K"
						},
						{
							"activity": "mySUPERPLAN 3799",
							"amount": 3,
							"update": "mySUPERPLAN 3799"
						},
						{
							"activity": "WIRELESS BROADBAND PLAN SE",
							"amount": 3,
							"update": "WIRELESS BROADBAND PLAN SE"
						},
						{
							"activity": "My Fully-Loaded Plan 999",
							"amount": 3,
							"update": "My Fully-Loaded Plan 999"
						},
						{
							"activity": "Best-Ever MSP UnliSurf Plan 999",
							"amount": 3,
							"update": "Best-Ever MSP UnliSurf Plan 999"
						},
						{
							"activity": "Platinum ALL-NET Plan 5000",
							"amount": 3,
							"update": "Platinum ALL-NET Plan 5000"
						},
						{
							"activity": "UNILAB PLAN",
							"amount": 3,
							"update": "UNILAB PLAN"
						},
						{
							"activity": "mySUPERPLAN 1799",
							"amount": 3,
							"update": "mySUPERPLAN 1799"
						},
						{
							"activity": "Tattoo LTE iPad Plan 999",
							"amount": 2,
							"update": "Tattoo LTE iPad Plan 999"
						},
						{
							"activity": "Melco Special Plan",
							"amount": 2,
							"update": "Melco Special Plan"
						},
						{
							"activity": "MYBUSINESS POSTPAID PLAN 3799",
							"amount": 2,
							"update": "MYBUSINESS POSTPAID PLAN 3799"
						},
						{
							"activity": "My Fully-Loaded Plan 499 (1FCN)",
							"amount": 2,
							"update": "My Fully-Loaded Plan 499 (1FCN)"
						},
						{
							"activity": "J & J PLAN",
							"amount": 2,
							"update": "J & J PLAN"
						},
						{
							"activity": "URF PLAN 600 WITH GPRS",
							"amount": 2,
							"update": "URF PLAN 600 WITH GPRS"
						},
						{
							"activity": "myPlatinum Lifestyle Plan 7999",
							"amount": 2,
							"update": "myPlatinum Lifestyle Plan 7999"
						},
						{
							"activity": "myShare Plan Extension",
							"amount": 2,
							"update": "myShare Plan Extension"
						},
						{
							"activity": "iPAD2 Unli Surf combo Plan 999",
							"amount": 2,
							"update": "iPAD2 Unli Surf combo Plan 999"
						},
						{
							"activity": "Tattoo Postpaid TORQUE Bundle",
							"amount": 2,
							"update": "Tattoo Postpaid TORQUE Bundle"
						},
						{
							"activity": "myBusiness Postpaid Plus Plan",
							"amount": 2,
							"update": "myBusiness Postpaid Plus Plan"
						},
						{
							"activity": "Unlimited Data Plan 999",
							"amount": 2,
							"update": "Unlimited Data Plan 999"
						},
						{
							"activity": "Best-Ever Platinum Plan 3799",
							"amount": 2,
							"update": "Best-Ever Platinum Plan 3799"
						},
						{
							"activity": "RVE SOFTWARE DATA PLAN",
							"amount": 2,
							"update": "RVE SOFTWARE DATA PLAN"
						},
						{
							"activity": "ACCOUNT SPECIFIC BUSINESS PLUS PLAN (WITH SUPERDUO)",
							"amount": 1,
							"update": "ACCOUNT SPECIFIC BUSINESS PLUS PLAN (WITH SUPERDUO)"
						},
						{
							"activity": "mySUPERPLAN 2499",
							"amount": 1,
							"update": "mySUPERPLAN 2499"
						},
						{
							"activity": "BlackBerry UnliSurf Combo 599",
							"amount": 1,
							"update": "BlackBerry UnliSurf Combo 599"
						},
						{
							"activity": "Best-Ever Platinum Plan 4999",
							"amount": 1,
							"update": "Best-Ever Platinum Plan 4999"
						},
						{
							"activity": "Tattoo Plan 499",
							"amount": 1,
							"update": "Tattoo Plan 499"
						},
						{
							"activity": "In-house Visibility Plan",
							"amount": 1,
							"update": "In-house Visibility Plan"
						},
						{
							"activity": "BPI MPOS PLAN 100",
							"amount": 1,
							"update": "BPI MPOS PLAN 100"
						},
						{
							"activity": "SM GROUP SPECIAL CUSTOM PLAN",
							"amount": 1,
							"update": "SM GROUP SPECIAL CUSTOM PLAN"
						},
						{
							"activity": "UKP PLAN 700 BARRED GPRS",
							"amount": 1,
							"update": "UKP PLAN 700 BARRED GPRS"
						},
						{
							"activity": "VPN EXPRESS WIRELESS UNLIMITED",
							"amount": 1,
							"update": "VPN EXPRESS WIRELESS UNLIMITED"
						},
						{
							"activity": "G-Flex Plan 2500",
							"amount": 1,
							"update": "G-Flex Plan 2500"
						},
						{
							"activity": "Best-Ever MSP Surf Plan 999",
							"amount": 1,
							"update": "Best-Ever MSP Surf Plan 999"
						},
						{
							"activity": "ACCENTURE PLAN WITH SUPERDUO",
							"amount": 1,
							"update": "ACCENTURE PLAN WITH SUPERDUO"
						},
						{
							"activity": "LANDCOM PLAN",
							"amount": 1,
							"update": "LANDCOM PLAN"
						},
						{
							"activity": "Platinum Roaming Plan 5000 (Bundle)",
							"amount": 1,
							"update": "Platinum Roaming Plan 5000 (Bundle)"
						},
						{
							"activity": "AT&T Postpaid iPad LTE Surfing Plan 499",
							"amount": 1,
							"update": "AT&T Postpaid iPad LTE Surfing Plan 499"
						},
						{
							"activity": "Best-Ever MSP UnliSurf Plan 1799 for BUSINESS",
							"amount": 1,
							"update": "Best-Ever MSP UnliSurf Plan 1799 for BUSINESS"
						},
						{
							"activity": "myShare Plan GLP Offer",
							"amount": 1,
							"update": "myShare Plan GLP Offer"
						},
						{
							"activity": "KCC Customized Plan",
							"amount": 1,
							"update": "KCC Customized Plan"
						},
						{
							"activity": "UKP PLAN 700 WITH GPRS",
							"amount": 1,
							"update": "UKP PLAN 700 WITH GPRS"
						},
						{
							"activity": "Consumer Globe Broadband Homephone",
							"amount": 1,
							"update": "Consumer Globe Broadband Homephone"
						},
						{
							"activity": "Best-Ever MSP Surf Plan 2499",
							"amount": 1,
							"update": "Best-Ever MSP Surf Plan 2499"
						},
						{
							"activity": "SM GROUP SPECIAL CUSTOM PLAN (NO GPRS)",
							"amount": 1,
							"update": "SM GROUP SPECIAL CUSTOM PLAN (NO GPRS)"
						},
						{
							"activity": "GoSURF Special Offers",
							"amount": 1,
							"update": "GoSURF Special Offers"
						},
						{
							"activity": "Platinum Lifestyle Plan 3799",
							"amount": 1,
							"update": "Platinum Lifestyle Plan 3799"
						},
						{
							"activity": "Best-Ever MSP Surf Plan 299",
							"amount": 1,
							"update": "Best-Ever MSP Surf Plan 299"
						},
						{
							"activity": "AT&T Tattoo 499",
							"amount": 1,
							"update": "AT&T Tattoo 499"
						},
						{
							"activity": "Tattoo Super Stick 1299",
							"amount": 1,
							"update": "Tattoo Super Stick 1299"
						},
						{
							"activity": "COCA COLA PLAN (WITH SUPERDUO)",
							"amount": 1,
							"update": "COCA COLA PLAN (WITH SUPERDUO)"
						},
						{
							"activity": "Platinum Elite 10K - 20 Freebies (A-E) or 2 Freebies (H-J)",
							"amount": 1,
							"update": "Platinum Elite 10K - 20 Freebies (A-E) or 2 Freebies (H-J)"
						},
						{
							"activity": "TATTOO BUSINESS SURF (42 MBPS)",
							"amount": 1,
							"update": "TATTOO BUSINESS SURF (42 MBPS)"
						},
						{
							"activity": "UnliSurf Combo 999 (GOSURF)",
							"amount": 1,
							"update": "UnliSurf Combo 999 (GOSURF)"
						},
						{
							"activity": "Platinum Lifestyle Plan 4999",
							"amount": 1,
							"update": "Platinum Lifestyle Plan 4999"
						},
						{
							"activity": "Tattoo Tablet Plan",
							"amount": 1,
							"update": "Tattoo Tablet Plan"
						},
						{
							"activity": "Load Tipid Combo 500",
							"amount": 1,
							"update": "Load Tipid Combo 500"
						},
						{
							"activity": "Load Tipid Combo 800",
							"amount": 1,
							"update": "Load Tipid Combo 800"
						}
					]
				}
			]
		}
	}



	, 'revenue': {
		"status": 200,
		"data": {
			"title": "Revenue Management",
			"metrics": [
				{
					"info": {
						"id": 5071,
						"name": "Collection Aged - Trial (0-30 Days)",
						"unit": "VALUE",
						"updateSchedule": "DAILY"
					},
					"value": {
						"date": "2016-07-18T00:00:00 -0500",
						"value": 6131912200,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 5081,
						"name": "Collection Aged - Trial (31-60 Days)",
						"unit": "VALUE",
						"updateSchedule": "DAILY"
					},
					"value": {
						"date": "2016-07-18T00:00:00 -0500",
						"value": 26147926000,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 5091,
						"name": "Collection Aged - Trial (61-90 Days)",
						"unit": "VALUE",
						"updateSchedule": "DAILY"
					},
					"value": {
						"date": "2016-07-18T00:00:00 -0500",
						"value": 6819188700,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 5101,
						"name": "Collection Aged - Trial (91-120 Days)",
						"unit": "VALUE",
						"updateSchedule": "DAILY"
					},
					"value": {
						"date": "2016-07-18T00:00:00 -0500",
						"value": 6145327100,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 5111,
						"name": "Collection Aged - Trial (> 120 Days)",
						"unit": "VALUE",
						"updateSchedule": "DAILY"
					},
					"value": {
						"date": "2016-07-18T00:00:00 -0500",
						"value": 249531974000,
						"status": "GRAY"
					}
				}
			],
			"gauges": [
				{
					"id": 15,
					"title": "Success Rate Prepaid - Turbo Charging",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"minValue": 50,
					"maxValue": 100,
					"direction": "UP",
					"metric": {
						"info": {
							"id": 5281,
							"name": "Prepaid Turbo Charging Success Rate",
							"unit": "PERCENTAGE",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2016-07-18T00:00:00 -0500",
							"value": 99.74,
							"status": "GREEN"
						}
					},
					"startWithStatus": "RED",
					"thresholds": [
						{
							"value": 95,
							"status": "YELLOW"
						},
						{
							"value": 99,
							"status": "GREEN"
						}
					],
					"type": "INVERTED",
					"history": [
						{
							"id": 15,
							"title": "Success Rate Prepaid - Turbo Charging",
							"date": "2016-07-17T00:00:00 -0500",
							"value": 99.89,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 15,
							"title": "Success Rate Prepaid - Turbo Charging",
							"date": "2016-07-16T00:00:00 -0500",
							"value": 99.88,
							"status": "GREEN",
							"direction": "DOWN"
						},
						{
							"id": 15,
							"title": "Success Rate Prepaid - Turbo Charging",
							"date": "2016-07-15T00:00:00 -0500",
							"value": 99.88,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 15,
							"title": "Success Rate Prepaid - Turbo Charging",
							"date": "2016-07-14T00:00:00 -0500",
							"value": 99.87,
							"status": "GREEN",
							"direction": "DOWN"
						},
						{
							"id": 15,
							"title": "Success Rate Prepaid - Turbo Charging",
							"date": "2016-07-13T00:00:00 -0500",
							"value": 99.87,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 15,
							"title": "Success Rate Prepaid - Turbo Charging",
							"date": "2016-07-12T00:00:00 -0500",
							"value": 99.87,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 15,
							"title": "Success Rate Prepaid - Turbo Charging",
							"date": "2016-07-11T00:00:00 -0500",
							"value": 99.86,
							"status": "GREEN",
							"direction": "DOWN"
						}
					]
				},
				{
					"id": 16,
					"title": "Success Rate Prepaid - Customer MNG",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"minValue": 50,
					"maxValue": 100,
					"direction": "UP",
					"metric": {
						"info": {
							"id": 5301,
							"name": "Prepaid Customer Mng Success Rate",
							"unit": "PERCENTAGE",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2016-07-16T00:00:00 -0500",
							"value": 99.65,
							"status": "GREEN"
						}
					},
					"startWithStatus": "RED",
					"thresholds": [
						{
							"value": 95,
							"status": "YELLOW"
						},
						{
							"value": 99,
							"status": "GREEN"
						}
					],
					"type": "INVERTED",
					"history": [
						{
							"id": 16,
							"title": "Success Rate Prepaid - Customer MNG",
							"date": "2016-07-15T00:00:00 -0500",
							"value": 99.72,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 16,
							"title": "Success Rate Prepaid - Customer MNG",
							"date": "2016-07-14T00:00:00 -0500",
							"value": 99.65,
							"status": "GREEN",
							"direction": "DOWN"
						},
						{
							"id": 16,
							"title": "Success Rate Prepaid - Customer MNG",
							"date": "2016-07-13T00:00:00 -0500",
							"value": 99.82,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 16,
							"title": "Success Rate Prepaid - Customer MNG",
							"date": "2016-07-12T00:00:00 -0500",
							"value": 99.16,
							"status": "GREEN",
							"direction": "DOWN"
						},
						{
							"id": 16,
							"title": "Success Rate Prepaid - Customer MNG",
							"date": "2016-07-11T00:00:00 -0500",
							"value": 99.85,
							"status": "GREEN",
							"direction": "UP"
						}
					]
				},
				{
					"id": 17,
					"title": "Success Rate Prepaid - Replenishment",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"minValue": 50,
					"maxValue": 100,
					"direction": "UP",
					"metric": {
						"info": {
							"id": 5321,
							"name": "Prepaid Replenishment Success Rate",
							"unit": "PERCENTAGE",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2016-07-18T00:00:00 -0500",
							"value": 99.96,
							"status": "GREEN"
						}
					},
					"startWithStatus": "RED",
					"thresholds": [
						{
							"value": 95,
							"status": "YELLOW"
						},
						{
							"value": 99,
							"status": "GREEN"
						}
					],
					"type": "INVERTED",
					"history": [
						{
							"id": 17,
							"title": "Success Rate Prepaid - Replenishment",
							"date": "2016-07-17T00:00:00 -0500",
							"value": 99.96,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 17,
							"title": "Success Rate Prepaid - Replenishment",
							"date": "2016-07-16T00:00:00 -0500",
							"value": 99.97,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 17,
							"title": "Success Rate Prepaid - Replenishment",
							"date": "2016-07-15T00:00:00 -0500",
							"value": 99.97,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 17,
							"title": "Success Rate Prepaid - Replenishment",
							"date": "2016-07-14T00:00:00 -0500",
							"value": 99.96,
							"status": "GREEN",
							"direction": "DOWN"
						},
						{
							"id": 17,
							"title": "Success Rate Prepaid - Replenishment",
							"date": "2016-07-13T00:00:00 -0500",
							"value": 99.96,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 17,
							"title": "Success Rate Prepaid - Replenishment",
							"date": "2016-07-12T00:00:00 -0500",
							"value": 99.97,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 17,
							"title": "Success Rate Prepaid - Replenishment",
							"date": "2016-07-11T00:00:00 -0500",
							"value": 99.97,
							"status": "GREEN",
							"direction": "UP"
						}
					]
				},
				{
					"id": 18,
					"title": "Success Rate Prepaid - EDR",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"minValue": 50,
					"maxValue": 100,
					"direction": "UP",
					"metric": {
						"info": {
							"id": 5341,
							"name": "Prepaid EDR Events",
							"unit": "PERCENTAGE",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2016-07-16T00:00:00 -0500",
							"value": 99.98,
							"status": "GREEN"
						}
					},
					"startWithStatus": "RED",
					"thresholds": [
						{
							"value": 95,
							"status": "YELLOW"
						},
						{
							"value": 99,
							"status": "GREEN"
						}
					],
					"type": "INVERTED",
					"history": [
						{
							"id": 18,
							"title": "Success Rate Prepaid - EDR",
							"date": "2016-07-15T00:00:00 -0500",
							"value": 99.98,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 18,
							"title": "Success Rate Prepaid - EDR",
							"date": "2016-07-14T00:00:00 -0500",
							"value": 99.92,
							"status": "GREEN",
							"direction": "DOWN"
						},
						{
							"id": 18,
							"title": "Success Rate Prepaid - EDR",
							"date": "2016-07-13T00:00:00 -0500",
							"value": 99.95,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 18,
							"title": "Success Rate Prepaid - EDR",
							"date": "2016-07-12T00:00:00 -0500",
							"value": 99.24,
							"status": "GREEN",
							"direction": "DOWN"
						},
						{
							"id": 18,
							"title": "Success Rate Prepaid - EDR",
							"date": "2016-07-11T00:00:00 -0500",
							"value": 99.23,
							"status": "GREEN",
							"direction": "DOWN"
						}
					]
				},
				{
					"id": 19,
					"title": "Success Rate Postpaid - Turbo Charging",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"minValue": 50,
					"maxValue": 100,
					"direction": "UP",
					"metric": {
						"info": {
							"id": 5291,
							"name": "Postpaid Turbo Charging Success Rate",
							"unit": "PERCENTAGE",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2016-07-16T00:00:00 -0500",
							"value": 99.28,
							"status": "GREEN"
						}
					},
					"startWithStatus": "RED",
					"thresholds": [
						{
							"value": 95,
							"status": "YELLOW"
						},
						{
							"value": 99,
							"status": "GREEN"
						}
					],
					"type": "INVERTED",
					"history": [
						{
							"id": 19,
							"title": "Success Rate Postpaid - Turbo Charging",
							"date": "2016-07-15T00:00:00 -0500",
							"value": 99.38,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 19,
							"title": "Success Rate Postpaid - Turbo Charging",
							"date": "2016-07-14T00:00:00 -0500",
							"value": 99.25,
							"status": "GREEN",
							"direction": "DOWN"
						},
						{
							"id": 19,
							"title": "Success Rate Postpaid - Turbo Charging",
							"date": "2016-07-13T00:00:00 -0500",
							"value": 99.45,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 19,
							"title": "Success Rate Postpaid - Turbo Charging",
							"date": "2016-07-12T00:00:00 -0500",
							"value": 99.88,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 19,
							"title": "Success Rate Postpaid - Turbo Charging",
							"date": "2016-07-11T00:00:00 -0500",
							"value": 99.23,
							"status": "GREEN",
							"direction": "DOWN"
						}
					]
				},
				{
					"id": 20,
					"title": "Success Rate Postpaid - Customer MNG",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"minValue": 50,
					"maxValue": 100,
					"direction": "UP",
					"metric": {
						"info": {
							"id": 5311,
							"name": "Postpaid Customer Mng Success Rate",
							"unit": "PERCENTAGE",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2016-07-16T00:00:00 -0500",
							"value": 99.9,
							"status": "GREEN"
						}
					},
					"startWithStatus": "RED",
					"thresholds": [
						{
							"value": 95,
							"status": "YELLOW"
						},
						{
							"value": 99,
							"status": "GREEN"
						}
					],
					"type": "INVERTED",
					"history": [
						{
							"id": 20,
							"title": "Success Rate Postpaid - Customer MNG",
							"date": "2016-07-15T00:00:00 -0500",
							"value": 99.8,
							"status": "GREEN",
							"direction": "DOWN"
						},
						{
							"id": 20,
							"title": "Success Rate Postpaid - Customer MNG",
							"date": "2016-07-14T00:00:00 -0500",
							"value": 99.79,
							"status": "GREEN",
							"direction": "DOWN"
						},
						{
							"id": 20,
							"title": "Success Rate Postpaid - Customer MNG",
							"date": "2016-07-13T00:00:00 -0500",
							"value": 99.85,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 20,
							"title": "Success Rate Postpaid - Customer MNG",
							"date": "2016-07-12T00:00:00 -0500",
							"value": 99.82,
							"status": "GREEN",
							"direction": "DOWN"
						},
						{
							"id": 20,
							"title": "Success Rate Postpaid - Customer MNG",
							"date": "2016-07-11T00:00:00 -0500",
							"value": 99.92,
							"status": "GREEN",
							"direction": "UP"
						}
					]
				},
				{
					"id": 21,
					"title": "Success Rate Postpaid - Replenishment",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"minValue": 50,
					"maxValue": 100,
					"direction": "UP",
					"metric": {
						"info": {
							"id": 5331,
							"name": "Postpaid Replenishment Success Rate",
							"unit": "PERCENTAGE",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2016-07-16T00:00:00 -0500",
							"value": 99.65,
							"status": "GREEN"
						}
					},
					"startWithStatus": "RED",
					"thresholds": [
						{
							"value": 95,
							"status": "YELLOW"
						},
						{
							"value": 99,
							"status": "GREEN"
						}
					],
					"type": "INVERTED",
					"history": [
						{
							"id": 21,
							"title": "Success Rate Postpaid - Replenishment",
							"date": "2016-07-15T00:00:00 -0500",
							"value": 99.78,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 21,
							"title": "Success Rate Postpaid - Replenishment",
							"date": "2016-07-14T00:00:00 -0500",
							"value": 99.23,
							"status": "GREEN",
							"direction": "DOWN"
						},
						{
							"id": 21,
							"title": "Success Rate Postpaid - Replenishment",
							"date": "2016-07-13T00:00:00 -0500",
							"value": 99.43,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 21,
							"title": "Success Rate Postpaid - Replenishment",
							"date": "2016-07-12T00:00:00 -0500",
							"value": 99.85,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 21,
							"title": "Success Rate Postpaid - Replenishment",
							"date": "2016-07-11T00:00:00 -0500",
							"value": 99.23,
							"status": "GREEN",
							"direction": "DOWN"
						}
					]
				},
				{
					"id": 22,
					"title": "Success Rate Postpaid - EDR",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"minValue": 50,
					"maxValue": 100,
					"direction": "UP",
					"metric": {
						"info": {
							"id": 5351,
							"name": "Postpaid EDR Events",
							"unit": "PERCENTAGE",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2016-07-16T00:00:00 -0500",
							"value": 99.28,
							"status": "GREEN"
						}
					},
					"startWithStatus": "RED",
					"thresholds": [
						{
							"value": 95,
							"status": "YELLOW"
						},
						{
							"value": 99,
							"status": "GREEN"
						}
					],
					"type": "INVERTED",
					"history": [
						{
							"id": 22,
							"title": "Success Rate Postpaid - EDR",
							"date": "2016-07-15T00:00:00 -0500",
							"value": 99.34,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 22,
							"title": "Success Rate Postpaid - EDR",
							"date": "2016-07-14T00:00:00 -0500",
							"value": 99.15,
							"status": "GREEN",
							"direction": "DOWN"
						},
						{
							"id": 22,
							"title": "Success Rate Postpaid - EDR",
							"date": "2016-07-13T00:00:00 -0500",
							"value": 99.28,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 22,
							"title": "Success Rate Postpaid - EDR",
							"date": "2016-07-12T00:00:00 -0500",
							"value": 99.65,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 22,
							"title": "Success Rate Postpaid - EDR",
							"date": "2016-07-11T00:00:00 -0500",
							"value": 99.15,
							"status": "GREEN",
							"direction": "DOWN"
						}
					]
				},
				{
					"id": 23,
					"title": "Prepaid Recharge Success Rate",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"minValue": 90,
					"maxValue": 100,
					"direction": "DOWN",
					"metric": {
						"info": {
							"id": 5121,
							"name": "Prepaid Recharge Success Rate",
							"unit": "PERCENTAGE",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2016-07-18T00:00:00 -0500",
							"value": 99.94,
							"status": "GREEN"
						}
					},
					"majorMetric": {
						"info": {
							"id": 5122,
							"name": "Previous Week",
							"unit": "PERCENTAGE",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2016-07-18T00:00:00 -0500",
							"value": 99.95,
							"status": "GRAY"
						}
					},
					"startWithStatus": "RED",
					"thresholds": [
						{
							"value": 95,
							"status": "YELLOW"
						},
						{
							"value": 99,
							"status": "GREEN"
						}
					],
					"type": "INVERTED",
					"pcntDiffToMajorMetric": 0,
					"history": [
						{
							"id": 23,
							"title": "Prepaid Recharge Success Rate",
							"date": "2016-07-17T00:00:00 -0500",
							"value": 99.95,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 23,
							"title": "Prepaid Recharge Success Rate",
							"date": "2016-07-16T00:00:00 -0500",
							"value": 99.95,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 23,
							"title": "Prepaid Recharge Success Rate",
							"date": "2016-07-15T00:00:00 -0500",
							"value": 99.96,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 23,
							"title": "Prepaid Recharge Success Rate",
							"date": "2016-07-14T00:00:00 -0500",
							"value": 99.93,
							"status": "GREEN",
							"direction": "DOWN"
						},
						{
							"id": 23,
							"title": "Prepaid Recharge Success Rate",
							"date": "2016-07-13T00:00:00 -0500",
							"value": 99.95,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 23,
							"title": "Prepaid Recharge Success Rate",
							"date": "2016-07-12T00:00:00 -0500",
							"value": 99.96,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 23,
							"title": "Prepaid Recharge Success Rate",
							"date": "2016-07-11T00:00:00 -0500",
							"value": 99.95,
							"status": "GREEN",
							"direction": "DOWN"
						}
					]
				},
				{
					"id": 24,
					"title": "Avg Latency - Prepaid",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"minValue": 10,
					"maxValue": 60,
					"direction": "UP",
					"metric": {
						"info": {
							"id": 5361,
							"name": "Prepaid Latency",
							"unit": "MILLISECONDS",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2016-07-16T00:00:00 -0500",
							"value": 6,
							"status": "BLUE"
						}
					},
					"majorMetric": {
						"info": {
							"id": 5362,
							"name": "Previous Week",
							"unit": "MILLISECONDS",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2016-07-16T00:00:00 -0500",
							"value": 1,
							"status": "GRAY"
						}
					},
					"startWithStatus": "BLUE",
					"type": "REGULAR",
					"pcntDiffToMajorMetric": 500,
					"history": [
						{
							"id": 24,
							"title": "Avg Latency - Prepaid",
							"date": "2016-07-15T00:00:00 -0500",
							"value": 2,
							"status": "GREEN",
							"direction": "DOWN"
						},
						{
							"id": 24,
							"title": "Avg Latency - Prepaid",
							"date": "2016-07-14T00:00:00 -0500",
							"value": 1,
							"status": "GREEN",
							"direction": "DOWN"
						},
						{
							"id": 24,
							"title": "Avg Latency - Prepaid",
							"date": "2016-07-13T00:00:00 -0500",
							"value": 1,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 24,
							"title": "Avg Latency - Prepaid",
							"date": "2016-07-12T00:00:00 -0500",
							"value": 3,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 24,
							"title": "Avg Latency - Prepaid",
							"date": "2016-07-11T00:00:00 -0500",
							"value": 2,
							"status": "GREEN",
							"direction": "DOWN"
						}
					]
				},
				{
					"id": 25,
					"title": "Prepaid Latency - SMS",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"direction": "DOWN",
					"metric": {
						"info": {
							"id": 5161,
							"name": "Prepaid Latency - SMS",
							"unit": "MILLISECONDS",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2016-07-16T00:00:00 -0500",
							"value": 1,
							"status": "BLUE"
						}
					},
					"majorMetric": {
						"info": {
							"id": 5162,
							"name": "Previous Week",
							"unit": "MILLISECONDS",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2016-07-16T00:00:00 -0500",
							"value": 4,
							"status": "GRAY"
						}
					},
					"startWithStatus": "BLUE",
					"type": "REGULAR",
					"pcntDiffToMajorMetric": -75,
					"history": [
						{
							"id": 25,
							"title": "Prepaid Latency - SMS",
							"date": "2016-07-15T00:00:00 -0500",
							"value": 3,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 25,
							"title": "Prepaid Latency - SMS",
							"date": "2016-07-14T00:00:00 -0500",
							"value": 1,
							"status": "GREEN",
							"direction": "DOWN"
						},
						{
							"id": 25,
							"title": "Prepaid Latency - SMS",
							"date": "2016-07-13T00:00:00 -0500",
							"value": 2,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 25,
							"title": "Prepaid Latency - SMS",
							"date": "2016-07-12T00:00:00 -0500",
							"value": 3,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 25,
							"title": "Prepaid Latency - SMS",
							"date": "2016-07-11T00:00:00 -0500",
							"value": 4,
							"status": "GREEN",
							"direction": "UP"
						}
					]
				},
				{
					"id": 26,
					"title": "Prepaid Latency - MMS",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"direction": "DOWN",
					"metric": {
						"info": {
							"id": 5151,
							"name": "Prepaid Latency - MMS",
							"unit": "MILLISECONDS",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2016-07-16T00:00:00 -0500",
							"value": 4,
							"status": "BLUE"
						}
					},
					"majorMetric": {
						"info": {
							"id": 5152,
							"name": "Previous Week",
							"unit": "MILLISECONDS",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2016-07-16T00:00:00 -0500",
							"value": 20,
							"status": "GRAY"
						}
					},
					"startWithStatus": "BLUE",
					"type": "REGULAR",
					"pcntDiffToMajorMetric": -80,
					"history": [
						{
							"id": 26,
							"title": "Prepaid Latency - MMS",
							"date": "2016-07-15T00:00:00 -0500",
							"value": 3,
							"status": "GREEN",
							"direction": "DOWN"
						},
						{
							"id": 26,
							"title": "Prepaid Latency - MMS",
							"date": "2016-07-14T00:00:00 -0500",
							"value": 5,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 26,
							"title": "Prepaid Latency - MMS",
							"date": "2016-07-13T00:00:00 -0500",
							"value": 10,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 26,
							"title": "Prepaid Latency - MMS",
							"date": "2016-07-12T00:00:00 -0500",
							"value": 16,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 26,
							"title": "Prepaid Latency - MMS",
							"date": "2016-07-11T00:00:00 -0500",
							"value": 13,
							"status": "GREEN",
							"direction": "DOWN"
						}
					]
				},
				{
					"id": 27,
					"title": "Prepaid Latency - Voice",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"direction": "DOWN",
					"metric": {
						"info": {
							"id": 5171,
							"name": "Prepaid Latency - Voice",
							"unit": "MILLISECONDS",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2016-07-16T00:00:00 -0500",
							"value": 3,
							"status": "BLUE"
						}
					},
					"majorMetric": {
						"info": {
							"id": 5172,
							"name": "Previous Week",
							"unit": "MILLISECONDS",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2016-07-16T00:00:00 -0500",
							"value": 5,
							"status": "GRAY"
						}
					},
					"startWithStatus": "BLUE",
					"type": "REGULAR",
					"pcntDiffToMajorMetric": -40,
					"history": [
						{
							"id": 27,
							"title": "Prepaid Latency - Voice",
							"date": "2016-07-15T00:00:00 -0500",
							"value": 2,
							"status": "GREEN",
							"direction": "DOWN"
						},
						{
							"id": 27,
							"title": "Prepaid Latency - Voice",
							"date": "2016-07-14T00:00:00 -0500",
							"value": 5,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 27,
							"title": "Prepaid Latency - Voice",
							"date": "2016-07-13T00:00:00 -0500",
							"value": 2,
							"status": "GREEN",
							"direction": "DOWN"
						},
						{
							"id": 27,
							"title": "Prepaid Latency - Voice",
							"date": "2016-07-12T00:00:00 -0500",
							"value": 4,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 27,
							"title": "Prepaid Latency - Voice",
							"date": "2016-07-11T00:00:00 -0500",
							"value": 3,
							"status": "GREEN",
							"direction": "DOWN"
						}
					]
				},
				{
					"id": 28,
					"title": "Prepaid Latency - GPRS",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"direction": "DOWN",
					"metric": {
						"info": {
							"id": 5141,
							"name": "Prepaid Latency - GPRS",
							"unit": "MILLISECONDS",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2016-07-16T00:00:00 -0500",
							"value": 20,
							"status": "BLUE"
						}
					},
					"majorMetric": {
						"info": {
							"id": 5142,
							"name": "Previous Week",
							"unit": "MILLISECONDS",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2016-07-16T00:00:00 -0500",
							"value": 21,
							"status": "GRAY"
						}
					},
					"startWithStatus": "BLUE",
					"type": "REGULAR",
					"pcntDiffToMajorMetric": -4,
					"history": [
						{
							"id": 28,
							"title": "Prepaid Latency - GPRS",
							"date": "2016-07-15T00:00:00 -0500",
							"value": 26,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 28,
							"title": "Prepaid Latency - GPRS",
							"date": "2016-07-14T00:00:00 -0500",
							"value": 24,
							"status": "GREEN",
							"direction": "DOWN"
						},
						{
							"id": 28,
							"title": "Prepaid Latency - GPRS",
							"date": "2016-07-13T00:00:00 -0500",
							"value": 20,
							"status": "GREEN",
							"direction": "DOWN"
						},
						{
							"id": 28,
							"title": "Prepaid Latency - GPRS",
							"date": "2016-07-12T00:00:00 -0500",
							"value": 18,
							"status": "GREEN",
							"direction": "DOWN"
						},
						{
							"id": 28,
							"title": "Prepaid Latency - GPRS",
							"date": "2016-07-11T00:00:00 -0500",
							"value": 21,
							"status": "GREEN",
							"direction": "UP"
						}
					]
				},
				{
					"id": 29,
					"title": "Prepaid Latency - Content",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"direction": "DOWN",
					"metric": {
						"info": {
							"id": 5131,
							"name": "Prepaid Latency - Content",
							"unit": "MILLISECONDS",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2016-07-16T00:00:00 -0500",
							"value": 1,
							"status": "BLUE"
						}
					},
					"majorMetric": {
						"info": {
							"id": 5132,
							"name": "Previous Week",
							"unit": "MILLISECONDS",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2016-06-28T00:00:00 -0500",
							"value": 57,
							"status": "GRAY"
						}
					},
					"startWithStatus": "BLUE",
					"type": "REGULAR",
					"pcntDiffToMajorMetric": -98,
					"history": [
						{
							"id": 29,
							"title": "Prepaid Latency - Content",
							"date": "2016-07-15T00:00:00 -0500",
							"value": 3,
							"status": "GREEN",
							"direction": "UP"
						}
					]
				},
				{
					"id": 30,
					"title": "Avg Latency - Postpaid",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"minValue": 10,
					"maxValue": 60,
					"direction": "UP",
					"metric": {
						"info": {
							"id": 5671,
							"name": "Postpaid Latency",
							"unit": "MILLISECONDS",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2016-07-16T00:00:00 -0500",
							"value": 5,
							"status": "BLUE"
						}
					},
					"majorMetric": {
						"info": {
							"id": 5672,
							"name": "Previous Week",
							"unit": "MILLISECONDS",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2016-07-16T00:00:00 -0500",
							"value": 2,
							"status": "GRAY"
						}
					},
					"startWithStatus": "BLUE",
					"type": "REGULAR",
					"pcntDiffToMajorMetric": 150,
					"history": [
						{
							"id": 30,
							"title": "Avg Latency - Postpaid",
							"date": "2016-07-15T00:00:00 -0500",
							"value": 2,
							"status": "GREEN",
							"direction": "DOWN"
						},
						{
							"id": 30,
							"title": "Avg Latency - Postpaid",
							"date": "2016-07-14T00:00:00 -0500",
							"value": 1,
							"status": "GREEN",
							"direction": "DOWN"
						},
						{
							"id": 30,
							"title": "Avg Latency - Postpaid",
							"date": "2016-07-13T00:00:00 -0500",
							"value": 1,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 30,
							"title": "Avg Latency - Postpaid",
							"date": "2016-07-12T00:00:00 -0500",
							"value": 3,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 30,
							"title": "Avg Latency - Postpaid",
							"date": "2016-07-11T00:00:00 -0500",
							"value": 2,
							"status": "GREEN",
							"direction": "DOWN"
						}
					]
				},
				{
					"id": 31,
					"title": "Postpaid Latency - SMS",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"direction": "DOWN",
					"metric": {
						"info": {
							"id": 5211,
							"name": "Postpaid Latency - SMS",
							"unit": "MILLISECONDS",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2016-07-16T00:00:00 -0500",
							"value": 1,
							"status": "BLUE"
						}
					},
					"majorMetric": {
						"info": {
							"id": 5212,
							"name": "Previous Week",
							"unit": "MILLISECONDS",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2016-07-16T00:00:00 -0500",
							"value": 2,
							"status": "GRAY"
						}
					},
					"startWithStatus": "BLUE",
					"type": "REGULAR",
					"pcntDiffToMajorMetric": -50,
					"history": [
						{
							"id": 31,
							"title": "Postpaid Latency - SMS",
							"date": "2016-07-15T00:00:00 -0500",
							"value": 3,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 31,
							"title": "Postpaid Latency - SMS",
							"date": "2016-07-14T00:00:00 -0500",
							"value": 3,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 31,
							"title": "Postpaid Latency - SMS",
							"date": "2016-07-13T00:00:00 -0500",
							"value": 1,
							"status": "GREEN",
							"direction": "DOWN"
						},
						{
							"id": 31,
							"title": "Postpaid Latency - SMS",
							"date": "2016-07-12T00:00:00 -0500",
							"value": 2,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 31,
							"title": "Postpaid Latency - SMS",
							"date": "2016-07-11T00:00:00 -0500",
							"value": 1,
							"status": "GREEN",
							"direction": "DOWN"
						}
					]
				},
				{
					"id": 32,
					"title": "Postpaid Latency - MMS",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"direction": "DOWN",
					"metric": {
						"info": {
							"id": 5201,
							"name": "Postpaid Latency - MMS",
							"unit": "MILLISECONDS",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2016-07-16T00:00:00 -0500",
							"value": 4,
							"status": "BLUE"
						}
					},
					"majorMetric": {
						"info": {
							"id": 5202,
							"name": "Previous Week",
							"unit": "MILLISECONDS",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2016-07-16T00:00:00 -0500",
							"value": 7,
							"status": "GRAY"
						}
					},
					"startWithStatus": "BLUE",
					"type": "REGULAR",
					"pcntDiffToMajorMetric": -42,
					"history": [
						{
							"id": 32,
							"title": "Postpaid Latency - MMS",
							"date": "2016-07-15T00:00:00 -0500",
							"value": 8,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 32,
							"title": "Postpaid Latency - MMS",
							"date": "2016-07-14T00:00:00 -0500",
							"value": 6,
							"status": "GREEN",
							"direction": "DOWN"
						},
						{
							"id": 32,
							"title": "Postpaid Latency - MMS",
							"date": "2016-07-13T00:00:00 -0500",
							"value": 5,
							"status": "GREEN",
							"direction": "DOWN"
						},
						{
							"id": 32,
							"title": "Postpaid Latency - MMS",
							"date": "2016-07-12T00:00:00 -0500",
							"value": 6,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 32,
							"title": "Postpaid Latency - MMS",
							"date": "2016-07-11T00:00:00 -0500",
							"value": 5,
							"status": "GREEN",
							"direction": "DOWN"
						}
					]
				},
				{
					"id": 33,
					"title": "Postpaid Latency - Voice",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"direction": "DOWN",
					"metric": {
						"info": {
							"id": 5221,
							"name": "Postpaid Latency - Voice",
							"unit": "MILLISECONDS",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2016-07-16T00:00:00 -0500",
							"value": 5,
							"status": "BLUE"
						}
					},
					"majorMetric": {
						"info": {
							"id": 5222,
							"name": "Previous Week",
							"unit": "MILLISECONDS",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2016-07-16T00:00:00 -0500",
							"value": 9,
							"status": "GRAY"
						}
					},
					"startWithStatus": "BLUE",
					"type": "REGULAR",
					"pcntDiffToMajorMetric": -44,
					"history": [
						{
							"id": 33,
							"title": "Postpaid Latency - Voice",
							"date": "2016-07-15T00:00:00 -0500",
							"value": 8,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 33,
							"title": "Postpaid Latency - Voice",
							"date": "2016-07-14T00:00:00 -0500",
							"value": 9,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 33,
							"title": "Postpaid Latency - Voice",
							"date": "2016-07-13T00:00:00 -0500",
							"value": 10,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 33,
							"title": "Postpaid Latency - Voice",
							"date": "2016-07-12T00:00:00 -0500",
							"value": 9,
							"status": "GREEN",
							"direction": "DOWN"
						},
						{
							"id": 33,
							"title": "Postpaid Latency - Voice",
							"date": "2016-07-11T00:00:00 -0500",
							"value": 8,
							"status": "GREEN",
							"direction": "DOWN"
						}
					]
				},
				{
					"id": 34,
					"title": "Postpaid Latency - GPRS",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"direction": "DOWN",
					"metric": {
						"info": {
							"id": 5191,
							"name": "Postpaid Latency - GPRS",
							"unit": "MILLISECONDS",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2016-07-16T00:00:00 -0500",
							"value": 12,
							"status": "BLUE"
						}
					},
					"majorMetric": {
						"info": {
							"id": 5192,
							"name": "Previous Week",
							"unit": "MILLISECONDS",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2016-06-28T00:00:00 -0500",
							"value": 129,
							"status": "GRAY"
						}
					},
					"startWithStatus": "BLUE",
					"type": "REGULAR",
					"pcntDiffToMajorMetric": -90,
					"history": []
				},
				{
					"id": 35,
					"title": "Postpaid Latency - Content",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"direction": "UP",
					"metric": {
						"info": {
							"id": 5181,
							"name": "Postpaid Latency - Content",
							"unit": "MILLISECONDS",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2016-07-16T00:00:00 -0500",
							"value": 1,
							"status": "BLUE"
						}
					},
					"majorMetric": {
						"info": {
							"id": 5182,
							"name": "Previous Week",
							"unit": "MILLISECONDS",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2016-07-16T00:00:00 -0500",
							"value": 1,
							"status": "GRAY"
						}
					},
					"startWithStatus": "BLUE",
					"type": "REGULAR",
					"pcntDiffToMajorMetric": 0,
					"history": [
						{
							"id": 35,
							"title": "Postpaid Latency - Content",
							"date": "2016-07-15T00:00:00 -0500",
							"value": 2,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 35,
							"title": "Postpaid Latency - Content",
							"date": "2016-07-14T00:00:00 -0500",
							"value": 3,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 35,
							"title": "Postpaid Latency - Content",
							"date": "2016-07-13T00:00:00 -0500",
							"value": 2,
							"status": "GREEN",
							"direction": "DOWN"
						},
						{
							"id": 35,
							"title": "Postpaid Latency - Content",
							"date": "2016-07-12T00:00:00 -0500",
							"value": 1,
							"status": "GREEN",
							"direction": "DOWN"
						},
						{
							"id": 35,
							"title": "Postpaid Latency - Content",
							"date": "2016-07-11T00:00:00 -0500",
							"value": 1,
							"status": "GREEN",
							"direction": "UP"
						}
					]
				}
			],
			"graphs": [
				{
					"id": 0,
					"title": "Postpaid Trends",
					"subTitle": "Daily",
					"metricSeries": [
						{
							"info": {
								"id": 5001,
								"name": "Postpaid - Activations",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 3112,
									"status": "GRAY"
								},
								{
									"date": "2016-07-13T00:00:00 -0500",
									"value": 2909,
									"status": "GRAY"
								},
								{
									"date": "2016-07-14T00:00:00 -0500",
									"value": 3094,
									"status": "GRAY"
								},
								{
									"date": "2016-07-15T00:00:00 -0500",
									"value": 3239,
									"status": "GRAY"
								},
								{
									"date": "2016-07-16T00:00:00 -0500",
									"value": 3168,
									"status": "GRAY"
								},
								{
									"date": "2016-07-17T00:00:00 -0500",
									"value": 2240,
									"status": "GRAY"
								},
								{
									"date": "2016-07-18T00:00:00 -0500",
									"value": 3101,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5011,
								"name": "Postpaid - Cancellations",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 858,
									"status": "GRAY"
								},
								{
									"date": "2016-07-13T00:00:00 -0500",
									"value": 854,
									"status": "GRAY"
								},
								{
									"date": "2016-07-14T00:00:00 -0500",
									"value": 777,
									"status": "GRAY"
								},
								{
									"date": "2016-07-15T00:00:00 -0500",
									"value": 751,
									"status": "GRAY"
								},
								{
									"date": "2016-07-16T00:00:00 -0500",
									"value": 712,
									"status": "GRAY"
								},
								{
									"date": "2016-07-17T00:00:00 -0500",
									"value": 806,
									"status": "GRAY"
								},
								{
									"date": "2016-07-18T00:00:00 -0500",
									"value": 824,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5021,
								"name": "Postpaid - Suspensions",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 4378,
									"status": "GRAY"
								},
								{
									"date": "2016-07-13T00:00:00 -0500",
									"value": 4463,
									"status": "GRAY"
								},
								{
									"date": "2016-07-14T00:00:00 -0500",
									"value": 3717,
									"status": "GRAY"
								},
								{
									"date": "2016-07-15T00:00:00 -0500",
									"value": 4375,
									"status": "GRAY"
								},
								{
									"date": "2016-07-16T00:00:00 -0500",
									"value": 2076,
									"status": "GRAY"
								},
								{
									"date": "2016-07-17T00:00:00 -0500",
									"value": 166,
									"status": "GRAY"
								},
								{
									"date": "2016-07-18T00:00:00 -0500",
									"value": 2971,
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				},
				{
					"id": 0,
					"title": "Prepaid Trends",
					"subTitle": "Daily",
					"metricSeries": [
						{
							"info": {
								"id": 5031,
								"name": "Prepaid - Activations",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 851346,
									"status": "GRAY"
								},
								{
									"date": "2016-07-13T00:00:00 -0500",
									"value": 824191,
									"status": "GRAY"
								},
								{
									"date": "2016-07-14T00:00:00 -0500",
									"value": 846321,
									"status": "GRAY"
								},
								{
									"date": "2016-07-15T00:00:00 -0500",
									"value": 941433,
									"status": "GRAY"
								},
								{
									"date": "2016-07-16T00:00:00 -0500",
									"value": 934926,
									"status": "GRAY"
								},
								{
									"date": "2016-07-17T00:00:00 -0500",
									"value": 868262,
									"status": "GRAY"
								},
								{
									"date": "2016-07-18T00:00:00 -0500",
									"value": 923383,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5041,
								"name": "Prepaid - Cancellations",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-12T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-13T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-14T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-15T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-16T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-17T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-18T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5051,
								"name": "Prepaid - Grace ",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 758665,
									"status": "GRAY"
								},
								{
									"date": "2016-07-13T00:00:00 -0500",
									"value": 760107,
									"status": "GRAY"
								},
								{
									"date": "2016-07-14T00:00:00 -0500",
									"value": 756255,
									"status": "GRAY"
								},
								{
									"date": "2016-07-15T00:00:00 -0500",
									"value": 771769,
									"status": "GRAY"
								},
								{
									"date": "2016-07-16T00:00:00 -0500",
									"value": 761975,
									"status": "GRAY"
								},
								{
									"date": "2016-07-17T00:00:00 -0500",
									"value": 694212,
									"status": "GRAY"
								},
								{
									"date": "2016-07-18T00:00:00 -0500",
									"value": 777332,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5061,
								"name": "Prepaid - Expired",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 404470,
									"status": "GRAY"
								},
								{
									"date": "2016-07-13T00:00:00 -0500",
									"value": 401408,
									"status": "GRAY"
								},
								{
									"date": "2016-07-14T00:00:00 -0500",
									"value": 417884,
									"status": "GRAY"
								},
								{
									"date": "2016-07-15T00:00:00 -0500",
									"value": 406659,
									"status": "GRAY"
								},
								{
									"date": "2016-07-16T00:00:00 -0500",
									"value": 372236,
									"status": "GRAY"
								},
								{
									"date": "2016-07-17T00:00:00 -0500",
									"value": 395683,
									"status": "GRAY"
								},
								{
									"date": "2016-07-18T00:00:00 -0500",
									"value": 413984,
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'revenue/collection/weekly': {
		"status": 200,
		"data": {
			"title": "Weekly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "Collection",
					"subTitle": "Daily",
					"metricSeries": [
						{
							"info": {
								"id": 5071,
								"name": "Collection Aged - Trial (0-30 Days)",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 146,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 196,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 211,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 108,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 107,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 117,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5081,
								"name": "Collection Aged - Trial (31-60 Days)",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 182,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 162,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 65,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 206,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 203,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 215,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5091,
								"name": "Collection Aged - Trial (61-90 Days)",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 116,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 236,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 245,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 193,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 177,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 71,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5101,
								"name": "Collection Aged - Trial (91-120 Days)",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 183,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 64,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 194,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 158,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 127,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 168,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5111,
								"name": "Collection Aged - Trial (> 120 Days)",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 137,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 190,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 80,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 90,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 206,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 185,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'revenue/collection/monthly': {
		"status": 200,
		"data": {
			"title": "Monthly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "Collection",
					"subTitle": "Daily",
					"metricSeries": [
						{
							"info": {
								"id": 5071,
								"name": "Collection Aged - Trial (0-30 Days)",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-05-28T00:00:00 -0500",
									"value": 121,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 53,
									"status": "GRAY"
								},
								{
									"date": "2016-05-30T00:00:00 -0500",
									"value": 203,
									"status": "GRAY"
								},
								{
									"date": "2016-05-31T00:00:00 -0500",
									"value": 249,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 162,
									"status": "GRAY"
								},
								{
									"date": "2016-06-02T00:00:00 -0500",
									"value": 100,
									"status": "GRAY"
								},
								{
									"date": "2016-06-03T00:00:00 -0500",
									"value": 184,
									"status": "GRAY"
								},
								{
									"date": "2016-06-04T00:00:00 -0500",
									"value": 159,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 99,
									"status": "GRAY"
								},
								{
									"date": "2016-06-06T00:00:00 -0500",
									"value": 196,
									"status": "GRAY"
								},
								{
									"date": "2016-06-07T00:00:00 -0500",
									"value": 170,
									"status": "GRAY"
								},
								{
									"date": "2016-06-08T00:00:00 -0500",
									"value": 155,
									"status": "GRAY"
								},
								{
									"date": "2016-06-09T00:00:00 -0500",
									"value": 92,
									"status": "GRAY"
								},
								{
									"date": "2016-06-10T00:00:00 -0500",
									"value": 193,
									"status": "GRAY"
								},
								{
									"date": "2016-06-11T00:00:00 -0500",
									"value": 141,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 121,
									"status": "GRAY"
								},
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 149,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 106,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 91,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 125,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 125,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 227,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 114,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 146,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 196,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 211,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 108,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 107,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 117,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5081,
								"name": "Collection Aged - Trial (31-60 Days)",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-05-28T00:00:00 -0500",
									"value": 66,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 221,
									"status": "GRAY"
								},
								{
									"date": "2016-05-30T00:00:00 -0500",
									"value": 87,
									"status": "GRAY"
								},
								{
									"date": "2016-05-31T00:00:00 -0500",
									"value": 222,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 157,
									"status": "GRAY"
								},
								{
									"date": "2016-06-02T00:00:00 -0500",
									"value": 73,
									"status": "GRAY"
								},
								{
									"date": "2016-06-03T00:00:00 -0500",
									"value": 50,
									"status": "GRAY"
								},
								{
									"date": "2016-06-04T00:00:00 -0500",
									"value": 58,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 161,
									"status": "GRAY"
								},
								{
									"date": "2016-06-06T00:00:00 -0500",
									"value": 144,
									"status": "GRAY"
								},
								{
									"date": "2016-06-07T00:00:00 -0500",
									"value": 180,
									"status": "GRAY"
								},
								{
									"date": "2016-06-08T00:00:00 -0500",
									"value": 222,
									"status": "GRAY"
								},
								{
									"date": "2016-06-09T00:00:00 -0500",
									"value": 129,
									"status": "GRAY"
								},
								{
									"date": "2016-06-10T00:00:00 -0500",
									"value": 120,
									"status": "GRAY"
								},
								{
									"date": "2016-06-11T00:00:00 -0500",
									"value": 204,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 142,
									"status": "GRAY"
								},
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 209,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 94,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 234,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 217,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 164,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 180,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 166,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 182,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 162,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 65,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 206,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 203,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 215,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5091,
								"name": "Collection Aged - Trial (61-90 Days)",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-05-28T00:00:00 -0500",
									"value": 125,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 178,
									"status": "GRAY"
								},
								{
									"date": "2016-05-30T00:00:00 -0500",
									"value": 200,
									"status": "GRAY"
								},
								{
									"date": "2016-05-31T00:00:00 -0500",
									"value": 90,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 213,
									"status": "GRAY"
								},
								{
									"date": "2016-06-02T00:00:00 -0500",
									"value": 155,
									"status": "GRAY"
								},
								{
									"date": "2016-06-03T00:00:00 -0500",
									"value": 144,
									"status": "GRAY"
								},
								{
									"date": "2016-06-04T00:00:00 -0500",
									"value": 144,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 95,
									"status": "GRAY"
								},
								{
									"date": "2016-06-06T00:00:00 -0500",
									"value": 208,
									"status": "GRAY"
								},
								{
									"date": "2016-06-07T00:00:00 -0500",
									"value": 178,
									"status": "GRAY"
								},
								{
									"date": "2016-06-08T00:00:00 -0500",
									"value": 136,
									"status": "GRAY"
								},
								{
									"date": "2016-06-09T00:00:00 -0500",
									"value": 185,
									"status": "GRAY"
								},
								{
									"date": "2016-06-10T00:00:00 -0500",
									"value": 198,
									"status": "GRAY"
								},
								{
									"date": "2016-06-11T00:00:00 -0500",
									"value": 70,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 104,
									"status": "GRAY"
								},
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 223,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 135,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 174,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 175,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 125,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 174,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 149,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 116,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 236,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 245,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 193,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 177,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 71,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5101,
								"name": "Collection Aged - Trial (91-120 Days)",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-05-28T00:00:00 -0500",
									"value": 170,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 80,
									"status": "GRAY"
								},
								{
									"date": "2016-05-30T00:00:00 -0500",
									"value": 61,
									"status": "GRAY"
								},
								{
									"date": "2016-05-31T00:00:00 -0500",
									"value": 172,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 129,
									"status": "GRAY"
								},
								{
									"date": "2016-06-02T00:00:00 -0500",
									"value": 64,
									"status": "GRAY"
								},
								{
									"date": "2016-06-03T00:00:00 -0500",
									"value": 144,
									"status": "GRAY"
								},
								{
									"date": "2016-06-04T00:00:00 -0500",
									"value": 189,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 191,
									"status": "GRAY"
								},
								{
									"date": "2016-06-06T00:00:00 -0500",
									"value": 95,
									"status": "GRAY"
								},
								{
									"date": "2016-06-07T00:00:00 -0500",
									"value": 71,
									"status": "GRAY"
								},
								{
									"date": "2016-06-08T00:00:00 -0500",
									"value": 152,
									"status": "GRAY"
								},
								{
									"date": "2016-06-09T00:00:00 -0500",
									"value": 222,
									"status": "GRAY"
								},
								{
									"date": "2016-06-10T00:00:00 -0500",
									"value": 205,
									"status": "GRAY"
								},
								{
									"date": "2016-06-11T00:00:00 -0500",
									"value": 69,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 194,
									"status": "GRAY"
								},
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 229,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 183,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 223,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 130,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 237,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 226,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 130,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 183,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 64,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 194,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 158,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 127,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 168,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5111,
								"name": "Collection Aged - Trial (> 120 Days)",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-05-28T00:00:00 -0500",
									"value": 89,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 181,
									"status": "GRAY"
								},
								{
									"date": "2016-05-30T00:00:00 -0500",
									"value": 121,
									"status": "GRAY"
								},
								{
									"date": "2016-05-31T00:00:00 -0500",
									"value": 85,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 120,
									"status": "GRAY"
								},
								{
									"date": "2016-06-02T00:00:00 -0500",
									"value": 208,
									"status": "GRAY"
								},
								{
									"date": "2016-06-03T00:00:00 -0500",
									"value": 107,
									"status": "GRAY"
								},
								{
									"date": "2016-06-04T00:00:00 -0500",
									"value": 229,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 113,
									"status": "GRAY"
								},
								{
									"date": "2016-06-06T00:00:00 -0500",
									"value": 65,
									"status": "GRAY"
								},
								{
									"date": "2016-06-07T00:00:00 -0500",
									"value": 201,
									"status": "GRAY"
								},
								{
									"date": "2016-06-08T00:00:00 -0500",
									"value": 166,
									"status": "GRAY"
								},
								{
									"date": "2016-06-09T00:00:00 -0500",
									"value": 232,
									"status": "GRAY"
								},
								{
									"date": "2016-06-10T00:00:00 -0500",
									"value": 88,
									"status": "GRAY"
								},
								{
									"date": "2016-06-11T00:00:00 -0500",
									"value": 146,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 176,
									"status": "GRAY"
								},
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 215,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 93,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 52,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 237,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 96,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 238,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 241,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 137,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 190,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 80,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 90,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 206,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 185,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'revenue/collection/quarterly': {
		"status": 200,
		"data": {
			"title": "Quarterly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "Collection",
					"subTitle": "Weekly",
					"metricSeries": [
						{
							"info": {
								"id": 5075,
								"name": "Collection Aged - Trial (0-30 Days)",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 84,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 98,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 193,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 83,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 120,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 111,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 167,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 202,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 214,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 185,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 214,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5085,
								"name": "Collection Aged - Trial (31-60 Days)",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 113,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 138,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 111,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 130,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 67,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 141,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 93,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 228,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 196,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 231,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 186,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5095,
								"name": "Collection Aged - Trial (61-90 Days)",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 155,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 58,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 68,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 193,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 185,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 225,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 167,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 153,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 111,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 162,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 72,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5105,
								"name": "Collection Aged - Trial (91-120 Days)",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 148,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 134,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 62,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 97,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 129,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 87,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 202,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 142,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 155,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 245,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 237,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5115,
								"name": "Collection Aged - Trial (> 120 Days)",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 75,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 100,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 229,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 232,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 169,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 247,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 83,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 223,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 110,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 240,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 204,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'revenue/postpaid-latency/weekly': {
		"status": 200,
		"data": {
			"title": "Weekly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "Postpaid Latency",
					"subTitle": "Daily",
					"metricSeries": [
						{
							"info": {
								"id": 5181,
								"name": "Postpaid Latency - Content",
								"unit": "MILLISECONDS",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 1,
									"status": "GRAY"
								},
								{
									"date": "2016-07-13T00:00:00 -0500",
									"value": 2,
									"status": "GRAY"
								},
								{
									"date": "2016-07-14T00:00:00 -0500",
									"value": 3,
									"status": "GRAY"
								},
								{
									"date": "2016-07-15T00:00:00 -0500",
									"value": 2,
									"status": "GRAY"
								},
								{
									"date": "2016-07-16T00:00:00 -0500",
									"value": 1,
									"status": "GRAY"
								},
								{
									"date": "2016-07-17T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-18T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5191,
								"name": "Postpaid Latency - GPRS",
								"unit": "MILLISECONDS",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-12T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-13T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-14T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-15T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-16T00:00:00 -0500",
									"value": 12,
									"status": "GRAY"
								},
								{
									"date": "2016-07-17T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-18T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5201,
								"name": "Postpaid Latency - MMS",
								"unit": "MILLISECONDS",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 6,
									"status": "GRAY"
								},
								{
									"date": "2016-07-13T00:00:00 -0500",
									"value": 5,
									"status": "GRAY"
								},
								{
									"date": "2016-07-14T00:00:00 -0500",
									"value": 6,
									"status": "GRAY"
								},
								{
									"date": "2016-07-15T00:00:00 -0500",
									"value": 8,
									"status": "GRAY"
								},
								{
									"date": "2016-07-16T00:00:00 -0500",
									"value": 4,
									"status": "GRAY"
								},
								{
									"date": "2016-07-17T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-18T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5211,
								"name": "Postpaid Latency - SMS",
								"unit": "MILLISECONDS",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 2,
									"status": "GRAY"
								},
								{
									"date": "2016-07-13T00:00:00 -0500",
									"value": 1,
									"status": "GRAY"
								},
								{
									"date": "2016-07-14T00:00:00 -0500",
									"value": 3,
									"status": "GRAY"
								},
								{
									"date": "2016-07-15T00:00:00 -0500",
									"value": 3,
									"status": "GRAY"
								},
								{
									"date": "2016-07-16T00:00:00 -0500",
									"value": 1,
									"status": "GRAY"
								},
								{
									"date": "2016-07-17T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-18T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5221,
								"name": "Postpaid Latency - Voice",
								"unit": "MILLISECONDS",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 9,
									"status": "GRAY"
								},
								{
									"date": "2016-07-13T00:00:00 -0500",
									"value": 10,
									"status": "GRAY"
								},
								{
									"date": "2016-07-14T00:00:00 -0500",
									"value": 9,
									"status": "GRAY"
								},
								{
									"date": "2016-07-15T00:00:00 -0500",
									"value": 8,
									"status": "GRAY"
								},
								{
									"date": "2016-07-16T00:00:00 -0500",
									"value": 5,
									"status": "GRAY"
								},
								{
									"date": "2016-07-17T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-18T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'revenue/postpaid-latency/monthly': {
		"status": 200,
		"data": {
			"title": "Monthly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "Postpaid Latency",
					"subTitle": "Daily",
					"metricSeries": [
						{
							"info": {
								"id": 5181,
								"name": "Postpaid Latency - Content",
								"unit": "MILLISECONDS",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-19T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-27T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-28T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-29T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-30T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"value": 1,
									"status": "GRAY"
								},
								{
									"date": "2016-07-02T00:00:00 -0500",
									"value": 1,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"value": 2,
									"status": "GRAY"
								},
								{
									"date": "2016-07-04T00:00:00 -0500",
									"value": 2,
									"status": "GRAY"
								},
								{
									"date": "2016-07-05T00:00:00 -0500",
									"value": 1,
									"status": "GRAY"
								},
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 2,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 1,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 1,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 1,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 2,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 1,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 1,
									"status": "GRAY"
								},
								{
									"date": "2016-07-13T00:00:00 -0500",
									"value": 2,
									"status": "GRAY"
								},
								{
									"date": "2016-07-14T00:00:00 -0500",
									"value": 3,
									"status": "GRAY"
								},
								{
									"date": "2016-07-15T00:00:00 -0500",
									"value": 2,
									"status": "GRAY"
								},
								{
									"date": "2016-07-16T00:00:00 -0500",
									"value": 1,
									"status": "GRAY"
								},
								{
									"date": "2016-07-17T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-18T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5191,
								"name": "Postpaid Latency - GPRS",
								"unit": "MILLISECONDS",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-19T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-27T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-28T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-29T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-30T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-02T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-04T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-05T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-06T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-13T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-14T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-15T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-16T00:00:00 -0500",
									"value": 12,
									"status": "GRAY"
								},
								{
									"date": "2016-07-17T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-18T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5201,
								"name": "Postpaid Latency - MMS",
								"unit": "MILLISECONDS",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-19T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-27T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-28T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-29T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-30T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"value": 7,
									"status": "GRAY"
								},
								{
									"date": "2016-07-02T00:00:00 -0500",
									"value": 8,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"value": 6,
									"status": "GRAY"
								},
								{
									"date": "2016-07-04T00:00:00 -0500",
									"value": 7,
									"status": "GRAY"
								},
								{
									"date": "2016-07-05T00:00:00 -0500",
									"value": 5,
									"status": "GRAY"
								},
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 3,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 5,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 3,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 7,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 4,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 5,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 6,
									"status": "GRAY"
								},
								{
									"date": "2016-07-13T00:00:00 -0500",
									"value": 5,
									"status": "GRAY"
								},
								{
									"date": "2016-07-14T00:00:00 -0500",
									"value": 6,
									"status": "GRAY"
								},
								{
									"date": "2016-07-15T00:00:00 -0500",
									"value": 8,
									"status": "GRAY"
								},
								{
									"date": "2016-07-16T00:00:00 -0500",
									"value": 4,
									"status": "GRAY"
								},
								{
									"date": "2016-07-17T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-18T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5211,
								"name": "Postpaid Latency - SMS",
								"unit": "MILLISECONDS",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-19T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-27T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-28T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-29T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-30T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"value": 2,
									"status": "GRAY"
								},
								{
									"date": "2016-07-02T00:00:00 -0500",
									"value": 1,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"value": 2,
									"status": "GRAY"
								},
								{
									"date": "2016-07-04T00:00:00 -0500",
									"value": 1,
									"status": "GRAY"
								},
								{
									"date": "2016-07-05T00:00:00 -0500",
									"value": 2,
									"status": "GRAY"
								},
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 3,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 2,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 1,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 2,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 3,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 1,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 2,
									"status": "GRAY"
								},
								{
									"date": "2016-07-13T00:00:00 -0500",
									"value": 1,
									"status": "GRAY"
								},
								{
									"date": "2016-07-14T00:00:00 -0500",
									"value": 3,
									"status": "GRAY"
								},
								{
									"date": "2016-07-15T00:00:00 -0500",
									"value": 3,
									"status": "GRAY"
								},
								{
									"date": "2016-07-16T00:00:00 -0500",
									"value": 1,
									"status": "GRAY"
								},
								{
									"date": "2016-07-17T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-18T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5221,
								"name": "Postpaid Latency - Voice",
								"unit": "MILLISECONDS",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-19T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-27T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-28T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-29T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-30T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"value": 7,
									"status": "GRAY"
								},
								{
									"date": "2016-07-02T00:00:00 -0500",
									"value": 9,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"value": 8,
									"status": "GRAY"
								},
								{
									"date": "2016-07-04T00:00:00 -0500",
									"value": 5,
									"status": "GRAY"
								},
								{
									"date": "2016-07-05T00:00:00 -0500",
									"value": 5,
									"status": "GRAY"
								},
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 10,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 10,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 8,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 9,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 7,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 8,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 9,
									"status": "GRAY"
								},
								{
									"date": "2016-07-13T00:00:00 -0500",
									"value": 10,
									"status": "GRAY"
								},
								{
									"date": "2016-07-14T00:00:00 -0500",
									"value": 9,
									"status": "GRAY"
								},
								{
									"date": "2016-07-15T00:00:00 -0500",
									"value": 8,
									"status": "GRAY"
								},
								{
									"date": "2016-07-16T00:00:00 -0500",
									"value": 5,
									"status": "GRAY"
								},
								{
									"date": "2016-07-17T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-18T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'revenue/postpaid-latency/quarterly': {
		"status": 200,
		"data": {
			"title": "Quarterly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "Postpaid Latency",
					"subTitle": "Weekly",
					"metricSeries": [
						{
							"info": {
								"id": 5185,
								"name": "Postpaid Latency - Content",
								"unit": "MILLISECONDS",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 216,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 180,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 58,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 229,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 190,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 212,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 169,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 203,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"value": 92,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-17T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5195,
								"name": "Postpaid Latency - GPRS",
								"unit": "MILLISECONDS",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 64,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 118,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 116,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 79,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 86,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 248,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 65,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 202,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"value": 221,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-17T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5205,
								"name": "Postpaid Latency - MMS",
								"unit": "MILLISECONDS",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 242,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 204,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 178,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 139,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 214,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 187,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 214,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 78,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"value": 119,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-17T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5215,
								"name": "Postpaid Latency - SMS",
								"unit": "MILLISECONDS",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 218,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 84,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 64,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 132,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 182,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 105,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 194,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 146,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"value": 249,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-17T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5225,
								"name": "Postpaid Latency - Voice",
								"unit": "MILLISECONDS",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 204,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 194,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 230,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 240,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 135,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 168,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 210,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 154,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"value": 76,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-17T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'revenue/postpaid-trends/weekly': {
		"status": 200,
		"data": {
			"title": "Weekly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "Postpaid Trends",
					"subTitle": "Daily",
					"metricSeries": [
						{
							"info": {
								"id": 5001,
								"name": "Postpaid - Activations",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 4193,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 4627,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 4630,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 4535,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 4177,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 4274,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5011,
								"name": "Postpaid - Cancellations",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 1323,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 1060,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 1623,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 923,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 703,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 555,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5021,
								"name": "Postpaid - Suspensions",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 1898,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 2469,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 3115,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 3375,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 2973,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 1468,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'revenue/postpaid-trends/monthly': {
		"status": 200,
		"data": {
			"title": "Monthly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "Postpaid Trends",
					"subTitle": "Daily",
					"metricSeries": [
						{
							"info": {
								"id": 5001,
								"name": "Postpaid - Activations",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-05-28T00:00:00 -0500",
									"value": 4693,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 3494,
									"status": "GRAY"
								},
								{
									"date": "2016-05-30T00:00:00 -0500",
									"value": 4626,
									"status": "GRAY"
								},
								{
									"date": "2016-05-31T00:00:00 -0500",
									"value": 7190,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 2698,
									"status": "GRAY"
								},
								{
									"date": "2016-06-02T00:00:00 -0500",
									"value": 3180,
									"status": "GRAY"
								},
								{
									"date": "2016-06-03T00:00:00 -0500",
									"value": 3814,
									"status": "GRAY"
								},
								{
									"date": "2016-06-04T00:00:00 -0500",
									"value": 3935,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 2391,
									"status": "GRAY"
								},
								{
									"date": "2016-06-06T00:00:00 -0500",
									"value": 3337,
									"status": "GRAY"
								},
								{
									"date": "2016-06-07T00:00:00 -0500",
									"value": 3652,
									"status": "GRAY"
								},
								{
									"date": "2016-06-08T00:00:00 -0500",
									"value": 3765,
									"status": "GRAY"
								},
								{
									"date": "2016-06-09T00:00:00 -0500",
									"value": 4440,
									"status": "GRAY"
								},
								{
									"date": "2016-06-10T00:00:00 -0500",
									"value": 4063,
									"status": "GRAY"
								},
								{
									"date": "2016-06-11T00:00:00 -0500",
									"value": 139,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 3020,
									"status": "GRAY"
								},
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 3756,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 3903,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 4415,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 4262,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 4303,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 3848,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 168,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 4193,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 4627,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 4630,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 4535,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 4177,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 4274,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5011,
								"name": "Postpaid - Cancellations",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-05-28T00:00:00 -0500",
									"value": 653,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 479,
									"status": "GRAY"
								},
								{
									"date": "2016-05-30T00:00:00 -0500",
									"value": 785,
									"status": "GRAY"
								},
								{
									"date": "2016-05-31T00:00:00 -0500",
									"value": 1015,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 1612,
									"status": "GRAY"
								},
								{
									"date": "2016-06-02T00:00:00 -0500",
									"value": 730,
									"status": "GRAY"
								},
								{
									"date": "2016-06-03T00:00:00 -0500",
									"value": 890,
									"status": "GRAY"
								},
								{
									"date": "2016-06-04T00:00:00 -0500",
									"value": 600,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 487,
									"status": "GRAY"
								},
								{
									"date": "2016-06-06T00:00:00 -0500",
									"value": 1592,
									"status": "GRAY"
								},
								{
									"date": "2016-06-07T00:00:00 -0500",
									"value": 1666,
									"status": "GRAY"
								},
								{
									"date": "2016-06-08T00:00:00 -0500",
									"value": 2113,
									"status": "GRAY"
								},
								{
									"date": "2016-06-09T00:00:00 -0500",
									"value": 1094,
									"status": "GRAY"
								},
								{
									"date": "2016-06-10T00:00:00 -0500",
									"value": 1553,
									"status": "GRAY"
								},
								{
									"date": "2016-06-11T00:00:00 -0500",
									"value": 216,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 554,
									"status": "GRAY"
								},
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 896,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 1173,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 1001,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 818,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 928,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 766,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 52,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 1323,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 1060,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 1623,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 923,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 703,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 555,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5021,
								"name": "Postpaid - Suspensions",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-05-28T00:00:00 -0500",
									"value": 2151,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 161,
									"status": "GRAY"
								},
								{
									"date": "2016-05-30T00:00:00 -0500",
									"value": 2469,
									"status": "GRAY"
								},
								{
									"date": "2016-05-31T00:00:00 -0500",
									"value": 3883,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 41515,
									"status": "GRAY"
								},
								{
									"date": "2016-06-02T00:00:00 -0500",
									"value": 2712,
									"status": "GRAY"
								},
								{
									"date": "2016-06-03T00:00:00 -0500",
									"value": 3068,
									"status": "GRAY"
								},
								{
									"date": "2016-06-04T00:00:00 -0500",
									"value": 2528,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 131,
									"status": "GRAY"
								},
								{
									"date": "2016-06-06T00:00:00 -0500",
									"value": 2451,
									"status": "GRAY"
								},
								{
									"date": "2016-06-07T00:00:00 -0500",
									"value": 2589,
									"status": "GRAY"
								},
								{
									"date": "2016-06-08T00:00:00 -0500",
									"value": 2407,
									"status": "GRAY"
								},
								{
									"date": "2016-06-09T00:00:00 -0500",
									"value": 2956,
									"status": "GRAY"
								},
								{
									"date": "2016-06-10T00:00:00 -0500",
									"value": 3150,
									"status": "GRAY"
								},
								{
									"date": "2016-06-11T00:00:00 -0500",
									"value": 141,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 148,
									"status": "GRAY"
								},
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 2077,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 3054,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 2890,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 2633,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 3031,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 1792,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 115,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 1898,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 2469,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 3115,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 3375,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 2973,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 1468,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'revenue/postpaid-trends/quarterly': {
		"status": 200,
		"data": {
			"title": "Quarterly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "Postpaid Trends",
					"subTitle": "Weekly",
					"metricSeries": [
						{
							"info": {
								"id": 5005,
								"name": "Postpaid - Activations",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 119,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 187,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 111,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 112,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 105,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 50,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 121,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 190,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 159,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 223,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 85,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5015,
								"name": "Postpaid - Cancellations",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 148,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 161,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 208,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 107,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 158,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 121,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 67,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 158,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 236,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 218,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 240,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5025,
								"name": "Postpaid - Suspensions",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 186,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 102,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 170,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 103,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 83,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 181,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 187,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 136,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 186,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 185,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 85,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'revenue/prepaid-latency/weekly': {
		"status": 200,
		"data": {
			"title": "Weekly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "Prepaid Latency",
					"subTitle": "Daily",
					"metricSeries": [
						{
							"info": {
								"id": 5131,
								"name": "Prepaid Latency - Content",
								"unit": "MILLISECONDS",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-12T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-13T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-14T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-15T00:00:00 -0500",
									"value": 3,
									"status": "GRAY"
								},
								{
									"date": "2016-07-16T00:00:00 -0500",
									"value": 1,
									"status": "GRAY"
								},
								{
									"date": "2016-07-17T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-18T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5141,
								"name": "Prepaid Latency - GPRS",
								"unit": "MILLISECONDS",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 18,
									"status": "GRAY"
								},
								{
									"date": "2016-07-13T00:00:00 -0500",
									"value": 20,
									"status": "GRAY"
								},
								{
									"date": "2016-07-14T00:00:00 -0500",
									"value": 24,
									"status": "GRAY"
								},
								{
									"date": "2016-07-15T00:00:00 -0500",
									"value": 26,
									"status": "GRAY"
								},
								{
									"date": "2016-07-16T00:00:00 -0500",
									"value": 20,
									"status": "GRAY"
								},
								{
									"date": "2016-07-17T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-18T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5151,
								"name": "Prepaid Latency - MMS",
								"unit": "MILLISECONDS",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 16,
									"status": "GRAY"
								},
								{
									"date": "2016-07-13T00:00:00 -0500",
									"value": 10,
									"status": "GRAY"
								},
								{
									"date": "2016-07-14T00:00:00 -0500",
									"value": 5,
									"status": "GRAY"
								},
								{
									"date": "2016-07-15T00:00:00 -0500",
									"value": 3,
									"status": "GRAY"
								},
								{
									"date": "2016-07-16T00:00:00 -0500",
									"value": 4,
									"status": "GRAY"
								},
								{
									"date": "2016-07-17T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-18T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5161,
								"name": "Prepaid Latency - SMS",
								"unit": "MILLISECONDS",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 3,
									"status": "GRAY"
								},
								{
									"date": "2016-07-13T00:00:00 -0500",
									"value": 2,
									"status": "GRAY"
								},
								{
									"date": "2016-07-14T00:00:00 -0500",
									"value": 1,
									"status": "GRAY"
								},
								{
									"date": "2016-07-15T00:00:00 -0500",
									"value": 3,
									"status": "GRAY"
								},
								{
									"date": "2016-07-16T00:00:00 -0500",
									"value": 1,
									"status": "GRAY"
								},
								{
									"date": "2016-07-17T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-18T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5171,
								"name": "Prepaid Latency - Voice",
								"unit": "MILLISECONDS",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 4,
									"status": "GRAY"
								},
								{
									"date": "2016-07-13T00:00:00 -0500",
									"value": 2,
									"status": "GRAY"
								},
								{
									"date": "2016-07-14T00:00:00 -0500",
									"value": 5,
									"status": "GRAY"
								},
								{
									"date": "2016-07-15T00:00:00 -0500",
									"value": 2,
									"status": "GRAY"
								},
								{
									"date": "2016-07-16T00:00:00 -0500",
									"value": 3,
									"status": "GRAY"
								},
								{
									"date": "2016-07-17T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-18T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'revenue/prepaid-latency/monthly': {
		"status": 200,
		"data": {
			"title": "Monthly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "Prepaid Latency",
					"subTitle": "Daily",
					"metricSeries": [
						{
							"info": {
								"id": 5131,
								"name": "Prepaid Latency - Content",
								"unit": "MILLISECONDS",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-19T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-27T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-28T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-29T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-30T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-02T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-04T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-05T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-06T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-13T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-14T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-15T00:00:00 -0500",
									"value": 3,
									"status": "GRAY"
								},
								{
									"date": "2016-07-16T00:00:00 -0500",
									"value": 1,
									"status": "GRAY"
								},
								{
									"date": "2016-07-17T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-18T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5141,
								"name": "Prepaid Latency - GPRS",
								"unit": "MILLISECONDS",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-19T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-27T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-28T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-29T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-30T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"value": 25,
									"status": "GRAY"
								},
								{
									"date": "2016-07-02T00:00:00 -0500",
									"value": 19,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"value": 22,
									"status": "GRAY"
								},
								{
									"date": "2016-07-04T00:00:00 -0500",
									"value": 19,
									"status": "GRAY"
								},
								{
									"date": "2016-07-05T00:00:00 -0500",
									"value": 25,
									"status": "GRAY"
								},
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 19,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 22,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 19,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 21,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 20,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 21,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 18,
									"status": "GRAY"
								},
								{
									"date": "2016-07-13T00:00:00 -0500",
									"value": 20,
									"status": "GRAY"
								},
								{
									"date": "2016-07-14T00:00:00 -0500",
									"value": 24,
									"status": "GRAY"
								},
								{
									"date": "2016-07-15T00:00:00 -0500",
									"value": 26,
									"status": "GRAY"
								},
								{
									"date": "2016-07-16T00:00:00 -0500",
									"value": 20,
									"status": "GRAY"
								},
								{
									"date": "2016-07-17T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-18T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5151,
								"name": "Prepaid Latency - MMS",
								"unit": "MILLISECONDS",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-19T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-27T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-28T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-29T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-30T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"value": 16,
									"status": "GRAY"
								},
								{
									"date": "2016-07-02T00:00:00 -0500",
									"value": 19,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"value": 18,
									"status": "GRAY"
								},
								{
									"date": "2016-07-04T00:00:00 -0500",
									"value": 20,
									"status": "GRAY"
								},
								{
									"date": "2016-07-05T00:00:00 -0500",
									"value": 8,
									"status": "GRAY"
								},
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 18,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 10,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 8,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 20,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 8,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 13,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 16,
									"status": "GRAY"
								},
								{
									"date": "2016-07-13T00:00:00 -0500",
									"value": 10,
									"status": "GRAY"
								},
								{
									"date": "2016-07-14T00:00:00 -0500",
									"value": 5,
									"status": "GRAY"
								},
								{
									"date": "2016-07-15T00:00:00 -0500",
									"value": 3,
									"status": "GRAY"
								},
								{
									"date": "2016-07-16T00:00:00 -0500",
									"value": 4,
									"status": "GRAY"
								},
								{
									"date": "2016-07-17T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-18T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5161,
								"name": "Prepaid Latency - SMS",
								"unit": "MILLISECONDS",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-19T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-27T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-28T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-29T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-30T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"value": 4,
									"status": "GRAY"
								},
								{
									"date": "2016-07-02T00:00:00 -0500",
									"value": 3,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"value": 4,
									"status": "GRAY"
								},
								{
									"date": "2016-07-04T00:00:00 -0500",
									"value": 3,
									"status": "GRAY"
								},
								{
									"date": "2016-07-05T00:00:00 -0500",
									"value": 5,
									"status": "GRAY"
								},
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 3,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 3,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 2,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 4,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 3,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 4,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 3,
									"status": "GRAY"
								},
								{
									"date": "2016-07-13T00:00:00 -0500",
									"value": 2,
									"status": "GRAY"
								},
								{
									"date": "2016-07-14T00:00:00 -0500",
									"value": 1,
									"status": "GRAY"
								},
								{
									"date": "2016-07-15T00:00:00 -0500",
									"value": 3,
									"status": "GRAY"
								},
								{
									"date": "2016-07-16T00:00:00 -0500",
									"value": 1,
									"status": "GRAY"
								},
								{
									"date": "2016-07-17T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-18T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5171,
								"name": "Prepaid Latency - Voice",
								"unit": "MILLISECONDS",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-19T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-27T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-28T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-29T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-30T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"value": 8,
									"status": "GRAY"
								},
								{
									"date": "2016-07-02T00:00:00 -0500",
									"value": 5,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"value": 8,
									"status": "GRAY"
								},
								{
									"date": "2016-07-04T00:00:00 -0500",
									"value": 6,
									"status": "GRAY"
								},
								{
									"date": "2016-07-05T00:00:00 -0500",
									"value": 3,
									"status": "GRAY"
								},
								{
									"date": "2016-07-06T00:00:00 -0500",
									"value": 8,
									"status": "GRAY"
								},
								{
									"date": "2016-07-07T00:00:00 -0500",
									"value": 5,
									"status": "GRAY"
								},
								{
									"date": "2016-07-08T00:00:00 -0500",
									"value": 6,
									"status": "GRAY"
								},
								{
									"date": "2016-07-09T00:00:00 -0500",
									"value": 5,
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"value": 6,
									"status": "GRAY"
								},
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 3,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 4,
									"status": "GRAY"
								},
								{
									"date": "2016-07-13T00:00:00 -0500",
									"value": 2,
									"status": "GRAY"
								},
								{
									"date": "2016-07-14T00:00:00 -0500",
									"value": 5,
									"status": "GRAY"
								},
								{
									"date": "2016-07-15T00:00:00 -0500",
									"value": 2,
									"status": "GRAY"
								},
								{
									"date": "2016-07-16T00:00:00 -0500",
									"value": 3,
									"status": "GRAY"
								},
								{
									"date": "2016-07-17T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-18T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'revenue/prepaid-latency/quarterly': {
		"status": 200,
		"data": {
			"title": "Quarterly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "Prepaid Latency",
					"subTitle": "Weekly",
					"metricSeries": [
						{
							"info": {
								"id": 5135,
								"name": "Prepaid Latency - Content",
								"unit": "MILLISECONDS",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 57,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 119,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 166,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 207,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 229,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 76,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 116,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 217,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"value": 249,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-17T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5145,
								"name": "Prepaid Latency - GPRS",
								"unit": "MILLISECONDS",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 190,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 117,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 93,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 189,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 195,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 117,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 208,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 242,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"value": 145,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-17T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5155,
								"name": "Prepaid Latency - MMS",
								"unit": "MILLISECONDS",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 158,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 97,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 222,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 95,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 126,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 77,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 163,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 145,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"value": 199,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-17T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5165,
								"name": "Prepaid Latency - SMS",
								"unit": "MILLISECONDS",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 127,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 93,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 130,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 195,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 108,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 189,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 187,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 171,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"value": 136,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-17T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5175,
								"name": "Prepaid Latency - Voice",
								"unit": "MILLISECONDS",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 84,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 246,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 132,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 180,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 233,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 186,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 148,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 140,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"value": 56,
									"status": "GRAY"
								},
								{
									"date": "2016-07-03T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-10T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-17T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'revenue/prepaid-trends/weekly': {
		"status": 200,
		"data": {
			"title": "Weekly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "Prepaid Trends",
					"subTitle": "Daily",
					"metricSeries": [
						{
							"info": {
								"id": 5031,
								"name": "Prepaid - Activations",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 240971,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 253821,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 234863,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 238937,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 246011,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 249364,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5041,
								"name": "Prepaid - Cancellations",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 223,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 68,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 183,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 99,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 169,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 140,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5051,
								"name": "Prepaid - Grace ",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 229890,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 226278,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 237651,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 237823,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 192363,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 263184,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5061,
								"name": "Prepaid - Expired",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 207639,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 210610,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 192272,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 172502,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 162264,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 212476,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'revenue/prepaid-trends/monthly': {
		"status": 200,
		"data": {
			"title": "Monthly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "Prepaid Trends",
					"subTitle": "Daily",
					"metricSeries": [
						{
							"info": {
								"id": 5031,
								"name": "Prepaid - Activations",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-05-28T00:00:00 -0500",
									"value": 231536,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 221223,
									"status": "GRAY"
								},
								{
									"date": "2016-05-30T00:00:00 -0500",
									"value": 251013,
									"status": "GRAY"
								},
								{
									"date": "2016-05-31T00:00:00 -0500",
									"value": 243158,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 249604,
									"status": "GRAY"
								},
								{
									"date": "2016-06-02T00:00:00 -0500",
									"value": 241735,
									"status": "GRAY"
								},
								{
									"date": "2016-06-03T00:00:00 -0500",
									"value": 251247,
									"status": "GRAY"
								},
								{
									"date": "2016-06-04T00:00:00 -0500",
									"value": 240997,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 229055,
									"status": "GRAY"
								},
								{
									"date": "2016-06-06T00:00:00 -0500",
									"value": 265426,
									"status": "GRAY"
								},
								{
									"date": "2016-06-07T00:00:00 -0500",
									"value": 256105,
									"status": "GRAY"
								},
								{
									"date": "2016-06-08T00:00:00 -0500",
									"value": 245372,
									"status": "GRAY"
								},
								{
									"date": "2016-06-09T00:00:00 -0500",
									"value": 241614,
									"status": "GRAY"
								},
								{
									"date": "2016-06-10T00:00:00 -0500",
									"value": 246846,
									"status": "GRAY"
								},
								{
									"date": "2016-06-11T00:00:00 -0500",
									"value": 148,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 248683,
									"status": "GRAY"
								},
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 270049,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 247706,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 243523,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 245845,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 277954,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 258383,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 213,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 240971,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 253821,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 234863,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 238937,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 246011,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 249364,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5041,
								"name": "Prepaid - Cancellations",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-05-28T00:00:00 -0500",
									"value": 190,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 136,
									"status": "GRAY"
								},
								{
									"date": "2016-05-30T00:00:00 -0500",
									"value": 62,
									"status": "GRAY"
								},
								{
									"date": "2016-05-31T00:00:00 -0500",
									"value": 124,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 224,
									"status": "GRAY"
								},
								{
									"date": "2016-06-02T00:00:00 -0500",
									"value": 103,
									"status": "GRAY"
								},
								{
									"date": "2016-06-03T00:00:00 -0500",
									"value": 118,
									"status": "GRAY"
								},
								{
									"date": "2016-06-04T00:00:00 -0500",
									"value": 147,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 97,
									"status": "GRAY"
								},
								{
									"date": "2016-06-06T00:00:00 -0500",
									"value": 193,
									"status": "GRAY"
								},
								{
									"date": "2016-06-07T00:00:00 -0500",
									"value": 91,
									"status": "GRAY"
								},
								{
									"date": "2016-06-08T00:00:00 -0500",
									"value": 103,
									"status": "GRAY"
								},
								{
									"date": "2016-06-09T00:00:00 -0500",
									"value": 228,
									"status": "GRAY"
								},
								{
									"date": "2016-06-10T00:00:00 -0500",
									"value": 162,
									"status": "GRAY"
								},
								{
									"date": "2016-06-11T00:00:00 -0500",
									"value": 227,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 57,
									"status": "GRAY"
								},
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 235,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 236,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 61,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 178,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 64,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 151,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 215,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 223,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 68,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 183,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 99,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 169,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 140,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5051,
								"name": "Prepaid - Grace ",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-05-28T00:00:00 -0500",
									"value": 159779,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 269901,
									"status": "GRAY"
								},
								{
									"date": "2016-05-30T00:00:00 -0500",
									"value": 222944,
									"status": "GRAY"
								},
								{
									"date": "2016-05-31T00:00:00 -0500",
									"value": 223887,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 222355,
									"status": "GRAY"
								},
								{
									"date": "2016-06-02T00:00:00 -0500",
									"value": 224155,
									"status": "GRAY"
								},
								{
									"date": "2016-06-03T00:00:00 -0500",
									"value": 198520,
									"status": "GRAY"
								},
								{
									"date": "2016-06-04T00:00:00 -0500",
									"value": 194237,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 299513,
									"status": "GRAY"
								},
								{
									"date": "2016-06-06T00:00:00 -0500",
									"value": 240197,
									"status": "GRAY"
								},
								{
									"date": "2016-06-07T00:00:00 -0500",
									"value": 230595,
									"status": "GRAY"
								},
								{
									"date": "2016-06-08T00:00:00 -0500",
									"value": 104928,
									"status": "GRAY"
								},
								{
									"date": "2016-06-09T00:00:00 -0500",
									"value": 302076,
									"status": "GRAY"
								},
								{
									"date": "2016-06-10T00:00:00 -0500",
									"value": 218648,
									"status": "GRAY"
								},
								{
									"date": "2016-06-11T00:00:00 -0500",
									"value": 193,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 232276,
									"status": "GRAY"
								},
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 233183,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 226093,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 234164,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 202437,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 262888,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 228532,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 58,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 229890,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 226278,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 237651,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 237823,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 192363,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 263184,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5061,
								"name": "Prepaid - Expired",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-05-28T00:00:00 -0500",
									"value": 161333,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 220645,
									"status": "GRAY"
								},
								{
									"date": "2016-05-30T00:00:00 -0500",
									"value": 211625,
									"status": "GRAY"
								},
								{
									"date": "2016-05-31T00:00:00 -0500",
									"value": 243625,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 241756,
									"status": "GRAY"
								},
								{
									"date": "2016-06-02T00:00:00 -0500",
									"value": 209314,
									"status": "GRAY"
								},
								{
									"date": "2016-06-03T00:00:00 -0500",
									"value": 211899,
									"status": "GRAY"
								},
								{
									"date": "2016-06-04T00:00:00 -0500",
									"value": 152324,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 251517,
									"status": "GRAY"
								},
								{
									"date": "2016-06-06T00:00:00 -0500",
									"value": 213889,
									"status": "GRAY"
								},
								{
									"date": "2016-06-07T00:00:00 -0500",
									"value": 217383,
									"status": "GRAY"
								},
								{
									"date": "2016-06-08T00:00:00 -0500",
									"value": 82836,
									"status": "GRAY"
								},
								{
									"date": "2016-06-09T00:00:00 -0500",
									"value": 314451,
									"status": "GRAY"
								},
								{
									"date": "2016-06-10T00:00:00 -0500",
									"value": 194938,
									"status": "GRAY"
								},
								{
									"date": "2016-06-11T00:00:00 -0500",
									"value": 200,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 208038,
									"status": "GRAY"
								},
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 244561,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 247952,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 254994,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 229927,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 232611,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 190308,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 59,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 207639,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 210610,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 192272,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 172502,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 162264,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 212476,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'revenue/prepaid-trends/quarterly': {
		"status": 200,
		"data": {
			"title": "Quarterly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "Prepaid Trends",
					"subTitle": "Weekly",
					"metricSeries": [
						{
							"info": {
								"id": 5035,
								"name": "Prepaid - Activations",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 196,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 97,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 186,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 93,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 220,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 83,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 144,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 111,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 216,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 194,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 220,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5045,
								"name": "Prepaid - Cancellations",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 103,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 159,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 135,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 160,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 205,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 221,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 148,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 135,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 122,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 157,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 102,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5055,
								"name": "Prepaid - Grace ",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 239,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 154,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 187,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 229,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 224,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 232,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 89,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 66,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 226,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 170,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 188,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5065,
								"name": "Prepaid - Expired",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 101,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 140,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 115,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 52,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 210,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 138,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 156,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 238,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 128,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 241,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 164,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'revenue/recharge-sucess-rate/weekly': {
		"status": 200,
		"data": {
			"title": "Weekly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "Recharge Success Rate",
					"subTitle": "Daily",
					"metricSeries": [
						{
							"info": {
								"id": 5121,
								"name": "Prepaid Recharge Success Rate",
								"unit": "PERCENTAGE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 99.97,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 99.95,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 99.96,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 99.95,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 99.96,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 99.96,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'revenue/recharge-sucess-rate/monthly': {
		"status": 200,
		"data": {
			"title": "Monthly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "Recharge Success Rate",
					"subTitle": "Daily",
					"metricSeries": [
						{
							"info": {
								"id": 5121,
								"name": "Prepaid Recharge Success Rate",
								"unit": "PERCENTAGE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-05-28T00:00:00 -0500",
									"value": 99.95,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 99.96,
									"status": "GRAY"
								},
								{
									"date": "2016-05-30T00:00:00 -0500",
									"value": 99.96,
									"status": "GRAY"
								},
								{
									"date": "2016-05-31T00:00:00 -0500",
									"value": 99.94,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 99.95,
									"status": "GRAY"
								},
								{
									"date": "2016-06-02T00:00:00 -0500",
									"value": 99.89,
									"status": "GRAY"
								},
								{
									"date": "2016-06-03T00:00:00 -0500",
									"value": 99.95,
									"status": "GRAY"
								},
								{
									"date": "2016-06-04T00:00:00 -0500",
									"value": 99.95,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 99.95,
									"status": "GRAY"
								},
								{
									"date": "2016-06-06T00:00:00 -0500",
									"value": 99.93,
									"status": "GRAY"
								},
								{
									"date": "2016-06-07T00:00:00 -0500",
									"value": 99.95,
									"status": "GRAY"
								},
								{
									"date": "2016-06-08T00:00:00 -0500",
									"value": 99.68,
									"status": "GRAY"
								},
								{
									"date": "2016-06-09T00:00:00 -0500",
									"value": 99.94,
									"status": "GRAY"
								},
								{
									"date": "2016-06-10T00:00:00 -0500",
									"value": 99.96,
									"status": "GRAY"
								},
								{
									"date": "2016-06-11T00:00:00 -0500",
									"value": 6.55,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 99.93,
									"status": "GRAY"
								},
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 99.94,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 99.96,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 99.96,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 99.91,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 99.96,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 99.96,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 78.41,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 99.97,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 99.95,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 99.96,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 99.95,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 99.96,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 99.96,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'revenue/recharge-sucess-rate/quarterly': {
		"status": 200,
		"data": {
			"title": "Quarterly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "Recharge Success Rate",
					"subTitle": "Weekly",
					"metricSeries": [
						{
							"info": {
								"id": 5125,
								"name": "Prepaid Recharge Success Rate",
								"unit": "PERCENTAGE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 58.37,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 45.89,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 87.65,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 22.99,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 28.27,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 76.29,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 99,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 60.97,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 86.95,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 39.81,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 66.61,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'revenue/success-rates/weekly': {
		"status": 200,
		"data": {
			"title": "Weekly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "All Success Rate",
					"subTitle": "Daily",
					"metricSeries": [
						{
							"info": {
								"id": 5281,
								"name": "Prepaid Turbo Charging Success Rate",
								"unit": "PERCENTAGE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 45.34,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 68.67,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 2.8,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 57.59,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 95.43,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 57.14,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5291,
								"name": "Postpaid Turbo Charging Success Rate",
								"unit": "PERCENTAGE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 31.84,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 29.86,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 71.55,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 33.48,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 65.86,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 81.13,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5301,
								"name": "Prepaid Customer Mng Success Rate",
								"unit": "PERCENTAGE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 0.83,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 49.85,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 59.89,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 40.64,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 89.58,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 46.43,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5311,
								"name": "Postpaid Customer Mng Success Rate",
								"unit": "PERCENTAGE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 53,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 75.55,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 33.29,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 75.51,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 74.95,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 67.48,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5321,
								"name": "Prepaid Replenishment Success Rate",
								"unit": "PERCENTAGE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 90.04,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 13.81,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 41.69,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 7.29,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 74.46,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 52.21,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5331,
								"name": "Postpaid Replenishment Success Rate",
								"unit": "PERCENTAGE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 43.5,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 21.51,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 39.66,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 37.94,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 5.88,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 11.55,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5341,
								"name": "Prepaid EDR Events",
								"unit": "PERCENTAGE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 59.59,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 6.85,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 47.95,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 10.25,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 25.35,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 67.68,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5351,
								"name": "Postpaid EDR Events",
								"unit": "PERCENTAGE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 24.1,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 91.55,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 74.84,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 19.36,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 55.77,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 69.21,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'revenue/success-rates/monthly': {
		"status": 200,
		"data": {
			"title": "Monthly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "All Success Rate",
					"subTitle": "Daily",
					"metricSeries": [
						{
							"info": {
								"id": 5281,
								"name": "Prepaid Turbo Charging Success Rate",
								"unit": "PERCENTAGE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-05-28T00:00:00 -0500",
									"value": 36.13,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 38.78,
									"status": "GRAY"
								},
								{
									"date": "2016-05-30T00:00:00 -0500",
									"value": 50.35,
									"status": "GRAY"
								},
								{
									"date": "2016-05-31T00:00:00 -0500",
									"value": 9.45,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 51.56,
									"status": "GRAY"
								},
								{
									"date": "2016-06-02T00:00:00 -0500",
									"value": 92.32,
									"status": "GRAY"
								},
								{
									"date": "2016-06-03T00:00:00 -0500",
									"value": 64.3,
									"status": "GRAY"
								},
								{
									"date": "2016-06-04T00:00:00 -0500",
									"value": 82.96,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 94.16,
									"status": "GRAY"
								},
								{
									"date": "2016-06-06T00:00:00 -0500",
									"value": 60.24,
									"status": "GRAY"
								},
								{
									"date": "2016-06-07T00:00:00 -0500",
									"value": 60.06,
									"status": "GRAY"
								},
								{
									"date": "2016-06-08T00:00:00 -0500",
									"value": 81.29,
									"status": "GRAY"
								},
								{
									"date": "2016-06-09T00:00:00 -0500",
									"value": 87.67,
									"status": "GRAY"
								},
								{
									"date": "2016-06-10T00:00:00 -0500",
									"value": 34.96,
									"status": "GRAY"
								},
								{
									"date": "2016-06-11T00:00:00 -0500",
									"value": 32.33,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 39.76,
									"status": "GRAY"
								},
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 62.56,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 98.53,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 96.36,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 63.51,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 25.93,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 35.86,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 51.97,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 45.34,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 68.67,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 2.8,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 57.59,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 95.43,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 57.14,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5291,
								"name": "Postpaid Turbo Charging Success Rate",
								"unit": "PERCENTAGE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-05-28T00:00:00 -0500",
									"value": 91.62,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 57.47,
									"status": "GRAY"
								},
								{
									"date": "2016-05-30T00:00:00 -0500",
									"value": 90.77,
									"status": "GRAY"
								},
								{
									"date": "2016-05-31T00:00:00 -0500",
									"value": 96.18,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 93.26,
									"status": "GRAY"
								},
								{
									"date": "2016-06-02T00:00:00 -0500",
									"value": 93.07,
									"status": "GRAY"
								},
								{
									"date": "2016-06-03T00:00:00 -0500",
									"value": 44.24,
									"status": "GRAY"
								},
								{
									"date": "2016-06-04T00:00:00 -0500",
									"value": 97.18,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 41.25,
									"status": "GRAY"
								},
								{
									"date": "2016-06-06T00:00:00 -0500",
									"value": 90.15,
									"status": "GRAY"
								},
								{
									"date": "2016-06-07T00:00:00 -0500",
									"value": 38.83,
									"status": "GRAY"
								},
								{
									"date": "2016-06-08T00:00:00 -0500",
									"value": 71.49,
									"status": "GRAY"
								},
								{
									"date": "2016-06-09T00:00:00 -0500",
									"value": 27.15,
									"status": "GRAY"
								},
								{
									"date": "2016-06-10T00:00:00 -0500",
									"value": 5.88,
									"status": "GRAY"
								},
								{
									"date": "2016-06-11T00:00:00 -0500",
									"value": 66.28,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 71.28,
									"status": "GRAY"
								},
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 54.54,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 91.36,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 21.44,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 70.9,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 97.32,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 14.88,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 24.31,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 31.84,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 29.86,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 71.55,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 33.48,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 65.86,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 81.13,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5301,
								"name": "Prepaid Customer Mng Success Rate",
								"unit": "PERCENTAGE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-05-28T00:00:00 -0500",
									"value": 42.21,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 27.8,
									"status": "GRAY"
								},
								{
									"date": "2016-05-30T00:00:00 -0500",
									"value": 61.92,
									"status": "GRAY"
								},
								{
									"date": "2016-05-31T00:00:00 -0500",
									"value": 48.38,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 88.23,
									"status": "GRAY"
								},
								{
									"date": "2016-06-02T00:00:00 -0500",
									"value": 50.51,
									"status": "GRAY"
								},
								{
									"date": "2016-06-03T00:00:00 -0500",
									"value": 64.14,
									"status": "GRAY"
								},
								{
									"date": "2016-06-04T00:00:00 -0500",
									"value": 3.95,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 64.54,
									"status": "GRAY"
								},
								{
									"date": "2016-06-06T00:00:00 -0500",
									"value": 78.82,
									"status": "GRAY"
								},
								{
									"date": "2016-06-07T00:00:00 -0500",
									"value": 82.49,
									"status": "GRAY"
								},
								{
									"date": "2016-06-08T00:00:00 -0500",
									"value": 70.52,
									"status": "GRAY"
								},
								{
									"date": "2016-06-09T00:00:00 -0500",
									"value": 31.21,
									"status": "GRAY"
								},
								{
									"date": "2016-06-10T00:00:00 -0500",
									"value": 5.44,
									"status": "GRAY"
								},
								{
									"date": "2016-06-11T00:00:00 -0500",
									"value": 61.25,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 30.47,
									"status": "GRAY"
								},
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 44.17,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 78.74,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 66.76,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 37.92,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 42.44,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 17.49,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 21.95,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 0.83,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 49.85,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 59.89,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 40.64,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 89.58,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 46.43,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5311,
								"name": "Postpaid Customer Mng Success Rate",
								"unit": "PERCENTAGE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-05-28T00:00:00 -0500",
									"value": 59.07,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 63.71,
									"status": "GRAY"
								},
								{
									"date": "2016-05-30T00:00:00 -0500",
									"value": 35.54,
									"status": "GRAY"
								},
								{
									"date": "2016-05-31T00:00:00 -0500",
									"value": 94.22,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 45.83,
									"status": "GRAY"
								},
								{
									"date": "2016-06-02T00:00:00 -0500",
									"value": 96.51,
									"status": "GRAY"
								},
								{
									"date": "2016-06-03T00:00:00 -0500",
									"value": 75.68,
									"status": "GRAY"
								},
								{
									"date": "2016-06-04T00:00:00 -0500",
									"value": 66.54,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 11.09,
									"status": "GRAY"
								},
								{
									"date": "2016-06-06T00:00:00 -0500",
									"value": 70.58,
									"status": "GRAY"
								},
								{
									"date": "2016-06-07T00:00:00 -0500",
									"value": 3.15,
									"status": "GRAY"
								},
								{
									"date": "2016-06-08T00:00:00 -0500",
									"value": 39.88,
									"status": "GRAY"
								},
								{
									"date": "2016-06-09T00:00:00 -0500",
									"value": 51.35,
									"status": "GRAY"
								},
								{
									"date": "2016-06-10T00:00:00 -0500",
									"value": 66.25,
									"status": "GRAY"
								},
								{
									"date": "2016-06-11T00:00:00 -0500",
									"value": 98.5,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 98.28,
									"status": "GRAY"
								},
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 49.29,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 13.89,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 24.88,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 92.14,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 91.07,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 91.05,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 73.53,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 53,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 75.55,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 33.29,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 75.51,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 74.95,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 67.48,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5321,
								"name": "Prepaid Replenishment Success Rate",
								"unit": "PERCENTAGE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-05-28T00:00:00 -0500",
									"value": 70.66,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 2.37,
									"status": "GRAY"
								},
								{
									"date": "2016-05-30T00:00:00 -0500",
									"value": 70.25,
									"status": "GRAY"
								},
								{
									"date": "2016-05-31T00:00:00 -0500",
									"value": 74.67,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 41.29,
									"status": "GRAY"
								},
								{
									"date": "2016-06-02T00:00:00 -0500",
									"value": 5.12,
									"status": "GRAY"
								},
								{
									"date": "2016-06-03T00:00:00 -0500",
									"value": 85.45,
									"status": "GRAY"
								},
								{
									"date": "2016-06-04T00:00:00 -0500",
									"value": 67.31,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 3.2,
									"status": "GRAY"
								},
								{
									"date": "2016-06-06T00:00:00 -0500",
									"value": 65.28,
									"status": "GRAY"
								},
								{
									"date": "2016-06-07T00:00:00 -0500",
									"value": 83.51,
									"status": "GRAY"
								},
								{
									"date": "2016-06-08T00:00:00 -0500",
									"value": 98.85,
									"status": "GRAY"
								},
								{
									"date": "2016-06-09T00:00:00 -0500",
									"value": 80.25,
									"status": "GRAY"
								},
								{
									"date": "2016-06-10T00:00:00 -0500",
									"value": 5.36,
									"status": "GRAY"
								},
								{
									"date": "2016-06-11T00:00:00 -0500",
									"value": 72.38,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 57.51,
									"status": "GRAY"
								},
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 78.96,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 56.44,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 40.1,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 58.61,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 67.54,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 61.83,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 77.56,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 90.04,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 13.81,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 41.69,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 7.29,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 74.46,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 52.21,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5331,
								"name": "Postpaid Replenishment Success Rate",
								"unit": "PERCENTAGE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-05-28T00:00:00 -0500",
									"value": 30.52,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 45.27,
									"status": "GRAY"
								},
								{
									"date": "2016-05-30T00:00:00 -0500",
									"value": 33.6,
									"status": "GRAY"
								},
								{
									"date": "2016-05-31T00:00:00 -0500",
									"value": 59.42,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 98.68,
									"status": "GRAY"
								},
								{
									"date": "2016-06-02T00:00:00 -0500",
									"value": 26.81,
									"status": "GRAY"
								},
								{
									"date": "2016-06-03T00:00:00 -0500",
									"value": 76.94,
									"status": "GRAY"
								},
								{
									"date": "2016-06-04T00:00:00 -0500",
									"value": 42.03,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 63.11,
									"status": "GRAY"
								},
								{
									"date": "2016-06-06T00:00:00 -0500",
									"value": 42.94,
									"status": "GRAY"
								},
								{
									"date": "2016-06-07T00:00:00 -0500",
									"value": 82.61,
									"status": "GRAY"
								},
								{
									"date": "2016-06-08T00:00:00 -0500",
									"value": 39.61,
									"status": "GRAY"
								},
								{
									"date": "2016-06-09T00:00:00 -0500",
									"value": 34.28,
									"status": "GRAY"
								},
								{
									"date": "2016-06-10T00:00:00 -0500",
									"value": 50.1,
									"status": "GRAY"
								},
								{
									"date": "2016-06-11T00:00:00 -0500",
									"value": 41.43,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 60.67,
									"status": "GRAY"
								},
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 39.42,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 64.67,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 1.93,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 87.38,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 20.05,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 22.72,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 26.53,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 43.5,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 21.51,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 39.66,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 37.94,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 5.88,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 11.55,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5341,
								"name": "Prepaid EDR Events",
								"unit": "PERCENTAGE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-05-28T00:00:00 -0500",
									"value": 35.47,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 23.62,
									"status": "GRAY"
								},
								{
									"date": "2016-05-30T00:00:00 -0500",
									"value": 7.67,
									"status": "GRAY"
								},
								{
									"date": "2016-05-31T00:00:00 -0500",
									"value": 65.21,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 78.62,
									"status": "GRAY"
								},
								{
									"date": "2016-06-02T00:00:00 -0500",
									"value": 91.09,
									"status": "GRAY"
								},
								{
									"date": "2016-06-03T00:00:00 -0500",
									"value": 33.82,
									"status": "GRAY"
								},
								{
									"date": "2016-06-04T00:00:00 -0500",
									"value": 96.45,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 86.82,
									"status": "GRAY"
								},
								{
									"date": "2016-06-06T00:00:00 -0500",
									"value": 70.85,
									"status": "GRAY"
								},
								{
									"date": "2016-06-07T00:00:00 -0500",
									"value": 43.07,
									"status": "GRAY"
								},
								{
									"date": "2016-06-08T00:00:00 -0500",
									"value": 21.61,
									"status": "GRAY"
								},
								{
									"date": "2016-06-09T00:00:00 -0500",
									"value": 66.48,
									"status": "GRAY"
								},
								{
									"date": "2016-06-10T00:00:00 -0500",
									"value": 2.39,
									"status": "GRAY"
								},
								{
									"date": "2016-06-11T00:00:00 -0500",
									"value": 6.21,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 68.4,
									"status": "GRAY"
								},
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 71.86,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 62.84,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 50.18,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 66.74,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 78.47,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 67.78,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 46.14,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 59.59,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 6.85,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 47.95,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 10.25,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 25.35,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 67.68,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5351,
								"name": "Postpaid EDR Events",
								"unit": "PERCENTAGE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-05-28T00:00:00 -0500",
									"value": 17.38,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 25.77,
									"status": "GRAY"
								},
								{
									"date": "2016-05-30T00:00:00 -0500",
									"value": 83.78,
									"status": "GRAY"
								},
								{
									"date": "2016-05-31T00:00:00 -0500",
									"value": 27.2,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 62.21,
									"status": "GRAY"
								},
								{
									"date": "2016-06-02T00:00:00 -0500",
									"value": 93.83,
									"status": "GRAY"
								},
								{
									"date": "2016-06-03T00:00:00 -0500",
									"value": 94.74,
									"status": "GRAY"
								},
								{
									"date": "2016-06-04T00:00:00 -0500",
									"value": 6.54,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 44.33,
									"status": "GRAY"
								},
								{
									"date": "2016-06-06T00:00:00 -0500",
									"value": 36.29,
									"status": "GRAY"
								},
								{
									"date": "2016-06-07T00:00:00 -0500",
									"value": 61.78,
									"status": "GRAY"
								},
								{
									"date": "2016-06-08T00:00:00 -0500",
									"value": 65.95,
									"status": "GRAY"
								},
								{
									"date": "2016-06-09T00:00:00 -0500",
									"value": 58.25,
									"status": "GRAY"
								},
								{
									"date": "2016-06-10T00:00:00 -0500",
									"value": 21.14,
									"status": "GRAY"
								},
								{
									"date": "2016-06-11T00:00:00 -0500",
									"value": 77.14,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 96.11,
									"status": "GRAY"
								},
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 64.43,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 30.75,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 5.86,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 98.97,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 46.57,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 31.65,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 66.84,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 24.1,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 91.55,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 74.84,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 19.36,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 55.77,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 69.21,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'revenue/success-rates/quarterly': {
		"status": 200,
		"data": {
			"title": "Quarterly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "All Success Rate",
					"subTitle": "Weekly",
					"metricSeries": [
						{
							"info": {
								"id": 5285,
								"name": "Prepaid Turbo Charging Success Rate",
								"unit": "PERCENTAGE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 63.33,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 81.6,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 25.76,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 54.65,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 7.81,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 24.09,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 33.03,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 26.5,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 64.67,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 87.67,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 0.04,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5295,
								"name": "Postpaid Turbo Charging Success Rate",
								"unit": "PERCENTAGE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 9.58,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 98.15,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 6.05,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 33.89,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 15.87,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 74.1,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 9.25,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 10.57,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 33.76,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 70.88,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 23.27,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5305,
								"name": "Prepaid Customer Mng Success Rate",
								"unit": "PERCENTAGE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 56.16,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 74.84,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 73.39,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 32.39,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 61.44,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 30.64,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 2.43,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 0.18,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 57.49,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 97,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 53.77,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5315,
								"name": "Postpaid Customer Mng Success Rate",
								"unit": "PERCENTAGE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 26.65,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 15.89,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 79.76,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 72.99,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 94.89,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 15.51,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 42.7,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 52.57,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 72.26,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 28.42,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 77.74,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5325,
								"name": "Prepaid Replenishment Success Rate",
								"unit": "PERCENTAGE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 9.82,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 62.63,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 83.74,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 74.96,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 3.35,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 38.45,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 76.37,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 13.29,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 66.01,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 96.23,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 67.77,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5335,
								"name": "Postpaid Replenishment Success Rate",
								"unit": "PERCENTAGE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 71.87,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 36.08,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 81.16,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 3.79,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 64.23,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 45.86,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 58.55,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 78.99,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 18.28,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 30.85,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 77.33,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5345,
								"name": "Prepaid EDR Events",
								"unit": "PERCENTAGE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 78.11,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 26.26,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 8.61,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 40.25,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 21.15,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 92.02,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 63.14,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 73.26,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 92.8,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 65.43,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 86.19,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 5355,
								"name": "Postpaid EDR Events",
								"unit": "PERCENTAGE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 21.83,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 64.33,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 43.97,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 10.52,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 88.2,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 19.65,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 68.44,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 63.14,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 53.25,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 55.95,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 36.45,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}



	, 'bill-cycles': {
		"status": 200,
		"data": {
			"title": "Billing Cycles",
			"metrics": [
				{
					"info": {
						"id": 2021,
						"name": "BC01 - Adjustments Count",
						"unit": "VALUE",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-01T00:00:00 -0500",
						"value": 1,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2041,
						"name": "BC01 - Revenue RC ",
						"unit": "DOLLAR",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-01T00:00:00 -0500",
						"value": 257523152,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2051,
						"name": "BC01 - Revenue OTC",
						"unit": "DOLLAR",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-01T00:00:00 -0500",
						"value": 73597480,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2061,
						"name": "BC01 - Adjustments Amount",
						"unit": "DOLLAR",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-01T00:00:00 -0500",
						"value": 10,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2071,
						"name": "BC01 - Bills",
						"unit": "VALUE",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-01T00:00:00 -0500",
						"value": 457645,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2081,
						"name": "BC01 - Undo",
						"unit": "VALUE",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-01T00:00:00 -0500",
						"value": 0,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2091,
						"name": "BC01 - Bills Supressed",
						"unit": "VALUE",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-01T00:00:00 -0500",
						"value": 30081,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2121,
						"name": "BC06 - Adjustments Count",
						"unit": "VALUE",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-06T00:00:00 -0500",
						"value": 2,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2141,
						"name": "BC06 - Revenue RC ",
						"unit": "DOLLAR",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-06T00:00:00 -0500",
						"value": 187868432,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2151,
						"name": "BC06 - Revenue OTC",
						"unit": "DOLLAR",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-06T00:00:00 -0500",
						"value": 56193844,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2161,
						"name": "BC06 - Adjustments Amount",
						"unit": "DOLLAR",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-06T00:00:00 -0500",
						"value": 20,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2171,
						"name": "BC06 - Bills",
						"unit": "VALUE",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-06T00:00:00 -0500",
						"value": 245532,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2181,
						"name": "BC06 - Undo",
						"unit": "VALUE",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-06T00:00:00 -0500",
						"value": 0,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2191,
						"name": "BC06 - Bills Supressed",
						"unit": "VALUE",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-06T00:00:00 -0500",
						"value": 30937,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2221,
						"name": "BC10 - Adjustments Count",
						"unit": "VALUE",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-10T00:00:00 -0500",
						"value": 3,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2241,
						"name": "BC10 - Revenue RC ",
						"unit": "DOLLAR",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-10T00:00:00 -0500",
						"value": 143845504,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2251,
						"name": "BC10 - Revenue OTC",
						"unit": "DOLLAR",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-10T00:00:00 -0500",
						"value": 29675494,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2261,
						"name": "BC10 - Adjustments Amount",
						"unit": "DOLLAR",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-10T00:00:00 -0500",
						"value": 30,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2271,
						"name": "BC10 - Bills",
						"unit": "VALUE",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-10T00:00:00 -0500",
						"value": 170427,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2281,
						"name": "BC10 - Undo",
						"unit": "VALUE",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-10T00:00:00 -0500",
						"value": 0,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2291,
						"name": "BC10 - Bills Supressed",
						"unit": "VALUE",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-10T00:00:00 -0500",
						"value": 23444,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2321,
						"name": "BC11 - Adjustments Count",
						"unit": "VALUE",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-11T00:00:00 -0500",
						"value": 4,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2341,
						"name": "BC11 - Revenue RC ",
						"unit": "DOLLAR",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-11T00:00:00 -0500",
						"value": 152301472,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2351,
						"name": "BC11 - Revenue OTC",
						"unit": "DOLLAR",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-11T00:00:00 -0500",
						"value": 27934000,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2361,
						"name": "BC11 - Adjustments Amount",
						"unit": "DOLLAR",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-11T00:00:00 -0500",
						"value": 40,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2371,
						"name": "BC11 - Bills",
						"unit": "VALUE",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-11T00:00:00 -0500",
						"value": 185925,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2381,
						"name": "BC11 - Undo",
						"unit": "VALUE",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-11T00:00:00 -0500",
						"value": 0,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2391,
						"name": "BC11 - Bills Supressed",
						"unit": "VALUE",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-11T00:00:00 -0500",
						"value": 33698,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2421,
						"name": "BC13 - Adjustments Count",
						"unit": "VALUE",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-13T00:00:00 -0500",
						"value": 5,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2441,
						"name": "BC13 - Revenue RC ",
						"unit": "DOLLAR",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-13T00:00:00 -0500",
						"value": 246736256,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2451,
						"name": "BC13 - Revenue OTC",
						"unit": "DOLLAR",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-13T00:00:00 -0500",
						"value": 104959440,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2461,
						"name": "BC13 - Adjustments Amount",
						"unit": "DOLLAR",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-13T00:00:00 -0500",
						"value": 50,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2471,
						"name": "BC13 - Bills",
						"unit": "VALUE",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-13T00:00:00 -0500",
						"value": 403457,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2481,
						"name": "BC13 - Undo",
						"unit": "VALUE",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-13T00:00:00 -0500",
						"value": 0,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2491,
						"name": "BC13 - Bills Supressed",
						"unit": "VALUE",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-13T00:00:00 -0500",
						"value": 21577,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2521,
						"name": "BC16 - Adjustments Count",
						"unit": "VALUE",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-16T00:00:00 -0500",
						"value": 6,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2541,
						"name": "BC16 - Revenue RC ",
						"unit": "DOLLAR",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-16T00:00:00 -0500",
						"value": 172653936,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2551,
						"name": "BC16 - Revenue OTC",
						"unit": "DOLLAR",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-16T00:00:00 -0500",
						"value": 39743116,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2561,
						"name": "BC16 - Adjustments Amount",
						"unit": "DOLLAR",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-16T00:00:00 -0500",
						"value": 60,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2571,
						"name": "BC16 - Bills",
						"unit": "VALUE",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-16T00:00:00 -0500",
						"value": 208892,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2581,
						"name": "BC16 - Undo",
						"unit": "VALUE",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-16T00:00:00 -0500",
						"value": 0,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2591,
						"name": "BC16 - Bills Supressed",
						"unit": "VALUE",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-16T00:00:00 -0500",
						"value": 29681,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2621,
						"name": "BC18 - Adjustments Count",
						"unit": "VALUE",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-18T00:00:00 -0500",
						"value": 7,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2641,
						"name": "BC18 - Revenue RC ",
						"unit": "DOLLAR",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-18T00:00:00 -0500",
						"value": 278969728,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2651,
						"name": "BC18 - Revenue OTC",
						"unit": "DOLLAR",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-18T00:00:00 -0500",
						"value": 69427200,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2661,
						"name": "BC18 - Adjustments Amount",
						"unit": "DOLLAR",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-18T00:00:00 -0500",
						"value": 70,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2671,
						"name": "BC18 - Bills",
						"unit": "VALUE",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-18T00:00:00 -0500",
						"value": 445732,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2681,
						"name": "BC18 - Undo",
						"unit": "VALUE",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-18T00:00:00 -0500",
						"value": 0,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2691,
						"name": "BC18 - Bills Supressed",
						"unit": "VALUE",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-18T00:00:00 -0500",
						"value": 50793,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2721,
						"name": "BC21 - Adjustments Count",
						"unit": "VALUE",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-21T00:00:00 -0500",
						"value": 8,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2741,
						"name": "BC21 - Revenue RC ",
						"unit": "DOLLAR",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-21T00:00:00 -0500",
						"value": 178969312,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2751,
						"name": "BC21 - Revenue OTC",
						"unit": "DOLLAR",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-21T00:00:00 -0500",
						"value": 42126680,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2761,
						"name": "BC21 - Adjustments Amount",
						"unit": "DOLLAR",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-21T00:00:00 -0500",
						"value": 80,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2771,
						"name": "BC21 - Bills",
						"unit": "VALUE",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-21T00:00:00 -0500",
						"value": 231186,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2781,
						"name": "BC21 - Undo",
						"unit": "VALUE",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-21T00:00:00 -0500",
						"value": 0,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2791,
						"name": "BC21 - Bills Supressed",
						"unit": "VALUE",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-21T00:00:00 -0500",
						"value": 31333,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2821,
						"name": "BC24 - Adjustments Count",
						"unit": "VALUE",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-24T00:00:00 -0500",
						"value": 9,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2841,
						"name": "BC24 - Revenue RC ",
						"unit": "DOLLAR",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-24T00:00:00 -0500",
						"value": 156496576,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2851,
						"name": "BC24 - Revenue OTC",
						"unit": "DOLLAR",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-24T00:00:00 -0500",
						"value": 42789220,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2861,
						"name": "BC24 - Adjustments Amount",
						"unit": "DOLLAR",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-24T00:00:00 -0500",
						"value": 90,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2871,
						"name": "BC24 - Bills",
						"unit": "VALUE",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-24T00:00:00 -0500",
						"value": 211540,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2881,
						"name": "BC24 - Undo",
						"unit": "VALUE",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-24T00:00:00 -0500",
						"value": 0,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2891,
						"name": "BC24 - Bills Supressed",
						"unit": "VALUE",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-24T00:00:00 -0500",
						"value": 28705,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2921,
						"name": "BC27 - Adjustments Count",
						"unit": "VALUE",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-06-27T00:00:00 -0500",
						"value": 1,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2941,
						"name": "BC27 - Revenue RC ",
						"unit": "DOLLAR",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-06-27T00:00:00 -0500",
						"value": 267176240,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2951,
						"name": "BC27 - Revenue OTC",
						"unit": "DOLLAR",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-06-27T00:00:00 -0500",
						"value": 104529344,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2961,
						"name": "BC27 - Adjustments Amount",
						"unit": "DOLLAR",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-06-27T00:00:00 -0500",
						"value": 10,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2971,
						"name": "BC27 - Bills",
						"unit": "VALUE",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-06-27T00:00:00 -0500",
						"value": 405917,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2981,
						"name": "BC27 - Undo",
						"unit": "VALUE",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-06-27T00:00:00 -0500",
						"value": 0,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 2991,
						"name": "BC27 - Bills Supressed",
						"unit": "VALUE",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-06-27T00:00:00 -0500",
						"value": 30667,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 3001,
						"name": "BC01 - Bill Cycle Status",
						"unit": "VALUE",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-01T00:00:00 -0500",
						"value": 1,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 3011,
						"name": "BC06 - Bill Cycle Status",
						"unit": "VALUE",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-06T00:00:00 -0500",
						"value": 1,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 3021,
						"name": "BC10 - Bill Cycle Status",
						"unit": "VALUE",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-10T00:00:00 -0500",
						"value": 1,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 3031,
						"name": "BC11 - Bill Cycle Status",
						"unit": "VALUE",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-11T00:00:00 -0500",
						"value": 1,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 3041,
						"name": "BC13 - Bill Cycle Status",
						"unit": "VALUE",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-13T00:00:00 -0500",
						"value": 1,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 3051,
						"name": "BC16 - Bill Cycle Status",
						"unit": "VALUE",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-16T00:00:00 -0500",
						"value": 1,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 3061,
						"name": "BC18 - Bill Cycle Status",
						"unit": "VALUE",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-18T00:00:00 -0500",
						"value": 1,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 3071,
						"name": "BC21 - Bill Cycle Status",
						"unit": "VALUE",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-21T00:00:00 -0500",
						"value": 1,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 3081,
						"name": "BC24 - Bill Cycle Status",
						"unit": "VALUE",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-24T00:00:00 -0500",
						"value": 0,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 3091,
						"name": "BC27 - Bill Cycle Status",
						"unit": "VALUE",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-06-27T00:00:00 -0500",
						"value": 1,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 3101,
						"name": "BC01 - Bill Cycle Month",
						"unit": "VALUE",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-01T00:00:00 -0500",
						"value": 6,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 3111,
						"name": "BC06 - Bill Cycle Month",
						"unit": "VALUE",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-06T00:00:00 -0500",
						"value": 7,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 3121,
						"name": "BC10 - Bill Cycle Month",
						"unit": "VALUE",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-10T00:00:00 -0500",
						"value": 7,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 3131,
						"name": "BC11 - Bill Cycle Month",
						"unit": "VALUE",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-11T00:00:00 -0500",
						"value": 7,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 3141,
						"name": "BC13 - Bill Cycle Month",
						"unit": "VALUE",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-13T00:00:00 -0500",
						"value": 7,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 3151,
						"name": "BC16 - Bill Cycle Month",
						"unit": "VALUE",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-16T00:00:00 -0500",
						"value": 7,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 3161,
						"name": "BC18 - Bill Cycle Month",
						"unit": "VALUE",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-18T00:00:00 -0500",
						"value": 7,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 3171,
						"name": "BC21 - Bill Cycle Month",
						"unit": "VALUE",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-21T00:00:00 -0500",
						"value": 7,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 3181,
						"name": "BC24 - Bill Cycle Month",
						"unit": "VALUE",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-07-24T00:00:00 -0500",
						"value": 7,
						"status": "GRAY"
					}
				},
				{
					"info": {
						"id": 3191,
						"name": "BC27 - Bill Cycle Month",
						"unit": "VALUE",
						"updateSchedule": "MONTHLY"
					},
					"value": {
						"date": "2016-06-27T00:00:00 -0500",
						"value": 6,
						"status": "GRAY"
					}
				}
			],
			"gauges": [
				{
					"id": 36,
					"title": "BC01 - Timeliness",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"direction": "UP",
					"metric": {
						"info": {
							"id": 2001,
							"name": "BC01 - Timeliness",
							"unit": "HOURS",
							"updateSchedule": "MONTHLY"
						},
						"value": {
							"date": "2016-07-01T00:00:00 -0500",
							"value": 154.56,
							"status": "RED"
						}
					},
					"startWithStatus": "GREEN",
					"thresholds": [
						{
							"value": 72,
							"status": "YELLOW"
						},
						{
							"value": 120,
							"status": "RED"
						}
					],
					"type": "REGULAR",
					"history": []
				},
				{
					"id": 37,
					"title": "BC01 - Accuracy",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"direction": "UP",
					"metric": {
						"info": {
							"id": 2011,
							"name": "BC01 - Accuracy",
							"unit": "PERCENTAGE",
							"updateSchedule": "MONTHLY"
						},
						"value": {
							"date": "2016-07-01T00:00:00 -0500",
							"value": 100,
							"status": "GREEN"
						}
					},
					"startWithStatus": "RED",
					"thresholds": [
						{
							"value": 98,
							"status": "YELLOW"
						},
						{
							"value": 99,
							"status": "GREEN"
						}
					],
					"type": "INVERTED",
					"history": []
				},
				{
					"id": 38,
					"title": "BC06 - Timeliness",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"direction": "UP",
					"metric": {
						"info": {
							"id": 2101,
							"name": "BC06 - Timeliness",
							"unit": "HOURS",
							"updateSchedule": "MONTHLY"
						},
						"value": {
							"date": "2016-07-01T00:00:00 -0500",
							"value": 84.72,
							"status": "YELLOW"
						}
					},
					"startWithStatus": "GREEN",
					"thresholds": [
						{
							"value": 72,
							"status": "YELLOW"
						},
						{
							"value": 120,
							"status": "RED"
						}
					],
					"type": "REGULAR",
					"history": []
				},
				{
					"id": 39,
					"title": "BC06 - Accuracy",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"direction": "UP",
					"metric": {
						"info": {
							"id": 2111,
							"name": "BC06 - Accuracy",
							"unit": "PERCENTAGE",
							"updateSchedule": "MONTHLY"
						},
						"value": {
							"date": "2016-07-01T00:00:00 -0500",
							"value": 100,
							"status": "GREEN"
						}
					},
					"startWithStatus": "RED",
					"thresholds": [
						{
							"value": 98,
							"status": "YELLOW"
						},
						{
							"value": 99,
							"status": "GREEN"
						}
					],
					"type": "INVERTED",
					"history": []
				},
				{
					"id": 40,
					"title": "BC10 - Timeliness",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"direction": "UP",
					"metric": {
						"info": {
							"id": 2201,
							"name": "BC10 - Timeliness",
							"unit": "HOURS",
							"updateSchedule": "MONTHLY"
						},
						"value": {
							"date": "2016-07-01T00:00:00 -0500",
							"value": 116.88,
							"status": "YELLOW"
						}
					},
					"startWithStatus": "GREEN",
					"thresholds": [
						{
							"value": 72,
							"status": "YELLOW"
						},
						{
							"value": 120,
							"status": "RED"
						}
					],
					"type": "REGULAR",
					"history": []
				},
				{
					"id": 41,
					"title": "BC10 - Accuracy",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"direction": "UP",
					"metric": {
						"info": {
							"id": 2211,
							"name": "BC10 - Accuracy",
							"unit": "PERCENTAGE",
							"updateSchedule": "MONTHLY"
						},
						"value": {
							"date": "2016-07-01T00:00:00 -0500",
							"value": 100,
							"status": "GREEN"
						}
					},
					"startWithStatus": "RED",
					"thresholds": [
						{
							"value": 98,
							"status": "YELLOW"
						},
						{
							"value": 99,
							"status": "GREEN"
						}
					],
					"type": "INVERTED",
					"history": []
				},
				{
					"id": 42,
					"title": "BC11 - Timeliness",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"direction": "UP",
					"metric": {
						"info": {
							"id": 2301,
							"name": "BC11 - Timeliness",
							"unit": "HOURS",
							"updateSchedule": "MONTHLY"
						},
						"value": {
							"date": "2016-07-01T00:00:00 -0500",
							"value": 135.6,
							"status": "RED"
						}
					},
					"startWithStatus": "GREEN",
					"thresholds": [
						{
							"value": 72,
							"status": "YELLOW"
						},
						{
							"value": 120,
							"status": "RED"
						}
					],
					"type": "REGULAR",
					"history": []
				},
				{
					"id": 43,
					"title": "BC11 - Accuracy",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"direction": "UP",
					"metric": {
						"info": {
							"id": 2311,
							"name": "BC11 - Accuracy",
							"unit": "PERCENTAGE",
							"updateSchedule": "MONTHLY"
						},
						"value": {
							"date": "2016-07-01T00:00:00 -0500",
							"value": 100,
							"status": "GREEN"
						}
					},
					"startWithStatus": "RED",
					"thresholds": [
						{
							"value": 98,
							"status": "YELLOW"
						},
						{
							"value": 99,
							"status": "GREEN"
						}
					],
					"type": "INVERTED",
					"history": []
				},
				{
					"id": 44,
					"title": "BC13 - Timeliness",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"direction": "UP",
					"metric": {
						"info": {
							"id": 2401,
							"name": "BC13 - Timeliness",
							"unit": "HOURS",
							"updateSchedule": "MONTHLY"
						},
						"value": {
							"date": "2016-07-01T00:00:00 -0500",
							"value": 94.08,
							"status": "YELLOW"
						}
					},
					"startWithStatus": "GREEN",
					"thresholds": [
						{
							"value": 72,
							"status": "YELLOW"
						},
						{
							"value": 120,
							"status": "RED"
						}
					],
					"type": "REGULAR",
					"history": []
				},
				{
					"id": 45,
					"title": "BC13 - Accuracy",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"direction": "UP",
					"metric": {
						"info": {
							"id": 2411,
							"name": "BC13 - Accuracy",
							"unit": "PERCENTAGE",
							"updateSchedule": "MONTHLY"
						},
						"value": {
							"date": "2016-07-01T00:00:00 -0500",
							"value": 100,
							"status": "GREEN"
						}
					},
					"startWithStatus": "RED",
					"thresholds": [
						{
							"value": 98,
							"status": "YELLOW"
						},
						{
							"value": 99,
							"status": "GREEN"
						}
					],
					"type": "INVERTED",
					"history": []
				},
				{
					"id": 46,
					"title": "BC16 - Timeliness",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"direction": "UP",
					"metric": {
						"info": {
							"id": 2501,
							"name": "BC16 - Timeliness",
							"unit": "HOURS",
							"updateSchedule": "MONTHLY"
						},
						"value": {
							"date": "2016-07-01T00:00:00 -0500",
							"value": 179.28,
							"status": "RED"
						}
					},
					"startWithStatus": "GREEN",
					"thresholds": [
						{
							"value": 72,
							"status": "YELLOW"
						},
						{
							"value": 120,
							"status": "RED"
						}
					],
					"type": "REGULAR",
					"history": []
				},
				{
					"id": 47,
					"title": "BC16 - Accuracy",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"direction": "UP",
					"metric": {
						"info": {
							"id": 2511,
							"name": "BC16 - Accuracy",
							"unit": "PERCENTAGE",
							"updateSchedule": "MONTHLY"
						},
						"value": {
							"date": "2016-07-01T00:00:00 -0500",
							"value": 100,
							"status": "GREEN"
						}
					},
					"startWithStatus": "RED",
					"thresholds": [
						{
							"value": 98,
							"status": "YELLOW"
						},
						{
							"value": 99,
							"status": "GREEN"
						}
					],
					"type": "INVERTED",
					"history": []
				},
				{
					"id": 48,
					"title": "BC18 - Timeliness",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"direction": "UP",
					"metric": {
						"info": {
							"id": 2601,
							"name": "BC18 - Timeliness",
							"unit": "HOURS",
							"updateSchedule": "MONTHLY"
						},
						"value": {
							"date": "2016-07-01T00:00:00 -0500",
							"value": 164.4,
							"status": "RED"
						}
					},
					"startWithStatus": "GREEN",
					"thresholds": [
						{
							"value": 72,
							"status": "YELLOW"
						},
						{
							"value": 120,
							"status": "RED"
						}
					],
					"type": "REGULAR",
					"history": []
				},
				{
					"id": 49,
					"title": "BC18 - Accuracy",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"direction": "UP",
					"metric": {
						"info": {
							"id": 2611,
							"name": "BC18 - Accuracy",
							"unit": "PERCENTAGE",
							"updateSchedule": "MONTHLY"
						},
						"value": {
							"date": "2016-07-01T00:00:00 -0500",
							"value": 100,
							"status": "GREEN"
						}
					},
					"startWithStatus": "RED",
					"thresholds": [
						{
							"value": 98,
							"status": "YELLOW"
						},
						{
							"value": 99,
							"status": "GREEN"
						}
					],
					"type": "INVERTED",
					"history": []
				},
				{
					"id": 50,
					"title": "BC21 - Timeliness",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"direction": "UP",
					"metric": {
						"info": {
							"id": 2701,
							"name": "BC21 - Timeliness",
							"unit": "HOURS",
							"updateSchedule": "MONTHLY"
						},
						"value": {
							"date": "2016-07-01T00:00:00 -0500",
							"value": 122.16,
							"status": "RED"
						}
					},
					"startWithStatus": "GREEN",
					"thresholds": [
						{
							"value": 72,
							"status": "YELLOW"
						},
						{
							"value": 120,
							"status": "RED"
						}
					],
					"type": "REGULAR",
					"history": []
				},
				{
					"id": 51,
					"title": "BC21 - Accuracy",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"direction": "UP",
					"metric": {
						"info": {
							"id": 2711,
							"name": "BC21 - Accuracy",
							"unit": "PERCENTAGE",
							"updateSchedule": "MONTHLY"
						},
						"value": {
							"date": "2016-07-01T00:00:00 -0500",
							"value": 100,
							"status": "GREEN"
						}
					},
					"startWithStatus": "RED",
					"thresholds": [
						{
							"value": 98,
							"status": "YELLOW"
						},
						{
							"value": 99,
							"status": "GREEN"
						}
					],
					"type": "INVERTED",
					"history": []
				},
				{
					"id": 52,
					"title": "BC24 - Timeliness",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"direction": "UP",
					"metric": {
						"info": {
							"id": 2801,
							"name": "BC24 - Timeliness",
							"unit": "HOURS",
							"updateSchedule": "MONTHLY"
						},
						"value": {
							"date": "2016-07-01T00:00:00 -0500",
							"value": 58.56,
							"status": "GREEN"
						}
					},
					"startWithStatus": "GREEN",
					"thresholds": [
						{
							"value": 72,
							"status": "YELLOW"
						},
						{
							"value": 120,
							"status": "RED"
						}
					],
					"type": "REGULAR",
					"history": []
				},
				{
					"id": 53,
					"title": "BC24 - Accuracy",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"direction": "UP",
					"metric": {
						"info": {
							"id": 2811,
							"name": "BC24 - Accuracy",
							"unit": "PERCENTAGE",
							"updateSchedule": "MONTHLY"
						},
						"value": {
							"date": "2016-07-01T00:00:00 -0500",
							"value": 100,
							"status": "GREEN"
						}
					},
					"startWithStatus": "RED",
					"thresholds": [
						{
							"value": 98,
							"status": "YELLOW"
						},
						{
							"value": 99,
							"status": "GREEN"
						}
					],
					"type": "INVERTED",
					"history": []
				},
				{
					"id": 54,
					"title": "BC27 - Timeliness",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"direction": "UP",
					"metric": {
						"info": {
							"id": 2901,
							"name": "BC27 - Timeliness",
							"unit": "HOURS",
							"updateSchedule": "MONTHLY"
						},
						"value": {
							"date": "2016-06-01T00:00:00 -0500",
							"value": 89.52,
							"status": "YELLOW"
						}
					},
					"startWithStatus": "GREEN",
					"thresholds": [
						{
							"value": 72,
							"status": "YELLOW"
						},
						{
							"value": 120,
							"status": "RED"
						}
					],
					"type": "REGULAR",
					"history": []
				},
				{
					"id": 55,
					"title": "BC27 - Accuracy",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"direction": "UP",
					"metric": {
						"info": {
							"id": 2911,
							"name": "BC27 - Accuracy",
							"unit": "PERCENTAGE",
							"updateSchedule": "MONTHLY"
						},
						"value": {
							"date": "2016-06-01T00:00:00 -0500",
							"value": 100,
							"status": "GREEN"
						}
					},
					"startWithStatus": "RED",
					"thresholds": [
						{
							"value": 98,
							"status": "YELLOW"
						},
						{
							"value": 99,
							"status": "GREEN"
						}
					],
					"type": "INVERTED",
					"history": []
				},
				{
					"id": 73,
					"title": "BC01 - Bill Rejects",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"direction": "UP",
					"metric": {
						"info": {
							"id": 2031,
							"name": "BC01 - Rejects",
							"unit": "VALUE",
							"updateSchedule": "MONTHLY"
						},
						"value": {
							"date": "2016-07-01T00:00:00 -0500",
							"value": 0,
							"status": "GREEN"
						}
					},
					"startWithStatus": "GREEN",
					"thresholds": [
						{
							"value": 10000,
							"status": "YELLOW"
						},
						{
							"value": 25000,
							"status": "RED"
						}
					],
					"type": "REGULAR",
					"history": []
				},
				{
					"id": 74,
					"title": "BC06 - Bill Rejects",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"direction": "UP",
					"metric": {
						"info": {
							"id": 2131,
							"name": "BC06 - Rejects",
							"unit": "VALUE",
							"updateSchedule": "MONTHLY"
						},
						"value": {
							"date": "2016-07-01T00:00:00 -0500",
							"value": 0,
							"status": "GREEN"
						}
					},
					"startWithStatus": "GREEN",
					"thresholds": [
						{
							"value": 10000,
							"status": "YELLOW"
						},
						{
							"value": 25000,
							"status": "RED"
						}
					],
					"type": "REGULAR",
					"history": []
				},
				{
					"id": 75,
					"title": "BC10 - Bill Rejects",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"direction": "UP",
					"metric": {
						"info": {
							"id": 2231,
							"name": "BC10 - Rejects",
							"unit": "VALUE",
							"updateSchedule": "MONTHLY"
						},
						"value": {
							"date": "2016-07-01T00:00:00 -0500",
							"value": 0,
							"status": "GREEN"
						}
					},
					"startWithStatus": "GREEN",
					"thresholds": [
						{
							"value": 10000,
							"status": "YELLOW"
						},
						{
							"value": 25000,
							"status": "RED"
						}
					],
					"type": "REGULAR",
					"history": []
				},
				{
					"id": 76,
					"title": "BC11 - Bill Rejects",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"direction": "UP",
					"metric": {
						"info": {
							"id": 2331,
							"name": "BC11 - Rejects",
							"unit": "VALUE",
							"updateSchedule": "MONTHLY"
						},
						"value": {
							"date": "2016-07-01T00:00:00 -0500",
							"value": 0,
							"status": "GREEN"
						}
					},
					"startWithStatus": "GREEN",
					"thresholds": [
						{
							"value": 10000,
							"status": "YELLOW"
						},
						{
							"value": 25000,
							"status": "RED"
						}
					],
					"type": "REGULAR",
					"history": []
				},
				{
					"id": 77,
					"title": "BC13 - Bill Rejects",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"direction": "UP",
					"metric": {
						"info": {
							"id": 2431,
							"name": "BC13 - Rejects",
							"unit": "VALUE",
							"updateSchedule": "MONTHLY"
						},
						"value": {
							"date": "2016-07-01T00:00:00 -0500",
							"value": 0,
							"status": "GREEN"
						}
					},
					"startWithStatus": "GREEN",
					"thresholds": [
						{
							"value": 10000,
							"status": "YELLOW"
						},
						{
							"value": 25000,
							"status": "RED"
						}
					],
					"type": "REGULAR",
					"history": []
				},
				{
					"id": 78,
					"title": "BC16 - Bill Rejects",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"direction": "UP",
					"metric": {
						"info": {
							"id": 2531,
							"name": "BC16 - Rejects",
							"unit": "VALUE",
							"updateSchedule": "MONTHLY"
						},
						"value": {
							"date": "2016-07-01T00:00:00 -0500",
							"value": 0,
							"status": "GREEN"
						}
					},
					"startWithStatus": "GREEN",
					"thresholds": [
						{
							"value": 10000,
							"status": "YELLOW"
						},
						{
							"value": 25000,
							"status": "RED"
						}
					],
					"type": "REGULAR",
					"history": []
				},
				{
					"id": 79,
					"title": "BC18 - Bill Rejects",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"direction": "UP",
					"metric": {
						"info": {
							"id": 2631,
							"name": "BC18 - Rejects",
							"unit": "VALUE",
							"updateSchedule": "MONTHLY"
						},
						"value": {
							"date": "2016-07-01T00:00:00 -0500",
							"value": 0,
							"status": "GREEN"
						}
					},
					"startWithStatus": "GREEN",
					"thresholds": [
						{
							"value": 10000,
							"status": "YELLOW"
						},
						{
							"value": 25000,
							"status": "RED"
						}
					],
					"type": "REGULAR",
					"history": []
				},
				{
					"id": 80,
					"title": "BC21 - Bill Rejects",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"direction": "UP",
					"metric": {
						"info": {
							"id": 2731,
							"name": "BC21 - Rejects",
							"unit": "VALUE",
							"updateSchedule": "MONTHLY"
						},
						"value": {
							"date": "2016-07-01T00:00:00 -0500",
							"value": 0,
							"status": "GREEN"
						}
					},
					"startWithStatus": "GREEN",
					"thresholds": [
						{
							"value": 10000,
							"status": "YELLOW"
						},
						{
							"value": 25000,
							"status": "RED"
						}
					],
					"type": "REGULAR",
					"history": []
				},
				{
					"id": 81,
					"title": "BC24 - Bill Rejects",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"direction": "UP",
					"metric": {
						"info": {
							"id": 2831,
							"name": "BC24 - Rejects",
							"unit": "VALUE",
							"updateSchedule": "MONTHLY"
						},
						"value": {
							"date": "2016-07-01T00:00:00 -0500",
							"value": 0,
							"status": "GREEN"
						}
					},
					"startWithStatus": "GREEN",
					"thresholds": [
						{
							"value": 10000,
							"status": "YELLOW"
						},
						{
							"value": 25000,
							"status": "RED"
						}
					],
					"type": "REGULAR",
					"history": []
				},
				{
					"id": 82,
					"title": "BC27 - Bill Rejects",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"direction": "UP",
					"metric": {
						"info": {
							"id": 2931,
							"name": "BC27 - Rejects",
							"unit": "VALUE",
							"updateSchedule": "MONTHLY"
						},
						"value": {
							"date": "2016-06-01T00:00:00 -0500",
							"value": 0,
							"status": "GREEN"
						}
					},
					"startWithStatus": "GREEN",
					"thresholds": [
						{
							"value": 10000,
							"status": "YELLOW"
						},
						{
							"value": 25000,
							"status": "RED"
						}
					],
					"type": "REGULAR",
					"history": []
				}
			],
			"graphs": []
		}
	}

	, 'bill-cycle/BC01': {
		"status": 200,
		"data": {
			"title": "Yearly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "Bill Cycle - BC01",
					"subTitle": "Yearly",
					"metricSeries": [
						{
							"info": {
								"id": 2001,
								"name": "BC01 - Timeliness",
								"unit": "HOURS",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"value": 186.72,
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"value": 106.56,
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"value": 146.88,
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"value": 221.52,
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"value": 155.28,
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"value": 108.96,
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"value": 166.08,
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"value": 258.48,
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"value": 121.68,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 154.8,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 185.04,
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"value": 154.56,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2011,
								"name": "BC01 - Accuracy",
								"unit": "PERCENTAGE",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"value": 100,
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"value": 100,
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"value": 100,
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"value": 100,
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"value": 100,
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"value": 100,
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"value": 100,
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"value": 100,
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"value": 100,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 100,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 100,
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"value": 100,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2021,
								"name": "BC01 - Adjustments Count",
								"unit": "VALUE",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"value": 241,
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"value": 302,
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"value": 336,
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"value": 250,
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"value": 354,
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"value": 278,
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"value": 261,
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"value": 304,
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"value": 291,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 407,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 459,
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"value": 6,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2031,
								"name": "BC01 - Rejects",
								"unit": "PERCENTAGE",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2041,
								"name": "BC01 - Revenue RC ",
								"unit": "DOLLAR",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"value": 208673808,
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"value": 204875344,
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"value": 210429872,
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"value": 211520656,
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"value": 221926128,
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"value": 235820512,
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"value": 245118976,
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"value": 248547872,
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"value": 288202112,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 292538848,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 261655984,
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"value": 257523152,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2051,
								"name": "BC01 - Revenue OTC",
								"unit": "DOLLAR",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"value": 47588424,
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"value": 87550784,
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"value": 44254988,
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"value": 68964976,
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"value": 91030608,
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"value": 94344800,
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"value": 86974736,
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"value": 88999760,
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"value": 65918864,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 79612688,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 71285352,
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"value": 73597480,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2061,
								"name": "BC01 - Adjustments Amount",
								"unit": "DOLLAR",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"value": 2410,
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"value": 3020,
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"value": 3360,
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"value": 2500,
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"value": 3540,
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"value": 2780,
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"value": 2610,
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"value": 3040,
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"value": 2910,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 4070,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 4590,
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"value": 60,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2071,
								"name": "BC01 - Bills",
								"unit": "VALUE",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"value": 326669,
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"value": 331624,
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"value": 335386,
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"value": 335776,
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"value": 360179,
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"value": 381870,
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"value": 405649,
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"value": 426960,
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"value": 449228,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 470178,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 463040,
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"value": 457645,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2081,
								"name": "BC01 - Undo",
								"unit": "VALUE",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"value": 0,
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2091,
								"name": "BC01 - Bills Supressed",
								"unit": "VALUE",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"value": 20800,
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"value": 21489,
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"value": 22328,
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"value": 22993,
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"value": 23747,
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"value": 24300,
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"value": 25847,
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"value": 26758,
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"value": 28102,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 28604,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 29154,
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"value": 30081,
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'bill-cycle/BC06': {
		"status": 200,
		"data": {
			"title": "Yearly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "Bill Cycle - BC06",
					"subTitle": "Yearly",
					"metricSeries": [
						{
							"info": {
								"id": 2101,
								"name": "BC06 - Timeliness",
								"unit": "HOURS",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2111,
								"name": "BC06 - Accuracy",
								"unit": "PERCENTAGE",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2121,
								"name": "BC06 - Adjustments Count",
								"unit": "VALUE",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2131,
								"name": "BC06 - Rejects",
								"unit": "PERCENTAGE",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2141,
								"name": "BC06 - Revenue RC ",
								"unit": "DOLLAR",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2151,
								"name": "BC06 - Revenue OTC",
								"unit": "DOLLAR",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2161,
								"name": "BC06 - Adjustments Amount",
								"unit": "DOLLAR",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2171,
								"name": "BC06 - Bills",
								"unit": "VALUE",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2181,
								"name": "BC06 - Undo",
								"unit": "VALUE",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2191,
								"name": "BC06 - Bills Supressed",
								"unit": "VALUE",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'bill-cycle/BC10': {
		"status": 200,
		"data": {
			"title": "Yearly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "Bill Cycle - BC10",
					"subTitle": "Yearly",
					"metricSeries": [
						{
							"info": {
								"id": 2201,
								"name": "BC10 - Timeliness",
								"unit": "HOURS",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2211,
								"name": "BC10 - Accuracy",
								"unit": "PERCENTAGE",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2221,
								"name": "BC10 - Adjustments Count",
								"unit": "VALUE",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2231,
								"name": "BC10 - Rejects",
								"unit": "PERCENTAGE",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2241,
								"name": "BC10 - Revenue RC ",
								"unit": "DOLLAR",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2251,
								"name": "BC10 - Revenue OTC",
								"unit": "DOLLAR",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2261,
								"name": "BC10 - Adjustments Amount",
								"unit": "DOLLAR",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2271,
								"name": "BC10 - Bills",
								"unit": "VALUE",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2281,
								"name": "BC10 - Undo",
								"unit": "VALUE",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2291,
								"name": "BC10 - Bills Supressed",
								"unit": "VALUE",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'bill-cycle/BC11': {
		"status": 200,
		"data": {
			"title": "Yearly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "Bill Cycle - BC11",
					"subTitle": "Yearly",
					"metricSeries": [
						{
							"info": {
								"id": 2301,
								"name": "BC11 - Timeliness",
								"unit": "HOURS",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2311,
								"name": "BC11 - Accuracy",
								"unit": "PERCENTAGE",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2321,
								"name": "BC11 - Adjustments Count",
								"unit": "VALUE",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2331,
								"name": "BC11 - Rejects",
								"unit": "PERCENTAGE",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2341,
								"name": "BC11 - Revenue RC ",
								"unit": "DOLLAR",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2351,
								"name": "BC11 - Revenue OTC",
								"unit": "DOLLAR",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2361,
								"name": "BC11 - Adjustments Amount",
								"unit": "DOLLAR",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2371,
								"name": "BC11 - Bills",
								"unit": "VALUE",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2381,
								"name": "BC11 - Undo",
								"unit": "VALUE",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2391,
								"name": "BC11 - Bills Supressed",
								"unit": "VALUE",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'bill-cycle/BC13': {
		"status": 200,
		"data": {
			"title": "Yearly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "Bill Cycle - BC13",
					"subTitle": "Yearly",
					"metricSeries": [
						{
							"info": {
								"id": 2401,
								"name": "BC13 - Timeliness",
								"unit": "HOURS",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2411,
								"name": "BC13 - Accuracy",
								"unit": "PERCENTAGE",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2421,
								"name": "BC13 - Adjustments Count",
								"unit": "VALUE",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2431,
								"name": "BC13 - Rejects",
								"unit": "PERCENTAGE",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2441,
								"name": "BC13 - Revenue RC ",
								"unit": "DOLLAR",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2451,
								"name": "BC13 - Revenue OTC",
								"unit": "DOLLAR",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2461,
								"name": "BC13 - Adjustments Amount",
								"unit": "DOLLAR",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2471,
								"name": "BC13 - Bills",
								"unit": "VALUE",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2481,
								"name": "BC13 - Undo",
								"unit": "VALUE",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2491,
								"name": "BC13 - Bills Supressed",
								"unit": "VALUE",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'bill-cycle/BC16': {
		"status": 200,
		"data": {
			"title": "Yearly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "Bill Cycle - BC16",
					"subTitle": "Yearly",
					"metricSeries": [
						{
							"info": {
								"id": 2501,
								"name": "BC16 - Timeliness",
								"unit": "HOURS",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2511,
								"name": "BC16 - Accuracy",
								"unit": "PERCENTAGE",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2521,
								"name": "BC16 - Adjustments Count",
								"unit": "VALUE",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2531,
								"name": "BC16 - Rejects",
								"unit": "PERCENTAGE",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2541,
								"name": "BC16 - Revenue RC ",
								"unit": "DOLLAR",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2551,
								"name": "BC16 - Revenue OTC",
								"unit": "DOLLAR",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2561,
								"name": "BC16 - Adjustments Amount",
								"unit": "DOLLAR",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2571,
								"name": "BC16 - Bills",
								"unit": "VALUE",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2581,
								"name": "BC16 - Undo",
								"unit": "VALUE",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2591,
								"name": "BC16 - Bills Supressed",
								"unit": "VALUE",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'bill-cycle/BC18': {
		"status": 200,
		"data": {
			"title": "Yearly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "Bill Cycle - BC18",
					"subTitle": "Yearly",
					"metricSeries": [
						{
							"info": {
								"id": 2601,
								"name": "BC18 - Timeliness",
								"unit": "HOURS",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2611,
								"name": "BC18 - Accuracy",
								"unit": "PERCENTAGE",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2621,
								"name": "BC18 - Adjustments Count",
								"unit": "VALUE",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2631,
								"name": "BC18 - Rejects",
								"unit": "PERCENTAGE",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2641,
								"name": "BC18 - Revenue RC ",
								"unit": "DOLLAR",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2651,
								"name": "BC18 - Revenue OTC",
								"unit": "DOLLAR",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2661,
								"name": "BC18 - Adjustments Amount",
								"unit": "DOLLAR",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2671,
								"name": "BC18 - Bills",
								"unit": "VALUE",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2681,
								"name": "BC18 - Undo",
								"unit": "VALUE",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2691,
								"name": "BC18 - Bills Supressed",
								"unit": "VALUE",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'bill-cycle/BC21': {
		"status": 200,
		"data": {
			"title": "Yearly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "Bill Cycle - BC21",
					"subTitle": "Yearly",
					"metricSeries": [
						{
							"info": {
								"id": 2701,
								"name": "BC21 - Timeliness",
								"unit": "HOURS",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2711,
								"name": "BC21 - Accuracy",
								"unit": "PERCENTAGE",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2721,
								"name": "BC21 - Adjustments Count",
								"unit": "VALUE",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2731,
								"name": "BC21 - Rejects",
								"unit": "PERCENTAGE",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2741,
								"name": "BC21 - Revenue RC ",
								"unit": "DOLLAR",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2751,
								"name": "BC21 - Revenue OTC",
								"unit": "DOLLAR",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2761,
								"name": "BC21 - Adjustments Amount",
								"unit": "DOLLAR",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2771,
								"name": "BC21 - Bills",
								"unit": "VALUE",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2781,
								"name": "BC21 - Undo",
								"unit": "VALUE",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2791,
								"name": "BC21 - Bills Supressed",
								"unit": "VALUE",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'bill-cycle/BC24': {
		"status": 200,
		"data": {
			"title": "Yearly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "Bill Cycle - BC24",
					"subTitle": "Yearly",
					"metricSeries": [
						{
							"info": {
								"id": 2801,
								"name": "BC24 - Timeliness",
								"unit": "HOURS",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2811,
								"name": "BC24 - Accuracy",
								"unit": "PERCENTAGE",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2821,
								"name": "BC24 - Adjustments Count",
								"unit": "VALUE",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2831,
								"name": "BC24 - Rejects",
								"unit": "PERCENTAGE",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2841,
								"name": "BC24 - Revenue RC ",
								"unit": "DOLLAR",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2851,
								"name": "BC24 - Revenue OTC",
								"unit": "DOLLAR",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2861,
								"name": "BC24 - Adjustments Amount",
								"unit": "DOLLAR",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2871,
								"name": "BC24 - Bills",
								"unit": "VALUE",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2881,
								"name": "BC24 - Undo",
								"unit": "VALUE",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2891,
								"name": "BC24 - Bills Supressed",
								"unit": "VALUE",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'bill-cycle/BC27': {
		"status": 200,
		"data": {
			"title": "Yearly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "Bill Cycle - BC27",
					"subTitle": "Yearly",
					"metricSeries": [
						{
							"info": {
								"id": 2901,
								"name": "BC27 - Timeliness",
								"unit": "HOURS",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2911,
								"name": "BC27 - Accuracy",
								"unit": "PERCENTAGE",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2921,
								"name": "BC27 - Adjustments Count",
								"unit": "VALUE",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2931,
								"name": "BC27 - Rejects",
								"unit": "PERCENTAGE",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2941,
								"name": "BC27 - Revenue RC ",
								"unit": "DOLLAR",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2951,
								"name": "BC27 - Revenue OTC",
								"unit": "DOLLAR",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2961,
								"name": "BC27 - Adjustments Amount",
								"unit": "DOLLAR",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2971,
								"name": "BC27 - Bills",
								"unit": "VALUE",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2981,
								"name": "BC27 - Undo",
								"unit": "VALUE",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 2991,
								"name": "BC27 - Bills Supressed",
								"unit": "VALUE",
								"updateSchedule": "MONTHLY"
							},
							"values": [
								{
									"date": "2015-08-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-09-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-10-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-11-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2015-12-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-01-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-02-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-03-01T00:00:00 -0600",
									"status": "GRAY"
								},
								{
									"date": "2016-04-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-01T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}



	, 'operations': {
		"status": 200,
		"data": {
			"title": "Operations",
			"metrics": [],
			"gauges": [
				{
					"id": 56,
					"title": "P1 Tickets",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"direction": "DOWN",
					"metric": {
						"info": {
							"id": 7061,
							"name": "P1 Volume",
							"unit": "VALUE",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2016-07-16T00:00:00 -0500",
							"value": 1,
							"status": "RED"
						}
					},
					"majorMetric": {
						"info": {
							"id": 7063,
							"name": "Last P1 On ",
							"unit": "DAY",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2016-07-16T00:00:00 -0500",
							"value": 1475515800000,
							"status": "GRAY"
						}
					},
					"startWithStatus": "GREEN",
					"thresholds": [
						{
							"value": 1,
							"status": "RED"
						}
					],
					"type": "REGULAR",
					"pcntDiffToMajorMetric": -100,
					"history": [
						{
							"id": 56,
							"title": "P1 Tickets",
							"date": "2016-07-15T00:00:00 -0500",
							"value": 2,
							"status": "RED",
							"direction": "UP"
						},
						{
							"id": 56,
							"title": "P1 Tickets",
							"date": "2016-07-14T00:00:00 -0500",
							"value": 1,
							"status": "RED",
							"direction": "DOWN"
						},
						{
							"id": 56,
							"title": "P1 Tickets",
							"date": "2016-07-13T00:00:00 -0500",
							"value": 2,
							"status": "RED",
							"direction": "UP"
						},
						{
							"id": 56,
							"title": "P1 Tickets",
							"date": "2016-07-12T00:00:00 -0500",
							"value": 4,
							"status": "RED",
							"direction": "UP"
						},
						{
							"id": 56,
							"title": "P1 Tickets",
							"date": "2016-07-11T00:00:00 -0500",
							"value": 1,
							"status": "RED",
							"direction": "DOWN"
						},
						{
							"id": 56,
							"title": "P1 Tickets",
							"date": "2016-07-10T00:00:00 -0500",
							"value": 2,
							"status": "RED",
							"direction": "UP"
						}
					]
				},
				{
					"id": 57,
					"title": "P2 Tickets",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"direction": "UP",
					"metric": {
						"info": {
							"id": 7071,
							"name": "P2 Volume",
							"unit": "VALUE",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2016-07-16T00:00:00 -0500",
							"value": 3,
							"status": "RED"
						}
					},
					"majorMetric": {
						"info": {
							"id": 7073,
							"name": "Last P2 On",
							"unit": "DAY",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2016-07-16T00:00:00 -0500",
							"value": 1476574020000,
							"status": "GRAY"
						}
					},
					"startWithStatus": "GREEN",
					"thresholds": [
						{
							"value": 1,
							"status": "YELLOW"
						},
						{
							"value": 2,
							"status": "RED"
						}
					],
					"type": "REGULAR",
					"pcntDiffToMajorMetric": 200,
					"history": [
						{
							"id": 57,
							"title": "P2 Tickets",
							"date": "2016-07-15T00:00:00 -0500",
							"value": 5,
							"status": "RED",
							"direction": "UP"
						},
						{
							"id": 57,
							"title": "P2 Tickets",
							"date": "2016-07-14T00:00:00 -0500",
							"value": 1,
							"status": "YELLOW",
							"direction": "DOWN"
						},
						{
							"id": 57,
							"title": "P2 Tickets",
							"date": "2016-07-13T00:00:00 -0500",
							"value": 4,
							"status": "RED",
							"direction": "UP"
						},
						{
							"id": 57,
							"title": "P2 Tickets",
							"date": "2016-07-12T00:00:00 -0500",
							"value": 6,
							"status": "RED",
							"direction": "UP"
						},
						{
							"id": 57,
							"title": "P2 Tickets",
							"date": "2016-07-11T00:00:00 -0500",
							"value": 4,
							"status": "RED",
							"direction": "DOWN"
						},
						{
							"id": 57,
							"title": "P2 Tickets",
							"date": "2016-07-10T00:00:00 -0500",
							"value": 3,
							"status": "RED",
							"direction": "DOWN"
						}
					]
				},
				{
					"id": 58,
					"title": "Barred in Ordering & Switch - Cancelled in Collections",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"minValue": 0,
					"maxValue": 1500,
					"direction": "UP",
					"metric": {
						"info": {
							"id": 7011,
							"name": "Cancelled in Collections but barred in Ordering and Switch",
							"unit": "VALUE",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2016-07-17T00:00:00 -0500",
							"value": 142,
							"status": "GREEN"
						}
					},
					"majorMetric": {
						"info": {
							"id": 7012,
							"name": "Previous Day",
							"unit": "VALUE",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2016-07-17T00:00:00 -0500",
							"value": 140,
							"status": "GRAY"
						}
					},
					"startWithStatus": "GREEN",
					"thresholds": [
						{
							"value": 500,
							"status": "YELLOW"
						},
						{
							"value": 1000,
							"status": "RED"
						}
					],
					"type": "REGULAR",
					"pcntDiffToMajorMetric": 2,
					"history": [
						{
							"id": 58,
							"title": "Barred in Ordering & Switch - Cancelled in Collections",
							"date": "2016-07-16T00:00:00 -0500",
							"value": 140,
							"status": "GREEN",
							"direction": "DOWN"
						},
						{
							"id": 58,
							"title": "Barred in Ordering & Switch - Cancelled in Collections",
							"date": "2016-07-15T00:00:00 -0500",
							"value": 148,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 58,
							"title": "Barred in Ordering & Switch - Cancelled in Collections",
							"date": "2016-07-14T00:00:00 -0500",
							"value": 140,
							"status": "GREEN",
							"direction": "DOWN"
						},
						{
							"id": 58,
							"title": "Barred in Ordering & Switch - Cancelled in Collections",
							"date": "2016-07-13T00:00:00 -0500",
							"value": 138,
							"status": "GREEN",
							"direction": "DOWN"
						},
						{
							"id": 58,
							"title": "Barred in Ordering & Switch - Cancelled in Collections",
							"date": "2016-07-12T00:00:00 -0500",
							"value": 138,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 58,
							"title": "Barred in Ordering & Switch - Cancelled in Collections",
							"date": "2016-07-11T00:00:00 -0500",
							"value": 139,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 58,
							"title": "Barred in Ordering & Switch - Cancelled in Collections",
							"date": "2016-07-10T00:00:00 -0500",
							"value": 137,
							"status": "GREEN",
							"direction": "DOWN"
						}
					]
				},
				{
					"id": 59,
					"title": "Barred in Ordering & Switch - Working in Collections",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"minValue": 0,
					"maxValue": 1500,
					"direction": "DOWN",
					"metric": {
						"info": {
							"id": 7021,
							"name": "Working in Collections but barred in Ordering and Switch",
							"unit": "VALUE",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2016-07-17T00:00:00 -0500",
							"value": 136,
							"status": "GREEN"
						}
					},
					"majorMetric": {
						"info": {
							"id": 7022,
							"name": "Previous Day",
							"unit": "VALUE",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2016-07-17T00:00:00 -0500",
							"value": 143,
							"status": "GRAY"
						}
					},
					"startWithStatus": "GREEN",
					"thresholds": [
						{
							"value": 500,
							"status": "YELLOW"
						},
						{
							"value": 1000,
							"status": "RED"
						}
					],
					"type": "REGULAR",
					"pcntDiffToMajorMetric": -4,
					"history": [
						{
							"id": 59,
							"title": "Barred in Ordering & Switch - Working in Collections",
							"date": "2016-07-16T00:00:00 -0500",
							"value": 143,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 59,
							"title": "Barred in Ordering & Switch - Working in Collections",
							"date": "2016-07-15T00:00:00 -0500",
							"value": 95,
							"status": "GREEN",
							"direction": "DOWN"
						},
						{
							"id": 59,
							"title": "Barred in Ordering & Switch - Working in Collections",
							"date": "2016-07-14T00:00:00 -0500",
							"value": 217,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 59,
							"title": "Barred in Ordering & Switch - Working in Collections",
							"date": "2016-07-13T00:00:00 -0500",
							"value": 69,
							"status": "GREEN",
							"direction": "DOWN"
						},
						{
							"id": 59,
							"title": "Barred in Ordering & Switch - Working in Collections",
							"date": "2016-07-12T00:00:00 -0500",
							"value": 102,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 59,
							"title": "Barred in Ordering & Switch - Working in Collections",
							"date": "2016-07-11T00:00:00 -0500",
							"value": 83,
							"status": "GREEN",
							"direction": "DOWN"
						},
						{
							"id": 59,
							"title": "Barred in Ordering & Switch - Working in Collections",
							"date": "2016-07-10T00:00:00 -0500",
							"value": 137,
							"status": "GREEN",
							"direction": "UP"
						}
					]
				},
				{
					"id": 60,
					"title": "Working in Ordering & Switch - Cancelled in Collections",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"minValue": 0,
					"maxValue": 1500,
					"direction": "DOWN",
					"metric": {
						"info": {
							"id": 7031,
							"name": "Cancelled in Collections but working in Ordering and Switch",
							"unit": "VALUE",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2016-07-17T00:00:00 -0500",
							"value": 46,
							"status": "GREEN"
						}
					},
					"majorMetric": {
						"info": {
							"id": 7032,
							"name": "Previous Day",
							"unit": "VALUE",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2016-07-17T00:00:00 -0500",
							"value": 47,
							"status": "GRAY"
						}
					},
					"startWithStatus": "GREEN",
					"thresholds": [
						{
							"value": 500,
							"status": "YELLOW"
						},
						{
							"value": 1000,
							"status": "RED"
						}
					],
					"type": "REGULAR",
					"pcntDiffToMajorMetric": -2,
					"history": [
						{
							"id": 60,
							"title": "Working in Ordering & Switch - Cancelled in Collections",
							"date": "2016-07-16T00:00:00 -0500",
							"value": 47,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 60,
							"title": "Working in Ordering & Switch - Cancelled in Collections",
							"date": "2016-07-15T00:00:00 -0500",
							"value": 47,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 60,
							"title": "Working in Ordering & Switch - Cancelled in Collections",
							"date": "2016-07-14T00:00:00 -0500",
							"value": 47,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 60,
							"title": "Working in Ordering & Switch - Cancelled in Collections",
							"date": "2016-07-13T00:00:00 -0500",
							"value": 47,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 60,
							"title": "Working in Ordering & Switch - Cancelled in Collections",
							"date": "2016-07-12T00:00:00 -0500",
							"value": 46,
							"status": "GREEN",
							"direction": "DOWN"
						},
						{
							"id": 60,
							"title": "Working in Ordering & Switch - Cancelled in Collections",
							"date": "2016-07-11T00:00:00 -0500",
							"value": 47,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 60,
							"title": "Working in Ordering & Switch - Cancelled in Collections",
							"date": "2016-07-10T00:00:00 -0500",
							"value": 47,
							"status": "GREEN",
							"direction": "UP"
						}
					]
				},
				{
					"id": 61,
					"title": "Working in Ordering & Switch - Barred in Collections",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"minValue": 0,
					"maxValue": 1500,
					"direction": "DOWN",
					"metric": {
						"info": {
							"id": 7041,
							"name": "Barred in Collections but working in Ordering and Switch",
							"unit": "VALUE",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2016-07-17T00:00:00 -0500",
							"value": 145,
							"status": "GREEN"
						}
					},
					"majorMetric": {
						"info": {
							"id": 7042,
							"name": "Previous Day",
							"unit": "VALUE",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2016-07-17T00:00:00 -0500",
							"value": 2829,
							"status": "GRAY"
						}
					},
					"startWithStatus": "GREEN",
					"thresholds": [
						{
							"value": 500,
							"status": "YELLOW"
						},
						{
							"value": 1000,
							"status": "RED"
						}
					],
					"type": "REGULAR",
					"pcntDiffToMajorMetric": -94,
					"history": [
						{
							"id": 61,
							"title": "Working in Ordering & Switch - Barred in Collections",
							"date": "2016-07-16T00:00:00 -0500",
							"value": 2829,
							"status": "RED",
							"direction": "UP"
						},
						{
							"id": 61,
							"title": "Working in Ordering & Switch - Barred in Collections",
							"date": "2016-07-15T00:00:00 -0500",
							"value": 136,
							"status": "GREEN",
							"direction": "DOWN"
						},
						{
							"id": 61,
							"title": "Working in Ordering & Switch - Barred in Collections",
							"date": "2016-07-14T00:00:00 -0500",
							"value": 112,
							"status": "GREEN",
							"direction": "DOWN"
						},
						{
							"id": 61,
							"title": "Working in Ordering & Switch - Barred in Collections",
							"date": "2016-07-13T00:00:00 -0500",
							"value": 116,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 61,
							"title": "Working in Ordering & Switch - Barred in Collections",
							"date": "2016-07-12T00:00:00 -0500",
							"value": 125,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 61,
							"title": "Working in Ordering & Switch - Barred in Collections",
							"date": "2016-07-11T00:00:00 -0500",
							"value": 134,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 61,
							"title": "Working in Ordering & Switch - Barred in Collections",
							"date": "2016-07-10T00:00:00 -0500",
							"value": 125,
							"status": "GREEN",
							"direction": "DOWN"
						}
					]
				},
				{
					"id": 62,
					"title": "Error Backlog",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"minValue": 0,
					"maxValue": 1000,
					"direction": "UP",
					"metric": {
						"info": {
							"id": 7001,
							"name": "Error Backlog",
							"unit": "VALUE",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2016-07-17T00:00:00 -0500",
							"value": 611,
							"status": "RED"
						}
					},
					"majorMetric": {
						"info": {
							"id": 7002,
							"name": "Previous Day",
							"unit": "VALUE",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2016-07-17T00:00:00 -0500",
							"value": 547,
							"status": "GRAY"
						}
					},
					"startWithStatus": "GREEN",
					"thresholds": [
						{
							"value": 300,
							"status": "YELLOW"
						},
						{
							"value": 500,
							"status": "RED"
						}
					],
					"type": "REGULAR",
					"pcntDiffToMajorMetric": 12,
					"history": [
						{
							"id": 62,
							"title": "Error Backlog",
							"date": "2016-07-16T00:00:00 -0500",
							"value": 547,
							"status": "RED",
							"direction": "DOWN"
						},
						{
							"id": 62,
							"title": "Error Backlog",
							"date": "2016-07-15T00:00:00 -0500",
							"value": 561,
							"status": "RED",
							"direction": "UP"
						},
						{
							"id": 62,
							"title": "Error Backlog",
							"date": "2016-07-14T00:00:00 -0500",
							"value": 309,
							"status": "YELLOW",
							"direction": "DOWN"
						},
						{
							"id": 62,
							"title": "Error Backlog",
							"date": "2016-07-13T00:00:00 -0500",
							"value": 303,
							"status": "YELLOW",
							"direction": "DOWN"
						},
						{
							"id": 62,
							"title": "Error Backlog",
							"date": "2016-07-12T00:00:00 -0500",
							"value": 312,
							"status": "YELLOW",
							"direction": "UP"
						},
						{
							"id": 62,
							"title": "Error Backlog",
							"date": "2016-07-11T00:00:00 -0500",
							"value": 357,
							"status": "YELLOW",
							"direction": "UP"
						},
						{
							"id": 62,
							"title": "Error Backlog",
							"date": "2016-07-10T00:00:00 -0500",
							"value": 263,
							"status": "GREEN",
							"direction": "DOWN"
						}
					]
				},
				{
					"id": 63,
					"title": "CRM BAP Backlog",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"minValue": 0,
					"maxValue": 8000,
					"direction": "UP",
					"metric": {
						"info": {
							"id": 7221,
							"name": "CRM BAP Backlog",
							"unit": "VALUE",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2016-07-17T00:00:00 -0500",
							"value": 304,
							"status": "GREEN"
						}
					},
					"majorMetric": {
						"info": {
							"id": 7222,
							"name": "Previous Day",
							"unit": "VALUE",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2016-07-17T00:00:00 -0500",
							"value": 8,
							"status": "GRAY"
						}
					},
					"startWithStatus": "GREEN",
					"thresholds": [
						{
							"value": 1000,
							"status": "YELLOW"
						},
						{
							"value": 5000,
							"status": "RED"
						}
					],
					"type": "REGULAR",
					"pcntDiffToMajorMetric": 3700,
					"history": [
						{
							"id": 63,
							"title": "CRM BAP Backlog",
							"date": "2016-07-16T00:00:00 -0500",
							"value": 8,
							"status": "GREEN",
							"direction": "DOWN"
						},
						{
							"id": 63,
							"title": "CRM BAP Backlog",
							"date": "2016-07-15T00:00:00 -0500",
							"value": 485,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 63,
							"title": "CRM BAP Backlog",
							"date": "2016-07-14T00:00:00 -0500",
							"value": 641,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 63,
							"title": "CRM BAP Backlog",
							"date": "2016-07-13T00:00:00 -0500",
							"value": 1,
							"status": "GREEN",
							"direction": "DOWN"
						},
						{
							"id": 63,
							"title": "CRM BAP Backlog",
							"date": "2016-07-12T00:00:00 -0500",
							"value": 4,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 63,
							"title": "CRM BAP Backlog",
							"date": "2016-07-11T00:00:00 -0500",
							"value": 2,
							"status": "GREEN",
							"direction": "DOWN"
						},
						{
							"id": 63,
							"title": "CRM BAP Backlog",
							"date": "2016-07-10T00:00:00 -0500",
							"value": 591,
							"status": "GREEN",
							"direction": "UP"
						}
					]
				}
			],
			"graphs": [
				{
					"id": 0,
					"title": "Ticket Incoming - Incidents",
					"subTitle": "Daily",
					"metricSeries": [
						{
							"info": {
								"id": 7101,
								"name": "P1 Incident",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 1,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 4,
									"status": "GRAY"
								},
								{
									"date": "2016-07-13T00:00:00 -0500",
									"value": 2,
									"status": "GRAY"
								},
								{
									"date": "2016-07-14T00:00:00 -0500",
									"value": 1,
									"status": "GRAY"
								},
								{
									"date": "2016-07-15T00:00:00 -0500",
									"value": 2,
									"status": "GRAY"
								},
								{
									"date": "2016-07-16T00:00:00 -0500",
									"value": 1,
									"status": "GRAY"
								},
								{
									"date": "2016-07-17T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7121,
								"name": "P2 Incident",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 4,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 6,
									"status": "GRAY"
								},
								{
									"date": "2016-07-13T00:00:00 -0500",
									"value": 4,
									"status": "GRAY"
								},
								{
									"date": "2016-07-14T00:00:00 -0500",
									"value": 3,
									"status": "GRAY"
								},
								{
									"date": "2016-07-15T00:00:00 -0500",
									"value": 5,
									"status": "GRAY"
								},
								{
									"date": "2016-07-16T00:00:00 -0500",
									"value": 3,
									"status": "GRAY"
								},
								{
									"date": "2016-07-17T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7141,
								"name": "P3 Incident",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 10,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 5,
									"status": "GRAY"
								},
								{
									"date": "2016-07-13T00:00:00 -0500",
									"value": 15,
									"status": "GRAY"
								},
								{
									"date": "2016-07-14T00:00:00 -0500",
									"value": 12,
									"status": "GRAY"
								},
								{
									"date": "2016-07-15T00:00:00 -0500",
									"value": 8,
									"status": "GRAY"
								},
								{
									"date": "2016-07-16T00:00:00 -0500",
									"value": 6,
									"status": "GRAY"
								},
								{
									"date": "2016-07-17T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7161,
								"name": "P4 Incident",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 9,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 10,
									"status": "GRAY"
								},
								{
									"date": "2016-07-13T00:00:00 -0500",
									"value": 20,
									"status": "GRAY"
								},
								{
									"date": "2016-07-14T00:00:00 -0500",
									"value": 15,
									"status": "GRAY"
								},
								{
									"date": "2016-07-15T00:00:00 -0500",
									"value": 10,
									"status": "GRAY"
								},
								{
									"date": "2016-07-16T00:00:00 -0500",
									"value": 8,
									"status": "GRAY"
								},
								{
									"date": "2016-07-17T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				},
				{
					"id": 0,
					"title": "Ticket Incoming - Service Requests",
					"subTitle": "Daily",
					"metricSeries": [
						{
							"info": {
								"id": 7131,
								"name": "P2 Service Request",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 28,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 40,
									"status": "GRAY"
								},
								{
									"date": "2016-07-13T00:00:00 -0500",
									"value": 30,
									"status": "GRAY"
								},
								{
									"date": "2016-07-14T00:00:00 -0500",
									"value": 25,
									"status": "GRAY"
								},
								{
									"date": "2016-07-15T00:00:00 -0500",
									"value": 28,
									"status": "GRAY"
								},
								{
									"date": "2016-07-16T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-17T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7151,
								"name": "P3 Service Request",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 40,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 38,
									"status": "GRAY"
								},
								{
									"date": "2016-07-13T00:00:00 -0500",
									"value": 42,
									"status": "GRAY"
								},
								{
									"date": "2016-07-14T00:00:00 -0500",
									"value": 39,
									"status": "GRAY"
								},
								{
									"date": "2016-07-15T00:00:00 -0500",
									"value": 32,
									"status": "GRAY"
								},
								{
									"date": "2016-07-16T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-17T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7171,
								"name": "P4 Service Request",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 30,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 28,
									"status": "GRAY"
								},
								{
									"date": "2016-07-13T00:00:00 -0500",
									"value": 22,
									"status": "GRAY"
								},
								{
									"date": "2016-07-14T00:00:00 -0500",
									"value": 40,
									"status": "GRAY"
								},
								{
									"date": "2016-07-15T00:00:00 -0500",
									"value": 31,
									"status": "GRAY"
								},
								{
									"date": "2016-07-16T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-17T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				},
				{
					"id": 0,
					"title": "Problem Backlog",
					"subTitle": "Daily",
					"metricSeries": [
						{
							"info": {
								"id": 7231,
								"name": "P1 Problem Backlog",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 1,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 1,
									"status": "GRAY"
								},
								{
									"date": "2016-07-13T00:00:00 -0500",
									"value": 1,
									"status": "GRAY"
								},
								{
									"date": "2016-07-14T00:00:00 -0500",
									"value": 1,
									"status": "GRAY"
								},
								{
									"date": "2016-07-15T00:00:00 -0500",
									"value": 1,
									"status": "GRAY"
								},
								{
									"date": "2016-07-16T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-17T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7241,
								"name": "P2 Problem Backlog",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 2,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 1,
									"status": "GRAY"
								},
								{
									"date": "2016-07-13T00:00:00 -0500",
									"value": 3,
									"status": "GRAY"
								},
								{
									"date": "2016-07-14T00:00:00 -0500",
									"value": 2,
									"status": "GRAY"
								},
								{
									"date": "2016-07-15T00:00:00 -0500",
									"value": 1,
									"status": "GRAY"
								},
								{
									"date": "2016-07-16T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-17T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7251,
								"name": "P3 Problem Backlog",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 5,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 3,
									"status": "GRAY"
								},
								{
									"date": "2016-07-13T00:00:00 -0500",
									"value": 2,
									"status": "GRAY"
								},
								{
									"date": "2016-07-14T00:00:00 -0500",
									"value": 1,
									"status": "GRAY"
								},
								{
									"date": "2016-07-15T00:00:00 -0500",
									"value": 2,
									"status": "GRAY"
								},
								{
									"date": "2016-07-16T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-17T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7261,
								"name": "P4 Problem Backlog",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-07-11T00:00:00 -0500",
									"value": 2,
									"status": "GRAY"
								},
								{
									"date": "2016-07-12T00:00:00 -0500",
									"value": 1,
									"status": "GRAY"
								},
								{
									"date": "2016-07-13T00:00:00 -0500",
									"value": 1,
									"status": "GRAY"
								},
								{
									"date": "2016-07-14T00:00:00 -0500",
									"value": 2,
									"status": "GRAY"
								},
								{
									"date": "2016-07-15T00:00:00 -0500",
									"value": 3,
									"status": "GRAY"
								},
								{
									"date": "2016-07-16T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-07-17T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'operations/tickets-backlog/weekly': {
		"status": 200,
		"data": {
			"title": "Weekly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "Tickets Backlog",
					"subTitle": "Daily",
					"metricSeries": [
						{
							"info": {
								"id": 7101,
								"name": "P1 Incident",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 77,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 191,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 87,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 131,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 222,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 202,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7121,
								"name": "P2 Incident",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 181,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 72,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 56,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 244,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 135,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 133,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7141,
								"name": "P3 Incident",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 183,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 130,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 92,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 103,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 193,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 76,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7161,
								"name": "P4 Incident",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 85,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 197,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 109,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 129,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 248,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 158,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7181,
								"name": "P5 Incident",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 148,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 154,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 242,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 94,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 88,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 217,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7201,
								"name": "P6 Incident",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 167,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 100,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 115,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 111,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 226,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 116,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7231,
								"name": "P1 Problem Backlog",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 195,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 202,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 208,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 108,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 211,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 196,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7241,
								"name": "P2 Problem Backlog",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 69,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 202,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 79,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 212,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 117,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 128,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7251,
								"name": "P3 Problem Backlog",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 68,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 78,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 184,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 219,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 130,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 134,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7261,
								"name": "P4 Problem Backlog",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 95,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 92,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 160,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 93,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 121,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 123,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7271,
								"name": "P5 Problem Backlog",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 181,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 212,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 204,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 232,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 121,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 108,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7281,
								"name": "P6 Problem Backlog",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 109,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 229,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 197,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 60,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 139,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 243,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7131,
								"name": "P2 Service Request",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 83,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 112,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 189,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 222,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 129,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 237,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7151,
								"name": "P3 Service Request",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 225,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 56,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 96,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 94,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 214,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 245,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7171,
								"name": "P4 Service Request",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 174,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 98,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 172,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 50,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 179,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 121,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7191,
								"name": "P5 Service Request",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 195,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 220,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 151,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 237,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 79,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 196,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7211,
								"name": "P6 Service Request",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 126,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 100,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 56,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 179,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 226,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 204,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'operations/tickets-backlog/monthly': {
		"status": 200,
		"data": {
			"title": "Monthly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "Tickets Backlog",
					"subTitle": "Daily",
					"metricSeries": [
						{
							"info": {
								"id": 7101,
								"name": "P1 Incident",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-05-28T00:00:00 -0500",
									"value": 75,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 60,
									"status": "GRAY"
								},
								{
									"date": "2016-05-30T00:00:00 -0500",
									"value": 166,
									"status": "GRAY"
								},
								{
									"date": "2016-05-31T00:00:00 -0500",
									"value": 248,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 67,
									"status": "GRAY"
								},
								{
									"date": "2016-06-02T00:00:00 -0500",
									"value": 215,
									"status": "GRAY"
								},
								{
									"date": "2016-06-03T00:00:00 -0500",
									"value": 93,
									"status": "GRAY"
								},
								{
									"date": "2016-06-04T00:00:00 -0500",
									"value": 200,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 125,
									"status": "GRAY"
								},
								{
									"date": "2016-06-06T00:00:00 -0500",
									"value": 133,
									"status": "GRAY"
								},
								{
									"date": "2016-06-07T00:00:00 -0500",
									"value": 227,
									"status": "GRAY"
								},
								{
									"date": "2016-06-08T00:00:00 -0500",
									"value": 136,
									"status": "GRAY"
								},
								{
									"date": "2016-06-09T00:00:00 -0500",
									"value": 206,
									"status": "GRAY"
								},
								{
									"date": "2016-06-10T00:00:00 -0500",
									"value": 143,
									"status": "GRAY"
								},
								{
									"date": "2016-06-11T00:00:00 -0500",
									"value": 101,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 174,
									"status": "GRAY"
								},
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 200,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 225,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 148,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 143,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 234,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 60,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 175,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 77,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 191,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 87,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 131,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 222,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 202,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7121,
								"name": "P2 Incident",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-05-28T00:00:00 -0500",
									"value": 55,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 204,
									"status": "GRAY"
								},
								{
									"date": "2016-05-30T00:00:00 -0500",
									"value": 194,
									"status": "GRAY"
								},
								{
									"date": "2016-05-31T00:00:00 -0500",
									"value": 137,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 127,
									"status": "GRAY"
								},
								{
									"date": "2016-06-02T00:00:00 -0500",
									"value": 195,
									"status": "GRAY"
								},
								{
									"date": "2016-06-03T00:00:00 -0500",
									"value": 174,
									"status": "GRAY"
								},
								{
									"date": "2016-06-04T00:00:00 -0500",
									"value": 113,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 65,
									"status": "GRAY"
								},
								{
									"date": "2016-06-06T00:00:00 -0500",
									"value": 130,
									"status": "GRAY"
								},
								{
									"date": "2016-06-07T00:00:00 -0500",
									"value": 180,
									"status": "GRAY"
								},
								{
									"date": "2016-06-08T00:00:00 -0500",
									"value": 97,
									"status": "GRAY"
								},
								{
									"date": "2016-06-09T00:00:00 -0500",
									"value": 136,
									"status": "GRAY"
								},
								{
									"date": "2016-06-10T00:00:00 -0500",
									"value": 223,
									"status": "GRAY"
								},
								{
									"date": "2016-06-11T00:00:00 -0500",
									"value": 212,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 158,
									"status": "GRAY"
								},
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 115,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 133,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 159,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 145,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 242,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 160,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 187,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 181,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 72,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 56,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 244,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 135,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 133,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7141,
								"name": "P3 Incident",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-05-28T00:00:00 -0500",
									"value": 149,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 229,
									"status": "GRAY"
								},
								{
									"date": "2016-05-30T00:00:00 -0500",
									"value": 57,
									"status": "GRAY"
								},
								{
									"date": "2016-05-31T00:00:00 -0500",
									"value": 69,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 104,
									"status": "GRAY"
								},
								{
									"date": "2016-06-02T00:00:00 -0500",
									"value": 84,
									"status": "GRAY"
								},
								{
									"date": "2016-06-03T00:00:00 -0500",
									"value": 230,
									"status": "GRAY"
								},
								{
									"date": "2016-06-04T00:00:00 -0500",
									"value": 148,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 146,
									"status": "GRAY"
								},
								{
									"date": "2016-06-06T00:00:00 -0500",
									"value": 155,
									"status": "GRAY"
								},
								{
									"date": "2016-06-07T00:00:00 -0500",
									"value": 238,
									"status": "GRAY"
								},
								{
									"date": "2016-06-08T00:00:00 -0500",
									"value": 180,
									"status": "GRAY"
								},
								{
									"date": "2016-06-09T00:00:00 -0500",
									"value": 177,
									"status": "GRAY"
								},
								{
									"date": "2016-06-10T00:00:00 -0500",
									"value": 115,
									"status": "GRAY"
								},
								{
									"date": "2016-06-11T00:00:00 -0500",
									"value": 51,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 65,
									"status": "GRAY"
								},
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 91,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 55,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 205,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 80,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 168,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 188,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 53,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 183,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 130,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 92,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 103,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 193,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 76,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7161,
								"name": "P4 Incident",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-05-28T00:00:00 -0500",
									"value": 191,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 79,
									"status": "GRAY"
								},
								{
									"date": "2016-05-30T00:00:00 -0500",
									"value": 232,
									"status": "GRAY"
								},
								{
									"date": "2016-05-31T00:00:00 -0500",
									"value": 172,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 130,
									"status": "GRAY"
								},
								{
									"date": "2016-06-02T00:00:00 -0500",
									"value": 99,
									"status": "GRAY"
								},
								{
									"date": "2016-06-03T00:00:00 -0500",
									"value": 111,
									"status": "GRAY"
								},
								{
									"date": "2016-06-04T00:00:00 -0500",
									"value": 67,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 92,
									"status": "GRAY"
								},
								{
									"date": "2016-06-06T00:00:00 -0500",
									"value": 91,
									"status": "GRAY"
								},
								{
									"date": "2016-06-07T00:00:00 -0500",
									"value": 182,
									"status": "GRAY"
								},
								{
									"date": "2016-06-08T00:00:00 -0500",
									"value": 232,
									"status": "GRAY"
								},
								{
									"date": "2016-06-09T00:00:00 -0500",
									"value": 193,
									"status": "GRAY"
								},
								{
									"date": "2016-06-10T00:00:00 -0500",
									"value": 86,
									"status": "GRAY"
								},
								{
									"date": "2016-06-11T00:00:00 -0500",
									"value": 58,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 107,
									"status": "GRAY"
								},
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 50,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 146,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 168,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 76,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 93,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 84,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 247,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 85,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 197,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 109,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 129,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 248,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 158,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7181,
								"name": "P5 Incident",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-05-28T00:00:00 -0500",
									"value": 185,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 163,
									"status": "GRAY"
								},
								{
									"date": "2016-05-30T00:00:00 -0500",
									"value": 113,
									"status": "GRAY"
								},
								{
									"date": "2016-05-31T00:00:00 -0500",
									"value": 115,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 204,
									"status": "GRAY"
								},
								{
									"date": "2016-06-02T00:00:00 -0500",
									"value": 162,
									"status": "GRAY"
								},
								{
									"date": "2016-06-03T00:00:00 -0500",
									"value": 199,
									"status": "GRAY"
								},
								{
									"date": "2016-06-04T00:00:00 -0500",
									"value": 209,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 133,
									"status": "GRAY"
								},
								{
									"date": "2016-06-06T00:00:00 -0500",
									"value": 201,
									"status": "GRAY"
								},
								{
									"date": "2016-06-07T00:00:00 -0500",
									"value": 217,
									"status": "GRAY"
								},
								{
									"date": "2016-06-08T00:00:00 -0500",
									"value": 125,
									"status": "GRAY"
								},
								{
									"date": "2016-06-09T00:00:00 -0500",
									"value": 146,
									"status": "GRAY"
								},
								{
									"date": "2016-06-10T00:00:00 -0500",
									"value": 203,
									"status": "GRAY"
								},
								{
									"date": "2016-06-11T00:00:00 -0500",
									"value": 200,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 177,
									"status": "GRAY"
								},
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 148,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 164,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 167,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 170,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 142,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 221,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 95,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 148,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 154,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 242,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 94,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 88,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 217,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7201,
								"name": "P6 Incident",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-05-28T00:00:00 -0500",
									"value": 216,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 161,
									"status": "GRAY"
								},
								{
									"date": "2016-05-30T00:00:00 -0500",
									"value": 74,
									"status": "GRAY"
								},
								{
									"date": "2016-05-31T00:00:00 -0500",
									"value": 189,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 188,
									"status": "GRAY"
								},
								{
									"date": "2016-06-02T00:00:00 -0500",
									"value": 54,
									"status": "GRAY"
								},
								{
									"date": "2016-06-03T00:00:00 -0500",
									"value": 120,
									"status": "GRAY"
								},
								{
									"date": "2016-06-04T00:00:00 -0500",
									"value": 108,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 161,
									"status": "GRAY"
								},
								{
									"date": "2016-06-06T00:00:00 -0500",
									"value": 206,
									"status": "GRAY"
								},
								{
									"date": "2016-06-07T00:00:00 -0500",
									"value": 117,
									"status": "GRAY"
								},
								{
									"date": "2016-06-08T00:00:00 -0500",
									"value": 186,
									"status": "GRAY"
								},
								{
									"date": "2016-06-09T00:00:00 -0500",
									"value": 186,
									"status": "GRAY"
								},
								{
									"date": "2016-06-10T00:00:00 -0500",
									"value": 121,
									"status": "GRAY"
								},
								{
									"date": "2016-06-11T00:00:00 -0500",
									"value": 211,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 234,
									"status": "GRAY"
								},
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 225,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 96,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 87,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 114,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 249,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 100,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 187,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 167,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 100,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 115,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 111,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 226,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 116,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7231,
								"name": "P1 Problem Backlog",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-05-28T00:00:00 -0500",
									"value": 216,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 233,
									"status": "GRAY"
								},
								{
									"date": "2016-05-30T00:00:00 -0500",
									"value": 218,
									"status": "GRAY"
								},
								{
									"date": "2016-05-31T00:00:00 -0500",
									"value": 72,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 138,
									"status": "GRAY"
								},
								{
									"date": "2016-06-02T00:00:00 -0500",
									"value": 124,
									"status": "GRAY"
								},
								{
									"date": "2016-06-03T00:00:00 -0500",
									"value": 242,
									"status": "GRAY"
								},
								{
									"date": "2016-06-04T00:00:00 -0500",
									"value": 206,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 71,
									"status": "GRAY"
								},
								{
									"date": "2016-06-06T00:00:00 -0500",
									"value": 56,
									"status": "GRAY"
								},
								{
									"date": "2016-06-07T00:00:00 -0500",
									"value": 132,
									"status": "GRAY"
								},
								{
									"date": "2016-06-08T00:00:00 -0500",
									"value": 143,
									"status": "GRAY"
								},
								{
									"date": "2016-06-09T00:00:00 -0500",
									"value": 78,
									"status": "GRAY"
								},
								{
									"date": "2016-06-10T00:00:00 -0500",
									"value": 183,
									"status": "GRAY"
								},
								{
									"date": "2016-06-11T00:00:00 -0500",
									"value": 199,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 212,
									"status": "GRAY"
								},
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 173,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 119,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 63,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 195,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 233,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 234,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 242,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 195,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 202,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 208,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 108,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 211,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 196,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7241,
								"name": "P2 Problem Backlog",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-05-28T00:00:00 -0500",
									"value": 105,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 181,
									"status": "GRAY"
								},
								{
									"date": "2016-05-30T00:00:00 -0500",
									"value": 176,
									"status": "GRAY"
								},
								{
									"date": "2016-05-31T00:00:00 -0500",
									"value": 85,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 108,
									"status": "GRAY"
								},
								{
									"date": "2016-06-02T00:00:00 -0500",
									"value": 124,
									"status": "GRAY"
								},
								{
									"date": "2016-06-03T00:00:00 -0500",
									"value": 148,
									"status": "GRAY"
								},
								{
									"date": "2016-06-04T00:00:00 -0500",
									"value": 156,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 61,
									"status": "GRAY"
								},
								{
									"date": "2016-06-06T00:00:00 -0500",
									"value": 155,
									"status": "GRAY"
								},
								{
									"date": "2016-06-07T00:00:00 -0500",
									"value": 58,
									"status": "GRAY"
								},
								{
									"date": "2016-06-08T00:00:00 -0500",
									"value": 123,
									"status": "GRAY"
								},
								{
									"date": "2016-06-09T00:00:00 -0500",
									"value": 244,
									"status": "GRAY"
								},
								{
									"date": "2016-06-10T00:00:00 -0500",
									"value": 148,
									"status": "GRAY"
								},
								{
									"date": "2016-06-11T00:00:00 -0500",
									"value": 225,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 240,
									"status": "GRAY"
								},
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 168,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 130,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 228,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 67,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 191,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 51,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 59,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 69,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 202,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 79,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 212,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 117,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 128,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7251,
								"name": "P3 Problem Backlog",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-05-28T00:00:00 -0500",
									"value": 81,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 240,
									"status": "GRAY"
								},
								{
									"date": "2016-05-30T00:00:00 -0500",
									"value": 100,
									"status": "GRAY"
								},
								{
									"date": "2016-05-31T00:00:00 -0500",
									"value": 108,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 226,
									"status": "GRAY"
								},
								{
									"date": "2016-06-02T00:00:00 -0500",
									"value": 71,
									"status": "GRAY"
								},
								{
									"date": "2016-06-03T00:00:00 -0500",
									"value": 189,
									"status": "GRAY"
								},
								{
									"date": "2016-06-04T00:00:00 -0500",
									"value": 235,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 92,
									"status": "GRAY"
								},
								{
									"date": "2016-06-06T00:00:00 -0500",
									"value": 78,
									"status": "GRAY"
								},
								{
									"date": "2016-06-07T00:00:00 -0500",
									"value": 246,
									"status": "GRAY"
								},
								{
									"date": "2016-06-08T00:00:00 -0500",
									"value": 88,
									"status": "GRAY"
								},
								{
									"date": "2016-06-09T00:00:00 -0500",
									"value": 153,
									"status": "GRAY"
								},
								{
									"date": "2016-06-10T00:00:00 -0500",
									"value": 99,
									"status": "GRAY"
								},
								{
									"date": "2016-06-11T00:00:00 -0500",
									"value": 110,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 193,
									"status": "GRAY"
								},
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 67,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 89,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 228,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 55,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 149,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 197,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 66,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 68,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 78,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 184,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 219,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 130,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 134,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7261,
								"name": "P4 Problem Backlog",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-05-28T00:00:00 -0500",
									"value": 182,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 163,
									"status": "GRAY"
								},
								{
									"date": "2016-05-30T00:00:00 -0500",
									"value": 54,
									"status": "GRAY"
								},
								{
									"date": "2016-05-31T00:00:00 -0500",
									"value": 106,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 206,
									"status": "GRAY"
								},
								{
									"date": "2016-06-02T00:00:00 -0500",
									"value": 231,
									"status": "GRAY"
								},
								{
									"date": "2016-06-03T00:00:00 -0500",
									"value": 97,
									"status": "GRAY"
								},
								{
									"date": "2016-06-04T00:00:00 -0500",
									"value": 168,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 115,
									"status": "GRAY"
								},
								{
									"date": "2016-06-06T00:00:00 -0500",
									"value": 180,
									"status": "GRAY"
								},
								{
									"date": "2016-06-07T00:00:00 -0500",
									"value": 248,
									"status": "GRAY"
								},
								{
									"date": "2016-06-08T00:00:00 -0500",
									"value": 129,
									"status": "GRAY"
								},
								{
									"date": "2016-06-09T00:00:00 -0500",
									"value": 98,
									"status": "GRAY"
								},
								{
									"date": "2016-06-10T00:00:00 -0500",
									"value": 205,
									"status": "GRAY"
								},
								{
									"date": "2016-06-11T00:00:00 -0500",
									"value": 94,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 134,
									"status": "GRAY"
								},
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 135,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 220,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 84,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 63,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 160,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 115,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 92,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 95,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 92,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 160,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 93,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 121,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 123,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7271,
								"name": "P5 Problem Backlog",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-05-28T00:00:00 -0500",
									"value": 142,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 88,
									"status": "GRAY"
								},
								{
									"date": "2016-05-30T00:00:00 -0500",
									"value": 239,
									"status": "GRAY"
								},
								{
									"date": "2016-05-31T00:00:00 -0500",
									"value": 94,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 181,
									"status": "GRAY"
								},
								{
									"date": "2016-06-02T00:00:00 -0500",
									"value": 53,
									"status": "GRAY"
								},
								{
									"date": "2016-06-03T00:00:00 -0500",
									"value": 143,
									"status": "GRAY"
								},
								{
									"date": "2016-06-04T00:00:00 -0500",
									"value": 138,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 148,
									"status": "GRAY"
								},
								{
									"date": "2016-06-06T00:00:00 -0500",
									"value": 168,
									"status": "GRAY"
								},
								{
									"date": "2016-06-07T00:00:00 -0500",
									"value": 68,
									"status": "GRAY"
								},
								{
									"date": "2016-06-08T00:00:00 -0500",
									"value": 90,
									"status": "GRAY"
								},
								{
									"date": "2016-06-09T00:00:00 -0500",
									"value": 228,
									"status": "GRAY"
								},
								{
									"date": "2016-06-10T00:00:00 -0500",
									"value": 74,
									"status": "GRAY"
								},
								{
									"date": "2016-06-11T00:00:00 -0500",
									"value": 159,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 186,
									"status": "GRAY"
								},
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 157,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 111,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 147,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 125,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 233,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 164,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 52,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 181,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 212,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 204,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 232,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 121,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 108,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7281,
								"name": "P6 Problem Backlog",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-05-28T00:00:00 -0500",
									"value": 81,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 173,
									"status": "GRAY"
								},
								{
									"date": "2016-05-30T00:00:00 -0500",
									"value": 110,
									"status": "GRAY"
								},
								{
									"date": "2016-05-31T00:00:00 -0500",
									"value": 126,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 111,
									"status": "GRAY"
								},
								{
									"date": "2016-06-02T00:00:00 -0500",
									"value": 108,
									"status": "GRAY"
								},
								{
									"date": "2016-06-03T00:00:00 -0500",
									"value": 238,
									"status": "GRAY"
								},
								{
									"date": "2016-06-04T00:00:00 -0500",
									"value": 151,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 244,
									"status": "GRAY"
								},
								{
									"date": "2016-06-06T00:00:00 -0500",
									"value": 137,
									"status": "GRAY"
								},
								{
									"date": "2016-06-07T00:00:00 -0500",
									"value": 174,
									"status": "GRAY"
								},
								{
									"date": "2016-06-08T00:00:00 -0500",
									"value": 139,
									"status": "GRAY"
								},
								{
									"date": "2016-06-09T00:00:00 -0500",
									"value": 122,
									"status": "GRAY"
								},
								{
									"date": "2016-06-10T00:00:00 -0500",
									"value": 114,
									"status": "GRAY"
								},
								{
									"date": "2016-06-11T00:00:00 -0500",
									"value": 186,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 214,
									"status": "GRAY"
								},
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 174,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 157,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 223,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 70,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 132,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 103,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 51,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 109,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 229,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 197,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 60,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 139,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 243,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7131,
								"name": "P2 Service Request",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-05-28T00:00:00 -0500",
									"value": 105,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 125,
									"status": "GRAY"
								},
								{
									"date": "2016-05-30T00:00:00 -0500",
									"value": 207,
									"status": "GRAY"
								},
								{
									"date": "2016-05-31T00:00:00 -0500",
									"value": 230,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 248,
									"status": "GRAY"
								},
								{
									"date": "2016-06-02T00:00:00 -0500",
									"value": 65,
									"status": "GRAY"
								},
								{
									"date": "2016-06-03T00:00:00 -0500",
									"value": 236,
									"status": "GRAY"
								},
								{
									"date": "2016-06-04T00:00:00 -0500",
									"value": 177,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 140,
									"status": "GRAY"
								},
								{
									"date": "2016-06-06T00:00:00 -0500",
									"value": 203,
									"status": "GRAY"
								},
								{
									"date": "2016-06-07T00:00:00 -0500",
									"value": 132,
									"status": "GRAY"
								},
								{
									"date": "2016-06-08T00:00:00 -0500",
									"value": 183,
									"status": "GRAY"
								},
								{
									"date": "2016-06-09T00:00:00 -0500",
									"value": 180,
									"status": "GRAY"
								},
								{
									"date": "2016-06-10T00:00:00 -0500",
									"value": 167,
									"status": "GRAY"
								},
								{
									"date": "2016-06-11T00:00:00 -0500",
									"value": 118,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 200,
									"status": "GRAY"
								},
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 67,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 179,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 81,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 69,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 207,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 171,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 72,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 83,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 112,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 189,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 222,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 129,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 237,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7151,
								"name": "P3 Service Request",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-05-28T00:00:00 -0500",
									"value": 178,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 200,
									"status": "GRAY"
								},
								{
									"date": "2016-05-30T00:00:00 -0500",
									"value": 128,
									"status": "GRAY"
								},
								{
									"date": "2016-05-31T00:00:00 -0500",
									"value": 164,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 64,
									"status": "GRAY"
								},
								{
									"date": "2016-06-02T00:00:00 -0500",
									"value": 241,
									"status": "GRAY"
								},
								{
									"date": "2016-06-03T00:00:00 -0500",
									"value": 122,
									"status": "GRAY"
								},
								{
									"date": "2016-06-04T00:00:00 -0500",
									"value": 53,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 165,
									"status": "GRAY"
								},
								{
									"date": "2016-06-06T00:00:00 -0500",
									"value": 87,
									"status": "GRAY"
								},
								{
									"date": "2016-06-07T00:00:00 -0500",
									"value": 68,
									"status": "GRAY"
								},
								{
									"date": "2016-06-08T00:00:00 -0500",
									"value": 71,
									"status": "GRAY"
								},
								{
									"date": "2016-06-09T00:00:00 -0500",
									"value": 77,
									"status": "GRAY"
								},
								{
									"date": "2016-06-10T00:00:00 -0500",
									"value": 161,
									"status": "GRAY"
								},
								{
									"date": "2016-06-11T00:00:00 -0500",
									"value": 224,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 138,
									"status": "GRAY"
								},
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 126,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 93,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 244,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 197,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 241,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 50,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 147,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 225,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 56,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 96,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 94,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 214,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 245,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7171,
								"name": "P4 Service Request",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-05-28T00:00:00 -0500",
									"value": 228,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 153,
									"status": "GRAY"
								},
								{
									"date": "2016-05-30T00:00:00 -0500",
									"value": 157,
									"status": "GRAY"
								},
								{
									"date": "2016-05-31T00:00:00 -0500",
									"value": 153,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 108,
									"status": "GRAY"
								},
								{
									"date": "2016-06-02T00:00:00 -0500",
									"value": 173,
									"status": "GRAY"
								},
								{
									"date": "2016-06-03T00:00:00 -0500",
									"value": 65,
									"status": "GRAY"
								},
								{
									"date": "2016-06-04T00:00:00 -0500",
									"value": 212,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 118,
									"status": "GRAY"
								},
								{
									"date": "2016-06-06T00:00:00 -0500",
									"value": 222,
									"status": "GRAY"
								},
								{
									"date": "2016-06-07T00:00:00 -0500",
									"value": 80,
									"status": "GRAY"
								},
								{
									"date": "2016-06-08T00:00:00 -0500",
									"value": 135,
									"status": "GRAY"
								},
								{
									"date": "2016-06-09T00:00:00 -0500",
									"value": 141,
									"status": "GRAY"
								},
								{
									"date": "2016-06-10T00:00:00 -0500",
									"value": 55,
									"status": "GRAY"
								},
								{
									"date": "2016-06-11T00:00:00 -0500",
									"value": 237,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 224,
									"status": "GRAY"
								},
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 112,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 246,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 168,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 234,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 222,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 201,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 59,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 174,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 98,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 172,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 50,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 179,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 121,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7191,
								"name": "P5 Service Request",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-05-28T00:00:00 -0500",
									"value": 162,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 179,
									"status": "GRAY"
								},
								{
									"date": "2016-05-30T00:00:00 -0500",
									"value": 176,
									"status": "GRAY"
								},
								{
									"date": "2016-05-31T00:00:00 -0500",
									"value": 58,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 190,
									"status": "GRAY"
								},
								{
									"date": "2016-06-02T00:00:00 -0500",
									"value": 102,
									"status": "GRAY"
								},
								{
									"date": "2016-06-03T00:00:00 -0500",
									"value": 103,
									"status": "GRAY"
								},
								{
									"date": "2016-06-04T00:00:00 -0500",
									"value": 186,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 213,
									"status": "GRAY"
								},
								{
									"date": "2016-06-06T00:00:00 -0500",
									"value": 178,
									"status": "GRAY"
								},
								{
									"date": "2016-06-07T00:00:00 -0500",
									"value": 106,
									"status": "GRAY"
								},
								{
									"date": "2016-06-08T00:00:00 -0500",
									"value": 170,
									"status": "GRAY"
								},
								{
									"date": "2016-06-09T00:00:00 -0500",
									"value": 50,
									"status": "GRAY"
								},
								{
									"date": "2016-06-10T00:00:00 -0500",
									"value": 232,
									"status": "GRAY"
								},
								{
									"date": "2016-06-11T00:00:00 -0500",
									"value": 210,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 164,
									"status": "GRAY"
								},
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 137,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 172,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 179,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 52,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 138,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 156,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 131,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 195,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 220,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 151,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 237,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 79,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 196,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7211,
								"name": "P6 Service Request",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-05-28T00:00:00 -0500",
									"value": 162,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 203,
									"status": "GRAY"
								},
								{
									"date": "2016-05-30T00:00:00 -0500",
									"value": 197,
									"status": "GRAY"
								},
								{
									"date": "2016-05-31T00:00:00 -0500",
									"value": 212,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 195,
									"status": "GRAY"
								},
								{
									"date": "2016-06-02T00:00:00 -0500",
									"value": 211,
									"status": "GRAY"
								},
								{
									"date": "2016-06-03T00:00:00 -0500",
									"value": 54,
									"status": "GRAY"
								},
								{
									"date": "2016-06-04T00:00:00 -0500",
									"value": 167,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 137,
									"status": "GRAY"
								},
								{
									"date": "2016-06-06T00:00:00 -0500",
									"value": 222,
									"status": "GRAY"
								},
								{
									"date": "2016-06-07T00:00:00 -0500",
									"value": 100,
									"status": "GRAY"
								},
								{
									"date": "2016-06-08T00:00:00 -0500",
									"value": 107,
									"status": "GRAY"
								},
								{
									"date": "2016-06-09T00:00:00 -0500",
									"value": 216,
									"status": "GRAY"
								},
								{
									"date": "2016-06-10T00:00:00 -0500",
									"value": 215,
									"status": "GRAY"
								},
								{
									"date": "2016-06-11T00:00:00 -0500",
									"value": 208,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 63,
									"status": "GRAY"
								},
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 182,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 129,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 179,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 127,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 50,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 224,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 78,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 126,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 100,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 56,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 179,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 226,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 204,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'operations/tickets-backlog/quarterly': {
		"status": 200,
		"data": {
			"title": "Quarterly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "Tickets Backlog",
					"subTitle": "Weekly",
					"metricSeries": [
						{
							"info": {
								"id": 7105,
								"name": "P1 Incident",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 130,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 80,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 167,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 115,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 115,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 102,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 111,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 100,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 82,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 78,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 60,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7125,
								"name": "P2 Incident",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 203,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 174,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 181,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 77,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 218,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 194,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 106,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 127,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 191,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 60,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 165,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7145,
								"name": "P3 Incident",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 75,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 77,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 212,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 191,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 183,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 220,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 144,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 249,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 57,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 146,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 244,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7165,
								"name": "P4 Incident",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 176,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 65,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 58,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 211,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 138,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 88,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 180,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 133,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 208,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 223,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 145,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7185,
								"name": "P5 Incident",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 62,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 123,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 66,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 141,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 226,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 170,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 148,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 123,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 143,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 149,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 164,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7205,
								"name": "P6 Incident",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 224,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 231,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 169,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 189,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 81,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 210,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 61,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 143,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 114,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 50,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 202,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7235,
								"name": "P1 Problem Backlog",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 95,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 78,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 164,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 239,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 181,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 220,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 241,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 136,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 54,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 108,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 69,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7245,
								"name": "P2 Problem Backlog",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 115,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 169,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 106,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 147,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 234,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 62,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 128,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 110,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 81,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 240,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 202,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7255,
								"name": "P3 Problem Backlog",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 99,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 199,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 114,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 179,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 155,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 189,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 237,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 240,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 174,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 59,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 200,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7265,
								"name": "P4 Problem Backlog",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 104,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 209,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 206,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 128,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 150,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 216,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 72,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 162,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 141,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 183,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 239,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7275,
								"name": "P5 Problem Backlog",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 141,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 206,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 126,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 56,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 122,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 146,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 167,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 135,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 122,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 128,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 74,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7285,
								"name": "P6 Problem Backlog",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 197,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 72,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 218,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 180,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 220,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 115,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 197,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 179,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 58,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 143,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 225,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7135,
								"name": "P2 Service Request",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 146,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 60,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 97,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 137,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 176,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 174,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 161,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 171,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 70,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 128,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 224,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7155,
								"name": "P3 Service Request",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 146,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 190,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 97,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 226,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 120,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 72,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 101,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 156,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 161,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 205,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 153,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7175,
								"name": "P4 Service Request",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 91,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 120,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 120,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 105,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 90,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 249,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 226,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 158,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 146,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 96,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 87,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7195,
								"name": "P5 Service Request",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 168,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 240,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 219,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 68,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 151,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 62,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 181,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 164,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 173,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 111,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 226,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7215,
								"name": "P6 Service Request",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 182,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 151,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 91,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 187,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 187,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 128,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 84,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 245,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 212,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 222,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 243,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'operations/data-discrepancies/weekly': {
		"status": 200,
		"data": {
			"title": "Weekly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "Data Discrepancies",
					"subTitle": "Daily",
					"metricSeries": [
						{
							"info": {
								"id": 7011,
								"name": "Cancelled in Collections but barred in Ordering and Switch",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 99,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 134,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 139,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 134,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 138,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 136,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7021,
								"name": "Working in Collections but barred in Ordering and Switch",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 125,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 98,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 162,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 133,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 113,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 203,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7031,
								"name": "Cancelled in Collections but working in Ordering and Switch",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 34,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 42,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 43,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 40,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 43,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 44,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7041,
								"name": "Barred in Collections but working in Ordering and Switch",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 120,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 131,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 132,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 128,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 130,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 125,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'operations/data-discrepancies/monthly': {
		"status": 200,
		"data": {
			"title": "Monthly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "Data Discrepancies",
					"subTitle": "Daily",
					"metricSeries": [
						{
							"info": {
								"id": 7011,
								"name": "Cancelled in Collections but barred in Ordering and Switch",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-05-28T00:00:00 -0500",
									"value": 160,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 160,
									"status": "GRAY"
								},
								{
									"date": "2016-05-30T00:00:00 -0500",
									"value": 162,
									"status": "GRAY"
								},
								{
									"date": "2016-05-31T00:00:00 -0500",
									"value": 162,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 160,
									"status": "GRAY"
								},
								{
									"date": "2016-06-02T00:00:00 -0500",
									"value": 156,
									"status": "GRAY"
								},
								{
									"date": "2016-06-03T00:00:00 -0500",
									"value": 157,
									"status": "GRAY"
								},
								{
									"date": "2016-06-04T00:00:00 -0500",
									"value": 158,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 157,
									"status": "GRAY"
								},
								{
									"date": "2016-06-06T00:00:00 -0500",
									"value": 157,
									"status": "GRAY"
								},
								{
									"date": "2016-06-07T00:00:00 -0500",
									"value": 158,
									"status": "GRAY"
								},
								{
									"date": "2016-06-08T00:00:00 -0500",
									"value": 154,
									"status": "GRAY"
								},
								{
									"date": "2016-06-09T00:00:00 -0500",
									"value": 157,
									"status": "GRAY"
								},
								{
									"date": "2016-06-10T00:00:00 -0500",
									"value": 161,
									"status": "GRAY"
								},
								{
									"date": "2016-06-11T00:00:00 -0500",
									"value": 71,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 156,
									"status": "GRAY"
								},
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 150,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 139,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 137,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 135,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 136,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 137,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 120,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 99,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 134,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 139,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 134,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 138,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 136,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7021,
								"name": "Working in Collections but barred in Ordering and Switch",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-05-28T00:00:00 -0500",
									"value": 102,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 101,
									"status": "GRAY"
								},
								{
									"date": "2016-05-30T00:00:00 -0500",
									"value": 163,
									"status": "GRAY"
								},
								{
									"date": "2016-05-31T00:00:00 -0500",
									"value": 181,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 198,
									"status": "GRAY"
								},
								{
									"date": "2016-06-02T00:00:00 -0500",
									"value": 249,
									"status": "GRAY"
								},
								{
									"date": "2016-06-03T00:00:00 -0500",
									"value": 75,
									"status": "GRAY"
								},
								{
									"date": "2016-06-04T00:00:00 -0500",
									"value": 142,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 134,
									"status": "GRAY"
								},
								{
									"date": "2016-06-06T00:00:00 -0500",
									"value": 231,
									"status": "GRAY"
								},
								{
									"date": "2016-06-07T00:00:00 -0500",
									"value": 138,
									"status": "GRAY"
								},
								{
									"date": "2016-06-08T00:00:00 -0500",
									"value": 96,
									"status": "GRAY"
								},
								{
									"date": "2016-06-09T00:00:00 -0500",
									"value": 237,
									"status": "GRAY"
								},
								{
									"date": "2016-06-10T00:00:00 -0500",
									"value": 63,
									"status": "GRAY"
								},
								{
									"date": "2016-06-11T00:00:00 -0500",
									"value": 91,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 220,
									"status": "GRAY"
								},
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 241,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 146,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 51,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 222,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 236,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 249,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 66,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 125,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 98,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 162,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 133,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 113,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 203,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7031,
								"name": "Cancelled in Collections but working in Ordering and Switch",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-05-28T00:00:00 -0500",
									"value": 52,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 52,
									"status": "GRAY"
								},
								{
									"date": "2016-05-30T00:00:00 -0500",
									"value": 52,
									"status": "GRAY"
								},
								{
									"date": "2016-05-31T00:00:00 -0500",
									"value": 53,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 53,
									"status": "GRAY"
								},
								{
									"date": "2016-06-02T00:00:00 -0500",
									"value": 53,
									"status": "GRAY"
								},
								{
									"date": "2016-06-03T00:00:00 -0500",
									"value": 55,
									"status": "GRAY"
								},
								{
									"date": "2016-06-04T00:00:00 -0500",
									"value": 56,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 56,
									"status": "GRAY"
								},
								{
									"date": "2016-06-06T00:00:00 -0500",
									"value": 55,
									"status": "GRAY"
								},
								{
									"date": "2016-06-07T00:00:00 -0500",
									"value": 54,
									"status": "GRAY"
								},
								{
									"date": "2016-06-08T00:00:00 -0500",
									"value": 52,
									"status": "GRAY"
								},
								{
									"date": "2016-06-09T00:00:00 -0500",
									"value": 52,
									"status": "GRAY"
								},
								{
									"date": "2016-06-10T00:00:00 -0500",
									"value": 53,
									"status": "GRAY"
								},
								{
									"date": "2016-06-11T00:00:00 -0500",
									"value": 108,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 54,
									"status": "GRAY"
								},
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 49,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 41,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 43,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 42,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 43,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 43,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 60,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 34,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 42,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 43,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 40,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 43,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 44,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7041,
								"name": "Barred in Collections but working in Ordering and Switch",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-05-28T00:00:00 -0500",
									"value": 114,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 877,
									"status": "GRAY"
								},
								{
									"date": "2016-05-30T00:00:00 -0500",
									"value": 118,
									"status": "GRAY"
								},
								{
									"date": "2016-05-31T00:00:00 -0500",
									"value": 120,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 154,
									"status": "GRAY"
								},
								{
									"date": "2016-06-02T00:00:00 -0500",
									"value": 127,
									"status": "GRAY"
								},
								{
									"date": "2016-06-03T00:00:00 -0500",
									"value": 130,
									"status": "GRAY"
								},
								{
									"date": "2016-06-04T00:00:00 -0500",
									"value": 121,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 122,
									"status": "GRAY"
								},
								{
									"date": "2016-06-06T00:00:00 -0500",
									"value": 126,
									"status": "GRAY"
								},
								{
									"date": "2016-06-07T00:00:00 -0500",
									"value": 120,
									"status": "GRAY"
								},
								{
									"date": "2016-06-08T00:00:00 -0500",
									"value": 117,
									"status": "GRAY"
								},
								{
									"date": "2016-06-09T00:00:00 -0500",
									"value": 118,
									"status": "GRAY"
								},
								{
									"date": "2016-06-10T00:00:00 -0500",
									"value": 116,
									"status": "GRAY"
								},
								{
									"date": "2016-06-11T00:00:00 -0500",
									"value": 94,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 113,
									"status": "GRAY"
								},
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 112,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 115,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 129,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 132,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 130,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 128,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 183,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 120,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 131,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 132,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 128,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 130,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 125,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'operations/data-discrepancies/quarterly': {
		"status": 200,
		"data": {
			"title": "Quarterly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "Data Discrepancies",
					"subTitle": "Weekly",
					"metricSeries": [
						{
							"info": {
								"id": 7015,
								"name": "Cancelled in Collections but barred in Ordering and Switch",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 121,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 165,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 52,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 113,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 182,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 210,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 245,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 146,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 167,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 84,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 200,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7025,
								"name": "Working in Collections but barred in Ordering and Switch",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 223,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 232,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 242,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 214,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 237,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 95,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 148,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 136,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 99,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 98,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 187,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7035,
								"name": "Cancelled in Collections but working in Ordering and Switch",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 119,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 115,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 129,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 76,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 173,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 68,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 99,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 197,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 188,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 203,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 179,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						},
						{
							"info": {
								"id": 7045,
								"name": "Barred in Collections but working in Ordering and Switch",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 225,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 188,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 122,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 222,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 211,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 225,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 207,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 132,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 70,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 211,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 152,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'operations/trb-backlog/weekly': {
		"status": 200,
		"data": {
			"title": "Weekly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "Error Backlog",
					"subTitle": "Daily",
					"metricSeries": [
						{
							"info": {
								"id": 7001,
								"name": "Error Backlog",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 583,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 17020,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 194,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 262,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 103,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 269,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 130,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 169,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 167,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 204,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 175,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-27T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'operations/trb-backlog/monthly': {
		"status": 200,
		"data": {
			"title": "Monthly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "Error Backlog",
					"subTitle": "Daily",
					"metricSeries": [
						{
							"info": {
								"id": 7001,
								"name": "Error Backlog",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 583,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 17020,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 194,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 262,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 103,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 269,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 130,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 169,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 167,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 204,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 175,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								},
								{
									"date": "2016-06-27T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'operations/trb-backlog/quarterly': {
		"status": 200,
		"data": {
			"title": "Quarterly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "Error Backlog",
					"subTitle": "Weekly",
					"metricSeries": [
						{
							"info": {
								"id": 7005,
								"name": "Error Backlog",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-03T00:00:00 -0500",
									"value": 140,
									"status": "GRAY"
								},
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 249,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 243,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 83,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 246,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 195,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 62,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 158,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 60,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 105,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 143,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 61,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'operations/crm-bap-backlong/weekly': {
		"status": 200,
		"data": {
			"title": "Weekly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "CRM BAP Backlog",
					"subTitle": "Daily",
					"metricSeries": [
						{
							"info": {
								"id": 7221,
								"name": "CRM BAP Backlog",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 133,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 82,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 122,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 97,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 238,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 177,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'operations/crm-bap-backlong/monthly': {
		"status": 200,
		"data": {
			"title": "Monthly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "CRM BAP Backlog",
					"subTitle": "Daily",
					"metricSeries": [
						{
							"info": {
								"id": 7221,
								"name": "CRM BAP Backlog",
								"unit": "VALUE",
								"updateSchedule": "DAILY"
							},
							"values": [
								{
									"date": "2016-05-28T00:00:00 -0500",
									"value": 145,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 181,
									"status": "GRAY"
								},
								{
									"date": "2016-05-30T00:00:00 -0500",
									"value": 194,
									"status": "GRAY"
								},
								{
									"date": "2016-05-31T00:00:00 -0500",
									"value": 158,
									"status": "GRAY"
								},
								{
									"date": "2016-06-01T00:00:00 -0500",
									"value": 51,
									"status": "GRAY"
								},
								{
									"date": "2016-06-02T00:00:00 -0500",
									"value": 76,
									"status": "GRAY"
								},
								{
									"date": "2016-06-03T00:00:00 -0500",
									"value": 194,
									"status": "GRAY"
								},
								{
									"date": "2016-06-04T00:00:00 -0500",
									"value": 87,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 202,
									"status": "GRAY"
								},
								{
									"date": "2016-06-06T00:00:00 -0500",
									"value": 69,
									"status": "GRAY"
								},
								{
									"date": "2016-06-07T00:00:00 -0500",
									"value": 83,
									"status": "GRAY"
								},
								{
									"date": "2016-06-08T00:00:00 -0500",
									"value": 126,
									"status": "GRAY"
								},
								{
									"date": "2016-06-09T00:00:00 -0500",
									"value": 153,
									"status": "GRAY"
								},
								{
									"date": "2016-06-10T00:00:00 -0500",
									"value": 189,
									"status": "GRAY"
								},
								{
									"date": "2016-06-11T00:00:00 -0500",
									"value": 141,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 192,
									"status": "GRAY"
								},
								{
									"date": "2016-06-13T00:00:00 -0500",
									"value": 221,
									"status": "GRAY"
								},
								{
									"date": "2016-06-14T00:00:00 -0500",
									"value": 100,
									"status": "GRAY"
								},
								{
									"date": "2016-06-15T00:00:00 -0500",
									"value": 203,
									"status": "GRAY"
								},
								{
									"date": "2016-06-16T00:00:00 -0500",
									"value": 146,
									"status": "GRAY"
								},
								{
									"date": "2016-06-17T00:00:00 -0500",
									"value": 92,
									"status": "GRAY"
								},
								{
									"date": "2016-06-18T00:00:00 -0500",
									"value": 107,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 109,
									"status": "GRAY"
								},
								{
									"date": "2016-06-20T00:00:00 -0500",
									"value": 133,
									"status": "GRAY"
								},
								{
									"date": "2016-06-21T00:00:00 -0500",
									"value": 82,
									"status": "GRAY"
								},
								{
									"date": "2016-06-22T00:00:00 -0500",
									"value": 122,
									"status": "GRAY"
								},
								{
									"date": "2016-06-23T00:00:00 -0500",
									"value": 97,
									"status": "GRAY"
								},
								{
									"date": "2016-06-24T00:00:00 -0500",
									"value": 238,
									"status": "GRAY"
								},
								{
									"date": "2016-06-25T00:00:00 -0500",
									"value": 177,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}

	, 'operations/crm-bap-backlong/quarterly': {
		"status": 200,
		"data": {
			"title": "Quarterly",
			"metrics": [],
			"gauges": [],
			"graphs": [
				{
					"id": 0,
					"title": "CRM BAP Backlog",
					"subTitle": "Weekly",
					"metricSeries": [
						{
							"info": {
								"id": 7225,
								"name": "CRM BAP Backlog",
								"unit": "VALUE",
								"updateSchedule": "WEEKLY"
							},
							"values": [
								{
									"date": "2016-04-10T00:00:00 -0500",
									"value": 213,
									"status": "GRAY"
								},
								{
									"date": "2016-04-17T00:00:00 -0500",
									"value": 113,
									"status": "GRAY"
								},
								{
									"date": "2016-04-24T00:00:00 -0500",
									"value": 156,
									"status": "GRAY"
								},
								{
									"date": "2016-05-01T00:00:00 -0500",
									"value": 99,
									"status": "GRAY"
								},
								{
									"date": "2016-05-08T00:00:00 -0500",
									"value": 185,
									"status": "GRAY"
								},
								{
									"date": "2016-05-15T00:00:00 -0500",
									"value": 120,
									"status": "GRAY"
								},
								{
									"date": "2016-05-22T00:00:00 -0500",
									"value": 171,
									"status": "GRAY"
								},
								{
									"date": "2016-05-29T00:00:00 -0500",
									"value": 134,
									"status": "GRAY"
								},
								{
									"date": "2016-06-05T00:00:00 -0500",
									"value": 58,
									"status": "GRAY"
								},
								{
									"date": "2016-06-12T00:00:00 -0500",
									"value": 228,
									"status": "GRAY"
								},
								{
									"date": "2016-06-19T00:00:00 -0500",
									"value": 104,
									"status": "GRAY"
								},
								{
									"date": "2016-06-26T00:00:00 -0500",
									"status": "GRAY"
								}
							]
						}
					],
					"notes": []
				}
			]
		}
	}


	, 'system-health': {
		"status": 200,
		"data": {
			"title": "System Health",
			"metrics": [],
			"gauges": [
				{
					"id": 65,
					"title": "Turbo Charging Pre-paid - Rated Events Success Rate",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"minValue": 95,
					"maxValue": 100,
					"direction": "UP",
					"metric": {
						"info": {
							"id": 9001,
							"name": "Turbo Charging Pre-paid - Rated Events Success Rate",
							"unit": "PERCENTAGE",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2016-07-19T00:00:00 -0500",
							"value": 99.89,
							"status": "GREEN"
						}
					},
					"startWithStatus": "RED",
					"thresholds": [
						{
							"value": 98,
							"status": "YELLOW"
						},
						{
							"value": 99,
							"status": "GREEN"
						}
					],
					"type": "INVERTED",
					"history": [
						{
							"id": 65,
							"title": "Turbo Charging Pre-paid - Rated Events Success Rate",
							"date": "2016-07-18T00:00:00 -0500",
							"value": 99.74,
							"status": "GREEN",
							"direction": "DOWN"
						},
						{
							"id": 65,
							"title": "Turbo Charging Pre-paid - Rated Events Success Rate",
							"date": "2016-07-17T00:00:00 -0500",
							"value": 99.89,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 65,
							"title": "Turbo Charging Pre-paid - Rated Events Success Rate",
							"date": "2016-07-16T00:00:00 -0500",
							"value": 99.88,
							"status": "GREEN",
							"direction": "DOWN"
						},
						{
							"id": 65,
							"title": "Turbo Charging Pre-paid - Rated Events Success Rate",
							"date": "2016-07-15T00:00:00 -0500",
							"value": 99.88,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 65,
							"title": "Turbo Charging Pre-paid - Rated Events Success Rate",
							"date": "2016-07-14T00:00:00 -0500",
							"value": 99.87,
							"status": "GREEN",
							"direction": "DOWN"
						},
						{
							"id": 65,
							"title": "Turbo Charging Pre-paid - Rated Events Success Rate",
							"date": "2016-07-13T00:00:00 -0500",
							"value": 99.87,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 65,
							"title": "Turbo Charging Pre-paid - Rated Events Success Rate",
							"date": "2016-07-12T00:00:00 -0500",
							"value": 99.87,
							"status": "GREEN",
							"direction": "UP"
						}
					]
				},
				{
					"id": 66,
					"title": "Turbo Charging Post-paid - EDR Rejected Records",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"minValue": 0,
					"maxValue": 1,
					"direction": "UP",
					"metric": {
						"info": {
							"id": 9011,
							"name": "Turbo Charging Post-paid - EDR Rejected Records",
							"unit": "PERCENTAGE",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2016-07-20T00:00:00 -0500",
							"value": 0.2,
							"status": "GREEN"
						}
					},
					"startWithStatus": "GREEN",
					"thresholds": [
						{
							"value": 0.3,
							"status": "YELLOW"
						},
						{
							"value": 0.5,
							"status": "RED"
						}
					],
					"type": "REGULAR",
					"history": [
						{
							"id": 66,
							"title": "Turbo Charging Post-paid - EDR Rejected Records",
							"date": "2016-07-19T00:00:00 -0500",
							"value": 0.07,
							"status": "GREEN",
							"direction": "DOWN"
						},
						{
							"id": 66,
							"title": "Turbo Charging Post-paid - EDR Rejected Records",
							"date": "2016-07-18T00:00:00 -0500",
							"value": 0.48,
							"status": "YELLOW",
							"direction": "UP"
						},
						{
							"id": 66,
							"title": "Turbo Charging Post-paid - EDR Rejected Records",
							"date": "2016-07-17T00:00:00 -0500",
							"value": 0.32,
							"status": "YELLOW",
							"direction": "DOWN"
						},
						{
							"id": 66,
							"title": "Turbo Charging Post-paid - EDR Rejected Records",
							"date": "2016-07-16T00:00:00 -0500",
							"value": 0.28,
							"status": "GREEN",
							"direction": "DOWN"
						},
						{
							"id": 66,
							"title": "Turbo Charging Post-paid - EDR Rejected Records",
							"date": "2016-07-15T00:00:00 -0500",
							"value": 0.15,
							"status": "GREEN",
							"direction": "DOWN"
						},
						{
							"id": 66,
							"title": "Turbo Charging Post-paid - EDR Rejected Records",
							"date": "2016-07-14T00:00:00 -0500",
							"value": 0.32,
							"status": "YELLOW",
							"direction": "UP"
						},
						{
							"id": 66,
							"title": "Turbo Charging Post-paid - EDR Rejected Records",
							"date": "2016-07-13T00:00:00 -0500",
							"value": 0.22,
							"status": "GREEN",
							"direction": "DOWN"
						},
						{
							"id": 66,
							"title": "Turbo Charging Post-paid - EDR Rejected Records",
							"date": "2016-07-12T00:00:00 -0500",
							"value": 0.08,
							"status": "GREEN",
							"direction": "DOWN"
						}
					]
				},
				{
					"id": 67,
					"title": "Universal Activator - Activation Rate (AUA module)",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"minValue": 95,
					"maxValue": 100,
					"direction": "UP",
					"metric": {
						"info": {
							"id": 9021,
							"name": "Universal Activator - Activation Rate (AUA module)",
							"unit": "PERCENTAGE",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2016-06-23T00:00:00 -0500",
							"value": 99,
							"status": "GREEN"
						}
					},
					"startWithStatus": "RED",
					"thresholds": [
						{
							"value": 98,
							"status": "YELLOW"
						},
						{
							"value": 99,
							"status": "GREEN"
						}
					],
					"type": "INVERTED",
					"history": []
				},
				{
					"id": 68,
					"title": "CRM - Backlogged Cases",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"minValue": 0,
					"maxValue": 20000,
					"direction": "UP",
					"metric": {
						"info": {
							"id": 9031,
							"name": "Customer Relationship MNG (CRM) - Backlogged Cases",
							"unit": "VALUE",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2016-07-19T00:00:00 -0500",
							"value": 174777,
							"status": "RED"
						}
					},
					"startWithStatus": "GREEN",
					"thresholds": [
						{
							"value": 17500,
							"status": "YELLOW"
						},
						{
							"value": 19000,
							"status": "RED"
						}
					],
					"type": "REGULAR",
					"history": [
						{
							"id": 68,
							"title": "CRM - Backlogged Cases",
							"date": "2016-07-18T00:00:00 -0500",
							"value": 175008,
							"status": "RED",
							"direction": "UP"
						},
						{
							"id": 68,
							"title": "CRM - Backlogged Cases",
							"date": "2016-07-17T00:00:00 -0500",
							"value": 175291,
							"status": "RED",
							"direction": "UP"
						},
						{
							"id": 68,
							"title": "CRM - Backlogged Cases",
							"date": "2016-07-16T00:00:00 -0500",
							"value": 174675,
							"status": "RED",
							"direction": "DOWN"
						},
						{
							"id": 68,
							"title": "CRM - Backlogged Cases",
							"date": "2016-07-15T00:00:00 -0500",
							"value": 173988,
							"status": "RED",
							"direction": "DOWN"
						},
						{
							"id": 68,
							"title": "CRM - Backlogged Cases",
							"date": "2016-07-14T00:00:00 -0500",
							"value": 173254,
							"status": "RED",
							"direction": "DOWN"
						},
						{
							"id": 68,
							"title": "CRM - Backlogged Cases",
							"date": "2016-07-13T00:00:00 -0500",
							"value": 173095,
							"status": "RED",
							"direction": "DOWN"
						},
						{
							"id": 68,
							"title": "CRM - Backlogged Cases",
							"date": "2016-07-12T00:00:00 -0500",
							"value": 173279,
							"status": "RED",
							"direction": "UP"
						}
					]
				},
				{
					"id": 69,
					"title": "Invoicing - Successful Bills",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"minValue": 95,
					"maxValue": 100,
					"direction": "UP",
					"metric": {
						"info": {
							"id": 9041,
							"name": "Invoicing - Successful Bills",
							"unit": "PERCENTAGE",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2016-06-23T00:00:00 -0500",
							"value": 98.75,
							"status": "YELLOW"
						}
					},
					"startWithStatus": "RED",
					"thresholds": [
						{
							"value": 98,
							"status": "YELLOW"
						},
						{
							"value": 99,
							"status": "GREEN"
						}
					],
					"type": "INVERTED",
					"history": []
				},
				{
					"id": 70,
					"title": "Ordering (OMS) - Completion Rate within 30 min",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"minValue": 95,
					"maxValue": 100,
					"direction": "UP",
					"metric": {
						"info": {
							"id": 9051,
							"name": "Ordering (OMS) - Completion Rate within 30 min",
							"unit": "PERCENTAGE",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2016-07-19T00:00:00 -0500",
							"value": 99.45,
							"status": "GREEN"
						}
					},
					"startWithStatus": "RED",
					"thresholds": [
						{
							"value": 98,
							"status": "YELLOW"
						},
						{
							"value": 99,
							"status": "GREEN"
						}
					],
					"type": "INVERTED",
					"history": [
						{
							"id": 70,
							"title": "Ordering (OMS) - Completion Rate within 30 min",
							"date": "2016-07-18T00:00:00 -0500",
							"value": 99.96,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 70,
							"title": "Ordering (OMS) - Completion Rate within 30 min",
							"date": "2016-07-17T00:00:00 -0500",
							"value": 99.92,
							"status": "GREEN",
							"direction": "DOWN"
						},
						{
							"id": 70,
							"title": "Ordering (OMS) - Completion Rate within 30 min",
							"date": "2016-07-16T00:00:00 -0500",
							"value": 99.93,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 70,
							"title": "Ordering (OMS) - Completion Rate within 30 min",
							"date": "2016-07-15T00:00:00 -0500",
							"value": 99.9,
							"status": "GREEN",
							"direction": "DOWN"
						},
						{
							"id": 70,
							"title": "Ordering (OMS) - Completion Rate within 30 min",
							"date": "2016-07-14T00:00:00 -0500",
							"value": 98.51,
							"status": "YELLOW",
							"direction": "DOWN"
						},
						{
							"id": 70,
							"title": "Ordering (OMS) - Completion Rate within 30 min",
							"date": "2016-07-13T00:00:00 -0500",
							"value": 99.74,
							"status": "GREEN",
							"direction": "UP"
						},
						{
							"id": 70,
							"title": "Ordering (OMS) - Completion Rate within 30 min",
							"date": "2016-07-12T00:00:00 -0500",
							"value": 99.96,
							"status": "GREEN",
							"direction": "UP"
						}
					]
				},
				{
					"id": 71,
					"title": "MCSS - Transactions Initiated",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"minValue": 0,
					"maxValue": 1000,
					"direction": "UP",
					"metric": {
						"info": {
							"id": 9061,
							"name": "Multi-Channel Self Service - Transactions Initiated",
							"unit": "VALUE",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2016-06-23T00:00:00 -0500",
							"value": 12547,
							"status": "GREEN"
						}
					},
					"startWithStatus": "RED",
					"thresholds": [
						{
							"value": 1,
							"status": "GREEN"
						}
					],
					"type": "INVERTED",
					"history": []
				},
				{
					"id": 72,
					"title": "EOD Completion - Time",
					"systemInfo": {
						"id": 1000,
						"name": "Globe Reporting"
					},
					"minValue": 0,
					"maxValue": 1000,
					"direction": "UP",
					"metric": {
						"info": {
							"id": 9071,
							"name": "EOD Cycle Completion - Time",
							"unit": "HOURS",
							"updateSchedule": "DAILY"
						},
						"value": {
							"date": "2016-06-23T00:00:00 -0500",
							"value": 123,
							"status": "GREEN"
						}
					},
					"startWithStatus": "GREEN",
					"thresholds": [
						{
							"value": 180,
							"status": "YELLOW"
						},
						{
							"value": 240,
							"status": "RED"
						}
					],
					"type": "REGULAR",
					"history": []
				}
			],
			"graphs": []
		}
	}

};
